/*!
*  filename: ej.webform.js
*  version : 12.3
*  Copyright Syncfusion Inc. 2001 - 2014. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
*/

(function () {
    setViewstate(ej.Accordion, ["cssClass", "enabled", "enableRTL", "selectedItems", "selectedItemIndex"]);
    setViewstate(ej.Autocomplete, ["cssClass", "enabled", "enableRTL", "readOnly", "value"]);
    setViewstate(ej.Button, ["enabled", "cssClass", "enableRTL"]);
    setViewstate(ej.Captcha, ["characterSet", "maximumLength", "caseSensitive", "autoValidate", "successMessage", "errorMessage", "encryptedCode", "isValid", "enableAudio", "enableRefreshImage", "enableRTL", "audioUrl"]);
    setViewstate(ej.CheckBox, ["checked", "enabled", "cssClass", "enableRTL"]);
    setViewstate(ej.ColorPicker, ["value", "cssClass", "enabled", "showRecentColors", "opacityValue", "toolIcon", "columns", "palette", "modelType"]);
    setViewstate(ej.CurrencyTextbox, ["cssClass", "locale", "enabled", "enableRTL", "readOnly", "value"]);
    setViewstate(ej.DatePicker, ["selectedDate", "dateFormat", "minDate", "maxDate", "locale", "enabled", "readOnly", "cssClass", "enableRTL"]);
    setViewstate(ej.DateTimePicker, ["value", "minDateTime", "maxDateTime", "locale", "enabled", "readOnly", "cssClass", "enableRTL"]);
    setViewstate(ej.DropDownList, ["value", "text", "enabled", "readOnly", "cssClass", "enableRTL", "selectedItems", "selectedItemIndex"]);
    setViewstate(ej.MaskEdit, ["value", "maskFormat", "inputMode", "enabled", "readOnly", "cssClass" ]);
    setViewstate(ej.Menu, ["animationType", "enabled", "cssClass", "enableRTL", "orientation"]);
    setViewstate(ej.NumericTextbox, ["cssClass", "locale", "enabled", "enableRTL", "readOnly", "value"]);
    setViewstate(ej.PercentageTextbox, ["cssClass", "locale", "enabled", "enableRTL", "readOnly", "value"]);
    setViewstate(ej.ProgressBar, ["value", "text", "percentage", "minValue", "maxValue", "enabled", "cssClass", "enableRTL"]);
    setViewstate(ej.RadioButton, ["checked", "enabled", "cssClass", "enableRTL"]);
    setViewstate(ej.Rating, ["value", "minValue", "maxValue", "readOnly", "cssClass"]);
    setViewstate(ej.RTE, ["cssClass", "locale", "enabled", "enableRTL", "value"]);
    setViewstate(ej.Slider, ["value", "values", "minValue", "maxValue", "incrementStep", "readOnly", "enabled", "enableRTL", "sliderType", "cssClass"]);
    setViewstate(ej.SplitButton, ["text", "cssClass", "enableRTL", "enabled"]);
    setViewstate(ej.Tab, ["selectedItemIndex", "enabled", "cssClass", "enableRTL"]);
    setViewstate(ej.Ribbon,["selectedItemIndex"]);
    setViewstate(ej.ListBox, ["selectedItemIndex", "selectedItemlist", "checkedItemlist"]);
    setViewstate(ej.TagCloud, ["enableRTL", "cssClass", "titleText", "titleImage", "format"]);
    setViewstate(ej.TimePicker, ["value", "minTime", "maxTime", "locale", "enabled", "readOnly", "cssClass", "enableRTL"]);
    setViewstate(ej.ToggleButton, ["enabled", "cssClass", "enableRTL", "toggleState", "activePrefixIcon",
                                            "activeSuffixIcon", "activeText", "defaultText", "defaultPrefixIcon", "defaultSuffixIcon"]);
    setViewstate(ej.Toolbar, ["enabled", "cssClass", "enableRTL", "orientation", "hide"]);
    setViewstate(ej.TreeView, ["cssClass", "enabled", "enableRTL", "expandedNodes", "checkedNodes"]);
    setViewstate(ej.Uploadbox, ["enabled", "multipleFilesSelection", "enableRTL", "cssClass", "showFileDetails"]);
    setViewstate(ej.PivotGrid, ["currentReport"]);
    setViewstate(ej.Schedule, ["currentDate", "currentView", "endHour", "startHour"]);
    setViewstate(ej.Grid, ["allowFiltering", "allowGrouping", "allowKeyboardNavigation", "allowMultiSorting", "allowPaging", "allowReordering","allowTextWrap","allowCellMerging",
                                             "allowResizing", "allowScrolling", "allowSearching", "allowSelection", "allowSorting", "showSummary",
                                             "cssClass", "detailsTemplate", "enableAltRow", "enableHeaderHover", "enablePersistence", "enableRTL", "enableRowHover", "locale",
                                             "query", "rowTemplate", "selectedRowIndex", "selectionType", "editSettings", "filterSettings", "groupSettings", "pageSettings",
                                             "scrollSettings", "sortSettings", "toolbarSettings","columns"]);
    if (ej.olap)
        setViewstate(ej.olap.OlapChart, ["currentReport"]);
    if (ej.datavisualization) {
        setViewstate(ej.datavisualization.Chart, ["series"]);
        setViewstate(ej.datavisualization.Map, ["enablePan", "enableAnimation", "enableResize"]);
        setViewstate(ej.datavisualization.TreeMap, ["highlightOnSelection", "enableResize"]);
        setViewstate(ej.datavisualization.CircularGauge, ["scales"]);
        setViewstate(ej.datavisualization.LinearGauge, ["scales"]);
        setViewstate(ej.datavisualization.Diagram, ["nodes", "connectors", "width", "height", "labels"]);
        
    }
})();

function setViewstate( namespace, viewstateData) {
    if (namespace)
        namespace.prototype._includeOnViewstate = viewstateData;
}
;

(function () {

    var args, clientArgs;
    setTimeout(function () { ej.isOnWebForms = true; }, 1000);
    ej.raiseWebFormsServerEvents = function (eventName, eventProp, clientProp) {
        if (eventProp.model.serverEvents.indexOf(eventName) != -1) {
            args = eventProp, clientArgs = ignoreDOMElement(clientProp);
            setTimeout(function () {
                try {
                    var modelStr = JSON.stringify({ type: args.originalEventType, args: clientArgs });
                    __doPostBack(args.model.uniqueId, modelStr);
                }
                catch (e) { }
            }, 0);
        }
    }
    function ignoreDOMElement(args) {
        if (!args) return null;
        for (var name in args) {
            var ele = args[name];
            if ($.isPlainObject(ele)) ignoreDOMElement(ele);
            else if (isDOMObj(ele) || (ele && typeof ele.preventDefault == "function"))
                delete args[name];
        }
        return args;
    }
    function isDOMObj(o) {
        return o instanceof $ || (o && o.nodeType && o.nodeType == 1);
    }

})();

function EJ_ClientSideOnPostBack() {
    clearPostBackData();
    var $form = typeof theForm == "undefined" ? $("body form") : $(theForm);
    if (!$form.length) return;
    $form.append(getPostBackData());
    addPostBackHandler();
}

function getPostBackData() {
    var controls = $("body .e-js");
    var div = $(document.createElement("div"));
    div.attr("id", "ej-hidden-model-container");
    for (var i = 0; i < controls.length; i++) {
        var widgets = $(controls[i]).data("ejWidgets");
        if (!widgets) continue;
        for (var j = 0; j < widgets.length; j++) {
            var that = $(controls[i]).data(widgets[j]);
            if (!that || !that.model.clientId) continue;
            var hidden = $(document.createElement("input")).attr({
                "type": "hidden",
                "id": that.model.clientId + "_hidden_model",
                "name": that.model.clientId + "_hidden_model"
            }).val(JSON.stringify(includeRequiredProp(that)));
            div.append(hidden);
        }
    }
    return div;
}

function includeRequiredProp(that) {
    var propArray = that._includeOnViewstate || [], model = {};
    for (var n = 0; n < propArray.length; n++)
        model[propArray[n]] = ej.util.getObject(propArray[n], that.model);
    return model;
}

function clearPostBackData() {
    removePostBackHandler();
    $("#ej-hidden-model-container").remove();
}

function addPostBackHandler() {
    if (typeof Sys != "undefined")
        Sys.WebForms.PageRequestManager.getInstance().add_endRequest(clearPostBackData);
}
function removePostBackHandler() {
    if (typeof Sys != "undefined")
        Sys.WebForms.PageRequestManager.getInstance().remove_endRequest(clearPostBackData);
};