﻿ej.EjLegendRender = function (chartobj) {

    this.chartObj = chartobj;
};


(function ($) {
ej.EjLegendRender.prototype =
{
    
  
    drawLegendTitle: function () {
        //draw legend title
        var legendTitle = this.chartObj.model.legend.title;
         var legendBoundsWidth = this.chartObj.model.LegendBounds.Width;
         var size = ej.EjSvgRender.utils._measureText(legendTitle.text, null, this.chartObj.model.legend.title.font); 
        var startX, startY;
        startX = this.chartObj.model.elementSpacing/2;
        startY = this.chartObj.model.elementSpacing+ (size.height) / 2;
        if (this.chartObj.model.legend.title.textAlignment.toLowerCase() == "near")
        {
            startX = this.chartObj.model.elementSpacing/2;
        }
        else if (this.chartObj.model.legend.title.textAlignment.toLowerCase() == "far")
        {
            var startX = legendBoundsWidth -(size.width) - this.chartObj.model.elementSpacing / 2;
           
        }
        else {
            var startX = legendBoundsWidth / 2 - (size.width) / 2;
        }

        if (startX < 0) {
            startX = 0;
            this.chartObj.model.LegendBounds.Width =(size. width);
        }
       
        
        if (this.chartObj.model.LegendBounds.Width < size.width + startX)
        {
            this.chartObj.model.LegendBounds.Width = size.width+startX;
        }
        
        var fontLegendtitle = this.chartObj.model.legend.title.font;
        var options = {
            'id': this.chartObj.svgObject.id + '_LegendTitleText',
            'x': startX,
            'y': startY,
            'fill': fontLegendtitle.color,
            'font-size': fontLegendtitle.size,
            'font-style': fontLegendtitle.fontStyle,
            'font-family': fontLegendtitle.fontFamily,
            'font-weight': fontLegendtitle.fontWeight,
            'text-anchor': 'start',
            'lgndCtx': true
        };

        this.chartObj.svgRenderer.drawText(options, legendTitle.text, this.chartObj.gLegendEle);

    },
    
    drawLegendItem: function (legendItem, x, y) {
        var shapeSize = this.chartObj.model.legend.itemStyle;
        var elementSpace = this.chartObj.model.elementSpacing;
        var location = { startX: x + shapeSize.width / 2, startY: (y + shapeSize.height / 2) };
        var index = (legendItem.PointIndex) ? legendItem.PointIndex : legendItem.SeriesIndex;
        var series = this.chartObj.model.series;
        var style = {
              ShapeSize: shapeSize,
              ElementSpace: elementSpace,
              Style: legendItem.LegendStyle,
              Gradient: legendItem.Gradient,
              ID: this.chartObj.svgObject.id + '_LegendItemShape' + index,
              SeriesIndex: legendItem.SeriesIndex,
              context: true
        };
        var symbolName;
        for (name in this.chartObj.model.symbolShape) {
            if (legendItem.Shape.toLowerCase() == name.toLowerCase()) {
                if (name.toLowerCase() == "seriestype")
                    symbolName = "SeriesType";
                else
                    symbolName = name;
                break;
            }     
        }
            if (symbolName == "SeriesType") {
                if (series[legendItem.SeriesIndex].type.toLowerCase() == "radar" || series[legendItem.SeriesIndex].type.toLowerCase() == "polar") {
                    var symbol = series[legendItem.SeriesIndex].drawType;
                    symbolName = this.capitalizeFirstString(symbol);
                }
                if (series[legendItem.SeriesIndex].type.toLowerCase() == "scatter") {
                    var symbol = series[legendItem.SeriesIndex].marker.shape;
                    symbolName = this.capitalizeFirstString(symbol);
                }
            }
            if (symbolName == "None") {
                if (series[legendItem.SeriesIndex].type.toLowerCase() == "pie" || series[legendItem.SeriesIndex].type.toLowerCase() == "doughnut")
                    symbolName = "Circle";
                else
                symbolName = "Rectangle";
            }
       
        var index = (ej.util.isNullOrUndefined(legendItem.PointIndex)) ? legendItem.SeriesIndex : legendItem.PointIndex;
        this.chartObj.gLegendItemEle = this.chartObj.svgRenderer.createGroup({ 'id': this.chartObj.svgObject.id + '_Legend' + index, 'cursor': 'pointer' });

        var commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
        commonEventArgs.data = { legendItem: legendItem, location: location, legend: true, model: this.chartObj.model, svgRenderer: this.chartObj.svgRenderer, svgObject: this.chartObj.svgObject, symbolShape: symbolName, style: style, gLegendItemEle: this.chartObj.gLegendItemEle };

        this.chartObj._trigger("legendItemRendering", commonEventArgs);
        
        
        ej.EjSvgRender.chartSymbol["_draw" + commonEventArgs.data.symbolShape](commonEventArgs.data.location, commonEventArgs.data.style, commonEventArgs.data, this.chartObj.gLegendItemEle);
        var color; 
        if (legendItem.LegendStyle.Color && legendItem.LegendStyle.Color.toLowerCase() !== 'gray' && this.chartObj.model.enableCanvasRendering) // for canvas gradient color
            color = this.chartObj.model.legend.font.color;
        else if (legendItem.LegendStyle.Color && legendItem.LegendStyle.Color.toLowerCase() !== 'gray') // for svg
            color = this.chartObj.model.legend.font.color;
        else
            color = 'gray';
    
        var fontLegend = this.chartObj.model.legend.font;
        var itemInfo = commonEventArgs.data.legendItem;
        var heightText = ej.EjSvgRender.utils._measureText(itemInfo.Text, this.chartObj.model.LegendBounds.Width, fontLegend).height;
        if (this.chartObj.model.legend.shape == "seriestype" || this.chartObj.model.legend.shape == "seriesType")
            x += this.chartObj.model.legend.itemPadding/2;
        var pointindex = legendItem.PointIndex;
        var options = {
            'id': this.chartObj.svgObject.id + '_LegendItemText' + index,
            'x': shapeSize.width + x + this.chartObj.model.legend.itemPadding/2,
            'y': commonEventArgs.data.location.startY,
            'fill': color,
            'font-size': fontLegend.size,
            'font-style': fontLegend.fontStyle,
            'font-family': fontLegend.fontFamily,
            'font-weight': fontLegend.fontWeight,
            'text-anchor': 'start',
            'lgndCtx': true
        };
        var matched = jQuery.uaMatch(navigator.userAgent);
		var isIE11 = !!navigator.userAgent.match(/Trident\/7\./);
       // if (matched.browser.toLowerCase() == "msie" || isIE11) 
            options.y = (commonEventArgs.data.location.startY +(heightText / 4)); // for dominant-baseline
        //else 
        //    this.chartObj.svgRenderer._setAttr($(options), { 'dominant-baseline': 'middle' });
			
		this.chartObj.svgRenderer.drawText(options,commonEventArgs.data.legendItem.Text,this.chartObj.gLegendItemEle);
		this.chartObj.svgRenderer.append(this.chartObj.gLegendItemEle, this.chartObj.gLegendEle);
		var legendbound = { X: this.chartObj.model.LegendBounds.X + this.chartObj.model.legend.border.width, Y: this.chartObj.model.LegendBounds.Y + this.chartObj.model.legend.border.width };
        var itembound = { X: (x), Y: (y) };
        var bounds = { LegendBound: legendbound, ItemBound: itembound };
        var legendRegion = { LegendItem: legendItem, Location: location, SymbolShape: symbolName, Style: style, Bounds: bounds };
        this.chartObj.model.legendRegion.push(legendRegion);
    },
    
    capitalizeFirstString:function(string){
        return string.charAt(0).toUpperCase() + string.slice(1);
    },

    drawLegend: function () {

        var modelsubTitleHeight = (this.chartObj.model.title.subTitle.text == "") ? 0 : (ej.EjSvgRender.utils._measureText(this.chartObj.model.title.subTitle.text, $(this.svgObject).width() - this.chartObj.model.margin.left - this.chartObj.model.margin.right, this.chartObj.model.title.subTitle.font).height + this.chartObj.model.elementSpacing);
        
        if (!ej.util.isNullOrUndefined(this.chartObj.model.legend) && this.chartObj.model.legend.visible) {
            // draw legend.
           var legendTitle = this.chartObj.model.legend.title;
           var height = ej.EjSvgRender.utils._measureText(legendTitle.text, null, this.chartObj.model.legend.title.font).height;
            if (this.chartObj.model.legend.position.toLowerCase() == this.chartObj.model.legendPosition.bottom) {
                this.chartObj.model.LegendBounds.Y = $(this.chartObj.svgObject).height() - (this.chartObj.model.elementSpacing* 1.5)- this.chartObj.model.LegendViewerBounds.Height-height;

                this.chartObj.model.LegendBounds.X = ($(this.chartObj.svgObject).width() / 2) - (this.chartObj.model.LegendViewerBounds.Width / 2);

            }
            else if (this.chartObj.model.legend.position.toLowerCase() == this.chartObj.model.legendPosition.top) {
                this.chartObj.model.LegendBounds.Y = ((this.chartObj.model._titleLocation) ? this.chartObj.model._titleLocation.Y : 0) + modelsubTitleHeight + this.chartObj.model.elementSpacing;
                this.chartObj.model.LegendBounds.X = ($(this.chartObj.svgObject).width() / 2) - (this.chartObj.model.LegendViewerBounds.Width / 2);
            }

            else if (this.chartObj.model.legend.position.toLowerCase() == this.chartObj.model.legendPosition.right) {
                this.chartObj.model.LegendBounds.Y = ($(this.chartObj.svgObject).height()) / 2 - (this.chartObj.model.LegendViewerBounds.Height / 2);
                this.chartObj.model.LegendBounds.X = $(this.chartObj.svgObject).width() - this.chartObj.model.elementSpacing - this.chartObj.model.LegendViewerBounds.Width;
            }

            else if (this.chartObj.model.legend.position.toLowerCase() == this.chartObj.model.legendPosition.left) {
                this.chartObj.model.LegendBounds.Y = ($(this.chartObj.svgObject).height()) / 2 - (this.chartObj.model.LegendViewerBounds.Height / 2);
                this.chartObj.model.LegendBounds.X = this.chartObj.model.elementSpacing;
            }
            else {
                this.chartObj.model.LegendBounds.Y = (this.chartObj.model.legend.location.y < $(this.chartObj.svgObject).height()) ? this.chartObj.model.legend.location.y : 0;
                this.chartObj.model.LegendBounds.X = (this.chartObj.model.legend.location.x < $(this.chartObj.svgObject).width()) ? this.chartObj.model.legend.location.x : 0;
            }
            if (this.chartObj.model.legend.position.toLowerCase() == 'left' || this.chartObj.model.legend.position.toLowerCase() == 'right') {
                if (this.chartObj.model.legend.alignment.toLowerCase() == 'center') {
                    this.chartObj.model.LegendBounds.Y = ($(this.chartObj.svgObject).height()) / 2 - (this.chartObj.model.LegendViewerBounds.Height / 2);
                } else if (this.chartObj.model.legend.alignment.toLowerCase() == 'near') {
                    this.chartObj.model.LegendBounds.Y = this.chartObj.model.m_Spacing.Top + this.chartObj.model.elementSpacing + (this.chartObj.model.legend.itemPadding / 2);
                } else {
                    this.chartObj.model.LegendBounds.Y = $(this.chartObj.svgObject).height() - this.chartObj.model.m_Spacing.Bottom - this.chartObj.model.LegendViewerBounds.Height - this.chartObj.model.elementSpacing - 5;
                }
                //adjust the legend viewer bound height based on legend alignment
                if (this.chartObj.model.AreaType == "cartesianaxes") {
                    if (this.chartObj.model.LegendBounds.Y < this.chartObj.model.m_AreaBounds.Y || this.chartObj.model.m_AreaBounds.Y + this.chartObj.model.LegendViewerBounds.Height >= this.chartObj.model.m_AreaBounds.Height) {
                        var legendHeight = 0;
                        for (var k = 0; k < this.chartObj.model.legendCollection.length; k++) {
                            legendHeight += this.chartObj.model.legendCollection[k].Bounds.Height;
                            if (legendHeight > this.chartObj.model.m_AreaBounds.Height) {
                                legendHeight -= this.chartObj.model.legendCollection[k].Bounds.Height; break;
                            }
                            this.chartObj.model.LegendViewerBounds.Height = legendHeight;
                            this.chartObj.model.LegendBounds.Y = (this.chartObj.model.m_AreaBounds.Height / 2) - (this.chartObj.model.LegendViewerBounds.Height / 2)
                           + this.chartObj.model.m_AreaBounds.Y;
                        }
                    }
                }
                else {
                    if (this.chartObj.model.LegendBounds.Y < 0 || this.chartObj.model.LegendBounds.Y + this.chartObj.model.LegendViewerBounds.Height >= $(this.chartObj.svgObject).height()) {
                        var legendHeight = 0;
                        for (var k = 0; k < this.chartObj.model.legendCollection.length; k++) {
                            legendHeight += this.chartObj.model.legendCollection[k].Bounds.Height;
                            if (legendHeight > $(this.chartObj.svgObject).height()) {
                                legendHeight -= this.chartObj.model.legendCollection[k].Bounds.Height;
                                break;
                            }
                        }
                        this.chartObj.model.LegendViewerBounds.Height = legendHeight;
                        this.chartObj.model.LegendBounds.Y = ($(this.chartObj.svgObject).height() / 2) - (this.chartObj.model.LegendViewerBounds.Height / 2);
                    }
                }
            }
            else {
                if (this.chartObj.model.legend.position.toLowerCase() != 'custom') {
                    if (this.chartObj.model.legend.alignment.toLowerCase() == 'center') {
                        if (this.chartObj.model.AreaType == "cartesianaxes") 
                            this.chartObj.model.LegendBounds.X = (this.chartObj.model.m_AreaBounds.Width / 2) - (this.chartObj.model.LegendViewerBounds.Width / 2)
                            + this.chartObj.model.m_AreaBounds.X;
                        else
                            this.chartObj.model.LegendBounds.X = ($(this.chartObj.svgObject).width() / 2) - (this.chartObj.model.LegendViewerBounds.Width / 2);
                    } else if (this.chartObj.model.legend.alignment.toLowerCase() == 'near') {
                        this.chartObj.model.LegendBounds.X = this.chartObj.model.m_Spacing.Left + this.chartObj.model.elementSpacing + (this.chartObj.model.legend.itemPadding / 2);
                    } else {
                        this.chartObj.model.LegendBounds.X = $(this.chartObj.svgObject).width() - this.chartObj.model.m_Spacing.Right - this.chartObj.model.LegendViewerBounds.Width - this.chartObj.model.elementSpacing - 5;
                    }
                    //adjust the legend viewer bound width based on legend alignment
                    if (this.chartObj.model.AreaType == "cartesianaxes")
                    {
                        if (this.chartObj.model.LegendBounds.X < this.chartObj.model.m_AreaBounds.X || this.chartObj.model.m_AreaBounds.X + this.chartObj.model.LegendViewerBounds.Width >= this.chartObj.model.m_AreaBounds.Width) {
                            var legendWidth = 0;
                            for (var k = 0; k < this.chartObj.model.legendCollection.length; k++) {
                                legendWidth += this.chartObj.model.legendCollection[k].Bounds.Width;
                                if (legendWidth > this.chartObj.model.m_AreaBounds.Width) {
                                    legendWidth -= this.chartObj.model.legendCollection[k].Bounds.Width; break;
                                }
                            }
                            this.chartObj.model.LegendViewerBounds.Width = legendWidth;
                            this.chartObj.model.LegendBounds.X = (this.chartObj.model.m_AreaBounds.Width / 2) - (this.chartObj.model.LegendViewerBounds.Width / 2)
                           + this.chartObj.model.m_AreaBounds.X;
                        }
                    }
                    else
                    {
                        if(this.chartObj.model.LegendBounds.X<0||this.chartObj.model.LegendBounds.X+this.chartObj.model.LegendViewerBounds.Width>=$(this.chartObj.svgObject).width())
                        {
                            var legendWidth = 0;
                            for (var k = 0; k < this.chartObj.model.legendCollection.length; k++) {
                                legendWidth += this.chartObj.model.legendCollection[k].Bounds.Width;
                                if (legendWidth > $(this.chartObj.svgObject).width()) {
                                    legendWidth -= this.chartObj.model.legendCollection[k].Bounds.Width;
                                    break;
                                }
                            }
                            this.chartObj.model.LegendViewerBounds.Width = legendWidth;
                            this.chartObj.model.LegendBounds.X = ($(this.chartObj.svgObject).width() / 2) - (this.chartObj.model.LegendViewerBounds.Width / 2);
                            
                        }
                    }
                }
                else
                {
                    if (this.chartObj.model.LegendBounds.X + this.chartObj.model.LegendViewerBounds.Width > $(this.chartObj.svgObject).width())
                        this.chartObj.model.LegendViewerBounds.Width = $(this.chartObj.svgObject).width() - this.chartObj.model.LegendBounds.X;
                    if (this.chartObj.model.LegendBounds.Y + this.chartObj.model.LegendViewerBounds.Height > $(this.chartObj.svgObject).height())
                        this.chartObj.model.LegendViewerBounds.Height = $(this.chartObj.svgObject).height() - this.chartObj.model.LegendBounds.Y;
                }
            }
			//Set height and width to legend Canvas element
			var legendTitle = this.chartObj.model.legend.title;
			var legendHeight = ej.EjSvgRender.utils._measureText(legendTitle.text, null, legendTitle.font).height;
            this.chartObj.legendSvgContainer.height = this.chartObj.model.LegendBounds.Height + legendHeight;
            this.chartObj.legendSvgContainer.width = this.chartObj.model.LegendBounds.Width;
            if (legendTitle.text != "" && legendTitle.text)
               this.drawLegendTitle();
            var legnTx = this.chartObj.model.LegendBounds.X;

            var legnTy = this.chartObj.model.LegendBounds.Y;
            var currentX, currentY;
            var startX, startY;
            currentX = startX = this.chartObj.model.legend.itemPadding;
            currentY = startY = this.chartObj.model.legend.itemPadding;
            if (this.chartObj.model.legend.title.text != "" && this.chartObj.model.legend.title.text != null && (this.chartObj.model.legend.position.toLowerCase() != "custom")) {
                currentY = startY = this.chartObj.model.legend.itemPadding + height;
            }               
            
            for (var k = 0; k < this.chartObj.model.legendCollection.length; k++) {
                var position = this.chartObj.model.legend.position.toLowerCase();
                if (position == this.chartObj.model.legendPosition.top || position == this.chartObj.model.legendPosition.bottom || position == this.chartObj.model.legendPosition.custom || this.chartObj.model.legend.rowCount || this.chartObj.model.legend.columnCount) {
                    if ((currentX + this.chartObj.model.legendCollection[k].Bounds.Width) > this.chartObj.model.LegendBounds.Width + startX) {
                        currentX = this.chartObj.model.legend.itemPadding;
                        currentY += this.chartObj.model.legendCollection[k].Bounds.Height;
                    }
                    this.drawLegendItem(this.chartObj.model.legendCollection[k], currentX, (currentY));
                    currentX += this.chartObj.model.legendCollection[k].Bounds.Width;
                }
                else {
                    if (((currentY + this.chartObj.model.legendCollection[k].Bounds.Height) > this.chartObj.model.LegendBounds.Height + startY)) {
                        currentY = this.chartObj.model.legend.itemPadding;
                        currentX = (this.chartObj.model.legendCollection[k].Bounds.Width) + (this.chartObj.model.legend.itemPadding);

                    }
                    this.drawLegendItem(this.chartObj.model.legendCollection[k], (currentX), (currentY));
                    currentY += this.chartObj.model.legendCollection[k].Bounds.Height;
                }
            }  
            $(this.chartObj.legendContainer).removeAttr("style");
            $(this.chartObj.legendContainer).show();

       $(this.chartObj.legendContainer).css({ "position": "absolute", "left": legnTx, "top": legnTy, "width": this.chartObj.model.LegendViewerBounds.Width, "height": this.chartObj.model.LegendViewerBounds.Height+height, "border-width": this.chartObj.model.legend.border.width, "border-color": this.chartObj.model.legend.border.color, "border-style": "solid" });
            if (this.chartObj.model.LegendBounds.Height  > this.chartObj.model.LegendViewerBounds.Height) {
                $(this.chartObj.legendContainer).css({ "overflow-y": "auto" });
            }
            if (this.chartObj.model.LegendBounds.Width  > this.chartObj.model.LegendViewerBounds.Width) {
                $(this.chartObj.legendContainer).css({ "overflow-x": "auto" });
            }
            if (this.chartObj.model.LegendBounds.Width > this.chartObj.model.LegendViewerBounds.Width && this.chartObj.model.LegendBounds.Height > this.chartObj.model.LegendViewerBounds.Height)
            {
                $(this.chartObj.legendContainer).css({ "overflow":"auto"});
            }
            $(this.chartObj.legendSvgContainer).css({ "height": this.chartObj.model.LegendBounds.Height+height, "width": this.chartObj.model.LegendBounds.Width });
            this.chartObj.svgRenderer.append(this.chartObj.gLegendEle, this.chartObj.legendSvgContainer);   
            if (this.chartObj.scrolltop != undefined)
                $(this.chartObj.legendContainer).scrollTop(this.chartObj.scrolltop);
            if (this.chartObj.scrollleft != undefined)
                $(this.chartObj.legendContainer).scrollLeft(this.chartObj.scrollleft);
           
        }
        else
            $(this.chartObj.legendContainer).hide();
    }
};
})(jQuery);