﻿(function ($, ej, undefined) {

    ej.ExcelFilter = ej.ExcelFilter || {};

    ej.excelFilter = function (options) {
        this._ctrlInstance = options["instance"];
        this.id = this._ctrlInstance._id;
        this._dialogContainer = null;
        this._showSort = options["showSortOptions"] || false;
        this._maxCount = options["maxFilterLimit"] || 1000;
        this._formatFiltering = false;
        this._locale = this._ctrlInstance.model.locale || "en-US";
        this._filterHandler = options["filterHandler"] || null;
        this._cssClass = options["cssClass"] || null;
        this._matchCase = options["allowCaseSensitive"] || false;
        this._title = options["title"] || this._getLocalizedLabel("title");
        this.fName = null;
        this._displayName = null;
        this._dataSource = null;
        this._$colType = null;
        this._$key = 0;
        this.filteredColumn = null;
        this.sortedColumns = null;        
        this._chkList = null;
        this._listsWrap = null;
        this._menuWrap = null;
        this._localJSON = null;
        this._actualCount = 0;
        this._totalRcrd = 0;
        this._enableResponsiveRow=false;
        this._searchCount = 0;
        this._currentData = null;
        this._openedFltr = null;
        this._predicates = [];
        this.cFilteredCols = [];
        this._noDlg = [];
        this._sepAftr = ["sortDesc","notequal", "between", "top10","endswith","contains"];
        this._posType = ["number", "date", "string", "boolean"];
        this._reqInProgess = false;
        this._isFiltered = false;
        this._onActionBegin = options["actionBegin"] || null;
        this._onActionComplete = options["actionComplete"] || null;
        this._selectAll = "<div class='e-ftrchk'><input type='checkbox' class='e-selectall' value='selectall' class='e-ftrchk' /><label class='e-ftrchk'>(Select All)</label></div>";
        this._blank = "<div class='e-ftrchk'><input type='checkbox' id='blanks' class='e-ftrchk e-blanks' /><label class='e-ftrchk' for='blanks'>(Blanks)</label></div>";
        this.numberMenuOpt = [
              { id: 1, text: this._getLocalizedLabel("SortNoSmaller"), sprite: "e-sortasc e-icon e-fnsort", htmlAttribute: { "ejfnrole": "sortAsc" } },
              { id: 2, text: this._getLocalizedLabel("SortNoLarger"), sprite: "e-sortdesc e-icon e-fnsort", htmlAttribute: { "ejfnrole": "sortDesc" } },
              { id: 3, text: this._getLocalizedLabel("ClearFilter"), sprite: "e-filternone e-icon", htmlAttribute: { "ejfnrole": "clearfilter" } },
              { id: 4, text: this._getLocalizedLabel("NumberFilter"),htmlAttribute: { "ejfnrole": "popup" }, child: this._getLocalizedLabel("NumberMenuOptions") }];
        this.stringMenuOpt  = this.booleanMenuOpt = [
              { id: 1, text: this._getLocalizedLabel("SortTextAscending"), sprite: "e-sortasc e-icon e-fnsort", htmlAttribute: { "ejfnrole": "sortAsc" } },
              { id: 2, text: this._getLocalizedLabel("SortTextDescending"), sprite: "e-sortdesc e-icon e-fnsort", htmlAttribute: { "ejfnrole": "sortDesc" } },
              { id: 3, text: this._getLocalizedLabel("ClearFilter"), sprite: "e-filternone e-icon", htmlAttribute: { "ejfnrole": "clearfilter" } },
              { id: 4, text: this._getLocalizedLabel("TextFilter"), htmlAttribute: { "ejfnrole": "popup" }, child: this._getLocalizedLabel("StringMenuOptions") }];
        this.dateMenuOpt = [
              { id: 1, text: this._getLocalizedLabel("SortDateOldest"), sprite: "e-sortasc e-icon e-fnsort", htmlAttribute: { "ejfnrole": "sortAsc" } },
              { id: 2, text: this._getLocalizedLabel("SortDateNewest"), sprite: "e-sortdesc e-icon e-fnsort", htmlAttribute: { "ejfnrole": "sortDesc" } },
              { id: 3, text: this._getLocalizedLabel("ClearFilter"), sprite: "e-filternone e-icon", htmlAttribute: { "ejfnrole": "clearfilter" } },
              { id: 4, text: this._getLocalizedLabel("DateFilter"), htmlAttribute: { "ejfnrole": "popup" }, child: this._getLocalizedLabel("DateMenuOptions") }
        ];
        
        return this;
    };
    ej.excelFilter.prototype = {
        getField: function () {
            return this.fName;
        },
        getFormat: function () {
            return this._$format;
        },
        //Collection to predicate processing
        getPredicate: function (cols, field, updateModel) {
            var c, dis = field != undefined ? [field] : ej.distinct(cols, "field", false), collection, pred = {};
            for (var f = 0, flen = dis.length; f < flen; f++) {
                collection = new ej.DataManager(cols).executeLocal(new ej.Query().where("field", "equal", dis[f]));
                pred[dis[f]] = this.generatePredicate(collection);
                if (updateModel) {
                    this._predicates[this._$key] = this._predicates[this._$key] || {};
                    this._predicates[this._$key][dis[f]] = pred[dis[f]];
                }

            }
            return pred;
        },

        generatePredicate: function (cols) {
            var len = cols ? cols.length : 0, predicate, first;
            if (!len) return;
            first = cols[0];
            predicate = ej.Predicate(first.field, first.operator, first.value, first.ignoreCase || !first.matchcase);
            for (var p = 1; p < len; p++) {
                predicate = predicate[cols[p].predicate](cols[p].field, cols[p].operator, cols[p].value, cols[p].ignoreCase || !cols[p].matchcase);
            }
            return predicate || null;
        },
        /*Main Dialog*/
        renderDialog: function (type) {
            this._$colType = type;
            var dlgId = this.id + type + "_excelDlg";           
            //if ($("#" + dlgId).length != 0)
            //    return;
            var $dlg = ej.buildTag("div#" + dlgId + ".e-excelfilter e-dlgcontainer e-shadow");
            var $ul = ej.buildTag("ul#" + this.id + type + "_MenuItem");
            var menuData = this._getMenuData(type);
            $ul = this._createLiTag($ul, menuData, false);
            var $searchBox = ej.buildTag("span.e-searchbox e-fields").append(ej.buildTag("input#" + this.id + "_SearchBox.e-ejinputtext e-searchinput", {}, {}, { "type": "text", "placeholder":"Search" })).append(ej.buildTag("span.e-search e-icon"))
            var $lbox = ej.buildTag("div#" + this.id + type + "_CheckBoxList.e-checkboxlist e-fields").append(ej.buildTag("div"));
            var $btns = this._createBtn();
            var $sBox = ej.buildTag("div.e-searchcontainer");            
            var $status = ej.buildTag("div.e-status e-fields e-hide", this._getLocalizedLabel("CheckBoxStatusMsg"));
            $dlg.append($ul);            
            $sBox.append($searchBox);
            $sBox.append($status);
            $sBox.append($lbox);
            $sBox.append($btns);
            $dlg.append($sBox);
            $dlg.appendTo(this._ctrlInstance.element);
            $dlg.css("display", "none");
            this._renderCustomFDlg(type);
            this._dialogContainer = $dlg;
            if(this._cssClass!=null)
                $dlg.addClass(this._cssClass);
            if (!this._showSort) {
                $ul.find(".e-fnsort").closest("li").css("display", "none");
                $ul.find("li.e-separator:first").css("display", "none");
            }
            this._lsitBoxTemplate();
            this._renderSubCtrls(type);
            if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 10)
                this._ctrlInstance._ieClearRemover($searchBox.find("input")[0]);
            this._wireEvents();
        },
        _renderSubCtrls: function (type) {
            $("#" + this.id + type + "_MenuItem").ejMenu({ orientation: "vertical", width: 266, click: ej.proxy(this._menuHandler, this), enableRTL: this._ctrlInstance.model.enableRTL });
            $("#" + this.id + type + "_OkBtn").ejButton({ text: this._getLocalizedLabel("Ok"), showRoundedCorner: true, width: 60, click: ej.proxy(this._fltrBtnHandler, this), enabled: true });
            $("#" + this.id + type + "_CancelBtn").ejButton({ text: this._getLocalizedLabel("Cancel"), showRoundedCorner: true, width: 60, click: ej.proxy(this.closeXFDialog, this) });
            $("#" + this.id + type + "_CheckBoxList").ejScroller({ height: 130, width: 234, scroll: ej.proxy(this._virtualize,this) });
            $("#" + this.id + type + "_CheckBoxList").ejWaitingPopup({ showOnInit: false });
        },
        openXFDialog: function (options) {           
            this.fName = options["field"];
            this._dataSource = options["dataSource"];
            this._$colType = options["type"] || "string";
            this._$format = options["format"] || "";
            this._enableResponsiveRow=options["enableResponsiveRow"];
            this.filteredColumn = options["filteredColumns"] || this._ctrlInstance.model.filterSettings.filteredColumns;
            this.sortedColumns = options["sortedColumns"] || this._ctrlInstance.model.sortSettings.sortedColumns;
            this._displayName = options["displayName"];
            this._$key = options["key"] || 0;
            var args = { requestType : "filterbeforeopen", filterModel : this, columnName:this.fName, columnType: this._$colType };
            if (this._ctrlInstance._trigger(this._onActionBegin, args))
                return;
            if (this._openedFltr == null || !this._openedFltr.is($("#" + this.id + this._$colType + "_excelDlg"))) {
                this.closeXFDialog();
                this._openedFltr = $("#" + this.id + this._$colType + "_excelDlg");
            }
            this._listsWrap = $("#" + this.id + this._$colType + "_CheckBoxList");
            this._menuWrap = $("#" + this.id + this._$colType + "_MenuItem");
            this._searchBox = this._openedFltr.find(".e-searchbox input");
            this._setPosition(this._openedFltr, options["position"]);
            this._openedFltr.addClass(options["cssClass"]);
            this._openedFltr.fadeIn(300, "easeOutQuad", function () {
            });
            this._isFiltered = this._predicates[this._$key] != undefined && this._predicates[this._$key][this.fName] != undefined;
            this._$format = (this._$colType == "date") ? "{0:MM/dd/yyyy hh:mm:ss}" : this._$format;
            this._processListData();            
            this._actualCount > this._maxCount ? this._openedFltr.find("div.e-status").removeClass("e-hide") : this._openedFltr.find("div.e-status").addClass("e-hide");            
            this._setDisable();
            var args = { requestType: "filterafteropen", filterModel: this, columnName: this.fName, columnType: this._$colType };
            if (this._ctrlInstance._trigger(this._onActionComplete, args))
                return;
        },
        closeXFDialog: function (e) {
            if (e != null) {
                var $target = $(e.target);
                if ($target.closest("#"+ this.id + this._$colType + "_CustomFDlg").length)
                    return;
            }            
            if (this._openedFltr) {
                if (!this._openedFltr.hasClass("e-dlgcustom")) {
                    this._openedFltr.fadeOut(300, "easeOutQuad", function () {
                    });
                    this._listsWrap.ejWaitingPopup("hide");
                }
                else {
                    this._openedFltr.ejDialog("close");
                }
               
            }
        },
        _setPosition: function (ele, pos) {
            ele.css("position", "absolute");
            ele.css("left", pos["X"]).css("top", pos["Y"]);                      
        },
        _setDisable: function () {
            var $clr = this._menuWrap.find("li[ejfnrole='clearfilter']");
            var $sort = this._menuWrap.find("li[ejfnrole *= 'sort']"), $checked = this._listsWrap.find("input").filter(":checked:not(.e-selectall)").length;
            !this._isFiltered ? $clr.addClass("e-disable-item") : $clr.removeClass("e-disable-item");
            if (this._showSort) {
                var sQM = ej.DataManager(this.sortedColumns).executeLocal(new ej.Query().where("field", "equal", this.fName));
                ( sQM.length && sQM[0]["direction"] == "ascending") ? $sort.filter("[ejfnrole='sortAsc']").addClass("e-disable-item") : $sort.filter("[ejfnrole='sortAsc']").removeClass("e-disable-item");
                (sQM.length && sQM[0]["direction"] == "descending") ? $sort.filter("[ejfnrole='sortDesc']").addClass("e-disable-item") : $sort.filter("[ejfnrole ='sortDesc']").removeClass("e-disable-item");
            }
            if (this._$colType == "boolean")
                this._menuWrap.find("li[aria-haspopup=true]").addClass("e-hide");
            $("#" + this.id + this._$colType + "_OkBtn").ejButton({ enabled: $checked != 0 });
            this._searchBox.val(""); this._searchBox.siblings().addClass("e-search").removeClass("e-cancel");
        },
        _createBtn: function (isCDlg) {
            var id = isCDlg ? this.id + this._$colType + "Custom" : this.id + this._$colType;
            var $divCon = ej.buildTag("div.e-btncontainer e-fields");
            var $div = ej.buildTag("div");
           $div.append(ej.buildTag("input#" + id + "_OkBtn.e-fltrbtn",{},{},{ type : "button" })).append(ej.buildTag("input#" + id + "_CancelBtn.e-fltrbtn",{},{},{ type : "button" }));
            return $divCon.append($div);
        },
        _menuHandler: function (args) {
            var role = $(args.element).attr("ejfnrole");
            var arg = {};
            if (this._showSort && (role == "sortAsc" || role == "sortDesc")) {
                var sOrder, sDetails;
                sOrder = role == "sortAsc" ? "ascending" : "descending";
                sDetails = { field: this.fName, direction: sOrder };
                arg = { originalEvent: args.event, action: "sorting", sortDetails: sDetails };
            }
            else if (role == "clearfilter") {
                var ftrDetails = { field: this.fName, operator: "", value: "", predicate: "or" };
                arg = { originalEvent: args.event, fieldName: this.fName, action: "clearfiltering", filterDetails: ftrDetails };
                var indx = $.inArray(this.fName, this.cFilteredCols);
                indx!=-1 && this.cFilteredCols.splice(indx, 1);
            }
            else if(role == "popup") {
                return;
            }
            else if (role == "operator") {
                this._openCustomFilter(args.text.replace(/ /g ,"").replace("...","").toLowerCase());
            }
            if (role != "operator") {
                this._filterHandler(arg);
                this.closeXFDialog();
            }
        },
        _searchBoxFocus: function (e) {
            var $target = $(e.target);
            if ($target.hasClass("e-cancel")) {
                $target.prev().val("");
                $target.next().addClass("e-cancel")
                $target.addClass("e-search");
                $target.prev().trigger("keyup");
            }
            if (e.type == "focusin") {
                $target.next().addClass("e-cancel");
                $target.next().removeClass("e-search");
            }
        },
        _search: function (e) {
            var enterText = e.target.value, args = {}, parsed, operator, $target = $(e.target);
            parsed = parseFloat(enterText) ? parseFloat(enterText) : enterText;
            operator ="contains" ;
            parsed = (parsed == "" || parsed == undefined) ? undefined : parsed;
            this._processListData({ type: "filterchoicesearch", value: parsed, operator: operator });
            if ($target.val() == "") {
                $target.next().addClass("e-search");
                $target.next().removeClass("e-cancel");
            } else {
                $target.next().addClass("e-cancel");
                $target.next().removeClass("e-search");
            }
        },
        _getLocalizedLabel: function (property) {
            return (ej.ExcelFilter.locale[this._locale] !== undefined && ej.ExcelFilter.locale[this._locale][property] !== undefined) ? ej.ExcelFilter.locale[this._locale][property] : ej.ExcelFilter.locale["en-US"][property];
        },
        _getMenuData: function (type) {
            return type != undefined ? this[type + "MenuOpt"] : [];
        },
        /*CheckBox list*/
        _lsitBoxTemplate: function () {
            var helper = {}, temp = {};            
           helper[this.id + "_getField"] = ej.proxy(this.getField, this);
            helper[this.id + "_getFormat"] = ej.proxy(this.getFormat, this);
            helper[this.id + "_checkBoxState"] = ej.proxy(this._setCheckState, this);
            helper[this.id + "_formatData"] = ej.proxy(this._formatting, this);
            helper[this.id + "_genId"] = this._genCheckID;
            $.views.helpers(helper);            
            var formatData = (this._formatFiltering || this._$colType == "date") ? "{{:~" + this.id + "_formatData(~" + this.id + "_getFormat(),#data[~" + this.id + "_getField()])}}" : "{{:#data[~" + this.id + "_getField()]}}";
            var valueFormat = (this._formatFiltering || this._$colType == "date") ? "{{:~" + this.id + "_formatData(~" + this.id + "_getFormat(),#data[~" + this.id + "_getField()])}}" : "{{:#data[~" + this.id + "_getField()]}}";
            var genID = this.id + this._$colType + "{{:~" + this.id + "_genId()}}";
            temp[this.id + this._$colType + "_listBox_Template"] = "<div class='e-ftrchk'><input type='checkbox' id='" + genID + "' value='" + valueFormat + "' class='e-ftrchk' {{:~" + this.id + "_checkBoxState(#data[~" + this.id + "_getField()])}}/><label class='e-ftrchk' for='" + genID + "'>" + formatData + "</label></div>";
            $.templates(temp);
        },
      
        _processListData: function (params) {
            var result, promise, args = {}, query = new ej.Query(), evtArgs = {}; this._searchCount = 0;
            var predicates = this._predicates[this._$key], pred;
            for (var prop in predicates) {
                if (prop == this.fName)
                    continue;
                var obj = predicates[prop], from = obj["from"];
                if (from)
                    query.skip(from == "top" ? 0 : this._dataSource.length - (this._dataSource.length - obj["take"])).take(obj["take"]);
                else
                    pred = pred != undefined ? pred["and"](obj) : obj;
            }
            args.columnName = this.fName;           
            query.requiresCount();
            pred && query.where(pred);
            evtArgs.requestType = params ? params.type : "filterchoicerequest",evtArgs.filterModel = this, evtArgs.query = query, evtArgs.dataSource = this._dataSource;
            if (this._ctrlInstance._trigger(this._onActionBegin, evtArgs))
                return;
            if (params && params.type == "filterchoicesearch") {
                params.value && query.where(this.fName, params.operator, params.value, !this._matchCase);
                promise = ej.DataManager(this._localJSON).executeLocal(query);               
                args.data = this._currentData = promise.result;
                args.type = params.type;
                this._totalRcrd = this._searchCount =  promise.count;
                this._setCheckBoxList(args);
            }
            else if (!(this._dataSource instanceof ej.DataManager)) {
                promise = ej.DataManager(this._dataSource).executeLocal(query);
                args.type = "filterchoicerequest";
                args.data = this._localJSON = this._currentData = promise.result;
                this._totalRcrd = promise.count;
                this._setCheckBoxList(args);
            }
            else {
                proxy = this; args.type = "filterchoicerequest";
                this._listsWrap.ejWaitingPopup("show");
                if (!this._reqInProgess) {
                    this._reqInProgess = true;
                    promise = this._dataSource.executeQuery(query);
                    promise.done(function (e) {
                        args.data = proxy._localJSON = proxy._currentData = e.result;
                        proxy._totalRcrd = e.count;
                        proxy._listsWrap.ejWaitingPopup("hide");
                        proxy._setCheckBoxList(args);
                        proxy._reqInProgess = false;
                    });
                }
            }           
        },
        _setCheckBoxList: function (args) {
            var evtArgs = {};
            evtArgs.requestType = args.type, evtArgs.dataSource = this._dataSource,evtArgs.filterModel = this;
            if (this._currentData.length != 0) {
                var sorts = ej.distinct(args.data, args.columnName, true);
                var sortedData = ej.mergeSort(sorts, args.columnName), flag = this._isFiltered;
                this._actualCount = sorts.length; sortedData.length = this._maxCount > this._actualCount ?this._actualCount : this._maxCount;
                this._blank = (ej.DataManager(sortedData).executeLocal(new ej.Query().where(ej.Predicate(args.columnName, "equal", null)))) ? "" : this._blank;
                this._listsWrap.find("div:first").html([this._selectAll, $.render[this.id + this._$colType + "_listBox_Template"](sortedData), this._blank].join(""));                
                this._chkList = this._listsWrap.find("input:checkbox").not(".e-selectall"), $inView = this._chkList.slice(0, 20);
                $inView.ejCheckBox({ change: ej.proxy(this._checkHandler, this) });
                $inView.filter(":checked").ejCheckBox({ checked: true });
                this._listsWrap.find(".e-selectall").ejCheckBox({  change: ej.proxy(this._selectAllHandler, this) });
				this._listsWrap.find(".e-selectall").attr("id",this.id + this._$colType + "SelectAll");
				this._listsWrap.find(".e-selectall").closest("span").siblings("label").attr("for", this.id + this._$colType + "SelectAll");
            }
            else
                this._listsWrap.find("div:first").html(ej.buildTag("div.e-ftrchk", this._getLocalizedLabel("NoResult"), {}, {}));
            if (!this._isFiltered || this._actualCount == this._chkList.filter(":checked").length)
                this._listsWrap.find(".e-selectall").ejCheckBox({ checked: true });
            this._listsWrap.ejScroller({ scrollTop: 0 }).ejScroller("refresh");
            if (this._ctrlInstance._trigger(this._onActionComplete, evtArgs))
                return;
        },
     
        _createLiTag: function ($ul, menuData, isChild) {
            proxy = this;
            $.each(menuData, function (index, obj) {
                var $li = ej.buildTag("li", {}, {}, obj["htmlAttribute"] || (isChild && { "ejfnrole": "operator" }) || {}), $child;
                var apd = (isChild && $.inArray(obj.value,proxy._noDlg)==-1) ? "..." : "";
                var $a = ej.buildTag("a", obj.text + apd, {}, {});
                obj["sprite"] != undefined && $a.append(ej.buildTag("span", {}, {}, { "class": obj["sprite"] }))
                if (obj["child"] != undefined)
                    $child = proxy._createLiTag(ej.buildTag("ul.e-shadow"), obj["child"], true);

                obj["child"] == undefined ? $ul.append($li.append($a)) : $ul.append($li.append($a).append($child))
                if ($.inArray(obj.value || (obj.htmlAttribute && obj.htmlAttribute.ejfnrole), proxy._sepAftr) != -1)
                    $ul.append(ej.buildTag("li.e-separator"));
            });
            return $ul;
        },
        _setCheckState: function (value) {           
            var val = this._$colType == "boolean" ? value.toString() : value;
            if (!this._isFiltered)
                return "checked";            
            else {
                var fC = ej.DataManager(this.filteredColumn).executeLocal(ej.Query().where("field", "equal", this.fName)), fQ;
                fQ = ej.DataManager(fC).executeLocal(ej.Query().where("value", "equal", val));
                return fQ.length != 0 ? "checked" : "";            
            }
        },
        _genCheckID: function () {
            return "CheckBox" + this.getIndex();
        },
        _formatting: function (format, value) {
            if (this._$colType == "date" && (format =="" || !this._formatFiltering))
                format = "{0:MM/dd/yyyy hh:mm:ss}";
            if (value == undefined || value === "" || value == null)
                return "(Blanks)";
            if (this._formatFiltering || this._$colType == "date") {
                var formatter = ej.Grid.prototype.formatting;                
                    return  format!="" ? formatter(format, value):value;                
            } 
        },
        _checkHandler: function (args) {
            $("#" + args.model.id).prop("checked", args.isChecked);
            var $checkedlist = this._listsWrap.find("input").filter(":checked:not(.e-selectall)"), clen = $checkedlist.length;
            var $selectall = this._listsWrap.find(".e-selectall"), canCheck;
            if (clen == this._chkList.length) {
                $selectall.prop("checked", true);
                canCheck = true;
            }
            else {
                $selectall.removeProp("checked");
                canCheck = false;
            }
            $selectall.ejCheckBox({ checked: canCheck });
            $("#" + this.id + this._$colType + "_OkBtn").ejButton({ enabled: clen != 0 });
        },
        _selectAllHandler: function (args) {
            
            if (args.isChecked) {
                this._chkList.filter(":not(:checked)").ejCheckBox({ checked: args.isChecked });
                this._chkList.prop("checked", true);
            }
            else {
                this._chkList.filter(function () { if ($(this).hasClass("e-checkbox") && $(this).prop("checked")) return this; }).ejCheckBox({ checked: args.isChecked });
                this._chkList.removeProp("checked"); this._chkList.removeAttr("checked");
            }
            $("#" + this.id + this._$colType + "_OkBtn").ejButton({ enabled: args.isChecked });
        },
        /*Custom Dialog*/
        _renderCustomFDlg: function (type) {
            var dlgId = this.id + type + "_CustomFDlg";
            if ($("#" + dlgId).length)
                return;
            var $dlg = ej.buildTag("div#" + dlgId + ".e-excelfilter e-dlgcustom");
            $dlg.addClass(this._cssClass);
            this._renderCDlgContent($dlg, type);
            $dlg.ejDialog({ showOnInit: false, enableResize: false, enableModal:true, allowKeyboardNavigation: false, title: this._title, width: 370,content:"#" + this.id, enableRTL:this._ctrlInstance.model.enableRTL , closeIconTooltip:"Close" });
        },

        _renderCDlgContent: function (content, type) {
            var $div1 = ej.buildTag("div.e-dlgfields", "Show rows where", {}, {});
            var $id = this.id + this._$colType;
            var $fset = ej.buildTag("fieldset.e-fieldset");
            var $op1 = ej.buildTag("tr.e-fields"), $op2 = ej.buildTag("tr.e-fields"), $op3 = ej.buildTag("tr.e-fields e-top");
            var $dp1 = ej.buildTag("input#" + $id + "_CustomDrop1"), $dp2 = ej.buildTag("input#" + $id + "_CustomDrop2"), $dp3 = ej.buildTag("input#" + $id + "_CustomDrop3");
            var $in1 = ej.buildTag("input#" + $id + "_CustomValue1.e-ejinputtext", {}, {}, { "type": "text" }), $in2 = ej.buildTag("input#" + $id + "_CustomValue2.e-ejinputtext", {}, {}, { "type": "text" }), $in3 = ej.buildTag("input#" + $id + "_CustomValue3.e-ejinputtext", {}, {}, { "type": "text" });
            var $pred = ej.buildTag("tr.e-predicate");
            var radioAnd = ej.buildTag("input#" + $id + "_CustomAndPredicate", {}, {}, { "type": "radio", "name": "predicate" , "value":"and" }), radioOr = ej.buildTag("input#" + $id + "_CustomOrPredicate", {}, {}, { "type": "radio", "name": "predicate", "value":"or" });
            var matchCase = ej.buildTag("input#" + $id + "_CustomMatchPredicate", {}, {}, { "type": "checkbox" });
            content.append($div1);
            var table = ej.buildTag("table.e-optable");

            $op1.append(ej.buildTag("td.e-operator").append($dp1))
                .append(ej.buildTag("td.e-value").append($in1));
            $pred.append(ej.buildTag("td", {}, {}, {}).append(radioAnd).append(ej.buildTag("label.e-caption", this._getLocalizedLabel("PredicateAnd"), {}, { "for": $id + "_CustomAndPredicate" }))
                .append(radioOr).append(ej.buildTag("label.e-caption", this._getLocalizedLabel("PredicateOr"), {}, { "for": $id + "_CustomOrPredicate" })));
            $op2.append(ej.buildTag("td.e-operator").append($dp2))
                .append(ej.buildTag("td.e-value").append($in2));
            table.append($op1)
            .append($pred)
            .append($op2);
			if(type == "string")
			    $pred.append(ej.buildTag("td", {}, {}, {}).append(matchCase).append(ej.buildTag("label.e-caption", this._getLocalizedLabel("MatchCase"), {}, { "for": $id + "_CustomMatchPredicate" })));
            if (type == "number") {
                $op3.append(ej.buildTag("td.e-operator").append($dp3))
                .append(ej.buildTag("td.e-value").append($in3));
                table.append($op3)
            }
            $fset.append(ej.buildTag("legend"))
                .append(table)
            content.append(ej.buildTag("div.e-dlgfields").append($fset));
            content.append(ej.buildTag("div.e-dlgfields").append(this._createBtn(true)));
            content.appendTo("body");
            var uppertype = type.replace(type.charAt(0), type.charAt(0).toUpperCase());
            $([$dp1, $dp2, $dp3]).ejDropDownList({ fields: { text: "text", value: "value" }, height: 27, width: 120, enableRTL: this._ctrlInstance.model.enableRTL });
            if (type == "number") {
                $([$in1, $in2, $in3]).ejNumericTextbox({ showSpinButton: false, height: "27px", width: "177px", enableRTL: this._ctrlInstance.model.enableRTL });
            }
            else if (type == "date") {
                $([$in1, $in2]).ejDatePicker({ "cssClass": this._ctrlInstance.model.cssClass, height: "27px", width: "177px", "enableRTL": this._ctrlInstance.model.enableRTL, watermarkText: this._getLocalizedLabel("DatePickerWaterMark") });
            }
            else if (type == "string") {
                $([$in1, $in2]).ejAutocomplete({ "cssClass": this._ctrlInstance.model.cssClass, "enableRTL": this._ctrlInstance.model.enableRTL, enableDistinct: true, width:"177px",height:"27px" });
            }
            $([radioAnd, radioOr]).ejRadioButton({ "cssClass": this._ctrlInstance.model.cssClass, "enableRTL": this._ctrlInstance.model.enableRTL });
            matchCase.ejCheckBox({ });
            $("#" + $id + "Custom_OkBtn").ejButton({ text: this._getLocalizedLabel("Ok"), showRoundedCorner: true, width:"23%", click: ej.proxy(this._fltrBtnHandler, this), enabled: true });
            $("#" + $id + "Custom_CancelBtn").ejButton({ text: this._getLocalizedLabel("Cancel"), showRoundedCorner: true, width: "23%", click: ej.proxy(this.closeXFDialog, this) })
        },
                     
        _openCustomFilter: function (operator) {
            var oper = operator != "top10" ? this._$colType: operator;
            var type = oper.replace(oper.charAt(0), oper.charAt(0).toUpperCase());
            var id = this.id + this._$colType;
            this.closeXFDialog();
            this._openedFltr = $("#" + id + "_CustomFDlg");
            var args = { requestType: "filterbeforeopen", filterModel: this, columnName: this.fName, columnType: this._$colType, isCustomFilter: true };
            if (this._ctrlInstance._trigger(this._onActionBegin, args))
                return;
            this._openedFltr.ejDialog("open");            
            this._openedFltr.find("legend").html(this._displayName);            
            var sl = (["Number","Date"].indexOf(type) != -1) ? 6 : 5;
            $("#" + id + "_CustomDrop1").ejDropDownList({ dataSource: this._getLocalizedLabel(type + "MenuOptions").slice(0,sl) });
            $("#" + id + "_CustomDrop2").ejDropDownList({ dataSource: this._getLocalizedLabel(type + "MenuOptions").slice(0, sl) });
			if (this._$colType == "number") {
                var decimalPlace = 0;
                if(operator == "top10"){
                    this._openedFltr.find(".e-optable tr").not(".e-top").addClass("e-hide");   
                    this._openedFltr.find(".e-optable tr.e-top").removeClass("e-hide");
                    $("#" + id + "_CustomDrop3").ejDropDownList({ dataSource: this._getLocalizedLabel(type + "MenuOptions") });
                }
                else{                   
                    decimalPlace = parseInt(this._$format.split("{0:C")[1]) || parseInt(this._$format.split("{0:c")[1]);                    
                    this._openedFltr.find(".e-optable tr.e-top").addClass("e-hide");
                    this._openedFltr.find(".e-optable tr").not(".e-top").removeClass("e-hide"); 
                    $("#" + id + "_CustomValue1").ejNumericTextbox("model.decimalPlaces", decimalPlace);
                    $("#" + id + "_CustomValue2").ejNumericTextbox("model.decimalPlaces", decimalPlace);
                }
            }
            else {
                this._openedFltr.find(".e-optable tr.e-top").addClass("e-hide");
                this._openedFltr.find(".e-optable tr").not(".e-top").removeClass("e-hide");
            }
            if(this._$colType == "string")
                this._openedFltr.find(".e-autocomplete").ejAutocomplete({
                    fields: { text: this.fName }, dataSource: this._dataSource, focusIn: function (args) {
                        var type = this.element.closest("td").siblings().find(".e-dropdownlist").ejDropDownList("getSelectedValue");
                        var $matchCase = this.element.closest(".e-dialog-scroller").find(".e-checkbox").prop("checked");
						 this.model.caseSensitiveSearch = $matchCase;
						 this.model.filterType = type == "" ? this.model.filterType : type;
                    }
                });
            this._setFilteredData(id, operator);
            var args = { requestType: "filterafteropen", filterModel: this, columnName: this.fName, columnType: this._$colType, isCustomFilter: true };
            if (this._ctrlInstance._trigger(this._onActionComplete, args))
                return;
        },

        _setFilteredData: function ($id, op) {
            var indx = $.inArray(this.fName, this.cFilteredCols);
            var fQM = [], optrs = [], fLen;
            var between = ["greaterthanorequal", "lessthanorequal"];
            if (op == "top10")
                return;
            if (indx != -1)
                fQM = ej.DataManager(this._ctrlInstance.model.filterSettings.filteredColumns).executeLocal(ej.Query().where("field", "equal", this.fName));
            fLen = fQM.length;
            var drops = this._openedFltr.find(".e-dropdownlist"), inputs = this._openedFltr.find(".e-value input:visible"), $pred = this._openedFltr.find(".e-predicate");            
            if (indx != -1 && fLen && fQM[0]["from"]!=undefined)
                optrs = [op, ""];
            else if (indx != -1 && fLen && fQM[0]["isCustom"])
                optrs = [fQM[0]["operator"], fQM[1] ? fQM[1]["operator"] : ""];
            else if (op == "between" || op == "customfilter")
                optrs = op != "customfilter" ? between : ["", ""];           
            else
                optrs = [op, ""];
           
            for (var i = 0; i < (indx != -1 ? fLen : 2) ; i++) {
                var opt = /\D*/.exec(optrs[i])[0];
                $(drops[i]).prop("value", opt);
                $(drops[i]).ejDropDownList("setSelectedValue", opt);
				 $(drops[i]).ejDropDownList({ change: function(arg){ 
					this.element.closest(".e-fields").find(".e-autocomplete").val("");
				 }});
                if ($(inputs[i]).hasClass("e-datepicker"))   
                    $("#" + inputs[i].id ).ejDatePicker("model.value", (indx != -1 && fLen && fQM[i]["isCustom"]) ? fQM[i]["value"] : null );                                
                else
                    $(inputs[i]).val((indx != -1 && fLen && fQM[i]["isCustom"]) ? fQM[i]["value"] : "");
               var $pre = (indx != -1 && fLen && fQM[i]["isCustom"]) ? fQM[i]["predicate"] : "and";
				$pred.find("input[value=" + $pre + "]").ejRadioButton({checked:  true});
				if(this._$colType == "string"){
					var $match = (indx != -1 && fLen && fQM[i]["isCustom"]) ? fQM[i]["matchcase"] : false;
					$pred.find("input[type='checkbox']").ejCheckBox({checked: $match, change: function(arg){ 
						this.element.closest(".e-dialog-scroller").find(".e-autocomplete").val("");
					}});
				}
            }            
        },
        _setDateObject: function (filterObject) {
            if (filterObject.value != null) {
                var $prevDate = new Date(filterObject.value.setDate(filterObject.value.getDate() - 1));
                var $nextDate = new Date(filterObject.value.setDate(filterObject.value.getDate() + 2));
                var $prevObj = $.extend({}, filterObject);
                var $nextObj = $.extend({}, filterObject);
                $prevObj.value = $prevDate;
                $nextObj.value = $nextDate;
                if (filterObject.operator == "equal") {
                    $prevObj.operator = "greaterthan";
                    $prevObj.predicate = "and";
                    $nextObj.operator = "lessthan";
                    $nextObj.predicate = "and";
                } else {
                    $prevObj.operator = "lessthanorequal";
                    $prevObj.predicate = "or";
                    $nextObj.operator = "greaterthanorequal";
                    $nextObj.predicate = "or";
                }
                var predicate = ej.Predicate($prevObj.field, $prevObj.operator, $prevObj.value, !$prevObj.matchcase);
                predicate = predicate[$nextObj.predicate]($nextObj.field, $nextObj.operator, $nextObj.value, !$nextObj.matchcase);
                filterObject.ejpredicate = predicate;
                return filterObject;
            }
            else
                return filterObject;
        },
        _getCDlgFields: function () {
            var dropDowns = this._openedFltr.find(".e-dropdownlist:visible");
            var $match = this._openedFltr.find(".e-checkbox"), matchcase = true,valueColl = [];
            var $inputs = this._openedFltr.find(".e-value input:visible");
            for (var i = 0,len = dropDowns.length; i < len; i++) {
                var dvalue = $(dropDowns[i]).ejDropDownList("getSelectedValue"), value;
                if (this._$colType == "number")
                    value = parseFloat($inputs.eq(i).ejNumericTextbox("model.value"));
                if (this._$colType == "string") {
                    value = $inputs.eq(i).val();
                    matchcase = $match.is(":checked");
                }
                if (this._$colType == "date") 
                    value = $inputs.eq(i).ejDatePicker("model.value");
                if (dvalue == "top" || dvalue == "bottom") {
                    valueColl.push({ field: this.fName, value: "", predicate: this._openedFltr.find(".e-predicate input[type='radio']:checked").val(), operator:"notequal", matchcase: matchcase, isCustom: true, take: value , from:dvalue });
                }
                else if (dvalue != "") {
                    var filterObj = { field: this.fName, value: value, predicate: this._openedFltr.find(".e-predicate input[type='radio']:checked").val(), operator: dvalue.toLowerCase(), matchcase: matchcase, isCustom: true };
                    valueColl.push((this._$colType == "date" && ["equal", "notequal"].indexOf(dvalue.toLowerCase()) != -1) ? this._setDateObject(filterObj) : filterObj);
                }
                else
                    return valueColl;
            }
            return valueColl;
        },
      
        _fltrBtnHandler: function (args) {
            var matchcase, valColl = [], arg = {}, predicate, fObj;
            if (!this._openedFltr.hasClass("e-dlgcustom")) {
                if (!this._isFiltered && this._listsWrap.find(".e-selectall").ejCheckBox("model.checked") && this._searchCount == 0) 
                    return this.closeXFDialog();                                  
                var checked = this._listsWrap.find("input").filter(":checked:not(.e-selectall)");
                var len = checked.length, cVal;
                var optr = this._colType == "string" ? "startswith" : "equal";
                var _isCase = this._colType == "string" ? this._matchCase : true;
                for (var i = 0; i < len; i++) {
                    cVal = $(checked[i]).hasClass("e-blanks") ? null : checked[i].value;
                    fObj = { field: this.fName, value: this._$colType == "boolean" ? Boolean(cVal) : cVal, predicate: "or", operator: optr, matchcase: _isCase };
                     if (this._$colType == "date") {
                         fObj.value = Globalize.parseDate(checked[i].value, this._$format.replace("{0:", "").replace("}", ""));                         
                         valColl.push(this._setDateObject(fObj));
                     }
                     else
                         valColl.push(fObj);
                }
            }
            else {
                valColl = this._getCDlgFields();
                $.inArray(this.fName, this.cFilteredCols) == -1 && this.cFilteredCols.push(this.fName);
            }
            var firstVal = valColl[0], isTake = firstVal["from"];
            if (firstVal.value != null) {
                predicate = firstVal["ejpredicate"] ? firstVal["ejpredicate"] : ej.Predicate(firstVal.field, firstVal.operator, firstVal.value, !firstVal.matchcase);
                for (var j = 1, jlen = valColl.length; j < jlen; j++) {
                    predicate = valColl[j].ejpredicate != undefined ? predicate[valColl[j].predicate](valColl[j].ejpredicate) : predicate[valColl[j].predicate](valColl[j].field, valColl[j].operator, valColl[j].value, !valColl[j].matchcase);
                }
                arg = { action: "filtering", filterCollection: valColl, fieldName: this.fName, ejpredicate: predicate };
                if (this._predicates[this._$key] == undefined)
                    this._predicates[this._$key] = {};
                this._predicates[this._$key][this.fName] = !isTake ? predicate : { from: firstVal["from"], take: firstVal["take"] };
                this.closeXFDialog();
                this._filterHandler(arg);
            }
        },
        _virtualize: function (e) {
            var height = $("#" + this.id + this._$colType + "_CheckBoxList").height();
            var chks = this._chkList.not(".e-checkbox").filter(function () { if (this.offsetTop > e.scrollTop - this.offsetHeight && e.scrollTop + height+70 > this.offsetTop + this.offsetHeight) return this; });
            if (chks.length == 0) return;
            chks.filter(":checked").ejCheckBox({ checked: true }); chks.filter(":not(:checked)").ejCheckBox({ checked: false });
            chks.ejCheckBox({ change: ej.proxy(this._checkHandler, this) });
        },
        resetExcelFilter: function (template) {
            var _i, _type, _id = this.id,_len, _$id;
            this._predicates = [];
            this._isFiltered = false;
            this.cFilteredCols = [];
            for (_i = 0, _len = this._posType.length; _i < _len; _i++) {
                _type = this._posType[_i], _$id = _id + _type;
                var cDlg = $("#" + _$id + "_CustomFDlg");               
                $("#" + _$id + "_CheckBoxList").ejWaitingPopup("destroy"); $("#" + _$id + "_excelDlg").remove();
                cDlg.find(".e-dropdownlist").ejDropDownList("destroy");
                cDlg.find(".e-button").ejButton("destroy");
                if (_type == "string" || _type == "boolean") cDlg.find(".e-autocomplete").ejAutocomplete("destroy");
                if (_type == "number") cDlg.find(".e-numerictextbox").ejNumericTextbox("destroy");
                if (_type == "date") cDlg.find(".e-datepicker").ejDatePicker("destroy");
                cDlg.ejDialog("destroy");
                $("#" + _$id + "_CustomFDlg").remove();
            }
        },
        _wireEvents: function () {
            this._ctrlInstance._on(this._dialogContainer, "focus click", ".e-searchbox", ej.proxy(this._searchBoxFocus, this));
            this._ctrlInstance._on(this._dialogContainer, "keyup", ".e-searchbox input", ej.proxy(this._search, this));
        }
    };

    ej.ExcelFilter.locale = ej.ExcelFilter.locale || {};
    ej.ExcelFilter.locale["en-US"] = {
        SortNoSmaller: "Sort Smallest to Largest",
        SortNoLarger: "Sort Largest to Smallest",
        SortTextAscending: "Sort A to Z",
        SortTextDescending: "Sort Z to A",
        SortDateOldest: "Sort by Oldest",
        SortDateNewest:"Sort by Newest",
        ClearFilter: "Clear Filter",
        NumberFilter: "Number Filters",
        TextFilter: "Text Filters",
        DateFilter: "Date Filters",
        StringMenuOptions: [{ text: "Equal", value: "equal" }, { text: "Not Equal", value: "notequal" }, { text: "Starts With", value: "startswith" }, { text: "Ends With", value: "endswith" }, { text: "Contains", value: "contains" }, { text: "Custom Filter", value: "customfilter" }],
        NumberMenuOptions: [{ text: "Equal", value: "equal" }, { text: "Not Equal", value: "notequal" }, { text: "Less Than", value: "lessthan" }, { text: "Less Than Or Equal", value: "lessthanorequal" }, { text: "Greater Than", value: "greaterthan" }, { text: "Greater Than Or Equal", value: "greaterthanorequal" }, { text: "Between", value: "between" }, { text: "Custom Filter", value: "customfilter" }],
        DateMenuOptions: [{ text: "Equal", value: "equal" }, { text: "Not Equal", value: "notequal" }, { text: "Less Than", value: "lessthan" }, { text: "Less Than Or Equal", value: "lessthanorequal" }, { text: "Greater Than", value: "greaterthan" }, { text: "Greater Than Or Equal", value: "greaterthanorequal" }, { text: "Between", value: "between" }, { text: "Custom Filter", value: "customfilter" }],
        Top10MenuOptions: [{ text: "Top", value: "top" }, { text: "Bottom", value: "bottom" }],
        title:"Custom Filter",
        PredicateAnd: "AND",
        PredicateOr: "OR",
        Ok: "OK",
        MatchCase: "Match Case",
        Cancel: "Cancel",
        NoResult: "No Matches Found",
        CheckBoxStatusMsg: "Not all items showing",
        DatePickerWaterMark: "Select date"
    };

})(jQuery, Syncfusion);