﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;
using System.ServiceModel.Activation;
using Syncfusion.Olap.Manager;
using Syncfusion.Olap.Reports;
using Syncfusion.JavaScript.Olap;
using System.Web.Script.Serialization;


namespace WebApplication7.wcf
{
    // NOTE: You can use the "Rename" command on the "Refactor" menu to change the class name "OlapChartService" in code, svc and config file together.
    // NOTE: In order to launch WCF Test Client for testing this service, please select OlapChartService.svc or OlapChartService.svc.cs at the Solution Explorer and start debugging.
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
    public class OlapChartService : IOlapChartService
    {
        JavaScriptSerializer serializer = new JavaScriptSerializer();
        OlapChart htmlHelper = new OlapChart();
        static string connectionString = "Data Source=http://bi.syncfusion.com/olap/msmdpump.dll; Initial Catalog=Adventure Works DW 2008 SE;";
       //static string connectionString = "Data Source=D:\\Adventure_Works_Ext.cub; provider=MSOLAP;";
        OlapDataManager DataManager = new OlapDataManager(connectionString);
      
        //This method provides the required information from the server side to initialize the OlapChart.
        public Dictionary<string, object> InitializeChart(string action, string customObject)
        {
            OlapDataManager DataManager = null;
            dynamic customData = serializer.Deserialize<dynamic>(customObject.ToString());
            
                DataManager = new OlapDataManager(connectionString);
            DataManager.SetCurrentReport(CreateOlapReport());
            return htmlHelper.GetJsonData(action, DataManager);
        }
        //This method provides the required information from the server side while drill up/down operation is performed in OlapChart.
        public Dictionary<string, object> DrillChart(string action, string drilledSeries, string olapReport)
        {
            DataManager.SetCurrentReport(Utils.DeserializeOlapReport(olapReport));
            return htmlHelper.GetJsonData(action, DataManager, drilledSeries);
        }

        //This method carries information about the default report rendered within OlapChart initially. 
        private OlapReport CreateOlapReport()
        {
            OlapReport olapReport = new OlapReport();
            olapReport.Name = "Default Report";
            olapReport.CurrentCubeName = "Adventure Works";

            DimensionElement dimensionElementRow = new DimensionElement();
            dimensionElementRow.Name = "Customer";
            dimensionElementRow.AddLevel("Customer Geography", "Customer");

            MeasureElements measureElementColumn = new MeasureElements();
            measureElementColumn.Elements.Add(new MeasureElement { Name = "Internet Sales Amount" });

            DimensionElement dimensionElementColumn= new DimensionElement();
            dimensionElementColumn.Name = "Date";
            dimensionElementColumn.AddLevel("Fiscal", "Fiscal Year");

            olapReport.SeriesElements.Add(dimensionElementRow);
            olapReport.CategoricalElements.Add(dimensionElementColumn);
            olapReport.CategoricalElements.Add(measureElementColumn);
            return olapReport;
        }


    }

}
