﻿/**
* @fileOverview Plugin to style the Html Schedule elements
* @copyright Copyright Syncfusion Inc. 2001 - 2014. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.2
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/

(function ($, ej, undefined) {
    ej.scheduleFeatures = ej.scheduleFeatures || {};

    var monthCellsTemplate = function () {
        this._monthCellsTemplate = ("<table class='e-table e-workcellstab'  height='100%'width='100%' cellpadding='0px' cellspacing='0px'>" +
        "<tbody>{{for cellrows ~cols1=cols1}}" +
        "<tr>{{for ~cwidth=cwidth ~cheight=cheight ~cols1}}" +
        "<td class='e-monthcells' width='{{:~cwidth}}' height='{{:~cheight}}'>" +
        "<div class='e-monthheader'></div><div class='e-appointwrapper'>" +
        "</td>{{/for}}" +
        "</tr>{{/for}}" +
        "</tbody></table>");
        return this._monthCellsTemplate;
    };

    var appointmentTemplate = function () {
        this._appTemplate = ("<div class='{{:appClass}} {{:appointCustomcss}}' id='Appointment_{{:id}}' role='presentation' style='{{if rtl == true}}right{{else}}left{{/if}}: {{:left}}; width: {{:appWidth}}; background: {{:appointData}};  color:{{:appointtextcolor}}; height: {{:appHeight}}px; top: {{:top}}px;' >"
        + "{{if appClass == 'e-appointment'}}" +
        "{{if orientation == 'vertical'}}<div class='e-tophandle'></div><div class='e-bottomhandle'></div>{{else}}<div class='e-lefthandle'></div><div class='e-righthandle'></div>{{/if}}" +
        "{{else}}<div class='e-lefthandle'></div><div class='e-righthandle'></div>" +
        "{{/if}}{{if userAppTemplId == false}}" +
       "<div class='e-appointinnertext'><div class='e-apptext'>{{:subject}} </div><div class='e-apptime'> {{:startTime}} - {{:endTime}}</div>"
        +"{{if value == true}}"+
        "<div class='e-multipleCategory'>{{:multiDiv}}</div>{{/if}}</div>" +
        "{{else}}{{:userTemplate}}{{/if}}</div>");
        return this._appTemplate;
    };

     var categorizeMultipleTemplate = function () {
        this._categorizeMultipleTemplate = (
            "{{for renderData }}<div style='background:{{:value}};height:11px;width:6px;float:left'>" +
            "</div>{{/for}}"
            );
        return this._categorizeMultipleTemplate;
    };

    var headerTemplate = function () {
        this._headerTemplate = (
        "{{for cols ~view=view ~colspan=colspan}}" +
        "<td class='e-headercells' colspan='{{:~colspan}}'>" +
        "<div class='e-dateheadercell'> <span class='e-headerdaydisplay'>{{:currentDay}}</span></div>" +
        "</td>" +
        "{{/for}}");
        return this._headerTemplate;
    };
    var leftHeaderTemplate = function () {
        this._leftIndent = ("<table class='e-table e-leftindenttable' width='{{:cswidth}}' cellpadding='0px' cellspacing='0px'>" +
        "<tbody> {{for trs ~tdClass=tdClass ~divClass=divClass}} <tr>{{for ~tdClass=tdClass ~divClass=divClass}} <td class='{{:~tdClass}}'style='height:27px;'> <div class='{{:~divClass}}'></div></td>{{/for}}</tr>" +
        "{{/for}}</tbody></table>");
        return this._leftIndent;
    };
    var alldayTemplate = function () {
        this._alldayTemplate = (
     "{{for cols ~colspan=colspan}} <td class='e-alldaycells' style='height:27px;' colspan='{{:~colspan}}'> </td>" +
        "{{/for}}");
        return this._alldayTemplate;
    };

    var workCellsTemplate = function () {
        this._workCellsTemplate = ("<table class='e-table e-workcellstab' height='100%'width='100%' cellpadding='0px' cellspacing='0px'>" +
        "<tbody >{{for cellrows ~cols1=cols1}}" +
        "<tr>{{for ~index=#index ~cwidth=cwidth ~cheight=cheight ~cols1 }}" +
        "{{if (~index+1) % 2 == 0 }}<td class='e-workcells' width='{{:~cwidth}}' height='{{:~cheight}}'>{{else}}<td class='e-workcells e-alternatecells'width='{{:~cwidth}}' height='{{:~cheight}}'>{{/if}}<div class='e-appointwrapper'></div></td>" +
        "{{/for}}" +
        "</tr>" +
        "{{/for}}</tbody></table>");
        return this._workCellsTemplate;
    };

    var timeCellsTemplate = function () {
        this._timeCellsTemplate = ("<div class='e-scrolltimecells'><table class='e-table e-timecelltable' cellpadding='0px' cellspacing='0px'>" +
        "<tbody>{{for timerows ~cols1=cols1 ~view1=viewclass}}" +
        "<tr>{{for ~name=time ~id=id ~view=~view1 }} " +
        "{{if ~view == 0}}<td class='e-timecells'><div class='e-timecelldivs'>{{:~name.slice(0,2)}}</div>" +
        "</td> <td class='e-timecells' rowspan='1'>{{for ~cols1}}{{if (#index+1)%2 ==0}}<div class='e-ampmdisplay'></div>{{else}}<div id='{{:~id}}' class='e-ampmdisplay e-ampmstyle'>{{:~name.slice(3,5)}}</div> {{/if}}{{/for}} </td>{{else}}<td class='e-timecells' style='width:51px;'><div class='e-timecelldivs'></div></td>{{/if}}{{/for}}</tr>{{/for}}</tbody></table></div>");
        return this._timeCellsTemplate;
    };

    /**
    * @namespace ej
    * @class ejSchedule
    * @requires jQuery
    * @requires jquery.easing.min.js
    * @requires jquery.globalize.min.js    
    * @requires jsrender.min.js
    * @requires ej.core.js
    * @requires ej.data.js
    * @requires ej.schedule.js
    * @requires ej.scroller.js
    * @requires ej.radiobutton.js
    * @requires ej.editor.js
    * @requires ej.dropdownlist.js
    * @requires ej.autocomplete.js
    * @requires ej.menu.js
    * @requires ej.dialog.js
    * @requires ej.button.js
    * @requires ej.checkbox.js
    * @requires ej.datepicker.js
    * @requires ej.timepicker.js
    * @classdesc Custom Design for Html Schedule control.
    * @example 
    * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
    * &lt;script&gt;
    * $('#Schedule').ejSchedule();         
    * &lt;/script&gt;
    */

    ej.widget("ejSchedule", "ej.Schedule", {
        // Root Css Class
        _rootCSS: "e-schedule",
        // widget element will be automatically set in this
        element: null,
        validTags: ["div"],
        // user defined model will be automatically set in this
        model: null,

        // default model
        defaults: {
            /**		
            * This property is used to bind the timezoneCollection items of schedule. 
            * @default Object
            * @type {Object}
            * @example       
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * $("#Schedule").ejSchedule({
            *   timezoneCollection: {
            *       }
            *    });
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            timezoneCollection: /** @lends ejSchedule# */{
            /**		
            * timezoneCollection for the schedule.
            * @name ejSchedule#timezoneCollection->dataSource
            * @default Object
            * @type {object}
            * @example 
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ timezoneCollection:{
            *         dataSource: [
            *        { text: "UTC -12:00", id:"1", value: "UTC -12:00" },
            *        { text: "UTC -11:00", id:"2", value: "UTC -11:00" },
            *        { text: "UTC -10:00", id:"3", value: "UTC -10:00" },
            *        { text: "UTC -09:00", id:"4", value: "UTC -09:00" },
            *        { text: "UTC -08:00", id:"5", value: "UTC -08:00" },
            *        { text: "UTC -07:00", id:"6", value: "UTC -07:00" }
            *           ]
            *           }
            *   });
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            dataSource: [
            { text: "UTC -12:00", id: "1", value: "UTC -12:00" },
            { text: "UTC -11:00", id: "2", value: "UTC -11:00" },
            { text: "UTC -10:00", id: "3", value: "UTC -10:00" },
            { text: "UTC -09:00", id: "4", value: "UTC -09:00" },
            { text: "UTC -08:00", id: "5", value: "UTC -08:00" },
            { text: "UTC -07:00", id: "6", value: "UTC -07:00" },
            { text: "UTC -06:00", id: "7", value: "UTC -06:00" },
            { text: "UTC -05:00", id: "8", value: "UTC -05:00" },
            { text: "UTC -04:30", id: "9", value: "UTC -04:30" },
            { text: "UTC -04:00", id: "10", value: "UTC -04:00" },
            { text: "UTC -03:30", id: "11", value: "UTC -03:30" },
            { text: "UTC -03:00", id: "12", value: "UTC -03:00" },
            { text: "UTC -02:00", id: "13", value: "UTC -02:00" },
            { text: "UTC -01:00", id: "14", value: "UTC -01:00" },
            { text: "UTC +00:00", id: "15", value: "UTC +00:00" },
            { text: "UTC +01:00", id: "16", value: "UTC +01:00" },
            { text: "UTC +02:00", id: "17", value: "UTC +02:00" },
            { text: "UTC +03:00", id: "18", value: "UTC +03:00" },
            { text: "UTC +03:30", id: "19", value: "UTC +03:30" },
            { text: "UTC +04:00", id: "20", value: "UTC +04:00" },
            { text: "UTC +04:30", id: "21", value: "UTC +04:30" },
            { text: "UTC +05:00", id: "22", value: "UTC +05:00" },
            { text: "UTC +05:30", id: "23", value: "UTC +05:30" },
            { text: "UTC +05:45", id: "24", value: "UTC +05:45" },
            { text: "UTC +06:00", id: "25", value: "UTC +06:00" },
            { text: "UTC +06:30", id: "26", value: "UTC +06:30" },
            { text: "UTC +07:00", id: "27", value: "UTC +07:00" },
            { text: "UTC +08:00", id: "28", value: "UTC +08:00" },
            { text: "UTC +09:00", id: "29", value: "UTC +09:00" },
            { text: "UTC +09:30", id: "30", value: "UTC +09:30" },
            { text: "UTC +10:00", id: "31", value: "UTC +10:00" },
            { text: "UTC +11:00", id: "32", value: "UTC +11:00" },
            { text: "UTC +12:00", id: "33", value: "UTC +12:00" },
            { text: "UTC +13:00", id: "34", value: "UTC +13:00" },
            ],
            /**		
            * Bind string value to text field of schedule.
            * @name ejSchedule#timezoneCollection->text
            * @default null
            * @type {string}
            * @example       
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * $("#Schedule").ejSchedule({
            *   timezoneCollection:{
            *         dataSource: [
            *        { text: "UTC -12:00", id:"1", value: "UTC -12:00" },
            *        { text: "UTC -11:00", id:"2", value: "UTC -11:00" },
            *        { text: "UTC -10:00", id:"3", value: "UTC -10:00" },
            *        { text: "UTC -09:00", id:"4", value: "UTC -09:00" },
            *        { text: "UTC -08:00", id:"5", value: "UTC -08:00" },
            *        { text: "UTC -07:00", id:"6", value: "UTC -07:00" }
            *           ],           
            *      text: "text",
            *      id:"id",
            *      value:"value"
            *       }                                      
            *    });
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            text: "text",
            /**		
            * Bind string value to id field of schedule.
            * @name ejSchedule#timezoneCollection->id
            * @default null
            * @type {string}
            * @example       
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * $("#Schedule").ejSchedule({
            *   timezoneCollection:{
            *         dataSource: [
            *        { text: "UTC -12:00", id:"1", value: "UTC -12:00" },
            *        { text: "UTC -11:00", id:"2", value: "UTC -11:00" },
            *        { text: "UTC -10:00", id:"3", value: "UTC -10:00" },
            *        { text: "UTC -09:00", id:"4", value: "UTC -09:00" },
            *        { text: "UTC -08:00", id:"5", value: "UTC -08:00" },
            *        { text: "UTC -07:00", id:"6", value: "UTC -07:00" }
            *           ],           
            *      text: "text",
            *      id:"id",
            *      value:"value"
            *       }                                      
            *    });
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            id: "id",
            /**		
            * Bind string value to value field of schedule.
            * @name ejSchedule#timezoneCollection->value
            * @default null
            * @type {string}
            * @example       
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * $("#Schedule").ejSchedule({
            *   timezoneCollection:{
            *         dataSource: [
            *        { text: "UTC -12:00", id:"1", value: "UTC -12:00" },
            *        { text: "UTC -11:00", id:"2", value: "UTC -11:00" },
            *        { text: "UTC -10:00", id:"3", value: "UTC -10:00" },
            *        { text: "UTC -09:00", id:"4", value: "UTC -09:00" },
            *        { text: "UTC -08:00", id:"5", value: "UTC -08:00" },
            *        { text: "UTC -07:00", id:"6", value: "UTC -07:00" }
            *           ],           
            *      text: "text",
            *      id:"id",
            *      value:"value"
            *       }                                      
            *    });
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            value: "value",
            },
            /**		
            * Defines the views to show in schedule control. 
            * @default [ "Day" , "Week" , "WorkWeek" , "Month" ]
            * @type {Array.string}
            * @example 
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br>
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ views: ["Day","Month"], currentView:"day"});
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            views: ["Day", "Week", "WorkWeek", "Month"],
            /**		
            * Defines the view of the schedule; this will mention the view of the schedule.     See {@link CurrentView}
            * @default ej.Schedule.CurrentView.Week
            * @type {enum}
            * @example 
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br>
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ currentView: ej.Schedule.CurrentView.Day});
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            currentView: "week",
            /**		
            * Defines the time mode of the schedule; this will mention the timemode of the schedule.     See {@link TimeMode}
            * @default ej.Schedule.TimeMode.Hour12
            * @type {enum}
            * @example 
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br>
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ timeMode: ej.Schedule.TimeMode.Hour24});
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            timeMode: null,
            /**		
           * Defines the date format of the schedule.
           * @default "MM/dd/yyyy"
           * @type {String}
           * @example 
           * &lt;div id="Schedule"&gt;&lt;/div&gt; <br>
           * &lt;script&gt;
           * 	$("#Schedule").ejSchedule({  dateFormat: "dd/MM/yyyy" });
           * &lt;/script&gt;
           * @memberof ejSchedule
           * @instance
           */
            dateFormat: "",
            /**		
            * Defines the timeZone of the schedule.
            * @default null
            * @type {string}
            * @example 
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ timeZone: "UTC +2:00"});
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            timeZone: null,
            /**		
            * Apply the start hour to the work area of schedule.
            * @default 0
            * @type {number}
            * @example 
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ startHour: 9});
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            startHour: 0,
            /**		
            * Apply the end hour to the work area of schedule.
            * @default 24
            * @type {number}
            * @example 
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ endHour: 18});
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            endHour: 24,
            /**		
            * Enable or disable the highlighting business hour behavior for schedule.
            * @default true
            * @type {boolean}
            * @example 
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ highlightBusinessHours: false});
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            highlightBusinessHours: true,
            /**		
            * Enables/disables the load on demand option for schedule appointment data.
            * @default true
            * @type {boolean}
            * @example 
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ enableLoadOnDemand: false});
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            enableLoadOnDemand: false,
            /**
            * Saves the current model value to the browser cookies for state maintanence. When we refresh the page, the Schedule control values will be retained.  
            * @default false
            * @type {boolean}
            * @example 
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ enablePersistence: true});
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            enablePersistence: false,
            /**		
            * Enable or disable the quick window open behavior for schedule.
            * @default true
            * @type {boolean}
            * @example
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ showQuickWindow: false});
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            showQuickWindow: true,
            /**		
            * Apply the business start hour of the schedule.
            * @default 9
            * @type {number}
            * @example 
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ highlightBusinessHours : true, businessStartHour: 7});
            * &lt;/script&gt;  
            * @memberof ejSchedule
            * @instance
            */
            businessStartHour: 9,
            /**		
            * Apply the business end hour of the schedule.
            * @default 18
            * @type {number}
            * @example 
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ highlightBusinessHours : true, businessEndHour: 16});
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            businessEndHour: 18,
            /**		
            * Defines the width of the schedule.
            * @default "800px"
            * @type {string}
            * @example 
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ width: "700px"});
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            width: "800px",
            /**		
            * Defines the height of the schedule.
            * @default "800px"
            * @type {string}
            * @example 
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ height: "700px"});
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            height: "800px",
		    /**		
            * Defines the Cell height of the schedule.
            * @default "20px"
            * @type {string}
            * @example 
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ cellHeight: "100px"});
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            cellHeight: "20px",
            /**		
            * Defines the Cell Width of the schedule.
            * @default ""
            * @type {string}
            * @example 
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ cellWidth: "100px"});
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            cellWidth: "",
            /**		
            * Apply the current date of the schedule.
            * @default new Date()
            * @type {date}
            * @example 
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ currentDate: new Date()});
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            currentDate: new Date(),
            /**		
            * Defines the Minimum date of the schedule.
            * @default new Date(1900, 01, 01)
            * @type {date}
            * @example 
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ minDate: new Date("10/11/2014")});
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            minDate: new Date(1900, 01, 01),
            /**		
            * Defines the Maximum date of the schedule.
            * @default maxDate: new Date(2099, 12, 31)
            * @type {date}
            * @example 
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ maxDate: new Date("20/11/2014")});
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            maxDate: new Date(2099, 12, 31),
            /**		
            * Specify the CSS class to schedule to achieve custom theme.
            * @default ""
            * @type {string}
            * @example 
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ cssClass: "gradient-lime"});
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            cssClass: "",
            /**		
            * Defines the locale for schedule.
            * @default "en-US"
            * @type {string}
            * @example 
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ locale: "en-US"});
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            locale: "en-US",
            /**		
            * Enables or disables the resize behavior of schedule.
            * @default false
            * @type {boolean}
            * @example 
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ enableResize: false});
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            enableResize: false,
            /**		
            * Enable or disable the interaction with appointments in schedule.
            * @default false
            * @type {boolean}
            * @example 
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ readOnly: false});
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
	        readOnly: false,
            /**		
            * Enables or disables the rtl direction for schedule.
            * @default false
            * @type {boolean}
            * @example 
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ enableRTL: true});
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            enableRTL: false,
            /**		
            * Enables or disables the previous next appointment navigation of schedule.
            * @default true
            * @type {boolean}
            * @example 
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ 
            *       enableAppointmentNavigation: true,
            *       currentDate:new Date(2014,1,1),
            *       appointmentSettings: { dataSource: window.Default, //collection of object from dataSource.
            *               id: "Id",
            *               subject: "Subject",
            *               description: "Description",
            *               startTime: "StartTime",
            *               endTime: "EndTime",
            *               recurrence: "Recurrence",
            *               recurrenceRule: "RecurrenceRule",
            *               allDay: "AllDay"
            *             }
            *       });
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            enableAppointmentNavigation: true,
            /**		
            * An element’s id which can be used for appointment template rendering.
            * @default null
            * @type {string}
            * @example 
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ appointmentTemplateId: "#templatename"});
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            appointmentTemplateId: null,
            /**		
            * An element’s id which can be used for resource header template rendering.
            * @default null
            * @type {string}
            * @example 
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ resourceHeaderTemplateId: "#resTemplate"});
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            resourceHeaderTemplateId: null,
            /**		
            * Enables or disables the appointment drag and drop behavior of schedule.
            * @default true
            * @type {boolean}
            * @example 
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ 
            *     allowDragDrop: true,
            *     appointmentSettings: { dataSource: window.Default, //collection of object from dataSource.
            *               id: "Id",
            *               subject: "Subject",
            *               description: "Description",
            *               startTime: "StartTime",
            *               endTime: "EndTime",
            *               recurrence: "Recurrence",
            *               recurrenceRule: "RecurrenceRule",
            *               allDay: "AllDay"
            *             }   
            *        });
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            allowDragDrop: true,
            /**		
            * Enables or disables the appointment resize behavior of schedule.
            * @default true
            * @type {boolean}
            * @example 
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ 
            *     enableAppointmentResize: true,
            *     appointmentSettings: { dataSource: window.Default, //collection of object from dataSource.
            *               id: "Id",
            *               subject: "Subject",
            *               description: "Description",
            *               startTime: "StartTime",
            *               endTime: "EndTime",
            *               recurrence: "Recurrence",
            *               recurrenceRule: "RecurrenceRule",
            *               allDay: "AllDay"
            *             }   
            *       });
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            enableAppointmentResize: true,
            /**		
            * Enables or disables the current time indicator of schedule.
            * @default true
            * @type {boolean}
            * @example 
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ showCurrentTimeIndicator: true});
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            showCurrentTimeIndicator: true,
            /**		
            * This property is used to set the reminder options of schedule. 
            * @default 
            * @type {Object}
            * @example       
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * $("#Schedule").ejSchedule({
            *   reminderSettings: {
            *       enable: true,
            *       }
            *    });
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */  
            reminderSettings: {
                /**		
                * Enables or disables the reminder settings option for schedule.
                * @name ejSchedule#reminderSettings->enable
                * @default false
                * @type {boolean}
                * @example 
                * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
                * &lt;script&gt;
                * 	$("#Schedule").ejSchedule({ reminderSettings:{enable: true}});
                * &lt;/script&gt;
                * @memberof ejSchedule
                * @instance
                */
                enable: false,
                /**		
                * Set the alert timing in reminder settings option of schedule.
                * @name ejSchedule#reminderSettings->alertBefore
                * @default 5
                * @type {number}
                * @example 
                * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
                * &lt;script&gt;
                * 	$("#Schedule").ejSchedule({ reminderSettings:{enable: true, alertBefore:6}});
                * &lt;/script&gt;
                * @memberof ejSchedule
                * @instance
                */
                alertBefore: 5
            },
            /**		
            * This property is used to bind the contextmenu items of schedule. 
            * @default Object
            * @type {Object}
            * @example       
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * $("#Schedule").ejSchedule({
            *   contextMenuSettings: {
            *       enable: true,
            *       }
            *    });
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            contextMenuSettings: /** @lends ejSchedule# */{
                /**		
                * Enables or disables the context menu option for schedule.
                * @name ejSchedule#contextMenuSettings->enable
                * @default false
                * @type {boolean}
                * @example 
                * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
                * &lt;script&gt;
                * 	$("#Schedule").ejSchedule({ contextMenuSettings:{enable: true}});
                * &lt;/script&gt;
                * @memberof ejSchedule
                * @instance
                */
                enable: false,
                /**		
                * Context menu collection for appointment and cells of schedule.
                * @name ejSchedule#contextMenuSettings->menuItems
                * @default Object
                * @type {object}
                * @example 
                * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
                * &lt;script&gt;
                * 	$("#Schedule").ejSchedule({ contextMenuSettings:{enable: true,
                *       menuItems:{appointment: [
                *        { id: "open", text: "Open Appointment" },
                *        { id: "delete", text: "Delete Appointment" }
                *    ],
                *    cells: [
                *        { id: "new", text: "New Appointment" },
                *        { id: "recurrence", text: "New Recurring Appointment" },
                *        { id: "today", text: "Today" },
                *        { id: "gotodate", text: "Go to date" },
                *        { id: "settings", text: "Settings" },
                *        { id: "view", text: "View", parentId: "settings" },
                *        { id: "timemode", text: "TimeMode", parentId: "settings" },
                *        { id: "view_Day", text: "Day", parentId: "view" },
                *        { id: "view_Week", text: "Week", parentId: "view" },
                *        { id: "view_Workweek", text: "Workweek", parentId: "view" },
                *        { id: "view_Month", text: "Month", parentId: "view" },
                *        { id: "timemode_Hour12", text: "12 Hours", parentId: "timemode" },
                *        { id: "timemode_Hour24", text: "24 Hours", parentId: "timemode" },
                *        { id: "businesshours", text: "Business Hours", parentId: "settings" }
                *    ]}
                *   }
                *   });
                * &lt;/script&gt;
                * @memberof ejSchedule
                * @instance
                */
                menuItems: {
                    // Context menu collection object for appointment.
                    appointment: [
                        { id: "open", text: "Open Appointment" },
                        { id: "delete", text: "Delete Appointment" }
                    ],
                    // Context menu collection object for cells.
                    cells: [
                        { id: "new", text: "New Appointment" },
                        { id: "recurrence", text: "New Recurring Appointment" },
                        { id: "today", text: "Today" },
                        { id: "gotodate", text: "Go to date" },
                        { id: "settings", text: "Settings" },
                        { id: "view", text: "View", parentId: "settings" },
                        { id: "timemode", text: "TimeMode", parentId: "settings" },
                        { id: "view_Day", text: "Day", parentId: "view" },
                        { id: "view_Week", text: "Week", parentId: "view" },
                        { id: "view_Workweek", text: "Workweek", parentId: "view" },
                        { id: "view_Month", text: "Month", parentId: "view" },
                        { id: "timemode_Hour12", text: "12 Hours", parentId: "timemode" },
                        { id: "timemode_Hour24", text: "24 Hours", parentId: "timemode" },
                        { id: "businesshours", text: "Business Hours", parentId: "settings" }
                    ]
                }
            },
            /**		
            * Groups the specified resources in the schedule control.
            * @default null
            * @type {Object}
            * @example 
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ 
            *       group: {
            *           resources: ["Rooms","Owners"]
            *       },    
            *       resources: [{
            *        field: "ownerId",
            *        title: "Owner",
            *        name: "Owners", allowMultiple: true,
            *        resourceSettings: { dataSource: [
            *        { text: "Room1", id: 1, color: "#f8a398" }], 
            *        text: "text", id: "id",  color: "color" }
            *      },
            *       {
            *           field: "roomId",
            *           title: "Room",
            *           name: "Rooms", allowMultiple: false,
            *           resourceSettings: { dataSource: [
            *           { text: "Andrew", id: 1, groupId: 1, color: "#f8a398" },
            *           { text: "Jerry", id: 2, groupId: 1, color: "#56ca85"}],
            *             text: "text", id: "id", groupId: "groupId", color: "color"
            *           }
            *        }],
            *       appointmentSettings: {
            *           dataSource: window.ResourcesData,
            *           id: "Id",
            *           subject: "Subject",
            *           startTime: "StartTime",
            *           endTime: "EndTime",
            *           allDay: "AllDay",
            *           recurrence: "Recurrence",
            *           recurrenceRule: "RecurrenceRule",
            *           resourceFields: "roomId,ownerId"
            *       } 
            *    });  
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            group: null,
            /**		
            * Binds the resource collection to the schedule.
            * @default null
            * @type {Object}
            * @example 
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ 
            *      resources: [
            *      {
            *        field: "ownerId",
            *        title: "Owner",
            *        name: "Owners", allowMultiple: true,
            *        resourceSettings: { dataSource: [
            *        { text: "Andrew", id: 1, groupId: 1, color: "#f8a398" },
            *        { text: "Cruise", id: 3, groupId: 2, color: "#56ca85" },
            *        { text: "Jerry", id: 5, groupId: 1, color: "#51a0ed" }],    
            *        text: "text", id: "id", groupId: "groupId", color: "color" }
            *      }],    
            *      appointmentSettings: { dataSource: window.ResourcesData, //collection of object from dataSource.
            *               id: "Id",
            *               subject: "Subject",
            *               startTime: "StartTime",
            *               endTime: "EndTime",
            *               recurrence: "Recurrence",
            *               recurrenceRule: "RecurrenceRule",
            *               allDay: "AllDay",
            *               resourceFields: "ownerId"
            *             } 
            *      });  
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            resources: null,
            /**     
            * Enables or disables the keyboard interaction of schedule.
            * @default true
            * @type {boolean}
            * @example 
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ allowKeyboardNavigation: true});
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            allowKeyboardNavigation: true,
            /**		
            * This property is used to bind the appointmentSettings data fields to the schedule. 
            * @default Object
            * @type {Object}
            * @example       
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * $("#Schedule").ejSchedule({
            *     appointmentSettings: { dataSource: window.Default, //collection of object from dataSource.
            *               id: "Id",
            *               subject: "Subject",
            *               description: "Description",
            *               startTime: "StartTime",
            *               endTime: "EndTime",
            *               recurrence: "Recurrence",
            *               recurrenceRule: "RecurrenceRule",
            *               allDay: "AllDay"
            *             }                                      
            *    });
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            appointmentSettings: /** @lends ejSchedule# */{
            /**		
            * Render schedule appointments by the specified dataSource.
            * @name ejSchedule#appointmentSettings->dataSource
            * @default null
            * @type {object}
            * @example       
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * $("#Schedule").ejSchedule({
            *     appointmentSettings: { dataSource: window.Default, //collection of object from dataSource.
            *               id: "Id",
            *               subject: "Subject",
            *               description: "Description",
            *               startTime: "StartTime",
            *               endTime: "EndTime",
            *               recurrence: "Recurrence",
            *               recurrenceRule: "RecurrenceRule",
            *               allDay: "AllDay"
            *             }                                      
            *    });
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            dataSource: null,
            /**		
            * Query the dataSource from the table for schedule.
            * @name ejSchedule#appointmentSettings->query
            * @default null
            * @type {object}
            * @example       
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * $("#Schedule").ejSchedule({
            *     appointmentSettings: { dataSource: window.Default, //collection of object from dataSource.
            *               id: "Id",
            *               subject: "Subject",
            *               description: "Description",
            *               startTime: "StartTime",
            *               endTime: "EndTime",
            *               recurrence: "Recurrence",
            *               recurrenceRule: "RecurrenceRule",
            *               allDay: "AllDay"
            *             }                                      
            *    });
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            query: null,
            /**		
            * Specify the tablename to retrive the data for schedule.
            * @name ejSchedule#appointmentSettings->tableName
            * @default null
            * @type {string}
            * @example       
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * $("#Schedule").ejSchedule({
            *     appointmentSettings: { tableName:"tablename",
            *               dataSource: window.Default, //collection of object from dataSource.
            *               id: "Id",
            *               subject: "Subject",
            *               description: "Description",
            *               startTime: "StartTime",
            *               endTime: "EndTime",
            *               recurrence: "Recurrence",
            *               recurrenceRule: "RecurrenceRule",
            *               allDay: "AllDay"
            *             }                                      
            *    });
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            tableName: null,
            /**		
            * Bind string value to id field of schedule.
            * @name ejSchedule#appointmentSettings->id
            * @default null
            * @type {string}
            * @example       
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * $("#Schedule").ejSchedule({
            *     appointmentSettings: { id: "Id",
            *               dataSource: window.Default, //collection of object from dataSource.                *               
            *               subject: "Subject",
            *               description: "Description",
            *               startTime: "StartTime",
            *               endTime: "EndTime",
            *               recurrence: "Recurrence",
            *               recurrenceRule: "RecurrenceRule",
            *               allDay: "AllDay"
            *             }                                      
            *    });
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            id: null,
            /**		
            * Bind string value to subject field of schedule.
            * @name ejSchedule#appointmentSettings->subject
            * @default null
            * @type {string}
            * @example       
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * $("#Schedule").ejSchedule({
            *     appointmentSettings: { subject: "Subject",
            *               dataSource: window.Default, //collection of object from dataSource.
            *               id: "Id",
            *               description: "Description",
            *               startTime: "StartTime",
            *               endTime: "EndTime",
            *               recurrence: "Recurrence",
            *               recurrenceRule: "RecurrenceRule",
            *               allDay: "AllDay"
            *             }                                      
            *    });
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            subject: null,
            /**		
            * Bind string value to description field of schedule.
            * @name ejSchedule#appointmentSettings->description
            * @default null
            * @type {string}
            * @example       
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * $("#Schedule").ejSchedule({
            *     appointmentSettings: { description: "Description",
            *               dataSource: window.Default, //collection of object from dataSource.
            *               id: "Id",
            *               subject: "Subject",               
            *               startTime: "StartTime",
            *               endTime: "EndTime",
            *               recurrence: "Recurrence",
            *               recurrenceRule: "RecurrenceRule",
            *               allDay: "AllDay"
            *             }                                      
            *    });
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            description: null,
            /**		
            * Bind string value to startTime field of schedule.
            * @name ejSchedule#appointmentSettings->startTime
            * @default null
            * @type {string}
            * @example       
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * $("#Schedule").ejSchedule({
            *     appointmentSettings: { startTime: "StartTime",
            *               dataSource: window.Default, //collection of object from dataSource.
            *               id: "Id",
            *               subject: "Subject",
            *               description: "Description",               
            *               endTime: "EndTime",
            *               recurrence: "Recurrence",
            *               recurrenceRule: "RecurrenceRule",
            *               allDay: "AllDay"
            *             }                                      
            *    });
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            startTime: null,
            /**		
            * Bind string value to endTime field of schedule.
            * @name ejSchedule#appointmentSettings->endTime
            * @default null
            * @type {string}
            * @example       
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * $("#Schedule").ejSchedule({
            *     appointmentSettings: { endTime: "EndTime",
            *               dataSource: window.Default, //collection of object from dataSource.
            *               id: "Id",
            *               subject: "Subject",
            *               description: "Description",
            *               startTime: "StartTime",
            *               recurrence: "Recurrence",
            *               recurrenceRule: "RecurrenceRule",
            *               allDay: "AllDay"
            *             }                                      
            *    });
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            endTime: null,
            /**		
            * Bind string value to recurrence field of schedule.
            * @name ejSchedule#appointmentSettings->recurrence
            * @default null
            * @type {string}
            * @example       
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * $("#Schedule").ejSchedule({
            *     appointmentSettings: { recurrence: "Recurrence",
            *               dataSource: window.Default, //collection of object from dataSource.
            *               id: "Id",
            *               subject: "Subject",
            *               description: "Description",
            *               startTime: "StartTime",
            *               endTime: "EndTime",
            *               recurrenceRule: "RecurrenceRule",
            *               allDay: "AllDay"
            *             }                                      
            *    });
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            recurrence: null,
            /**		
            * Bind string value to recurrenceRule field of schedule.
            * @name ejSchedule#appointmentSettings->recurrenceRule
            * @default null
            * @type {string}
            * @example       
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * $("#Schedule").ejSchedule({
            *     appointmentSettings: { recurrenceRule: "RecurrenceRule",
            *               dataSource: window.Default, //collection of object from dataSource.
            *               id: "Id",
            *               subject: "Subject",
            *               description: "Description",
            *               startTime: "StartTime",
            *               endTime: "EndTime",
            *               recurrence: "Recurrence",
            *               allDay: "AllDay"
            *             }                                      
            *    });
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            recurrenceRule: null,
            /**		
            * Bind string value to allday field of schedule.
            * @name ejSchedule#appointmentSettings->allDay
            * @default null
            * @type {string}
            * @example       
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * $("#Schedule").ejSchedule({
            *     appointmentSettings: { dataSource: window.Default, //collection of object from dataSource.
            *               id: "Id",
            *               subject: "Subject",
            *               description: "Description",
            *               startTime: "StartTime",
            *               endTime: "EndTime",
            *               recurrence: "Recurrence",
            *               recurrenceRule: "RecurrenceRule",
            *               allDay: "AllDay"
            *             }                                      
            *    });
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            allDay: null,
            /**		
            * Binds the resource related fields to the schedule.
            * @name ejSchedule#appointmentSettings->resourceFields
            * @default null
            * @type {string}
            * @example 
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ 
            *      resources: [
            *      {
            *        field: "ownerId",
            *        title: "Owner",
            *        name: "Owners", allowMultiple: true,
            *        resourceSettings: { dataSource: [
            *        { text: "Andrew", id: 1, groupId: 1, color: "#f8a398" },
            *        { text: "Cruise", id: 3, groupId: 2, color: "#56ca85" },
            *        { text: "Jerry", id: 5, groupId: 1, color: "#51a0ed" }],    
            *        text: "text", id: "id", groupId: "groupId", color: "color" }
            *      }],    
            *      appointmentSettings: { dataSource: window.ResourcesData, //collection of object from dataSource.
            *               id: "Id",
            *               subject: "Subject",
            *               startTime: "StartTime",
            *               endTime: "EndTime",
            *               recurrence: "Recurrence",
            *               recurrenceRule: "RecurrenceRule",
            *               allDay: "AllDay",
            *               resourceFields: "ownerId"
            *             } 
            *      });  
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            resourceFields: null,
                /**		
           * Bind string value to categorize field of schedule.
           * @name ejSchedule#appointmentSettings->categorize
           * @default null
           * @type {string}
           * @example       
           * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
           * &lt;script&gt;
           * $("#Schedule").ejSchedule({
           *     appointmentSettings: { dataSource: window.Default, //collection of object from dataSource.
           *               id: "Id",
           *               subject: "Subject",
           *               description: "Description",
           *               startTime: "StartTime",
           *               endTime: "EndTime",
           *               recurrence: "Recurrence",
           *               recurrenceRule: "RecurrenceRule",
           *               allDay: "AllDay",
           *               categorize: "Categorize"
           *             }                                      
           *    });
           * &lt;/script&gt;
           * @memberof ejSchedule
           * @instance
           */
            categorize:null
            },
            /**		
            * Defines the specific start and end dates to be rendered in the schedule control. To render such user-specified custom dates in the schedule control, it is necessary to set the currentView property of the schedule to customview.
            * @default null
            * @type {Object}
            * @example 
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br>
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ 
            *           views: ["Day", "Week", "WorkWeek", "Month", "CustomView"], 
            *           currentView: ej.Schedule.CurrentView.CustomView,
            *           renderDates: {
            *               start: new Date(2014, 11, 7),
            *               end: new Date(2014, 12, 10)
            *           }
            *   });
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            renderDates: null,
            /**		
            * Defines the orientation type of the schedule; Renders the schedule either in vertical or horizontal mode as specified through this property.
            * @default ej.Schedule.Orientation.Vertical
            * @type {enum}
            * @example 
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br>
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ orientation: ej.Schedule.Orientation.Horizontal});
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            orientation: "vertical",
            /**		
            * This property is used to bind the Categorize items of schedule. 
            * @default Object
            * @type {Object}
            * @example       
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * $("#Schedule").ejSchedule({
            *   categorizeSettings: {
            *       enable: true,
            *       }
            *    });
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            categorizeSettings: /** @lends ejSchedule# */{
            /**		
            * Enables or disables the Categorize option for schedule.
            * @name ejSchedule#categorizeSettings->enable
            * @default false
            * @type {boolean}
            * @example 
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ categorizeSettings:{enable: false}});
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
             enable: false,
            /**		
            * allowMultiple option enables/disables the multiple selection of categories for the appointments.
            * @name ejSchedule#categorizeSettings->allowMultiple
            * @default false
            * @type {boolean}
            * @example 
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ categorizeSettings:{allowMultiple: false}});
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
             allowMultiple: false,
            /**		
            * Categorize collection for the schedule.
            * @name ejSchedule#categorizeSettings->dataSource
            * @default Object
            * @type {object}
            * @example 
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * 	$("#Schedule").ejSchedule({ categorizeSettings:{enable: true,allowMultiple:false,
            *  dataSource:[
            *  { text: "Blue Category", id: 1, color: "#7499e1", fontColor: "green" },
            *  { text: "Green Category", id: 2, color: "#7cce6e", fontColor: "green" },
            *  { text: "Orange Category", id: 3, color: "#f19d5a", fontColor: "green" },
            *  { text: "Purple Category", id: 4, color: "#937bd1", fontColor: "green" },
            *  { text: "Red Category", id: 5, color: "#d98889", fontColor: "green" },
            *  { text: "Yellow Category", id: 6, color: "#f8f264", fontColor: "green" }                
            *  ],
            *   });
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
             dataSource:
                [
                { text: "Blue Category", id: 1, color: "#7499e1", fontColor: "green" },
                { text: "Green Category", id: 2, color: "#7cce6e", fontColor: "green" },
                { text: "Orange Category", id: 3, color: "#f19d5a", fontColor: "green" },
                { text: "Purple Category", id: 4, color: "#937bd1", fontColor: "green" },
                { text: "Red Category", id: 5, color: "#d98889", fontColor: "green" },
                { text: "Yellow Category", id: 6, color: "#f8f264", fontColor: "green" }
                ],
                /**		
            * Bind string value to text field of schedule.
            * @name ejSchedule#categorizeSettings->text
            * @default null
            * @type {string}
            * @example       
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * $("#Schedule").ejSchedule({
            *   categorizeSettings:{
            *    enable:true,
            *    allowMultiple:false,
            *      dataSource:[
            *     { text: "Blue Category", id: 1, color: "#7499e1", fontColor: "green" },
            *     { text: "Green Category", id: 2, color: "#7cce6e", fontColor: "green" },
            *     { text: "Orange Category", id: 3, color: "#f19d5a", fontColor: "green" },
            *     { text: "Purple Category", id: 4, color: "#937bd1", fontColor: "green" },
            *     { text: "Red Category", id: 5, color: "#d98889", fontColor: "green" },
            *     { text: "Yellow Category", id: 6, color: "#f8f264", fontColor: "green" }                
            *     ],            
            *      text: "text",
            *      id:"id",
            *      color:"color",
            *      fontColor:"fontColor"
            *       }
            *      }                                      
            *    });
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */

            text: "text",
            /**		
            * Bind string value to id field of schedule.
            * @name ejSchedule#categorizeSettings->id
            * @default null
            * @type {string}
            * @example       
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * $("#Schedule").ejSchedule({
            *   categorizeSettings:{
            *    enable:true,
            *    allowMultiple:false,
            *      dataSource:[
            *     { text: "Blue Category", id: 1, color: "#7499e1", fontColor: "green" },
            *     { text: "Green Category", id: 2, color: "#7cce6e", fontColor: "green" },
            *     { text: "Orange Category", id: 3, color: "#f19d5a", fontColor: "green" },
            *     { text: "Purple Category", id: 4, color: "#937bd1", fontColor: "green" },
            *     { text: "Red Category", id: 5, color: "#d98889", fontColor: "green" },
            *     { text: "Yellow Category", id: 6, color: "#f8f264", fontColor: "green" }                
            *     ],            
            *      text: "text",
            *      id:"id",
            *      color:"color",
            *      fontColor:"fontColor"
            *       }
            *      }                                      
            *    });
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            id: "id",
                    /**		
            * Bind string value to color field of schedule.
            * @name ejSchedule#categorizeSettings->color
            * @default null
            * @type {string}
            * @example       
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * $("#Schedule").ejSchedule({
            *   categorizeSettings:{
            *    enable:true,
            *    allowMultiple:false,
            *      dataSource:[
            *     { text: "Blue Category", id: 1, color: "#7499e1", fontColor: "green" },
            *     { text: "Green Category", id: 2, color: "#7cce6e", fontColor: "green" },
            *     { text: "Orange Category", id: 3, color: "#f19d5a", fontColor: "green" },
            *     { text: "Purple Category", id: 4, color: "#937bd1", fontColor: "green" },
            *     { text: "Red Category", id: 5, color: "#d98889", fontColor: "green" },
            *     { text: "Yellow Category", id: 6, color: "#f8f264", fontColor: "green" }                
            *     ],            
            *      text: "text",
            *      id:"id",
            *      color:"color",
            *      fontColor:"fontColor"
            *       }
            *      }                                      
            *    });
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            color: "color",
                    /**		
            * Bind string value to fontColor field of schedule.
            * @name ejSchedule#categorizeSettings->fontColor
            * @default null
            * @type {string}
            * @example       
            * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * $("#Schedule").ejSchedule({
            *   categorizeSettings:{
            *    enable:true,
            *    allowMultiple:false,
            *      dataSource:[
            *     { text: "Blue Category", id: 1, color: "#7499e1", fontColor: "green" },
            *     { text: "Green Category", id: 2, color: "#7cce6e", fontColor: "green" },
            *     { text: "Orange Category", id: 3, color: "#f19d5a", fontColor: "green" },
            *     { text: "Purple Category", id: 4, color: "#937bd1", fontColor: "green" },
            *     { text: "Red Category", id: 5, color: "#d98889", fontColor: "green" },
            *     { text: "Yellow Category", id: 6, color: "#f8f264", fontColor: "green" }                
            *     ],            
            *      text: "text",
            *      id:"id",
            *      color:"color",
            *      fontColor:"fontColor"
            *       }
            *      }                                      
            *    });
            * &lt;/script&gt;
            * @memberof ejSchedule
            * @instance
            */
            fontColor:"fontColor"
            },
        /**    
        * Triggered after the cell is clicked.
        * @event
        * @name ejSchedule#cellClick 	
        * @param {Object} argument.object Returns the object of cellClick event.  
        * @param {boolean} argument.cancel Returns the cancel option value.
        * @param {object} argument.endTime Returns the end time of the clicked cell.
        * @param {object} argument.model Returns the schedule model.
        * @param {object} argument.startTime Returns the start time of the clicked cell.
        * @param {object} argument.target Returns the target of the clicked cell.
        * @param {string} argument.type Returns the name of the event.
        * @example
        * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
        * &lt;script&gt;
        * $("#Schedule").ejSchedule({
        *    cellClick: function (args) {}
        * });
        * &lt;/script&gt;
        * @memberof ejSchedule
        * @instance
        */
        cellClick: null,
        /**    
        * Triggered after the appointment is clicked.
        * @event
        * @name ejSchedule#appointmentClick 	
        * @param {Object} argument.object Returns the object of appointmentClick event.  
        * @param {object} argument.appointment Returns the clicked appointment object.
        * @param {boolean} argument.cancel Returns the cancel option value.
        * @param {object} argument.model Returns the schedule model.
        * @param {string} argument.type Returns the name of the event.
        * @example 
        * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
        * &lt;script&gt;
        * $("#Schedule").ejSchedule({
        *     appointmentSettings: { dataSource: window.Default, //collection of object from dataSource.
        *               id: "Id",
        *               subject: "Subject",
        *               description: "Description",
        *               startTime: "StartTime",
        *               endTime: "EndTime",
        *               recurrence: "Recurrence",
        *               recurrenceRule: "RecurrenceRule",
        *               allDay: "AllDay"
        *             },   
        *    appointmentClick: function (args) {}
        * });
        * &lt;/script&gt;
        * @memberof ejSchedule
        * @instance
        */
        appointmentClick: null,
        /**    
        * Triggered after the cell is clicked twice.
        * @event
        * @name ejSchedule#cellDoubleClick 	
        * @param {Object} argument.object Returns the object of cellDoubleClick event.  
        * @param {boolean} argument.cancel Returns the cancel option value.
        * @param {object} argument.endTime Returns the end time of the double clicked cell.
        * @param {object} argument.model Returns the schedule model.
        * @param {object} argument.startTime Returns the start time of the double clicked cell.
        * @param {object} argument.target Returns the target of the double clicked cell.
        * @param {string} argument.type Returns the name of the event.
        * @example 
        * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
        * &lt;script&gt;
        * $("#Schedule").ejSchedule({
        *    cellDoubleClick: function (args) {}
        * });
        * &lt;/script&gt;
        * @memberof ejSchedule
        * @instance
        */
        cellDoubleClick: null,
        /**    
        * Triggered before the appointment window is opened.
        * @event
        * @name ejSchedule#appointmentWindowOpen 	
        * @param {Object} argument.object returns the object of appointmentWindowOpen event while select detail option from quick window.  
        * @param {boolean} argument.cancel Returns the cancel option value.
        * @param {object} argument.endTime Returns the end time of the double clicked cell.
        * @param {object} argument.model Returns the schedule model.
        * @param {string} argument.originalEventType Returns the action name which triggers window open.
        * @param {object} argument.startTime Returns the start time of the double clicked cell.
        * @param {object} argument.target Returns the target of the double clicked cell.
        * @param {string} argument.type Returns the name of the event.
        
        * @param {Object} argument.object Returns the object of edit appointmentWindowOpen event while select edit appointment/edit series option.  
        * @param {object} argument.appointment Returns the edit appointment object.
        * @param {boolean} argument.cancel Returns the cancel option value.
        * @param {boolean} argument.edit Returns the edit occurrence option value.
        * @param {object} argument.model Returns the schedule model.
        * @param {string} argument.type Returns the name of the event.
        
        * @example 
        * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
        * &lt;script&gt;
        * $("#Schedule").ejSchedule({
        *    appointmentWindowOpen: function (args) {}
        * });
        * &lt;/script&gt;
        * @memberof ejSchedule
        * @instance
        */
        appointmentWindowOpen: null,
        /**    
        * Triggered after the appointment is saved.
        * @event
        * @name ejSchedule#appointmentSaved	
        * @param {Object} argument.object Returns the object of appointmentSaved event using appointment window.  
        * @param {object} argument.appointment Returns the saved appintment object.
        * @param {boolean} argument.cancel Returns the cancel option value.
        * @param {object} argument.model Returns the schedule model.
        * @param {string} argument.type Returns the name of the event.
        
        * @param {Object} argument.object Returns the object of appointmentSaved event using quick window.  
        * @param {boolean} argument.cancel Returns the cancel option value.
        * @param {object} argument.appointment Returns the saved appintment object.
        * @param {object} argument.model Returns the schedule model.
        * @param {string} argument.type Returns the name of the event.
        
        * @example 
        * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
        * &lt;script&gt;
        * $("#Schedule").ejSchedule({
        *    appointmentSaved: function (args) {}
        * });
        * &lt;/script&gt;
        * @memberof ejSchedule
        * @instance
        */
        appointmentSaved: null,
        /**    
        * Triggered after the appointment is edited.
        * @event
        * @name ejSchedule#appointmentEdited	
        * @param {Object} argument.object Returns the object of appointmentEdited event.  
        * @param {object} argument.appointment Returns the edited appintment object.
        * @param {boolean} argument.cancel Returns the cancel option value.
        * @param {object} argument.model Returns the schedule model.
        * @param {string} argument.type Returns the name of the event.
        * @example 
        * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
        * &lt;script&gt;
        * $("#Schedule").ejSchedule({
        *     appointmentSettings: { dataSource: window.Default, //collection of object from dataSource.
        *               id: "Id",
        *               subject: "Subject",
        *               description: "Description",
        *               startTime: "StartTime",
        *               endTime: "EndTime",
        *               recurrence: "Recurrence",
        *               recurrenceRule: "RecurrenceRule",
        *               allDay: "AllDay"
        *             },
        *    appointmentEdited: function (args) {}
        * });
        * &lt;/script&gt;
        * @memberof ejSchedule
        * @instance
        */
        appointmentEdited: null,
        /**    
        			* Triggered after the appointment is deleted.
        			* @event
        			* @name ejSchedule#appointmentDeleted	
        			* @param {Object} argument.object Returns the object of appointmentDeleted event.
        			* @param {boolean} argument.cancel Returns the cancel option value.
                    * @param {object} argument.appointment Returns the deleted appintment object.
        			* @param {object} argument.model Returns the schedule model.
        			* @param {string} argument.type Returns the name of the event.
        			* @example 
                    * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
                    * &lt;script&gt;
                    * $("#Schedule").ejSchedule({
                    *     appointmentSettings: { dataSource: window.Default, //collection of object from dataSource.
                    *               id: "Id",
                    *               subject: "Subject",
                    *               description: "Description",
                    *               startTime: "StartTime",
                    *               endTime: "EndTime",
                    *               recurrence: "Recurrence",
                    *               recurrenceRule: "RecurrenceRule",
                    *               allDay: "AllDay"
                    *             },
        			*    appointmentDeleted: function (args) {}
        			* });
                    * &lt;/script&gt;
        * @memberof ejSchedule
        * @instance
        */
        appointmentDeleted: null,
        /**    
        			* Triggered after the navigate the view or date of the schedule.
        			* @event
        			* @name ejSchedule#navigation
        			* @param {Object} argument.object Returns the object of schedule view navigation event.
                    * @param {object} argument.Date Returns the current date object.
        			* @param {boolean} argument.cancel Returns the cancel option value.
        			* @param {object} argument.model Returns the schedule model.
                    * @param {string} argument.currentView Returns the current view value.
                    * @param {string} argument.prevView Returns the previous view value.
                    * @param {object} argument.target Returns the target of the action.
        			* @param {string} argument.type Returns the name of the event.
        
                    * @param {Object} argument.object Returns the object of previous/next date navigation event.  
        			* @param {boolean} argument.cancel Returns the cancel option value.
        			* @param {object} argument.model Returns the schedule model.
                    * @param {object} argument.currentDate Returns the new date of the schedule.
                    * @param {object} argument.prevDate Returns the previous date of the schedule.
                    * @param {object} argument.target Returns the target of the action.
        			* @param {string} argument.type Returns the name of the event.
        
                    * @param {Object} argument.object Returns the navigation event while change the date using calendar in schedule.  
        			* @param {boolean} argument.cancel Returns the cancel option value.
        			* @param {object} argument.model Returns the schedule model.
                    * @param {object} argument.currentDate Returns the new date of the schedule.
                    * @param {object} argument.prevDate Returns the previous date of the schedule.
                    * @param {object} argument.target Returns the target of the action.
        			* @param {string} argument.type Returns the name of the event.
        
        			* @example 
                    * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
                    * &lt;script&gt;
                    * $("#Schedule").ejSchedule({
        			*    navigation: function (args) {}
        			* });
                    * &lt;/script&gt;
        * @memberof ejSchedule
        * @instance
        */
        navigation: null,
        /**     
        * Triggered when the appointment is start dragging. 
        * @event
        * @name ejSchedule#dragStart		
        * @param {Object} argument.object Returns the object of dargStart event.
			* @param {boolean} argument.cancel Returns the cancel option value.
			* @param {object} argument.model Returns the schedule model.
            * @param {object} argument.target Returns the target of the dragging appointment.
			* @param {string} argument.type Returns the name of the event.
        * @example 
        * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * $("#Schedule").ejSchedule({
            *     appointmentSettings: { dataSource: window.Default, //collection of object from dataSource.
            *               id: "Id",
            *               subject: "Subject",
            *               description: "Description",
            *               startTime: "StartTime",
            *               endTime: "EndTime",
            *               recurrence: "Recurrence",
            *               recurrenceRule: "RecurrenceRule",
            *               allDay: "AllDay"
            *             },
        *    dragStart: function (args) {}
        * });
        * &lt;/script&gt;
        * @memberof ejSchedule
        * @instance
        */
        dragStart: null,
        /**     
        * Triggered when the appointment is drag over.
        * @event
        * @name ejSchedule#drag
            * @param {Object} argument.object Returns the object of dragOver event.  
			* @param {boolean} argument.cancel Returns the cancel option value.
			* @param {object} argument.model Returns the schedule model.
            * @param {object} argument.target Returns the target of the drag over appointment.
			* @param {string} argument.type Returns the name of the event.
        * @example 
        * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * $("#Schedule").ejSchedule({
            *     appointmentSettings: { dataSource: window.Default, //collection of object from dataSource.
            *               id: "Id",
            *               subject: "Subject",
            *               description: "Description",
            *               startTime: "StartTime",
            *               endTime: "EndTime",
            *               recurrence: "Recurrence",
            *               recurrenceRule: "RecurrenceRule",
            *               allDay: "AllDay"
            *             },
        *    drag: function (args) {}
        * });
        * &lt;/script&gt;
        * @memberof ejSchedule
        * @instance
        */
        drag: null,
        /**     
        * Triggered when the appointment drop. 
        * @event
        * @name ejSchedule#dragStop
            * @param {Object} argument.object Returns the object of dragDrop event.
            * @param {object} argument.appointment Returns the dropped appointment object.
			* @param {boolean} argument.cancel Returns the cancel option value.
			* @param {object} argument.model Returns the schedule model.
			* @param {string} argument.type Returns the name of the event.
        * @example 
        * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * $("#Schedule").ejSchedule({
            *     appointmentSettings: { dataSource: window.Default, //collection of object from dataSource.
            *               id: "Id",
            *               subject: "Subject",
            *               description: "Description",
            *               startTime: "StartTime",
            *               endTime: "EndTime",
            *               recurrence: "Recurrence",
            *               recurrenceRule: "RecurrenceRule",
            *               allDay: "AllDay"
            *             },
        *    dragStop: function (args) {}
        * });
        * &lt;/script&gt;
        * @memberof ejSchedule
        * @instance
        */
        dragStop: null,
        /**     
        * Triggered when start resizing the appointment. 
        * @event
        * @name ejSchedule#resizeStart
            * @param {Object} argument.object Returns the object of resizeStart event.
			* @param {boolean} argument.cancel Returns the cancel option value.
            * @param {object} argument.element Returns the resize element value.
			* @param {object} argument.model Returns the schedule model.
			* @param {string} argument.type Returns the name of the event.
        * @example 
        * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * $("#Schedule").ejSchedule({
            *     appointmentSettings: { dataSource: window.Default, //collection of object from dataSource.
            *               id: "Id",
            *               subject: "Subject",
            *               description: "Description",
            *               startTime: "StartTime",
            *               endTime: "EndTime",
            *               recurrence: "Recurrence",
            *               recurrenceRule: "RecurrenceRule",
            *               allDay: "AllDay"
            *             },
        *    resizeStart: function (args) {}
        * });
        * &lt;/script&gt;
        * @memberof ejSchedule
        * @instance
        */
        resizeStart: null,
        /**     
        * Triggered when resizing the appointment. 
        * @event
        * @name ejSchedule#resize
            * @param {Object} argument.object Returns the object of resizing event.
			* @param {boolean} argument.cancel Returns the cancel option value.
            * @param {object} argument.element Returns the resize element value.
			* @param {object} argument.model Returns the schedule model.
			* @param {string} argument.type Returns the name of the event.
        * @example 
        * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
            * &lt;script&gt;
            * $("#Schedule").ejSchedule({
            *     appointmentSettings: { dataSource: window.Default, //collection of object from dataSource.
            *               id: "Id",
            *               subject: "Subject",
            *               description: "Description",
            *               startTime: "StartTime",
            *               endTime: "EndTime",
            *               recurrence: "Recurrence",
            *               recurrenceRule: "RecurrenceRule",
            *               allDay: "AllDay"
            *             },
        *    resize: function (args) {}
        * });
        * &lt;/script&gt;
        * @memberof ejSchedule
        * @instance
        */
        resize: null,
        /**     
        * Triggered when stop resizing the appointment. 
        * @event
        * @name ejSchedule#resizeStop
            * @param {Object} argument.object Returns the object of resizeStop event
            * @param {object} argument.appointment Returns the resized appointment value.
			* @param {boolean} argument.cancel Returns the cancel option value.
			* @param {object} argument.model Returns the schedule model.
            * @param {object} argument.target Returns the target of the resized appointment.
			* @param {string} argument.type Returns the name of the event.
        * @example 
        * &lt;div id="Schedule"&gt;&lt;/div&gt; <br>
            * &lt;script&gt;
            * $("#Schedule").ejSchedule({
            *     appointmentSettings: { dataSource: window.Default, //collection of object from dataSource.
            *               id: "Id",
            *               subject: "Subject",
            *               description: "Description",
            *               startTime: "StartTime",
            *               endTime: "EndTime",
            *               recurrence: "Recurrence",
            *               recurrenceRule: "RecurrenceRule",
            *               allDay: "AllDay"
            *             },
        *    resizeStop: function (args) {}
        * });
        * &lt;/script&gt;
        * @memberof ejSchedule
        * @instance
        */
        resizeStop: null,
        /**    
        * Triggered after the context menu is clicked.
        * @event
        * @name ejSchedule#menuItemClick
        * @param {Object} argument.object Returns the object of menuItemClick event.  
        * @param {boolean} argument.cancel Returns the cancel option value.
        * @param {object} argument.events Returns the object of menu item event.
        * @param {object} argument.model Returns the schedule model.
        * @param {string} argument.type Returns the name of the event.
        * @example
        * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
        * &lt;script&gt;
        * $("#Schedule").ejSchedule({
        *    menuItemClick: function (args) {}
        * });
        * &lt;/script&gt;
        * @memberof ejSchedule
        * @instance
        */
        menuItemClick: null,
        /**    
        * Triggered before the context menu open.
        * @event
        * @name ejSchedule#beforeContextMenuOpen
        * @param {Object} argument.object Returns the object of beforeContextMenuOpen event.  
        * @param {boolean} argument.cancel Returns the cancel option value.
        * @param {object} argument.events Returns the object of before open menu target.
        * @param {object} argument.model Returns the schedule model.
        * @param {string} argument.type Returns the name of the event.
        * @example
        * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
        * &lt;script&gt;
        * $("#Schedule").ejSchedule({
        *    beforeContextMenuOpen: function (args) {}
        * });
        * &lt;/script&gt;
        * @memberof ejSchedule
        * @instance
        */
        beforeContextMenuOpen: null,
        /**    
        * Triggers when the reminder is raised for an appointment.
        * @event
        * @name ejSchedule#reminder
        * @param {boolean} argument.cancel Returns the cancel option value.
        * @param {object} argument.model Returns the schedule model.
        * @param {string} argument.type Returns the name of the event.
        * @param {object} argument.reminderAppointment Returns the appointment object for which the reminder is raised.
        * @example
        * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
        * &lt;script&gt;
        * $("#Schedule").ejSchedule({
        *    reminder: function (args) {}
        * });
        * &lt;/script&gt;
        * @memberof ejSchedule
        * @instance
        */
        reminder: null,
        /**    
        * Triggers when the action begin of schedule.
        * @event
        * @name ejSchedule#actionBegin

        * @param {Object} argument Event parameters when view change action starts:
        * @param {object} argument.Date Returns the current date value.
        * @param {boolean} argument.cancel Returns the cancel option value.
        * @param {string} argument.currentView Returns the current view value.
        * @param {object} argument.model Returns the schedule model.
        * @param {string} argument.requestType Returns the action begin request type.
        * @param {object} argument.target Returns the target of the click.
        * @param {string} argument.type Returns the name of the event.
        
        * @param {Object} argument Event parameters when date navigate action starts:
        * @param {boolean} argument.cancel Returns the cancel option value.
        * @param {object} argument.currentDate Returns the current date value.
        * @param {object} argument.model Returns the schedule model.
        * @param {string} argument.requestType Returns the action begin request type.
        * @param {object} argument.target Returns the target of the click.
        * @param {string} argument.type Returns the name of the event.

        * @param {Object} argument Event parameters when date change by calendar action starts:
        * @param {boolean} argument.cancel Returns the cancel option value.
        * @param {object} argument.currentDate Returns the current date value.
        * @param {object} argument.model Returns the schedule model.
        * @param {string} argument.requestType Returns the action begin request type.
        * @param {object} argument.target Returns the target of the click.
        * @param {string} argument.type Returns the name of the event.

        * @param {Object} argument Event parameters when appointment save action starts:
        * @param {boolean} argument.cancel Returns the cancel option value.
        * @param {object} argument.data Returns the save appointment value.
        * @param {object} argument.model Returns the schedule model.
        * @param {string} argument.requestType Returns the action begin request type.
        * @param {string} argument.type Returns the name of the event.

        * @param {Object} argument Event parameters when appointment edit action starts:
        * @param {boolean} argument.cancel Returns the cancel option value.
        * @param {object} argument.data Returns the edit appointment value.
        * @param {object} argument.model Returns the schedule model.
        * @param {string} argument.requestType Returns the action begin request type.
        * @param {string} argument.type Returns the name of the event.

        * @param {Object} argument Event parameters when appointment delete action starts:
        * @param {boolean} argument.cancel Returns the cancel option value.
        * @param {number} argument.id Returns the id of delete appointment.
        * @param {object} argument.model Returns the schedule model.
        * @param {string} argument.requestType Returns the action begin request type.
        * @param {string} argument.type Returns the name of the event.

        * @param {Object} argument Event parameters when appointment drag action starts:
        * @param {boolean} argument.cancel Returns the cancel option value.
        * @param {object} argument.data Returns the target of the appointment we drag.
        * @param {object} argument.model Returns the schedule model.
        * @param {string} argument.requestType Returns the action begin request type.
        * @param {string} argument.type Returns the name of the event.

        * @param {Object} argument Event parameters when appointment resize action starts:
        * @param {boolean} argument.cancel Returns the cancel option value.
        * @param {object} argument.data Returns the target of the appointment we resize.
        * @param {object} argument.model Returns the schedule model.
        * @param {string} argument.requestType Returns the action begin request type.
        * @param {string} argument.type Returns the name of the event.

        * @example
        * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
        * &lt;script&gt;
        * $("#Schedule").ejSchedule({
        *    actionBegin: function (args) {}
        * });
        * &lt;/script&gt;
        * @memberof ejSchedule
        * @instance
        */
        actionBegin: null,
        /**    
        * Triggers when the action complete of schedule.
        * @event
        * @name ejSchedule#actionComplete

        * @param {Object} argument Event parameters when view change action completed:
        * @param {boolean} argument.cancel Returns the cancel option value.
        * @param {object} argument.data Returns the data about viewchange action.
        * @param {object} argument.model Returns the schedule model.
        * @param {string} argument.requestType Returns the action complete request type.
        * @param {string} argument.type Returns the name of the event.

        * @param {Object} argument Event parameters when date navigate action completed:
        * @param {boolean} argument.cancel Returns the cancel option value.
        * @param {object} argument.data Returns the data about the date navigate action.
        * @param {object} argument.model Returns the schedule model.
        * @param {string} argument.requestType Returns the action complete request type.
        * @param {string} argument.type Returns the name of the event.

        * @param {Object} argument Event parameters when date change by calendar action completed:
        * @param {boolean} argument.cancel Returns the cancel option value.
        * @param {object} argument.data Returns the data about calendar navigation action.
        * @param {object} argument.model Returns the schedule model.
        * @param {string} argument.requestType Returns the action complete request type.
        * @param {string} argument.type Returns the name of the event.

        * @param {Object} argument Event parameters when appointment save action completed:
        * @param {boolean} argument.cancel Returns the cancel option value.
        * @param {object} argument.data Returns the data about appointment saved value.
        * @param {object} argument.model Returns the schedule model.
        * @param {string} argument.requestType Returns the action complete request type.
        * @param {string} argument.type Returns the name of the event.

        * @param {Object} argument Event parameters when appointment edit action completed:
        * @param {boolean} argument.cancel Returns the cancel option value.
        * @param {object} argument.data Returns the data about appointment edited value.
        * @param {object} argument.model Returns the schedule model.
        * @param {string} argument.requestType Returns the action complete request type.
        * @param {string} argument.type Returns the name of the event.

        * @param {Object} argument Event parameters when appointment delete action completed:
        * @param {boolean} argument.cancel Returns the cancel option value.
        * @param {object} argument.data Returns the data about appointment deleted action.
        * @param {object} argument.model Returns the schedule model.
        * @param {string} argument.requestType Returns the action complete request type.
        * @param {string} argument.type Returns the name of the event.

        * @param {Object} argument Event parameters when appointment dragging action completed:
        * @param {object} argument.appointment Returns the appointment data we dropped.
        * @param {boolean} argument.cancel Returns the cancel option value.
        * @param {object} argument.model Returns the schedule model.
        * @param {string} argument.requestType Returns the action complete request type.
        * @param {string} argument.type Returns the name of the event.

        * @param {Object} argument Event parameters when appointment resizing action completed:
        * @param {boolean} argument.cancel Returns the cancel option value.
        * @param {object} argument.data Returns the element we resized.
        * @param {object} argument.model Returns the schedule model.
        * @param {string} argument.requestType Returns the action complete request type.
        * @param {string} argument.type Returns the name of the event.

        * @example
        * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
        * &lt;script&gt;
        * $("#Schedule").ejSchedule({
        *    actionComplete: function (args) {}
        * });
        * &lt;/script&gt;
        * @memberof ejSchedule
        * @instance
        */
        actionComplete: null,
    },
        dataTypes: {
            views: "array",
            timezoneCollection: {
                dataSource: "array"
            },
            renderDates: "data",
            enablePersistence: "boolean",
            //timeMode: "enum",
            //currentView: "enum",
            resources: "array",
            resources: {
                resourceSettings:"arary",
            },
            group: {
                resources: "array"
            },
            appointmentSettings: {
                dataSource: "data",
                query: "data"
            },
            contextMenuSettings: {
                menuItems: {
                    appointment: "array",
                    cells:"array",
                }
            }
        },
        _ignoreOnPersist: [
            "appointmentSettings.query", "appointmentSettings.dataSource", "timezoneCollection.dataSource",
            "allowKeyboardNavigation", "showQuickWindow", "cssClass", "locale", "enableResize",
            "readOnly", "enableRTL", "enableAppointmentNavigation", "appointmentTemplateId", "resourceHeaderTemplateId", "allowDragDrop", "enableAppointmentResize",
            "showCurrentTimeIndicator", "reminderSettings.enable", "contextMenuSettings.enable", "group.resources", "categorizeSettings.enable", "categorizeSettings.dataSource",
            "cellClick", "appointmentClick", "cellDoubleClick", "appointmentWindowOpen", "appointmentSaved", "appointmentEdited", "appointmentDeleted", "navigation", "dragStart", "dragStop",
            "resizeStart", "resize", "resizeStop", "menuItemClick", "beforeContextMenuOpen", "reminder"
        ],
    _ignoreFromAppointmentOnExport:["dataSource","query","tableName","resourceFields"],
        _resources: function (index, property, value, old) {
            this.element.empty();
            this._bindResourcesData();
            if (!ej.isNullOrUndefined(this.dataSource()))
                this._renderAppointmentAll();
        },
        observables: ["appointmentSettings.dataSource", "currentView", "currentDate"],
        _tags: [
            { tag: "timezoneCollection", attr: [], "singular": "timezoneCollection" },
            { tag: "appointmentSettings.dataSource", attr: [], "singular": "dataSource" },
            {
                tag: "resources", attr: ["allowMultiple", "resourcesetting.text", "resourcesetting.id", "resourcesetting.groupId", "resourcesetting.color",
                  [{
                      tag: "resourceSettings.dataSource", attr: []
                  }]
                ]
            },
            { tag: "contextMenuSettings.menuItems.appointment", attr: ["id", "text", "parentId"], "singular": "appointment" },
            { tag: "contextMenuSettings.menuItems.cells", attr: ["id", "text", "parentId"] },
            { tag: "categorizeSettings.dataSource", attr: ["text", "id", "color", "fontColor"] },
            { tag: "timezoneCollection.dataSource", attr: ["text", "id", "value"] }
        ],
    currentView: ej.util.valueFunction("currentView"),
    currentDate: ej.util.valueFunction("currentDate"),
    dataSource: ej.util.valueFunction("appointmentSettings.dataSource"),

    // constructor function
    /**
    * Create the schedule widget
    * @private
    */
    _init: function () {
        this._currentDateFormat(this.model.dateFormat);       
            this._trigger("load");
            this.element.addClass("e-schedule"); //While resize the window the root class has been removed. 
            if (ej.isNullOrUndefined(this.model.appointmentSettings.query) || !(this.model.appointmentSettings.query instanceof ej.Query))
                this.model.appointmentSettings.query = ej.Query();
            (this.model.cssClass != null) && this.element.addClass(this.model.cssClass);
            this._initPrivateProperties();
            
            if (ej.scheduleFeatures.resources && !ej.isNullOrUndefined(this.model.resources))
                this._bindResourcesData();
            else
                this._renderInitSchedule();
            this._wireEvents();
            
            !ej.isNullOrUndefined(this.model.appointmentSettings) && (this._dataManager = this.dataSource() instanceof ej.DataManager ? this.dataSource() : this.dataSource() != null ? ej.DataManager(this.dataSource()) : null);
            this._bindAppointmentsData("Load");
        this.model.enableRTL && this.element.addClass("e-rtl");
        //Reminder options
        if (this.model.reminderSettings.enable) {
            this._checkReminders();
            this._reminderInterval = window.setInterval($.proxy(this._checkReminders, this), 60000);
        }
        this._businessHourScroller();
    },

    /**
    * To configure the properties at runtime using SetModel		
    * @private
    */
    _setModel: function (options) {
        var flag = false, _resFlag = false;
        for (var prop in options) {
            switch (prop) {
                case "views":
                    this.model.views = options[prop];
                    this.hTD.find("table.e-viewstable").remove();
                    this.hTD.find("div.e-viewsdiv").append(this._renderViewNavigation(options[prop]));
                    break;
                case "currentView":
                    this._navView = true;
                    this._viewChange(null, null, ej.util.getVal(options[prop]));
                    break;
                case "currentDate":
                    this._setCurrentDate = true;
                    if($.type(options[prop])=="string")					
					this._currentDateFormat(this.model.dateFormat);
					((this.currentDate() < this.model.minDate) && this.currentDate(this.model.minDate));
                    ((this.currentDate() > this.model.maxDate) && this.currentDate(this.model.maxDate));
                    this._navigateClick(null);
                    break;
                case "minDate":
                    this._currentDateFormat(this.model.dateFormat);
                    flag = true;
                    break;
                case "maxDate":
                    this._currentDateFormat(this.model.dateFormat);
                    flag = true;
                    break;
                case "timeMode":
                    this.model.timeMode=this._timeMode = options[prop];
                    this._appointmentAddWindow.find('.startendtime').ejTimePicker({ timeFormat: (this._timeMode == "12") ? this._pattern.t : "HH:mm" });
                    if(this.currentView() !== "month" && !(this._isCustomView())){
                        var viewclass = this.currentView() == "month" ? 1 : 0; //"e-monthtimecells" : "e-timecelldivs";
                        var timeCellhtml = this.timeCellTemplate.render({ timerows: this._getStartEndTime(), cols1: [1, 2], viewclass: viewclass });
                        this.$TimeCellTD.children().remove();
                        this.$TimeCellTD.append(timeCellhtml); if (this.model.showCurrentTimeIndicator) $(".e-highlightcurrenttimeline").remove(); 
                        this.element.find(".e-scrolltimecells").css("top", -(this.element.find(".e-draggableworkarea").scrollTop()) + "px");
                        this._highlightCurrentTime(this.model.showCurrentTimeIndicator);
                        if (!ej.isNullOrUndefined(this.dataSource()))
                           this._renderAppointmentAll();
                    }
                    break;
                case "timeZone":
                    this.model.timeZone = options[prop];
                    this.element.find("div.e-categorybar").remove();
                    this.element.find("div.e-appointment,div.e-alldayappointment,div.e-monthappointment").remove();
                    this._bindAppointmentsData("Load");
                    break;
                case "timezoneCollection":
                    $.extend(this.model.timezoneCollection, options[prop]);
                    this._appointmentAddWindow.find('.startutc').ejDropDownList({ dataSource: this.model.timezoneCollection.dataSource });
                    this._appointmentAddWindow.find('.endutc').ejDropDownList({ dataSource: this.model.timezoneCollection.dataSource });
                    break;
                case "startHour":
                    this.model.startHour = options[prop];
                    this._setNewStartEndHours();
                    break;
                case "endHour":
                    this.model.endHour = options[prop];
                    this._setNewStartEndHours();
                    break;
                case "highlightBusinessHours":
                    this.model.highlightBusinessHours = options[prop];
                    (this.model.highlightBusinessHours) ? this._highlightBusinessHours() : this.element.find(".e-workcells").removeClass("e-businesshighlightworkcells") && this.element.find(".e-monthcells").removeClass("e-monthcellhighlight");
                    (this.model.highlightBusinessHours == false) ? this._businessHourScroller() : "";
                    break;
                case "businessStartHour":
                    this.model.businessStartHour = options[prop];
                    this.currentView() !== "month" && !(this._isCustomView()) ? this.element.find(".e-workcells").removeClass("e-businesshighlightworkcells") : this.element.find(".e-monthcells").removeClass("e-monthcellhighlight");
                    this.model.highlightBusinessHours && this._highlightBusinessHours();
                    break;
                case "businessEndHour":
                    this.model.businessEndHour = options[prop];
                    this.currentView() !== "month" && !(this._isCustomView()) ? this.element.find(".e-workcells").removeClass("e-businesshighlightworkcells") : this.element.find(".e-monthcells").removeClass("e-monthcellhighlight");
                    this.model.highlightBusinessHours && this._highlightBusinessHours();
                    break;
                case "height":
                    this.model.height = options[prop];
                    if (this.model.showCurrentTimeIndicator) $(".e-highlightcurrenttimeline").remove(); 
                    flag = true;
                    break;
                case "width":
                    this.model.width = options[prop];
                    if (this.model.showCurrentTimeIndicator) $(".e-highlightcurrenttimeline").remove(); 
                    flag = true;
                    break;
                case "cssClass":
                    this.element.removeClass(this.model.cssClass).addClass(options[prop]);
                    break;
                case "locale":
                    this.model.locale = options[prop];
                    var culture = Globalize.culture(this.model.locale);
        	        this._dayShortNames = culture.calendar.days.namesAbbr;
        	        this._dayFullNames = culture.calendar.days.names;
        	        this._monthNames = culture.calendar.months.names;
        	        this._pattern = culture.calendar.patterns;
                    flag = true;
                    break;
                case "dateFormat":
                    this._appointmentAddWindow.find('.startenddate').ejDatePicker({ dateFormat: options[prop] });
                    this._appointmentAddWindow.find('.recurstartdate').ejDatePicker({ dateFormat: options[prop] });
                    this._appointmentAddWindow.find('.e-until').ejDatePicker({ dateFormat: options[prop] });
                    this._currentDateFormat(options[prop]);
                    break;
                case "enableResize":
                    this.model.enableResize = options[prop];
                    if (this.model.enableResize) {
                        !ej.isTouchDevice() ? this._on($(window), "resize", this._scheduleResize) : this._on($(window), "orientationchange", this._scheduleResize);
                        this._wireResizeEvents();
                    }
                    break;
		        case "readOnly":
                    this.model.readOnly = options[prop];
                    this._renderAppointmentAll();
                    break;
                case "showCurrentTimeIndicator":
                    this.model.showCurrentTimeIndicator = options[prop];
                    this._highlightCurrentTime(this.model.showCurrentTimeIndicator);
                    if (!this.model.showCurrentTimeIndicator) this.currentView() !== "month" && !(this._isCustomView()) ? $(".e-highlightcurrenttimeline").remove() : $(this.element.find(".e-monthcells")).removeClass("e-monthcurrenttime");
                    break;
                case "enableRTL":
                    options[prop] ? this.element.addClass("e-rtl") : this.element.removeClass("e-rtl");
                    this.model.enableRTL = options[prop];
                    var model = this.model;
                    this.element.ejSchedule("destroy").ejSchedule(model);
                    break;
                case "appointmentTemplateId":
                    this.model.appointmentTemplateId = options[prop];
                    this.element.find("div.e-appointment,div.e-alldayappointment,div.e-monthappointment").remove();
                    this.element.find("div.e-categorybar").remove();
                    if (!ej.isNullOrUndefined(this.dataSource()))
                    this._renderAppointmentAll();
                    break;
                case "allowKeyboardNavigation":
                    this.model.allowKeyboardNavigation = options[prop];
                    if (this.model.allowKeyboardNavigation) {
                        this._on(this.element, "keydown", $.proxy(this._onKeyDown, this));
                        this._on($(document), "keydown", $.proxy(this._documentOnKeyDown, this));
                    }
                    else {
                        this._off(this.element, "keydown");
                        this._off($(document), "keydown");
                    }
                    break;
                case "renderDates":
                    $.extend(this.model.renderDates, options[prop]);
                    this._navView = true; this._navigate = false;
                    this._viewChange(null, null, "customview");
                    break;
                case "appointmentSettings":
                    $.extend(this.model.appointmentSettings, options[prop]);
                    this.element.find("div.e-categorybar").remove();
                    this.element.find("div.e-appointment,div.e-alldayappointment,div.e-monthappointment,div.e-appsoverflow").remove();
                    this._bindAppointmentsData("Load");
                    break;
                case "contextMenuSettings":
                    $.extend(this.model.contextMenuSettings, options[prop]);
                    if (this.model.contextMenuSettings.enable && ej.isNullOrUndefined(this._contextMenu))
                        this._showContextMenu(this.model.contextMenuSettings.enable);
                    break;
                case "reminderSettings":
                    if (options[prop].enable)
                        this._checkReminders() && (this._reminderInterval = window.setInterval($.proxy(this._checkReminders, this), 60000));
                    else
                        window.clearInterval(this._reminderInterval);
                    break;
                case "enableAppointmentNavigation":
                    this.model.enableAppointmentNavigation = options[prop];
                    if(!this.model.enableAppointmentNavigation)
                        this.element.find(".e-prev,.e-next").remove();
                    else{
                        this._nextPrevAppointment(this.model.enableAppointmentNavigation);
                        if (!ej.isNullOrUndefined(this.dataSource()))
                            this._renderAppointmentAll();
                    }
                    break;
                case "resources":
                    if (ej.scheduleFeatures.resources && !ej.isNullOrUndefined(this.model.resources)) {
                        $.extend(this.model.resources, options[prop]);
                        flag = true; _resFlag = true;
                    }
                    break;
                case "categorizeSettings":
                    $.extend(this.model.categorizeSettings, options[prop]);
                    if (!ej.isNullOrUndefined(this.model.categorizeSettings)) {                      
                        if (this._appointmentAddWindow.find('.e-categorizevalue').length == 0) {
                            $appWindow = "<tr><td class='e-leftfields e-textlabel'>" + this._getLocalizedLabels("Categorize") + ":</td><td colspan='3' class='e-rightfields'>" + "<input id= '" + this._id + "_categorize' class='e-categorizevalue' type='text' value=''/><div id='ownerlist'></div></td></tr>";
                            this._appointmentAddWindow.find('.' + this._id + "summary").after($appWindow);
                            this._renderTemplates();
                            var control = this._appointmentAddWindow;
                            this._renderCategoryItems(control);
                        }
                        this._showContextMenu(this.model.contextMenuSettings.enable);
                        if (!ej.isNullOrUndefined(this.dataSource()))
                            this._renderAppointmentAll();
                    }
                    break;

                case "group":
                    if (ej.scheduleFeatures.resources && !ej.isNullOrUndefined(this.model.resources)) {
                        $.extend(this.model.group, options[prop]);
                        flag = true; _resFlag = true;
                    }
                    break;
                case "cellWidth":
                    this.model.cellWidth = options[prop];
                    if (this.model.showCurrentTimeIndicator) $(".e-highlightcurrenttimeline").remove();
                    flag = true;
                    break;
                case "cellHeight":
                    this.model.cellHeight = options[prop];
                    if (this.model.showCurrentTimeIndicator) $(".e-highlightcurrenttimeline").remove();
                    flag = true;
                    break;
                case "orientation":
                    this.model.orientation = options[prop];
                    flag = true;
                    break;
                case "resourceHeaderTemplateId":
                    this.model.resourceHeaderTemplateId = options[prop];
                    if (ej.scheduleFeatures.resources && !ej.isNullOrUndefined(this.model.group) && !ej.isNullOrUndefined(this.model.resources)) {
                        if (this.model.orientation == "horizontal") {
                            var resDiv = $(this.wTR.find("td")[0]);
                            resDiv.find("div.e-horizontresdiv").remove();
                            var resHtml = this._renderHorizontalResources();
                            resDiv.html(resHtml);
                        }
                        else {
                            this.aTR.empty();
                            this._renderHeaderAllDayTemplate();
                            this._headerbarWidth();
                            this.element.find(".e-schedulesettings").html(this._getLocalizedLabels("AllDay"));
                            this._renderAllDayAppointments();
                        }
                    }
                    break;
            }
        }
        if (flag) {
            this.element.empty();
            this.model.width = this.scrollWidth;
            this.model.height = this.scrollHeight;
			$("#" + this._id + "AppointmentAddEditWindow_wrapper,#" + this._id + "AppointmentQuickWindow_wrapper,#" + this._id + "AppDetailsWindow_wrapper").remove();
			(!_resFlag) ? this._renderInitSchedule() : this._bindResourcesData();
			(this.model.highlightBusinessHours == true) ? this._businessHourScroller() : "";
            if (!ej.isNullOrUndefined(this.dataSource()))
            this._renderAppointmentAll();
        }
    },

    //Touch Schedule:
    /**
    * To configure the touch for schedule		
    * @private
    */
    _touchSchedule: function (e) {
	if ($(e.target).is(".e-appointment,.e-alldayappointment,.e-monthappointment") ||  $(e.target).parents().is(".e-appointment,.e-alldayappointment,.e-monthappointment"))
            return false;
	    var event, value = parseInt(this.element.find(".e-draggableworkarea").css("margin-left"));
        switch (e.type) {
            case "swipeleft":
                if (this._mediaQuery) {
                    if (-value < (this.element.find(".e-draggableworkarea").width() - (this.element.find(".e-draggableworkarea").width() / this.res1.length))) {
                        this.element.find(".e-headeralldaydiv,.e-draggableworkarea").animate({ "margin-left": value + (-this.element.find(".e-draggableworkarea").width() / this.res1.length) }, 500);
                        return false;
                    }
                    this.element.find(".e-headeralldaydiv,.e-draggableworkarea").css("margin-left", "0px");
                }
                event = { currentTarget: this.element.find('.e-navigatenext') };
                this._navigateClick(event);
                break;
            case "swiperight":
                if (this._mediaQuery) {
                    if (-value > 0) {
                        this.element.find(".e-headeralldaydiv,.e-draggableworkarea").animate({ "margin-left": value + this.element.find(".e-draggableworkarea").width() / this.res1.length }, 500);
                        return false;
                    }
                    this.element.find(".e-headeralldaydiv,.e-draggableworkarea").css("margin-left", -(this.element.find(".e-draggableworkarea").width() - (this.element.find(".e-draggableworkarea").width() / this.res1.length)));
                }
                event = { currentTarget: this.element.find('.e-navigateprevious') };
                this._navigateClick(event);
                break;
        }
    },

    /**
    * To configure the private properties of schedule		
    * @private
    */
    _initPrivateProperties: function () {
        this._appId = 0;
        this._parentId = 0;
        this._currentAction = "";
        this._reminderClose = false;
        this._currentAppointmentData = [];
        this._processed = [];
        this._dateRender = [];
        this._rRule = {};
        this._dayNames = ["SU", "MO", "TU", "WE", "TH", "FR", "SA"];
        var culture = Globalize.culture(this.model.locale);
        this._dayShortNames = culture.calendar.days.namesAbbr;
        this._dayFullNames = culture.calendar.days.names;
        this._monthNames = culture.calendar.months.names;
        this._pattern = culture.calendar.patterns;
        this._navView = false;
        this._editKey = false;
        this._cellClick = false;
        this._gotoDate = true;
        this._recurChecked = false;
        this._currentRowIndex = 0;
        this._currentColIndex = 0;
        this._setCurrentDate = false;
        this._browserInfo = ej.browserInfo();
        this._leftResizing = false;
        this._rightResizing = false;
        this._topResizing = false;
        this._bottomResizing = false;
        this._focused = null;
        this._navigate = false;
        this._mediaQuery = false;
    },
    /**
    * destroy the schedule widget
    * all events bound using this._on will be unbind automatically and bring the control to pre-init state.
    * @alias destroy
    * @return jQuery
    * @example 
    * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
    * &lt;script&gt;
    * $('#Schedule').ejSchedule();
        * var schObj = $("#Schedule").data("ejSchedule");
    * schObj.destroy(); // destroy the schedule
    * &lt;/script&gt;
    * @memberof ejSchedule
    * @instance
    */
    _destroy: function () {
        //Appointment window and Edit window controls destory
        this._destorySubControls($("#" + this._id + "_AddEditForm"));
        this._destorySubControls($("#" + this._id + "_RecurForm"));
        this.element.find("#" + this._id + "_navigator").ejDatePicker("destroy");
        //Clear  set interval
        window.clearInterval(this._intervalID);
        //Remove dialogs
        $("#" + this._id + "AppointmentAddEditWindow_wrapper,#" + this._id + "AppointmentQuickWindow_wrapper,#" + this._id + "AppDetailsWindow_wrapper").remove();
        //Remove templates
        $("#" + this._id + "_WorkCells_Template,#" + this._id + "_MonthCells_Template,#" + this._id + "_TimeCells_Template,#" + this._id + "_HeaderDate_Template,#" + this._id + "_Appointment_Template,#" + this._id + "_AlldayCells_Template").remove();
        this.element.empty().removeClass("e-schedule");
    },

    /**
    * Destroy subcontrols.
    * @private
    */
    _destorySubControls: function (formelement) {
        $formEle = formelement.find('.e-timepicker,.e-datepicker,.e-dropdownlist,.e-autocomplete');
        for (var index = 0; index < $formEle.length; index++) {
            $element = $($formEle[index]);
            if ($element.hasClass('e-timepicker'))
                $element.ejTimePicker("destroy");
            else if ($element.hasClass('e-datepicker'))
                $element.ejDatePicker("destroy");
            else if ($element.hasClass('e-dropdownlist'))
                $element.ejDropDownList("destroy");
            else if ($element.hasClass('e-autocomplete'))
                $element.ejAutocomplete("destroy");
        }
    },

    /**
    * Wiring the events to schedule control		
    * @private
    */
    _wireEvents: function () {
        this._on((this.element, $(window)), "mousedown", $.proxy(this._onScheduleMouseDown, this));
        this._on(this.element, "click", "div.e-navigateprevious,div.e-navigatenext", $.proxy(this._navigateClick, this));
        this._on($(window), "resize", $.proxy(this._onScheduleResize, this));
        this._on(this.element, "click", ".e-commonviewbutton", $.proxy(this._viewChange, this));
        this._on(this.element, "click", ".e-datedisplay", $.proxy(this._viewCalendar, this));
        this._on(this.element, "click", "div.e-appsoverflow", $.proxy(this._appOverflowClick, this));
        //next/prev event
        this._on(this.element, "click", ".e-prev.enable,.e-next.enable", $.proxy(this._nextPrev, this));
        //Work Cell events
        this._on(this.element, "dblclick", ".e-headercells", $.proxy(this._navigateView, this));
        this._on(this.element, "click", ".e-headercells,.e-timecells,td.e-monthcells div.e-monthheader", $.proxy(this._navigateView, this));
        this._on(this.element, "mouseover", "td.e-workcells,td.e-monthcells", $.proxy(this._onCellMouseOver, this));
        this._on(this.element, "mouseout", "td.e-workcells,td.e-monthcells", $.proxy(this._onCellMouseOver, this));
        this._on(this.element, $.isFunction($.fn.tap) ? "tap" : "click", ".e-workcells,.e-alldaycells,.e-alldayappointment,.e-monthcells,div.e-monthappointment", $.proxy(this._cellSelection, this));
        if (!this._mediaQuery) {
            this._on(this.element, ej.eventType.mouseDown, "td.e-workcells,td.e-monthcells", $.proxy(this._mouseButtonClick, this));
            this._on(this.element, "keydown click", "td.e-workcells,td.e-monthcells", $.proxy(this._shiftSelection, this));
        }
        // Appointments events
        this._on(this.element, (ej.isDevice()) ? "click" : "dblclick", ".e-workcells,.e-alldaycells,.e-alldayappointment,div.e-monthappointment,.e-monthcells", $.proxy(this._appointmentWindow, this));
        this._on(this.element, "mouseover", ".e-appointment,.e-alldayappointment,.e-monthappointment", $.proxy(this._onAppointMouseOver, this));
        this._on(this.element, "mouseout", ".e-appointment,.e-alldayappointment,.e-monthappointment", $.proxy(this._onAppointMouseOver, this));
        (this._mediaQuery) && this._on(this.element, "click", "#navDrawer", $.proxy(this._drawerOpen, this));
        // Keydown events
        if (this.model.allowKeyboardNavigation) {
            this._on(this.element, "keydown", $.proxy(this._onKeyDown, this));
            this._on($(document), "keydown", $.proxy(this._documentOnKeyDown, this));
        }
        if (this.model.orientation == "horizontal")
            this._on(this.element, "click", "td.e-parentnodecategory", $.proxy(this._onResourceClick, this));
        //Touch event.
        this._on(this.element, "swipeleft swiperight", ".e-contentarearow .e-workcellstab", $.proxy(this._touchSchedule, this));
        // Rezize events
        if (this.model.enableResize)
            !ej.isTouchDevice() ? this._on($(window), "resize", this._scheduleResize) : this._on($(window), "orientationchange", this._scheduleResize);
    },

    _drawerOpen: function () {
        this._scheduleDrawer.ejNavigationDrawer("open");
    },

    _mouseButtonClick: function (e) {
        if (!(e.altKey) && !(e.shiftKey) && !(e.ctrlKey) && (e.which != 3)) {
            if (e.which == 1 || e.type == "touchstart") {
                var oEl = e.target || document.activeElement || e.srcElement;
                this._mouseSelect(e, oEl);
            }
        }
    },
    _shiftSelection: function (e) {
        if (e.shiftKey == true && e.which == 1) {
            var oE1 = this._focused;
            this.model.showQuickWindow && (this._quickAppointWindow.ejDialog("close") && this._quickAppDetailsWindow.ejDialog("close"));
            this.element.find("e.workcells,e.alldaycells,.e-monthcells").removeClass("e-mousehover");
            this.element.find(".e-workcells,.e-alldaycells,.e-monthcells").removeClass("e-selectedCell");
            this.element.find('.e-selectedAppointment').removeClass("e-selectedAppointment");
            var oRowCell = this.element.find('div.e-draggableworkarea tr');
            var sourceRowIndex, sourceColumnIndex;
            sourceRowIndex = $(oE1).parent()[0].rowIndex;
            sourceColumnIndex = $(oE1)[0].cellIndex;
            var view = this.currentView();
            var rowcount = oRowCell.length - 1;
            var i, j, k;
            var currentRowIndex = $(e.target).parent()[0].rowIndex;
            var currentColumnIndex = $(e.target)[0].cellIndex;
            var renderDate = (this.model.orientation == "horizontal" && this.model.currentView == "month") ? this.monthDays : this.model.orientation == "vertical" ? this.dateRender : this._dateRender;
            var orientation = this.model.orientation;
            var horicells = (this.model.endHour - this.model.startHour) * 2;
            var cellindex = $(e.target).hasClass("e-workcells") ? $(e.target).index() : $(e.target).hasClass("e-alldaycells") ? $(e.target).index() : 7 - ((parseInt($(e.target).index() / 7) + 1) * 7 - $(e.target).index()) + ($(e.target).parent().index() * 7);
            ((orientation == "horizontal") && (cellindex = view !== "month" ? Math.floor(cellindex / horicells) : cellindex));
            var curDate = new Date(renderDate[cellindex]);
            if ((curDate >= this.model.minDate) && (curDate <= this.model.maxDate)) {
                if ($(e.target).hasClass('e-workcells')) {
                    if (this.model.orientation == "vertical") {
                        var viewCount = view == "day" ? 1 : view == "workweek" ? 5 : 7;
                        var resIndex = Math.floor($(e.target).index() / viewCount);
                        var resmaxcolindex = (viewCount * (resIndex + 1));
                        var resmincolindex = (viewCount * resIndex);
                        if (sourceColumnIndex >= parseInt(resmincolindex) && sourceColumnIndex <= parseInt(resmaxcolindex) - 1 && currentColumnIndex != "undefined") {
                            if (sourceColumnIndex == currentColumnIndex) {
                                if (currentRowIndex > sourceRowIndex) {
                                    for (k = parseInt(sourceRowIndex) ; k <= currentRowIndex; k++) {
                                        $(oRowCell[k].cells[sourceColumnIndex]).addClass("e-selectedCell");
                                    }
                                }
                                else if (currentRowIndex < sourceRowIndex) {
                                    for (k = parseInt(sourceRowIndex) ; k >= currentRowIndex; k--) {
                                        $(oRowCell[k].cells[sourceColumnIndex]).addClass("e-selectedCell");
                                    }
                                }
                                else {
                                    $(oRowCell[currentRowIndex].cells[currentColumnIndex]).addClass("e-selectedCell");
                                }
                            }
                            else if (currentColumnIndex > sourceColumnIndex) {
                                var difference = currentColumnIndex - sourceColumnIndex;
                                for (i = parseInt(sourceRowIndex) ; i <= rowcount; i++) {
                                    $(oRowCell[i].cells[sourceColumnIndex]).addClass("e-selectedCell");
                                }
                                if (difference > 1) {
                                    for (k = 1; k <= difference - 1; k++) {
                                        for (var m = 0; m <= rowcount; m++) {
                                            $(oRowCell[m].cells[currentColumnIndex - k]).addClass("e-selectedCell");
                                        }
                                    }
                                }
                                for (j = 0; j <= currentRowIndex; j++) {
                                    $(oRowCell[j].cells[currentColumnIndex]).addClass("e-selectedCell");
                                }
                            }
                            else if (currentColumnIndex < sourceColumnIndex) {
                                var difference = sourceColumnIndex - currentColumnIndex;
                                for (i = parseInt(sourceRowIndex) ; i >= 0 ; i--) {
                                    $(oRowCell[i].cells[sourceColumnIndex]).addClass("e-selectedCell");
                                }
                                if (difference > 1) {
                                    for (k = 1; k <= difference - 1; k++) {
                                        for (var m = 0; m <= rowcount; m++) {
                                            $(oRowCell[m].cells[[currentColumnIndex + k]]).addClass("e-selectedCell");
                                        }
                                    }
                                }
                                for (j = parseInt(currentRowIndex) ; j <= rowcount; j++) {
                                    $(oRowCell[j].cells[currentColumnIndex]).addClass("e-selectedCell");
                                }
                            }
                            this._currentRowIndex = currentRowIndex;
                            this._currentColIndex = currentColumnIndex;
                            $(oRowCell[currentRowIndex].cells[currentColumnIndex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                        }
                        else { return false; }
                    }
                    else {
                        var count = view == "day" ? 1 : view == "workweek" ? 5 : 7;
                        var viewCount = this.model.currentView == "month" ? this.totdays.length : count * (this.model.endHour - this.model.startHour) * 2;
                        var resIndex = Math.floor($(e.target).index() / viewCount);
                        var resmaxcolindex = (viewCount * (resIndex + 1));
                        var resmincolindex = (viewCount * resIndex);
                        if (sourceRowIndex == currentRowIndex && sourceColumnIndex >= parseInt(resmincolindex) && sourceColumnIndex <= parseInt(resmaxcolindex) - 1 && currentColumnIndex != "undefined") {
                            if (currentColumnIndex > sourceColumnIndex) {
                                for (j = sourceColumnIndex ; j <= currentColumnIndex; j++) {
                                    $(oRowCell[currentRowIndex].cells[j]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                                }
                            }
                            else if (currentColumnIndex <= sourceColumnIndex) {
                                for (j = sourceColumnIndex ; j >= currentColumnIndex; j--) {
                                    $(oRowCell[currentRowIndex].cells[j]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                                }
                            }
                        }
                        else { return false; }
                    }
                }
                else if ($(e.target).hasClass('e-monthcells')) {
                    var resIndex = Math.floor($(e.target).index() / 7);
                    var mincolindex = 7 * (parseInt(resIndex));
                    var maxcolindex = 7 * (resIndex + 1);
                    if (sourceColumnIndex >= parseInt(mincolindex) && sourceColumnIndex <= parseInt(maxcolindex) - 1 && currentColumnIndex != "undefined") {
                        if (currentRowIndex == sourceRowIndex) {
                            if (currentColumnIndex < sourceColumnIndex) {
                                for (k = sourceColumnIndex; k >= currentColumnIndex; k--) {
                                    $(oRowCell[currentRowIndex].cells[k]).addClass("e-selectedCell");
                                }
                            }
                            else if (currentColumnIndex > sourceColumnIndex) {
                                for (k = sourceColumnIndex; k <= currentColumnIndex; k++) {
                                    $(oRowCell[currentRowIndex].cells[k]).addClass("e-selectedCell");
                                }
                            }
                            else if (currentColumnIndex == sourceColumnIndex) {
                                $(oRowCell[currentRowIndex].cells[currentColumnIndex]).addClass("e-selectedCell");
                            }
                        }
                        else if (currentRowIndex > sourceRowIndex) {
                            var difference = (currentRowIndex - sourceRowIndex);
                            for (i = sourceColumnIndex; i < maxcolindex; i++) {
                                $(oRowCell[sourceRowIndex].cells[i]).addClass("e-selectedCell");
                            }
                            if (difference > 1) {
                                for (k = 1; k <= difference - 1; k++) {
                                    for (i = mincolindex ; i < maxcolindex; i++) {
                                        $(oRowCell[sourceRowIndex + k].cells[i]).addClass("e-selectedCell");
                                    }
                                }
                            }
                            for (j = mincolindex; j <= currentColumnIndex; j++) {
                                $(oRowCell[currentRowIndex].cells[j]).addClass("e-selectedCell");
                            }
                        }
                        else if (currentRowIndex < sourceRowIndex) {
                            var difference = (sourceRowIndex - currentRowIndex);
                            for (i = sourceColumnIndex; i >= mincolindex; i--) {
                                $(oRowCell[sourceRowIndex].cells[i]).addClass("e-selectedCell");
                            }
                            if (difference > 1) {
                                for (k = 1; k <= difference - 1; k++) {
                                    for (i = mincolindex; i < maxcolindex; i++) {
                                        $(oRowCell[sourceRowIndex - k].cells[i]).addClass("e-selectedCell");
                                    }
                                }
                            }
                            for (j = maxcolindex - 1; j >= currentColumnIndex; j--) {
                                $(oRowCell[currentRowIndex].cells[j]).addClass("e-selectedCell");
                            }
                        }
                        this._currentRowIndex = currentRowIndex;
                        this._currentColIndex = currentColumnIndex;
                        $(oRowCell[currentRowIndex].cells[currentColumnIndex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    }
                    else { return false; }
                }
            }
        }
    },

    _mouseSelect: function (event, oEl) {
        this.model.showQuickWindow && (this._quickAppointWindow.ejDialog("close") && this._quickAppDetailsWindow.ejDialog("close"));
        var oRowCell = this.element.find('div.e-draggableworkarea tr');
        if ($(oEl).hasClass("e-selectedAppointment")) {
            this.element.find('.e-selectedAppointment').removeClass("e-selectedAppointment");
            $(oRowCell[0].cells[0]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
        }
        var sourceRowIndex, sourceColumnIndex, lastRowIndex, lastColumnIndex;
        var target = this.element.find('div.e-draggableworkarea');
        sourceRowIndex = $(oEl).parent()[0].rowIndex;
        sourceColumnIndex = $(oEl)[0].cellIndex;
        var view = this.currentView();
        var rowcount = oRowCell.length - 1;
        this._currentRowIndex = sourceRowIndex;
        this._currentColIndex = sourceColumnIndex;
        var orientation = this.model.orientation;
        var horicells = (this.model.endHour - this.model.startHour) * 2;
        var mindate = this.model.minDate; var maxdate = this.model.maxDate;
        var renderDate = (this.model.orientation == "horizontal" && this.model.currentView == "month") ? this.monthDays : this.model.orientation == "vertical" ? this.dateRender : this._dateRender;
        var cellindexs = $(event.target).hasClass("e-workcells") ? $(event.target).index() : $(event.target).hasClass("e-alldaycells") ? $(event.target).index() : 7 - ((parseInt($(event.target).index() / 7) + 1) * 7 - $(event.target).index()) + ($(event.target).parent().index() * 7);
        ((orientation == "horizontal") &&(cellindexs = view !== "month" ? Math.floor(cellindexs /horicells) : cellindexs));              
        var curDates = new Date(renderDate[cellindexs]);
        if ((curDates >= mindate) && (curDates <= maxdate)) {
            if ($(oEl).hasClass('e-workcells') || $(oEl).hasClass('e-monthcells')) {
                oRowCell.bind(ej.eventType.mouseMove, function (e) {
                    e.preventDefault();
                    var currTarget = e.target;
                    if (e.type == 'touchmove') {
                        var coor = e.originalEvent.changedTouches[0];
                        currTarget = document.elementFromPoint(coor.pageX, coor.pageY);
                    }
                    var cellindex = $(currTarget).hasClass("e-workcells") ? $(currTarget).index() : $(currTarget).hasClass("e-alldaycells") ? $(currTarget).index() : 7 - ((parseInt($(currTarget).index() / 7) + 1) * 7 - $(currTarget).index()) + ($(currTarget).parent().index() * 7);
                    ((orientation == "horizontal") && (cellindex = view !== "month" ? Math.floor(cellindex / horicells) : cellindex));
                    var curDate = new Date(renderDate[cellindex]);
                    if ((curDate >= mindate) && (curDate <= maxdate)) {
                        if ($(currTarget).hasClass('e-workcells') || $(currTarget).hasClass('e-monthcells')) {
                            var i, j, k;
                            var currentRowIndex = $(currTarget).parent()[0].rowIndex;
                            var currentColumnIndex = $(currTarget)[0].cellIndex;
                            if (orientation == "vertical") {
                                if ($(currTarget).hasClass('e-workcells')) {
                                    var viewCount = view == "day" ? 1 : view == "workweek" ? 5 : 7;
                                    var resIndex = Math.floor($(currTarget).index() / viewCount);
                                    var resmaxcolindex = (viewCount * (resIndex + 1));
                                    var resmincolindex = (viewCount * resIndex);
                                    if (sourceColumnIndex >= parseInt(resmincolindex) && sourceColumnIndex <= parseInt(resmaxcolindex) - 1 && currentColumnIndex != "undefined") {
                                        if (sourceColumnIndex == currentColumnIndex && (currentRowIndex <= sourceRowIndex || currentRowIndex >= sourceRowIndex)) {
                                            if ($(oRowCell[currentRowIndex].cells[currentColumnIndex]).hasClass("e-selectedCell")) {
                                                if (currentColumnIndex > lastColumnIndex) {
                                                    for (i = rowcount; i >= 0; i--)
                                                        $(oRowCell[i].cells[currentColumnIndex - 1]).removeClass("e-selectedCell");
                                                    if (currentRowIndex > sourceRowIndex) {
                                                        for (i = 0; i <= rowcount; i++)
                                                            $(oRowCell[i].cells[currentColumnIndex]).removeClass("e-selectedCell");
                                                    }
                                                    else if (currentRowIndex < sourceRowIndex) {
                                                        for (i = 0; i < currentRowIndex; i++)
                                                            $(oRowCell[i].cells[currentColumnIndex]).removeClass("e-selectedCell");
                                                    }
                                                    else if (currentRowIndex == sourceRowIndex) {
                                                        for (i = 0; i <= rowcount; i++) {
                                                            if (i != sourceRowIndex)
                                                                $(oRowCell[i].cells[currentColumnIndex]).removeClass("e-selectedCell");
                                                        }
                                                    }
                                                }
                                                else if (currentColumnIndex < lastColumnIndex) {
                                                    for (i = rowcount; i >= 0; i--)
                                                        $(oRowCell[i].cells[currentColumnIndex + 1]).removeClass("e-selectedCell");
                                                    if (currentRowIndex > sourceRowIndex) {
                                                        for (i = rowcount; i > currentRowIndex; i--)
                                                            $(oRowCell[i].cells[currentColumnIndex]).removeClass("e-selectedCell");
                                                    }
                                                    else if (currentRowIndex < sourceRowIndex) {
                                                        for (i = rowcount; i > sourceRowIndex; i--)
                                                            $(oRowCell[i].cells[currentColumnIndex]).removeClass("e-selectedCell");
                                                    }
                                                    else if (currentRowIndex == sourceRowIndex) {
                                                        for (i = 0; i <= rowcount; i++) {
                                                            if (i != sourceRowIndex)
                                                                $(oRowCell[i].cells[currentColumnIndex]).removeClass("e-selectedCell");
                                                        }
                                                    }
                                                }
                                                else if (currentColumnIndex == lastColumnIndex) {
                                                    if (currentRowIndex > sourceRowIndex) {
                                                        for (i = rowcount; i > currentRowIndex; i--)
                                                            $(oRowCell[i].cells[currentColumnIndex]).removeClass("e-selectedCell");
                                                    }
                                                    else if (currentRowIndex < sourceRowIndex) {
                                                        for (i = 0; i < currentRowIndex; i++)
                                                            $(oRowCell[i].cells[currentColumnIndex]).removeClass("e-selectedCell");
                                                    }
                                                    else if (currentRowIndex == sourceRowIndex) {
                                                        for (i = 0; i <= rowcount; i++) {
                                                            if (i != sourceRowIndex)
                                                                $(oRowCell[i].cells[currentColumnIndex]).removeClass("e-selectedCell");
                                                        }
                                                    }
                                                }
                                            }
                                            else {
                                                if (currentRowIndex > sourceRowIndex) {
                                                    for (i = 0; i <= rowcount; i++)
                                                        $(oRowCell[i].cells[lastColumnIndex]).removeClass("e-selectedCell");
                                                    for (j = 0; j < sourceRowIndex; j++)
                                                        $(oRowCell[j].cells[sourceColumnIndex]).removeClass("e-selectedCell");
                                                    for (k = parseInt(sourceRowIndex) ; k <= currentRowIndex; k++) {
                                                        $(oRowCell[k].cells[sourceColumnIndex]).addClass("e-selectedCell");
                                                    }
                                                }
                                                else if (currentRowIndex < sourceRowIndex) {
                                                    for (i = 0; i < rowcount; i++)
                                                        $(oRowCell[i].cells[lastColumnIndex]).removeClass("e-selectedCell");
                                                    for (j = rowcount; j > sourceRowIndex; j--)
                                                        $(oRowCell[j].cells[sourceColumnIndex]).removeClass("e-selectedCell");
                                                    for (k = parseInt(sourceRowIndex) ; k >= currentRowIndex; k--) {
                                                        $(oRowCell[k].cells[sourceColumnIndex]).addClass("e-selectedCell");
                                                    }
                                                }
                                            }
                                            $(oRowCell[currentRowIndex].cells[currentColumnIndex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                                        }
                                        else if (currentColumnIndex > sourceColumnIndex) {
                                            if ($(oRowCell[currentRowIndex].cells[currentColumnIndex]).hasClass("e-selectedCell")) {
                                                if (currentColumnIndex < lastColumnIndex) {
                                                    for (i = rowcount; i >= 0; i--)
                                                        $(oRowCell[i].cells[lastColumnIndex]).removeClass("e-selectedCell");
                                                    for (j = rowcount; j > currentRowIndex; j--)
                                                        $(oRowCell[j].cells[currentColumnIndex]).removeClass("e-selectedCell");
                                                }
                                                else if (currentColumnIndex == lastColumnIndex) {
                                                    for (i = rowcount; i > currentRowIndex; i--)
                                                        $(oRowCell[i].cells[currentColumnIndex]).removeClass("e-selectedCell");
                                                }
                                                $(oRowCell[currentRowIndex].cells[currentColumnIndex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                                            } else {
                                                for (var l = 0; l < sourceRowIndex; l++) {
                                                    $(oRowCell[l].cells[sourceColumnIndex]).removeClass("e-selectedCell");
                                                }
                                                var difference = currentColumnIndex - sourceColumnIndex;
                                                for (i = parseInt(sourceRowIndex) ; i <= rowcount; i++) {
                                                    $(oRowCell[i].cells[sourceColumnIndex]).addClass("e-selectedCell");
                                                }
                                                if (difference > 1) {
                                                    for (k = 1; k <= difference - 1; k++) {
                                                        for (var m = 0; m <= rowcount; m++) {
                                                            $(oRowCell[m].cells[currentColumnIndex - k]).addClass("e-selectedCell");
                                                        }
                                                    }
                                                }
                                                for (j = 0; j <= currentRowIndex; j++) {
                                                    $(oRowCell[j].cells[currentColumnIndex]).addClass("e-selectedCell");
                                                }
                                                $(oRowCell[currentRowIndex].cells[currentColumnIndex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                                            }
                                        }
                                        else if (currentColumnIndex < sourceColumnIndex) {
                                            if ($(oRowCell[currentRowIndex].cells[currentColumnIndex]).hasClass("e-selectedCell")) {
                                                if (currentColumnIndex > lastColumnIndex) {
                                                    for (i = rowcount; i >= 0; i--)
                                                        $(oRowCell[i].cells[lastColumnIndex]).removeClass("e-selectedCell");
                                                    for (j = 0; j < currentRowIndex; j++)
                                                        $(oRowCell[j].cells[currentColumnIndex]).removeClass("e-selectedCell");
                                                }
                                                else if (currentColumnIndex == lastColumnIndex) {
                                                    for (i = 0; i < currentRowIndex; i++)
                                                        $(oRowCell[i].cells[currentColumnIndex]).removeClass("e-selectedCell");
                                                }
                                                $(oRowCell[currentRowIndex].cells[currentColumnIndex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                                            } else {
                                                for (var l = rowcount; l > sourceRowIndex; l--) {
                                                    $(oRowCell[l].cells[sourceColumnIndex]).removeClass("e-selectedCell");
                                                }
                                                var difference = sourceColumnIndex - currentColumnIndex;
                                                for (i = parseInt(sourceRowIndex) ; i >= 0 ; i--) {
                                                    $(oRowCell[i].cells[sourceColumnIndex]).addClass("e-selectedCell");
                                                }
                                                if (difference > 1) {
                                                    for (k = 1; k <= difference - 1; k++) {
                                                        for (var m = 0; m <= rowcount; m++) {
                                                            $(oRowCell[m].cells[[currentColumnIndex + k]]).addClass("e-selectedCell");
                                                        }
                                                    }
                                                }
                                                for (j = rowcount ; j >= parseInt(currentRowIndex) ; j--) {
                                                    $(oRowCell[j].cells[currentColumnIndex]).addClass("e-selectedCell");
                                                }
                                                $(oRowCell[currentRowIndex].cells[currentColumnIndex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                                            }
                                        }
                                    }
                                    else { return false; }
                                }
                                else if ($(currTarget).hasClass('e-monthcells')) {
                                    var resIndex = Math.floor($(currTarget).index() / 7);
                                    var mincolindex = 7 * (parseInt(resIndex));
                                    var maxcolindex = 7 * (resIndex + 1);
                                    if (sourceColumnIndex >= parseInt(mincolindex) && sourceColumnIndex <= parseInt(maxcolindex) - 1 && currentColumnIndex != "undefined") {
                                        if ($(oRowCell[currentRowIndex].cells[currentColumnIndex]).hasClass("e-selectedCell")) {
                                            if (currentRowIndex == sourceRowIndex) {
                                                if (currentRowIndex < lastRowIndex) {
                                                    for (i = maxcolindex; i > currentColumnIndex; i--)
                                                        $(oRowCell[currentRowIndex].cells[i]).removeClass("e-selectedCell");
                                                    for (j = maxcolindex; j >= 0; j--)
                                                        $(oRowCell[currentRowIndex + 1].cells[j]).removeClass("e-selectedCell");
                                                }
                                                else if (currentRowIndex > lastRowIndex) {
                                                    for (i = currentColumnIndex; i < maxcolindex; i++)
                                                        $(oRowCell[currentRowIndex - 1].cells[i]).removeClass("e-selectedCell");
                                                    for (j = 0; j < currentColumnIndex; j++)
                                                        $(oRowCell[currentRowIndex].cells[j]).removeClass("e-selectedCell");
                                                }
                                                else if (currentRowIndex == lastRowIndex) {
                                                    if (currentColumnIndex > sourceColumnIndex) {
                                                        for (i = maxcolindex; i > currentColumnIndex; i--)
                                                            $(oRowCell[currentRowIndex].cells[i]).removeClass("e-selectedCell");
                                                    }
                                                    else if (currentColumnIndex < sourceColumnIndex) {
                                                        for (i = 0; i < currentColumnIndex; i++)
                                                            $(oRowCell[currentRowIndex].cells[i]).removeClass("e-selectedCell");
                                                    }
                                                    if (currentColumnIndex == sourceColumnIndex) {
                                                        for (i = 0; i <= maxcolindex; i++) {
                                                            if (i != sourceColumnIndex)
                                                                $(oRowCell[currentRowIndex].cells[i]).removeClass("e-selectedCell");
                                                        }
                                                    }
                                                }
                                            }
                                            else if (currentRowIndex > sourceRowIndex) {
                                                if (currentRowIndex < lastRowIndex) {
                                                    for (i = maxcolindex; i > currentColumnIndex; i--)
                                                        $(oRowCell[currentRowIndex].cells[i]).removeClass("e-selectedCell");
                                                    for (j = maxcolindex; j >= 0; j--)
                                                        $(oRowCell[currentRowIndex + 1].cells[j]).removeClass("e-selectedCell");
                                                }
                                                else if (currentRowIndex == lastRowIndex) {
                                                    for (j = maxcolindex; j > currentColumnIndex; j--)
                                                        $(oRowCell[currentRowIndex].cells[j]).removeClass("e-selectedCell");
                                                }
                                            }
                                            else if (currentRowIndex < sourceRowIndex) {
                                                if (currentRowIndex > lastRowIndex) {
                                                    for (i = currentColumnIndex; i < maxcolindex; i++)
                                                        $(oRowCell[currentRowIndex - 1].cells[i]).removeClass("e-selectedCell");
                                                    for (j = 0; j < currentColumnIndex; j++)
                                                        $(oRowCell[currentRowIndex].cells[j]).removeClass("e-selectedCell");

                                                }
                                                else if (currentRowIndex == lastRowIndex) {
                                                    for (j = 0; j < currentColumnIndex; j++)
                                                        $(oRowCell[currentRowIndex].cells[j]).removeClass("e-selectedCell");
                                                }
                                            }
                                            $(oRowCell[currentRowIndex].cells[currentColumnIndex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                                        }
                                        else {
                                            if (currentRowIndex == sourceRowIndex) {
                                                if (currentColumnIndex < sourceColumnIndex) {
                                                    for (i = maxcolindex; i >= 0; i--) {
                                                        $(oRowCell[currentRowIndex + 1].cells[i]).removeClass("e-selectedCell");
                                                    }
                                                    for (j = maxcolindex; j > currentColumnIndex; j--) {
                                                        $(oRowCell[currentRowIndex].cells[j]).removeClass("e-selectedCell");
                                                    }
                                                    for (k = sourceColumnIndex; k >= currentColumnIndex; k--) {
                                                        $(oRowCell[currentRowIndex].cells[k]).addClass("e-selectedCell");
                                                    }
                                                }
                                                else if (currentColumnIndex > sourceColumnIndex) {
                                                    for (i = 0; i < maxcolindex; i++) {
                                                        if (currentRowIndex != 0)
                                                            $(oRowCell[currentRowIndex - 1].cells[i]).removeClass("e-selectedCell");
                                                    }
                                                    for (j = 0; j < sourceColumnIndex; j++) {
                                                        $(oRowCell[currentRowIndex].cells[j]).removeClass("e-selectedCell");
                                                    }
                                                    for (k = sourceColumnIndex; k <= currentColumnIndex; k++) {
                                                        $(oRowCell[currentRowIndex].cells[k]).addClass("e-selectedCell");
                                                    }
                                                }
                                                else if (currentColumnIndex == sourceColumnIndex) {
                                                    $(oRowCell[currentRowIndex].cells[currentColumnIndex]).addClass("e-selectedCell");
                                                }
                                            }
                                            else if (currentRowIndex > sourceRowIndex) {
                                                for (var l = mincolindex; l < sourceColumnIndex; l++) {
                                                    $(oRowCell[sourceRowIndex].cells[l]).removeClass("e-selectedCell");
                                                }
                                                var difference = (currentRowIndex - sourceRowIndex);
                                                for (i = sourceColumnIndex; i < maxcolindex; i++) {
                                                    $(oRowCell[sourceRowIndex].cells[i]).addClass("e-selectedCell");
                                                }
                                                if (difference > 1) {
                                                    for (k = 1; k <= difference; k++) {
                                                        for (i = mincolindex ; i < maxcolindex; i++) {
                                                            $(oRowCell[sourceRowIndex + k].cells[i]).addClass("e-selectedCell");
                                                        }
                                                    }
                                                }
                                                for (j = mincolindex; j <= currentColumnIndex; j++) {
                                                    $(oRowCell[currentRowIndex].cells[j]).addClass("e-selectedCell");
                                                }
                                            }
                                            else if (currentRowIndex < sourceRowIndex) {
                                                for (var l = maxcolindex; l > sourceColumnIndex; l--) {
                                                    $(oRowCell[sourceRowIndex].cells[l]).removeClass("e-selectedCell");
                                                }
                                                var difference = (sourceRowIndex - currentRowIndex);
                                                for (i = sourceColumnIndex; i >= mincolindex; i--) {
                                                    $(oRowCell[sourceRowIndex].cells[i]).addClass("e-selectedCell");
                                                }
                                                if (difference > 1) {
                                                    for (k = 1; k <= difference; k++) {
                                                        for (i = mincolindex; i < maxcolindex; i++) {
                                                            $(oRowCell[sourceRowIndex - k].cells[i]).addClass("e-selectedCell");
                                                        }
                                                    }
                                                }
                                                for (j = maxcolindex - 1; j >= currentColumnIndex; j--) {
                                                    $(oRowCell[currentRowIndex].cells[j]).addClass("e-selectedCell");
                                                }
                                            }
                                            $(oRowCell[currentRowIndex].cells[currentColumnIndex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                                        }
                                    }
                                    else { return false; }
                                }
                                lastRowIndex = currentRowIndex;
                                lastColumnIndex = currentColumnIndex;
                            }
                            else {
                                var count = view == "day" ? 1 : view == "workweek" ? 5 : 7;
                                var viewCount = view == "month" ? 31 : count * horicells;
                                var resIndex = Math.floor($(e.target).index() / viewCount);
                                var resmaxcolindex = (viewCount * (resIndex + 1));
                                var resmincolindex = (viewCount * resIndex);
                                if (sourceRowIndex == currentRowIndex && sourceColumnIndex >= parseInt(resmincolindex) && sourceColumnIndex <= parseInt(resmaxcolindex) - 1 && currentColumnIndex != "undefined") {
                                    if ($(oRowCell[currentRowIndex].cells[currentColumnIndex]).hasClass("e-selectedCell")) {
                                        if (currentColumnIndex > sourceColumnIndex) {
                                            for (i = resmaxcolindex; i > currentColumnIndex; i--)
                                                $(oRowCell[currentRowIndex].cells[i]).removeClass("e-selectedCell");
                                        }
                                        else if (currentColumnIndex < sourceColumnIndex) {
                                            for (i = 0; i < currentColumnIndex; i++)
                                                $(oRowCell[currentRowIndex].cells[i]).removeClass("e-selectedCell");
                                        }
                                        else if (currentColumnIndex == sourceColumnIndex) {
                                            for (i = 0; i <= resmaxcolindex; i++) {
                                                $(oRowCell[currentRowIndex].cells[i]).removeClass("e-selectedCell");
                                            }
                                        }
                                        $(oRowCell[currentRowIndex].cells[currentColumnIndex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                                    }
                                    else {
                                        if (currentColumnIndex > sourceColumnIndex) {
                                            for (j = sourceColumnIndex ; j <= currentColumnIndex; j++) {
                                                $(oRowCell[currentRowIndex].cells[j]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                                            }
                                        }
                                        else if (currentColumnIndex <= sourceColumnIndex) {
                                            for (j = sourceColumnIndex ; j >= currentColumnIndex; j--) {
                                                $(oRowCell[currentRowIndex].cells[j]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                                            }
                                        }
                                    }
                                }
                                else { return false; }
                            }
                        }
                    }
                });
                oRowCell.bind(ej.eventType.mouseUp, function (e) {
                    oRowCell.unbind(ej.eventType.mouseMove);
                });
                this.element.find("e.workcells,e.alldaycells,.e-monthcells").removeClass("e-mousehover");
                this.element.find(".e-workcells,.e-alldaycells,.e-monthcells").removeClass("e-selectedCell");
                this.element.find('.e-selectedAppointment').removeClass("e-selectedAppointment");
            }
        }
    },
    /**
    * Section For handling mouse down action on the schedule control.
    * @private
    */
    _onScheduleMouseDown: function (e) {
        var _targ = $(e.target);
        var appointdiv = _targ.hasClass("e-appointment,e-alldayappointment,e-monthappointment") ? _targ : _targ.parents(".e-appointment,.e-alldayappointment,.e-monthappointment");
        if (!_targ.hasClass("e-workcells") && !appointdiv.hasClass("e-appointment") && !appointdiv.hasClass("e-alldayappointment") && !appointdiv.hasClass("e-monthappointment") && !_targ.hasClass("e-alldaycells") && !_targ.hasClass("e-monthcells") && !(_targ).parents(".e-scheduledialog").hasClass("e-scheduledialog")) {
            this.model.showQuickWindow && (this._quickAppointWindow.ejDialog("close") && this._quickAppDetailsWindow.ejDialog("close"));
            this.element.find(".e-workcells").removeClass("e-mousehover");
        }
    },
    /**
    * Section For handle mouse hover action in the schedule cells.
    * @private
    */
    _onCellMouseOver: function (e) {
        var element = $(e.currentTarget);
        var index = $(e.target).hasClass("e-workcells") ? $(e.target).index() : $(e.target).hasClass("e-alldaycells") ? $(e.target).index() : 7 - ((parseInt($(e.target).index() / 7) + 1) * 7 - $(e.target).index()) + ($(e.target).parent().index() * 7);             
        if (this.model.orientation == "horizontal") {
            index = this.model.currentView !== "month" ? Math.floor(index / ((this.model.endHour - this.model.startHour) * 2)) : index;
        }
        var renderDate = (this.model.orientation == "horizontal" && this.model.currentView == "month") ? this.monthDays : this.model.orientation == "vertical" ? this.dateRender : this._dateRender;
        var curDate = new Date(renderDate[index]);        
        if ((curDate >= this.model.minDate) && (curDate <= this.model.maxDate)) {
            if (e.type === "mouseover") {
                this.element.find(".e-mousehover").removeClass("e-mousehover");
                if ((element.hasClass("e-workcells") || element.hasClass("e-monthcells")) && !element.hasClass("e-resourceheadercells"))
                    element.addClass("e-mousehover");
            }
            else if (e.type === "mouseout") {
                if (element.hasClass("e-workcells") || element.hasClass("e-monthcells"))
                    element.removeClass("e-mousehover");
            }
        } else
            return false;
    },
    /**
    * Section For handle mouse hover action in the schedule appointments.
    * @private
    */
    _onAppointMouseOver: function (e) {
        if (this.model.enableAppointmentResize && !this.model.readOnly) {
            var appointdiv = $(e.target).hasClass("e-appointment,e-alldayappointment,e-monthappointment") ? $(e.target) : $(e.target).parents(".e-appointment,.e-alldayappointment,.e-monthappointment");
            if (appointdiv.hasClass("e-appointment") && this.model.orientation == "vertical") {
                if (e.type === "mouseover") {
                    appointdiv.find(".e-bottomhandle,.e-tophandle").addClass("e-icon e-nsexpand");
                    appointdiv.find(".e-bottomhandle").addClass("e-appointresizer-bottom");
                    appointdiv.find(".e-tophandle").addClass("e-appointresizer-top");
                }
                else if (e.type === "mouseout") {
                    appointdiv.find(".e-bottomhandle,.e-tophandle").removeClass("e-icon e-nsexpand");
                }

            }
            else if (((appointdiv.hasClass("e-alldayappointment") || appointdiv.hasClass("e-monthappointment")) && this.model.orientation == "vertical") || (this.model.orientation == "horizontal")) {
                if (e.type === "mouseover") {
                    appointdiv.find(".e-lefthandle,.e-righthandle").addClass("e-icon e-ewexpand");
                    appointdiv.find(".e-lefthandle").addClass("e-appointresizer-left");
                    appointdiv.find(".e-righthandle").addClass("e-appointresizer-right");
                }
                else if (e.type === "mouseout") {
                    appointdiv.find(".e-lefthandle,.e-righthandle").removeClass("e-icon e-ewexpand");
                }
            }
        }
    },
    /**
    * Section For handle cell selection action of the schedule.
    * @private
    */
    _cellSelection: function (e) {
        if (e.shiftKey)
            return false;
        this.element.find("e.workcells,e.alldaycells,.e-monthcells").removeClass("e-mousehover");
        this.element.find(".e-workcells,.e-alldaycells,.e-monthcells").removeClass("e-selectedCell");
        this.element.find('.e-selectedAppointment').removeClass("e-selectedAppointment");
        var localizeDays = Globalize.culture(this.model.locale);
            var _target = !ej.isNullOrUndefined(e.target) ? $(e.target) : $(e);
            if ((_target.hasClass("e-workcells") || _target.hasClass("e-alldaycells") || _target.hasClass("e-monthcells")) && !_target.hasClass("e-resourceheadercells")) {
                this.model.showQuickWindow && this._quickAppDetailsWindow.ejDialog("close");
                this._cellIndex = _target.hasClass("e-workcells") ? _target.index() : _target.hasClass("e-alldaycells") ? _target.index() : 7 - ((parseInt(_target.index() / 7) + 1) * 7 - _target.index()) + (_target.parent().index() * 7);
                if (this.model.orientation == "horizontal") {
                    this._cellIndex = this.model.currentView !== "month" ? Math.floor(this._cellIndex / ((this.model.endHour - this.model.startHour) * 2)) : this._cellIndex;
                    this._workCellIndex = _target.parent().index();
                }
                var renderDate = (this.model.orientation == "horizontal" && this.model.currentView == "month") ? this.monthDays : this.model.orientation == "vertical" ? this.dateRender : this._dateRender;
                var curDate = new Date(renderDate[this._cellIndex]);
                if ((this.model.minDate > curDate || this.model.maxDate < curDate)) { return false; }
                if (_target.hasClass("e-workcells") && this.model.currentView !== "month") {
                    var time = this.model.orientation == "vertical" ? this.model.startHour + (_target.parent().index() / 2) : this.model.startHour + ((_target.index() - (((this.model.endHour - this.model.startHour) * 2) * this._cellIndex)) / 2);
                    var timemin = time.toString().split(".");
                    this.cur_StartTime = new Date(curDate).setHours(parseInt(timemin[0]), parseInt(timemin[1]) == 5 ? 30 : 00);
                    var min = (parseInt(new Date(this.cur_StartTime).getHours()) == 23 && parseInt(new Date(this.cur_StartTime).getMinutes()) == 30) ? new Date(this.cur_StartTime).getMinutes() + 29 : new Date(this.cur_StartTime).getMinutes() + 30;
                    this.cur_EndTime = new Date(new Date(this.cur_StartTime).setMinutes(min));
                    this._appointmentAddWindow.find(".allday").ejCheckBox({ checked: false });
                }
                else if (_target.hasClass("e-workcells") && this.model.orientation == "horizontal" && this.model.currentView == "month") {
                    this.cur_StartTime = new Date(new Date(curDate).setHours(0, 0));
                    this.cur_EndTime = new Date(new Date(curDate).setHours(23, 59));
                    this._appointmentAddWindow.find(".allday").ejCheckBox({ checked: true });
                }
                else {
                    //           this._cellIndex = index;
                    this.cur_StartTime = new Date(new Date(curDate).setHours(0, 0));
                    this.cur_EndTime = new Date(new Date(curDate).setHours(23, 59));
                    this._appointmentAddWindow.find(".allday").ejCheckBox({ checked: true });
                }
                if (this.model.showQuickWindow) {
                    this._quickAppointWindow.find("#" + this._id + "_quickAppwindow").css("display", "block");
                    //add the dialog code to display while clicking on the cells
                    this._quickAppointWindow.find('.e-quickstartend').html(localizeDays.calendar.days.names[new Date(curDate).getDay()] + ", " + Globalize.format(new Date(curDate), "MMMM") + " " + new Date(curDate).getDate() + ", " + Globalize.format(new Date(this.cur_StartTime), this._timeMode == "12" ? this._pattern.t : "HH:mm") + " - " + Globalize.format(new Date(this.cur_EndTime), this._timeMode == "12" ? this._pattern.t : "HH:mm"));
                    var topElmt = $(e).hasClass("e-workcells") || $(e).hasClass("e-alldaycells") || $(e).hasClass("e-monthcells") ? $(e) : $(e.target);
                    (e.type != "beforeOpen" && !this.model.readOnly) ? this._quickAppointWindow.ejDialog("open") : "";
                    this._quickAppointWindow.find('.subject').val("");
                    var x = topElmt.offset().left - ((this._quickAppointWindow.width() - topElmt.width()) / 2) + 10;
                    var y = topElmt.offset().top - this._quickAppointWindow.height() - 10;
                    this._quickAppointWindow.ejDialog({ position: { X: x, Y: y } });
                    if (ej.scheduleFeatures.resources && !ej.isNullOrUndefined(this.model.resources))
                        this._getResourceDetails(_target);
                }
                var event = { startTime: new Date(this.cur_StartTime), endTime: this.cur_EndTime, target: e };
                if (this._trigger("cellClick", event)) return false;
                _target.addClass("e-selectedCell").attr("tabIndex", 0).focus();
                this._focused = $(":focus");
                this.model.showQuickWindow && this._quickAppointWindow.find('.subject').focus();
                this._cellClick = true;
                this._appointmentAddWindow.ejDialog({ title: this._getLocalizedLabels("CreateAppointmentTitle") });
            }
            else {
                if (!_target.hasClass("e-resourceheadercells")) {
                    this._cellClick = false;
                    this._quickAppDetailsWindow && this._quickAppDetailsWindow.find("" + "#" + this._id + "_quickAppDetailswindow").css("display", "block");
                    this.model.showQuickWindow && this._quickAppointWindow.ejDialog("close");
                    var appoint = _target.hasClass("e-appointment") || _target.hasClass("e-monthappointment") || _target.hasClass("e-alldayappointment") ? _target : _target.parents(".e-appointment,.e-alldayappointment,.e-monthappointment");
                    if (appoint.length <= 0) return false;
                    appoint.attr("tabIndex", 0).focus();
                    appoint.addClass("e-selectedAppointment");

                    this._appId = parseInt(appoint[0].id.split("_")[1]);
                    var query = new ej.Query().where(this.model.appointmentSettings["id"], ej.FilterOperators.equal, this._appId);
                    var templist = new ej.DataManager(this._processed).executeLocal(query);
                    var value = (((templist[0][this.model.appointmentSettings["endTime"]] - templist[0][this.model.appointmentSettings["startTime"]]) / 3600000) > 24) ? this._getAppointmentByParentId(this._appId) : templist[0];
                    this._quickAppDetailsWindow && this._quickAppDetailsWindow.find('.e-quicksubject').html(templist[0][this.model.appointmentSettings["subject"]]);
                    var temp = templist[0];
                    var startTimeDisp = this._timeMode == "12" ? Globalize.format(temp[this.model.appointmentSettings["startTime"]], this._pattern.t) : Globalize.format(temp[this.model.appointmentSettings["startTime"]], "HH:mm");
                    var endTimeDisp = this._timeMode == "12" ? Globalize.format(temp[this.model.appointmentSettings["endTime"]], this._pattern.t) : Globalize.format(temp[this.model.appointmentSettings["endTime"]], "HH:mm");

                    var diffTime = new Date().getTime() - (temp[this.model.appointmentSettings["startTime"]].getTime());

                    var diffMinute = 60 * 1000;
                    var diffHour = 60 * diffMinute;
                    var diffDays = 24 * diffHour;

                    var result = Math.abs(new Date() - temp[this.model.appointmentSettings["startTime"]]);
                    var h = Math.floor(result / 1000 / 60 / 60); h = (h <= 9 ? '0' + h : h);
                    var m = new Date(result).getUTCMinutes(); m = (m <= 9 ? '0' + m : m);

                    var dueIn = Math.ceil(diffTime / diffMinute - 1) < 0 && h < 24 ? this._getLocalizedLabels("EventBeginsin") + " " + h + " " + this._getLocalizedLabels("Hours") + " " + m + " " + this._getLocalizedLabels("Minutes") :
                        Math.ceil(diffTime / diffMinute - 1) < 0 && h >= 24 ? this._getLocalizedLabels("EventBeginsin") + " " + Math.abs(Math.ceil(diffTime / diffDays)) + " " + this._getLocalizedLabels("Days") : this._getLocalizedLabels("Overdue");
                    if (this.model.showQuickWindow) {
                        this._quickAppDetailsWindow.find('.e-rightfields').html(dueIn);
                        var startdate = localizeDays.calendar.days.names[temp[this.model.appointmentSettings["startTime"]].getDay()] + ", " + Globalize.format(temp[this.model.appointmentSettings["startTime"]], "MMMM") + " " + temp[this.model.appointmentSettings["startTime"]].getDate() + ", " + startTimeDisp + " - " + endTimeDisp;
                        var enddate = localizeDays.calendar.days.names[temp[this.model.appointmentSettings["startTime"]].getDay()] + ", " + Globalize.format(temp[this.model.appointmentSettings["startTime"]], "MMMM") + " " + temp[this.model.appointmentSettings["startTime"]].getDate() + " - " + localizeDays.calendar.days.names[temp[this.model.appointmentSettings["endTime"]].getDay()] + ", " + Globalize.format(temp[this.model.appointmentSettings["endTime"]], "MMMM") + " " + temp[this.model.appointmentSettings["endTime"]].getDate() + ", " + startTimeDisp + " - " + endTimeDisp;
                        (((temp[this.model.appointmentSettings["endTime"]] - temp[this.model.appointmentSettings["startTime"]]) / 3600000) < 24) ? this._quickAppDetailsWindow.find('.e-quickstartendtime').html(startdate) : this._quickAppDetailsWindow.find('.e-quickstartendtime').html(enddate);

                        if (temp[this.model.appointmentSettings["recurrence"]] == 1)
                            this._quickAppDetailsWindow.find('.e-editseries').removeClass("e-disable").on('click', $.proxy(this._editClick, this));

                        else
                            this._quickAppDetailsWindow.find('.e-editseries').addClass("e-disable").off('click');
                        (e.type != "beforeOpen") ? this._quickAppDetailsWindow.ejDialog("open") : "";
                        (this.model.readOnly) ? this._quickAppDetailsWindow.find(".e-scheduledelete").addClass("e-disable") : this._quickAppDetailsWindow.find(".e-scheduledelete").removeClass("e-disable");

                       
                        if($(appoint).width() > this.element.width())
                            var left = ($(appoint).offset().left > this.element.offset().left) ? $(appoint).offset().left : (this.element.find('.e-draggableworkarea').scrollLeft() > $(appoint).width()) ? this.element.offset().left : this.element.width() / 2 - 4;
                        else
                        var left = $(appoint).offset().left- ((this._quickAppDetailsWindow.width() - $(appoint).width()) / 2 - 4);
                        var top = $(appoint).offset().top - this._quickAppDetailsWindow.height() - 10;
                        this._quickAppDetailsWindow.ejDialog({ position: { X: left, Y: top } });
                        this._quickAppDetailsWindow.focus();
                    }
                    var data = { appointment: templist[0] };
                    if (this._trigger("appointmentClick", data))
                        return false;
                    this._appointmentAddWindow.ejDialog({ title: this._getLocalizedLabels("Editevent") });
                }
            }
            if (!$(_target).hasClass("e-monthcells"))
                this.element.find(".e-scrolltimecells").css("top", (-this.element.find('.e-draggableworkarea').scrollTop()) + "px");
    },
    /**
   * Section For Check the reminder with 60000 ms interval.
   * @private
   */
    _checkReminders: function (args) {
        this._todayAppointments = [];
        for (var i = 0; i < this._processed.length; i++) {
            if ((Globalize.format(new Date(this._processed[i][this.model.appointmentSettings["startTime"]]), this._pattern.d) <= Globalize.format(new Date(), this._pattern.d))) {
                this._todayAppointments.push(this._processed[i]);
            }
        }
        var proxy = this;
        jQuery.each(this._todayAppointments, function (val, i) {
            var reminderValue = proxy.model.reminderSettings.alertBefore;
            var startTime = i[proxy.model.appointmentSettings["startTime"]];
            if (reminderValue != -1 && reminderValue != null) {
                var currTime = new Date().getTime();
                var difference = (currTime - new Date(startTime).getTime()) / (1000 * 60);
                if (Math.round(difference) == (reminderValue * -1))
                    proxy._trigger("reminder", { reminderAppointment: i });
                
            }
        });
    },
    /**
    * Section For render the context menu of schedule.
    * @private
    */
    _showContextMenu: function (flag) {
        var gotoFlag = false, cellCollection = this.model.contextMenuSettings.menuItems.cells;
        if (flag) {
            this._contextMenu = ej.buildTag("ul#" + this._id + "contextMenu");
            this.element.append(this._contextMenu);
            this._contextMenu.ejMenu({
                fields: { id: "id", text: "text", parentId: "parentId" },
                menuType: ej.MenuType.ContextMenu,
                openOnClick: false,
                contextMenuTarget: "#" + this._id,
                width: "auto",
                click: $.proxy(this._onMenuSelect, this),
                beforeOpen: $.proxy(this._beforeopen, this)
            });
            if (this.model.categorizeSettings.enable && this.model.contextMenuSettings.menuItems.appointment) {  
                var menuItems = this.model.contextMenuSettings.menuItems.appointment;
                var dataLength = this.model.categorizeSettings.dataSource.length;
                for (var i = 0; i < menuItems.length; i++) 
                {
                    if (menuItems[i].id == 'categorize') {
                        var menuId = i;
                        break;
                    }

                }
                    for (var i = 0; i < dataLength; i++) {
                        var dataSet = this.model.categorizeSettings;
                        this.model.contextMenuSettings.menuItems.appointment.push({ text: dataSet.dataSource[i][dataSet.text], id: "categorize_" + dataSet.dataSource[i][dataSet.id], fontColor: dataSet.dataSource[i][dataSet.fontColor], color: dataSet.dataSource[i][dataSet.color], parentId: this.model.contextMenuSettings.menuItems.appointment[menuId].id.toString() });
                    }
                }
            
            if (this._gotoDate) {
                if (this.model.contextMenuSettings.enable) {
                    for (var id in cellCollection) {
                        if (cellCollection[id].id == "gotodate") {
                            gotoFlag = true;
                            break;
                        }
                    }
                    if (gotoFlag) {
                        this._renderGotoWindow();
                        this._gotoDate = false;
                    }
                }
            }
        }
    },

    /**
    * Section For handle before context menu open action.
    * @private
    */
    _beforeopen: function (args) {
        if (this.model.contextMenuSettings.enable) {
            $(document).unbind(ej.eventType.mouseMove);
            var targetClass = $(args.target), appFlag;
            this._baseTarget = targetClass;
            if (this._trigger("beforeContextMenuOpen", { events: args })) return false;
            
            var menuObj = this._contextMenu.data("ejMenu");
            args.cancel = (targetClass.hasClass("e-workcells") || targetClass.hasClass("e-alldaycells") || targetClass.hasClass("e-appointinnertext") || targetClass.hasClass("e-monthcells") || targetClass.hasClass("e-apptime") || targetClass.hasClass("e-apptext")) ? false : true;
            appFlag = (targetClass.hasClass("e-appointinnertext") || targetClass.hasClass("e-apptime") || targetClass.hasClass("e-apptext")) ? false : true;
            (appFlag) ? menuObj.option("fields.dataSource", this.model.contextMenuSettings.menuItems.cells) : menuObj.option("fields.dataSource", this.model.contextMenuSettings.menuItems.appointment);
            if (this.model.readOnly) {
                menuObj.disableItemByID("new");
                menuObj.disableItemByID("recurrence");
                menuObj.disableItemByID("delete");
                menuObj.disableItemByID("categorize");
            }
            else {
                menuObj.enableItemByID("new");
                menuObj.enableItemByID("recurrence");
                menuObj.enableItemByID("delete");
                menuObj.enableItemByID("categorize");
            }
            this._cellSelection(args);
            this._target = args;
            this._quickAppointWindow.ejDialog("close");
            this._quickAppDetailsWindow.ejDialog("close");

            if (this.model.categorizeSettings.enable && appFlag == false)
            {
                var findDiv = this._contextMenu.find('li#categorize').find('li').children();

                if (findDiv.find('div').length == 0) {
                    for (var i = 0; i < this.model.categorizeSettings.dataSource.length; i++) {
                        this._contextMenu.find('li#categorize').find('li#categorize_' + this.model.categorizeSettings.dataSource[i].id).children().append('<div><div style="border: 1px solid black;height: 12px;margin-left: 2px;margin-top: 2px;width: 12px;background-color:' + this.model.categorizeSettings.dataSource[i].color + '"></div></div>');
                    }
                }
                for (var i = 1; i <= this.model.categorizeSettings.dataSource.length; i++) {
                    if (this._contextMenu.find('li#categorize').find('li#categorize_' + i).children().find('div:first-child.e-categorizeMenuSelected'))
                        this._contextMenu.find('li#categorize').find('li#categorize_' + i).children().find('div:first-child').removeClass('e-categorizeMenuSelected');
                }
                var query = new ej.Query().where(this.model.appointmentSettings["id"], ej.FilterOperators.equal, this._appId);
                var addItem = ej.DataManager(this._processed).executeLocal(query);
                if (addItem[0][this.model.appointmentSettings["categorize"]]) {
                    var categorizeItems = addItem[0][this.model.appointmentSettings["categorize"]].split(',');
                    if (this.model.categorizeSettings.allowMultiple) {
                        if (categorizeItems[0].length > 0) {
                            for (var i = 0; i < categorizeItems.length; i++) {
                                this._contextMenu.find('li#categorize').find('li#categorize_' + categorizeItems[i]).children().find('div:first-child').addClass('e-categorizeMenuSelected');
                            }
                        }
                    }
                    else {
                        if (categorizeItems[0].length > 0) {
                            var lastValue = categorizeItems.length - 1;
                            this._contextMenu.find('li#categorize').find('li#categorize_' + categorizeItems[lastValue]).children().find('div:first-child').addClass('e-categorizeMenuSelected');
                        }
                    }
                }
            }
            else {
                if(this._contextMenu.find('li#categorize'))
                    this._contextMenu.find('li#categorize').css("display", "none");               
            }
            
        }
        else {
            var obj = this._contextMenu.data("ejMenu");
            obj.hide();
            return false;
        }
    },
    /**
    * Section For handle menu select from context menu of schedule.
    * @private
    */
    _onMenuSelect: function (args) {
        var id = args.events.ID.split("_"), parentData = "";
        var target = this._baseTarget;
        if(target.parents(".e-appointment").hasClass("e-appointment") || target.parents(".e-monthappointment").hasClass("e-monthappointment")||target.parents(".e-alldayappointment").hasClass("e-alldayappointment")){
         var query = new ej.Query().where(this.model.appointmentSettings["id"], ej.FilterOperators.equal, this._appId);
         var appointDetails = ej.DataManager(this._processed).executeLocal(query);
         parentData = (appointDetails[0][this.model.appointmentSettings["recurrence"]] == 1 && appointDetails[0][this.model.appointmentSettings["recurrenceRule"]].indexOf("RECUREDITID") != -1) ? appointDetails[0] : this._getAppointmentByParentId(this._appId);
     }
        else {
            parentData = { startTime: new Date(this.cur_StartTime), endTime: this.cur_EndTime, resourceInfo: this._getResourceDetails(target) };
        }
        if (this._trigger("menuItemClick", { events: args, targetInfo: parentData })) return false;
        switch (id[0]) {
            case "new":
                this._appointmentWindow(this._target);
                break;
            case "recurrence":
                this._appointmentWindow(this._target);
                this._appointmentAddWindow.find(".recurrence").ejCheckBox({ checked: true });
                this._repeat(args = { isChecked: true });
                break;
            case "open":
                this._appointmentWindow(this._target);
                break;
            case "today":
                this._navigateClick(this.currentDate(new Date()));
                break;
            case "view":
                this.currentView(id[1].toLowerCase());
                this._renderCurrentView("ViewChange");
                break;
            case "timemode":
                this.model.timeMode=this._timeMode = (id[1] == "Hour12") ? "12" : "24";
				this._appointmentAddWindow.find('.startendtime').ejTimePicker({timeFormat: (this._timeMode == "12") ? this._pattern.t : "HH:mm"});
                if (this.currentView() !== "month" && !(this._isCustomView())) {
                    var viewclass = this.currentView() == "month" ? 1 : 0; //"e-monthtimecells" : "e-timecelldivs";
                    var timeCellhtml = this.timeCellTemplate.render({ timerows: this._getStartEndTime(), cols1: [1, 2], viewclass: viewclass });
                    this.$TimeCellTD.children().remove();
                    this.$TimeCellTD.append(timeCellhtml); if (this.model.showCurrentTimeIndicator) $(".e-highlightcurrenttimeline").remove(); 
                    this.element.find(".e-scrolltimecells").css("top", -(this.element.find(".e-draggableworkarea").scrollTop()) + "px");
                    this._highlightCurrentTime(this.model.showCurrentTimeIndicator);
                    this._renderAppointmentAll();
                }
                break;
            case "businesshours":
                this.model.highlightBusinessHours = (this.model.highlightBusinessHours) ? false : true;
                (this.model.highlightBusinessHours) ? this._highlightBusinessHours() : this.element.find(".e-workcells").removeClass("e-businesshighlightworkcells") && this.element.find(".e-monthcells").removeClass("e-monthcellhighlight");
                break;
            case "gotodate":
                this._gotoWindow.ejDialog("open");
                break;
            case "delete":
                this._deleteAppoint();
                break;
            case "print":
                this._printAppointment();
                break;
            case "categorize":
                if (ej.isNullOrUndefined(id[1]))
                    this.element.find(".e-appointment,.e-alldayappointment,.e-monthappointment").removeClass("e-selectedAppointment");
                else
                {
                    if (this.model.categorizeSettings.enable)
                    {
                        var getId = id[1]; var idValue = "";
                        if (parentData[this.model.appointmentSettings["categorize"]]) {
                            var categorizeItems = parentData[this.model.appointmentSettings["categorize"]].split(',');
                            if (!this.model.categorizeSettings.allowMultiple) {
                                if (categorizeItems[categorizeItems.length - 1] == getId)
                                    idValue = "";
                                else
                                    idValue = getId.toString();
                            }
                            else {
                                if (categorizeItems[0].length > 0) {
                                    for (var i = 0; i < categorizeItems.length; i++) {
                                        if (categorizeItems[i] == getId) {
                                            var findId = true;
                                            break;
                                        }
                                    }
                                    if (findId == true) {
                                        for (var i = 0; i < categorizeItems.length; i++) {
                                            if (categorizeItems[categorizeItems.length - 1] != getId) {
                                                if (categorizeItems[i] != getId) {
                                                    if (categorizeItems.length - 1 != i)
                                                        idValue = idValue + categorizeItems[i] + ",";
                                                    else
                                                        idValue = idValue + categorizeItems[i];
                                                }
                                            }
                                            else {
                                                if (categorizeItems[i] != getId) {
                                                    if (categorizeItems.length - 2 != i)
                                                        idValue = idValue + categorizeItems[i] + ",";
                                                    else
                                                        idValue = idValue + categorizeItems[i];
                                                }
                                            }
                                        }
                                    }
                                    else
                                        idValue = parentData[this.model.appointmentSettings["categorize"]] + "," + getId;
                                }
                            }
                        }
                        else {
                            idValue = getId.toString();
                        }
                        parentData[this.model.appointmentSettings["categorize"]] = idValue;
                        this.element.find("#Appointment_" + this._appId).remove();
                        new ej.DataManager(this._currentAppointmentData).update(this.model.appointmentSettings["id"], parentData);
                        this._renderSingleApp(parentData, parentData);
                        break;

                    }
                }               
        }
    },
    /**
    * Section For handle the goto ok button click.
    * @private
    */
    _gotoOk: function (args) {
        if ($(args.currentTarget).hasClass("e-gotoOk")) {
            var date = this._gotoWindow.find("#" + this._id + "gotodate").ejDatePicker("option", "value");
            var view = this._gotoWindow.find("#" + this._id + "show").ejDropDownList("option", "itemValue");
            this.currentDate(new Date(date));
            this.currentView(view.toLowerCase());
            this._renderCurrentView("ViewChange");
        }
        this._gotoCancel();
    },
    /**
    * Section For handle the goto cancel button click.
    * @private
    */
    _gotoCancel: function () {
        this._gotoWindow.find("#" + this._id + "gotodate").ejDatePicker({ value: new Date() });
        this._gotoWindow.find("#" + this._id + "show").ejDropDownList({ value: "Day" });
        this._gotoWindow.ejDialog("close");
    },
    /**
    * Section For render the goto window controls of schedule.
    * @private
    */
    _renderGoto: function () {
        this._gotoWindow.find("#" + this._id + "gotodate").ejDatePicker({ enableRTL: this.model.enableRTL, width: '100%', value: this.currentDate(), locale: this.model.locale, cssClass: this.model.cssClass });
        this._gotoWindow.find("#" + this._id + "show").ejDropDownList({ enableRTL: this.model.enableRTL, dataSource: [{ text: this._getLocalizedLabels("Day"), value: "day" }, { text: this._getLocalizedLabels("Week"), value: "week" }, { text: this._getLocalizedLabels("WorkWeek"), value: "workweek" }, { text: this._getLocalizedLabels("Month"), value: "month"}], width: "100%", selectedItemIndex: 0, cssClass: this.model.cssClass });
        this._gotoWindow.find(".e-gotobutton").ejButton({ enableRTL: this.model.enableRTL, showRoundedCorner: true, width: "60px", cssClass: this.model.cssClass });
    },
    /**
    * Section For render the gotowindow of schedule.
    * @private
    */
    _renderGotoWindow: function () {
        this._gotoWindow = ej.buildTag('div.e-gotodialog#' + this._id + "gotoWindow");
        var $goWindow = "<div><table width='100%' cellpadding='5'><tbody><tr><td>" + this._getLocalizedLabels("Date") + ":</td><td><input id='" + this._id + "gotodate' type='text' value='' /></td></tr>" +
                "<tr><td>" + this._getLocalizedLabels("Showin") + ":</td><td><input type='text' id='" + this._id + "show' /></td></tr></tbody></table>";
        $goWindow += "<div class='e-floatright'><table><tr><td><div><button id='" + this._id + "gotook' class='e-gotobutton e-gotoOk'>" + this._getLocalizedLabels("Ok") + "</button></div></td>" +
                              "<td><div><button id='" + this._id + "gotocancel' class='e-gotobutton e-gotoCancel'>" + this._getLocalizedLabels("Cancel") + "</button></div></td></tr></table></div></div>";
        this._on(this._gotoWindow, "click", ".e-gotobutton", $.proxy(this._gotoOk, this));
        this._gotoWindow.append($goWindow);
        this.element.append(this._gotoWindow);
        this._renderGoto();
        this._gotoWindow.ejDialog({
            width: 300,
            cssClass: this.model.cssClass,
            showOnInit: false,
            enableRTL: this.model.enableRTL, enableModal: true,
            title: this._getLocalizedLabels("Gotodate"),
            content: "#" + this._id,
            enableResize: false,
            allowKeyboardNavigation: false,
            close: $.proxy(this._gotoCancel, this)
        });
        $("#" + this._id + "gotoWindow_wrapper").addClass("e-scheduledialog").find(".e-titlebar").addClass("e-dialogheader");
    },

    /**
    * Section For handle current time indicator shown in the schedule.
    * @private
    */
    _highlightCurrentTime: function (_showIndicator) {
        Globalize.culture(this.model.locale);
        if (_showIndicator) {
            var flag = false, index = 0;
            for (var i = 0; i < this._dateRender.length; i++) {
                if (Globalize.format(new Date(this._dateRender[i]), this._pattern.d) === Globalize.format(new Date(), this._pattern.d)) {
                    flag = true;
                    (this.currentView() !== "month" && !(this._isCustomView()) && this.model.enableRTL == true) ? index = (this._dateRender.length - 1) - i : index = i;
                }
            }
            if (this.currentView() !== "month" && !(this._isCustomView())) {
                if (flag) {
                    var temp = this;
                    var view = this.currentView() === "week" ? 7 : this.currentView() === "workweek" ? 5 : this.currentView() == "customview" ? this._dateRender.length : 1;
                    var timeWidth = (this.model.cellWidth) ? parseInt(this.model.cellWidth) : this.element.find('.e-draggableworkarea')[0].offsetWidth / (view * this.res1.length);
                    if (new Date().getHours() >= temp.model.startHour && new Date().getHours() <= temp.model.endHour) {
                        if (temp.model.orientation == "vertical") {
                            for (var i = 0; i < this.res1.length; i++) {
                                this.element.find('.e-draggableworkarea').append('<div id="' + this._id + i + '_HighlightCurrentTimeline" class="e-highlightcurrenttimeline"></div>');
                                $('#' + this._id + i + '_HighlightCurrentTimeline').append('<div class="e-currenttime"></div>').append(ej.buildTag("div.e-icon e-timeidicatorcircle e-lefttimeindicator")).append(ej.buildTag("div.e-icon e-timeidicatorcircle e-righttimeindicator"));
                                $('#' + this._id + i + '_HighlightCurrentTimeline').css("width", timeWidth + "px").css("left", ((index + (view * i)) * timeWidth) + "px");
                                $('#' + this._id + i + '_HighlightCurrentTimeline').find('.e-righttimeindicator').css("margin-left", (timeWidth - 3) + "px");
                            }
                        }
                        else {
                            this._renderHorizontalCurrentTime();
                        }
                    }
                    function ChangeCurrentTimePosition() {
                        var now = new Date();
                        now.setMinutes(now.getMinutes());
                        var position;
                        if (now.getHours() >= temp.model.startHour && now.getHours() <= temp.model.endHour) {
                            if (temp.model.orientation == "vertical") {
                                var topVal = ((((now.getHours() - temp.model.startHour) * 60) + now.getMinutes()) * (temp.element.find(".e-workcells").height() + 1) * 2) / 60;
                                for (var i = 0; i < temp.res1.length; i++)
                                    $('#' + temp._id + i + '_HighlightCurrentTimeline').css("top", topVal - 1);
                                var currentTime = temp._timeMode == "12" ? Globalize.format(new Date(), "hh:mm tt") : Globalize.format(new Date(), "HH:mm");
                                for (var i = 0; i < temp.res1.length; i++) {
                                    $('#' + temp._id + i + '_HighlightCurrentTimeline').find(".e-currenttime").html(currentTime);
                                    if (temp._timeMode == "12") $('#' + temp._id + i + '_HighlightCurrentTimeline').find(".e-currenttime").addClass("e-timewidth");
                                }
                            }
                            else {
                                temp._horizontalTimePosition(temp, now);
                            }
                        }
                    }
                    ChangeCurrentTimePosition();
                    this._intervalID = window.setInterval(ChangeCurrentTimePosition, 60000);
                }
                else {
                    clearInterval(this._intervalID);
                    $(".e-highlightcurrenttimeline").remove();
                }
            }
            else {
                if (flag) {
                    if (this.model.orientation == "vertical") {
                        var rowPosition = Math.ceil((index + 1) / 7); var cellId;
                        if (!this.model.group) this.res1 = ["0"];
                        for (var i = 0; i < this.res1.length; i++) {
                            cellId = (i * (7) + (new Date(this._dateRender[index]).getDay() + 1)) + ((rowPosition - 1) * ((this.res1.length) * 7));
                            $(this.element.find(".e-monthcells")[Math.floor(cellId) - 1]).addClass("e-monthcurrenttime");
                        }
                    }
                    else
                        this._renderHorizontalCurrentTime();
                }
                else
                    this.model.orientation == "vertical" ? this.element.find(".e-monthcells").removeClass("e-monthcurrenttime") : this.element.find(".e-workcells").removeClass("e-monthcurrenttime");
            }
        }
    },
    _filter: function () {
        var filter = [];
        for (var a = 0; a < this._processed.length; a++) {
            if ((new Date(this._processed[a][this.model.appointmentSettings["endTime"]]) >= this.model.minDate) && (new Date(this._processed[a][this.model.appointmentSettings["endTime"]]) <= this.model.maxDate))
                filter.push(this._processed[a]);
        }
        return filter;
    },
    _getPreviousNextAppointment: function () {
            var dateCount = this._dateRender;
            var appointmentsList = this._filter();
            this._previousList = [];
            this._nextList = [];
            this.appointment;
            for (var app = 0; app < appointmentsList.length; app++) {
                if (new Date(appointmentsList[app][this.model.appointmentSettings["startTime"]]) < new Date(dateCount[0]) && new Date(appointmentsList[app][this.model.appointmentSettings["endTime"]]) < new Date(dateCount[0])) {
                    this._previousList.push(appointmentsList[app]);
                }
                else if (new Date(appointmentsList[app][this.model.appointmentSettings["startTime"]]) > new Date(dateCount[(dateCount.length - 1)]) && new Date(appointmentsList[app][this.model.appointmentSettings["endTime"]]) > new Date(dateCount[(dateCount.length - 1)])) {
                    this._nextList.push(appointmentsList[app]);
                }
            }
            this.appointment = { previous: this._previousList, next: this._nextList };
        },

        _nextPrevAppointment: function (flag) {
            if (flag && !(this._browserInfo.name === "msie" && this._browserInfo.version < 9)) {
                var base = this.element.find("#" + this._id + "_scroller");
                this.height = base.height();
                this.width = base.width();
                var scroll = this.element.find(".e-vscroll").width();
                var timecell = this.element.find(".e-scrolltimecells").width();
                var top = (this.height / 2) - (150 / 2), left;
                var prev = ej.buildTag("div.e-prev enable", this._getLocalizedLabels("PreviousAppointment"), {}, {});
                var next = ej.buildTag("div.e-next enable", this._getLocalizedLabels("NextAppointment"), {}, {});
                left = (this.model.orientation == "vertical") ? ((this.currentView() != "month") && !(this._isCustomView()) ? -4 : -10) : -60;
                if (!this.model.enableRTL) {
                    prev.css("top", (top + 40) + "px").css("transform", "rotate(90deg)").css("left", left + "px");
                    next.css("top", (top + 40) + "px").css("transform", "rotate(-90deg)").css("left", (this.width - scroll -((this.model.orientation == "vertical")?35:90)) + "px");
                }
                else {
                    next.css("top", (top + 40) + "px").css("transform", "rotate(90deg)").css("left", (left - ((this.currentView() != "month") && !(this._isCustomView()) ? 39 : 51)) + "px");
                    prev.css("top", (top + 40) + "px").css("transform", "rotate(-90deg)").css("left", (this.width - timecell - ((this.currentView() != "month") && !(this._isCustomView()) ? 31 : 41)) + "px");
                }
                base.append(prev).append(next);
            }
        },

        _nextPrev: function (e) {
            var proxy = this;
            if ($(e.currentTarget).hasClass("e-prev")) {
                this.appointment.previous.sort(function (a, b) {
                    return new Date(b[proxy.model.appointmentSettings["startTime"]]) - new Date(a[proxy.model.appointmentSettings["startTime"]]);
                });
                this._navigateClick(this.currentDate(new Date(this.appointment.previous[0][this.model.appointmentSettings["startTime"]])));
            }
            else if ($(e.currentTarget).hasClass("e-next")) {
                this.appointment.next.sort(function (a, b) {
                    return new Date(a[proxy.model.appointmentSettings["startTime"]]) - new Date(b[proxy.model.appointmentSettings["startTime"]]);
                });
                this._navigateClick(this.currentDate(new Date(this.appointment.next[0][this.model.appointmentSettings["startTime"]])));
            }
        },

        _nextPrevButton: function (app) {
            if (app.length != 0)
                this.element.find(".e-prev,.e-next").css("display", "none");
            else {
                this._getPreviousNextAppointment();
                this.element.find(".e-prev,.e-next").css("display", "block");
                if (this.appointment.previous.length == 0)
                    this.element.find(".e-prev").removeClass("enable").css("opacity", "0.4");
                else
                    this.element.find(".e-prev").addClass("enable").css("opacity", "1");
                if (this.appointment.next.length == 0)
                    this.element.find(".e-next").removeClass("enable").css("opacity", "0.4");
                else
                    this.element.find(".e-next").addClass("enable").css("opacity", "1");
            }

        },

    /**
    * Section For handle view navigate action of the schedule.
    * @private
    */
        _navigateView: function (e) {
            var newView, oldview = this.currentView();
            var _target = $(e.target);
            if (this.model.orientation == "vertical") {
                if (this.currentView() === "month" || (this._isCustomView())) {
                    if (_target.hasClass("e-monthheader")) {
                        if (this.model.views.indexOf("Day") == -1) return false;
                        var cellIndex = _target.parent().index();
                        var index = (cellIndex > 6) ? (cellIndex % 7) : cellIndex;
                        var navidate = this._getRenderDates()[((_target.parent().parent().index() * 7) + index)];
                        if (this.model.minDate <= navidate && this.model.maxDate >= navidate)
                            this.currentDate(navidate);
                        else  return false; 
						newView = "day";
                    }
                    else if (_target.hasClass("e-timecells") || _target.hasClass("e-timecelldivs")) {
                        var target = _target.hasClass("e-timecells") ? _target : _target.parent();
                        if (this.model.views.indexOf("Week") == -1) return false;
                        var navidate = this._getRenderDates()[(target.parent().index() * 7)];
                        if (this.model.minDate <= navidate && this.model.maxDate >= navidate) 
                            this.currentDate(navidate);
                        else  return false; 
                        newView = "week";
                    }
                }
                else if (this.currentView() === "week" || this.currentView() === "workweek" || (this.currentView() === "customview" && this._renderDays <= 7)) {
                    var dayTarget = _target.hasClass("e-headercells") ? _target : _target.parent().hasClass("e-headercells") ? _target.parent() : _target.parent().parent();
                    if (this.model.views.indexOf("Day") == -1 || !dayTarget.hasClass("e-headercells")) return false;
                    var cellIndex = dayTarget.index();
                    var cols = this.currentView() === "workweek" ? 5 : this.currentView() === "customview" ? this._dateRender.length : 7;
                    var index = (cellIndex > cols - 1) ? (cellIndex % cols) : cellIndex;
                    var navidate = this._getRenderDates()[index];
                    if (this.model.minDate <= navidate && this.model.maxDate >= navidate) 
                        this.currentDate(new Date(navidate));
                    else  return false; 
                    newView = "day";
                }
                this._navView = true;
                this._viewChange(e, oldview, newView);
                this._businessHourScroller();
            }
            else if (this.model.orientation == "horizontal" && ej.scheduleFeatures.horizontal)
                this._horizontalViewNavigation(e);
    },

    /**
    * Section For handle over flow icon click of the schedule.
    * @private
    */
    _appOverflowClick: function (e) {
        //to stop the day view navigation while we click overflow app
        if (this.model.views.indexOf("Day") !== -1) {
            var overflowId = $(e.target)[0].id.toString().split("_");
            this.currentDate(new Date(overflowId[3], overflowId[1] - 1, overflowId[2]));
            this._navView = true;
            this._viewChange(e, this.currentView(), "day");
        }
        else return false;
    },
    /**
    * Section For handle calendar navigation of the schedule.
    * @private
    */
    _viewCalendar: function (e) {
        var obj = this.element.find("#" + this._id + "_navigator").data("ejDatePicker");
        if (obj) {
            obj.show();
            this.element.find("#" + this._id + "_navigator").ejDatePicker({ value: new Date(this.currentDate()), minDate: this.model.minDate, maxDate: this.model.maxDate });
            var controlmargin = this.element.position();
            if (this.model.enableRTL)
                $("div.e-datepicker").css("top", (controlmargin.top + 47) + "px").css("left", (controlmargin.left + this.element.width() - 280) + "px");
            else
                $("div.e-datepicker").css("top", (controlmargin.top + 47) + "px").css("left", (controlmargin.left + 55) + "px");
        }
        this.element.find(".e-workcells").removeClass("e-selectedCell");
        this.element.find(".e-workcells").removeClass("e-mousehover");
        this.element.find(".e-appointment,.e-alldayappointment,.e-monthappointment").removeClass("e-selectedAppointment");
    },
    /**
    * Section For change the current view of the schedule.
    * @private
    */
    _viewChange: function (e, oldview, newView) {
        var flag = true, data;
        data = { currentview: this.currentView(), Date: new Date(this.currentDate()), target: e, requestType: "viewNavigate" };
        if (this._trigger("actionBegin", data))
            return false;
		this.model.showQuickWindow && (this._quickAppointWindow.ejDialog("close") && this._quickAppDetailsWindow.ejDialog("close"));
        if (oldview !== newView || (!oldview && !newView)) {
            if (!this._navView) {
                flag = (this.currentView() == (e.currentTarget.className.split("e-")[2]).split(" ")[0]) ? false : true;
                this.currentView($(e.currentTarget).hasClass("e-activeview") ? this.currentView() : (e.currentTarget.className.split("e-")[2]).split(" ")[0]);
            }
            else
                this.currentView(newView);
            if (flag) this._renderCurrentView("ViewChange");
        }
        data = { prevView: oldview, currentView: this.currentView(), Date: new Date(this.currentDate()), target: e, type: "Scheduleview" };
        if (this._trigger("navigation", data))
            return false;
        (this._mediaQuery && (oldview != this.currentView())) && this.element.find(".e-workareadiv,.e-navigate").addClass("navigate");
        this._trigger("actionComplete", { data: data, requestType: "viewNavigate" });
    },
    /**
    * Section For render the current view of the schedule.
        * @private
        */
        _renderCurrentView: function (currentAction) { //clear the old view and render with newly selected view
            //clear old view 
            this.element.find(".e-commonviewbutton").blur();
            this.element.find(".e-commonviewbutton").removeClass("e-activeview");
            if (this.model.orientation == "vertical")
                this.element.find(".e-headerdaydisplay,.e-datedisplay,.e-headrealldaytable").children().remove();
            this.wTR.children().remove();
            this.aTR.children().remove();
            this._calculateCustomDays();
            this._getRenderDates();
            //set new view
            this.element.find(".e-" + this.currentView()).addClass("e-activeview").attr("tabIndex", 0).focus();
            this._renderHeaderAllDayTemplate();
            this._renderContentAreaTemplate();
            (this.element.find('.e-workcells').width() < this.element.find('.e-dateheadercell').width() && this.model.orientation == "horizontal" && this.model.cellWidth == "") ? this.element.find('.e-workcells').width(this.model.currentView == "month" || (this._isCustomView()) ? this.element.find('.e-horizontmonthheaderdaytd').width() : this.element.find('.e-horizontaltimetd ').width()) : "";
            this._renderScroller();
            if (this.model.orientation == "vertical") {
                this._headerbarWidth();
                this.element.find(".e-schedulesettings").html(this._getLocalizedLabels("AllDay"));
                this.element.find(".e-ampmdisplay").height(this.element.find(".e-workcells").height());
            }
            else if (this.model.orientation == "horizontal" && ej.scheduleFeatures.horizontal)
                this._moveScroller();
            this._renderHeaderDays();
            if (!ej.isNullOrUndefined(this.dataSource())) {
            if(this.model.enableLoadOnDemand)
                this._bindAppointmentsData(currentAction);
            else {
                this._dataProcessing(this._currentAppointmentData);
                this._renderAppointmentAll();
             }
            }
            (this.model.highlightBusinessHours) ? this._highlightBusinessHours() : this.element.find(".e-workcells").removeClass("e-businesshighlightworkcells");
            this._highlightCurrentTime(this.model.showCurrentTimeIndicator);
            this._validateMinMaxDate();
            this._navView = false;
            (this._dateRender.length > 60 || (parseInt(this.model.cellHeight) < 35 && this.model.cellHeight !== "20px") && this.model.orientation == "vertical") ? this.element.find('td.e-timecells .e-timecelldivs').addClass('e-timedivcells') : "";

    },
    /**
    * Section For render the header day cells of the schedule.
        * @private
        */
        _renderHeaderDays: function () {
            this.dateRender = [];
            var dateList = this._getRenderDates();
            this.res1 = (!ej.isNullOrUndefined(this.model.group)) ? this.res1 : [0];
            for (var i = 0; i < this.res1.length; i++) {
                for (var j = 0; j < dateList.length; j++) {
                    this.dateRender.push(new Date(dateList[j]));
                }
            }
            //            var dateRender = this.dateRender; // this._getRenderDates();
            var localizeDays = Globalize.culture(this.model.locale);
            var dateVal = this._getCurrentDateHeaderValue();
            this.element.find("div.e-datedisplay")[0].innerHTML = dateVal;
            if (this.model.orientation == "vertical") {
                if (this.currentView() !== "month" && !(this._isCustomView())) {
                    var curday, temp;
                    for (var i = 0; i < this.dateRender.length; i++) {
                        curday = (this.currentView() === "day") ? (ej.isNullOrUndefined(this.model.resources) && ej.isNullOrUndefined(this.model.group)) ? localizeDays.calendar.days.names[new Date(this.dateRender[i]).getDay()] : localizeDays.calendar.days.names[new Date(this.dateRender[i]).getDay()].slice(0, 3) : localizeDays.calendar.days.names[new Date(this.dateRender[i]).getDay()].slice(0, 3);
                        temp = this.currentView() === "day" ? (ej.isNullOrUndefined(this.model.resources) && ej.isNullOrUndefined(this.model.group)) ? curday + " " + Globalize.format(new Date(this.dateRender[i]), "dd MMMM yyyy") : curday + " " + Globalize.format(new Date(this.dateRender[i]), "dd MMM yy") : curday + " " + new Date(this.dateRender[i]).getDate();
                        this.element.find(".e-headerdaydisplay")[i].innerHTML = temp;
                    }
                    this.element.find(".e-alldaycells").css('height', "27px");
                    this.element.find(".e-emptyalldaytd").css('height', "27px");
                    this.element.find(".e-headercells").addClass("e-dateheaderselect");
                }
                else
                    this._renderMonthTimeCells();
            }
            else if(this.model.orientation == "horizontal" && ej.scheduleFeatures.horizontal)
                this._renderHorizontalHeaderDays(localizeDays);
    },
    /**
    * Section For render the month time cells of the schedule.
        * @private
        */
        _renderMonthTimeCells: function () {
            var timeCellIndex = 0; var dateRender = this._dateRender, k = 0, resCount = !ej.isNullOrUndefined(this.model.group) ? this.res1.length * 7 : 7;
            for (var i = 0; i < dateRender.length; i++) {
                for (var j = k; j < resCount; j = j + 7) {
                    $(this.element.find("div.e-monthheader"))[j].innerHTML = (Globalize.format(new Date(dateRender[i]), "dd")).toString();
                    if (this.currentView() !== "customview") {
                        if (new Date(dateRender[i]).getMonth() !== new Date(this.currentDate()).getMonth())
                            $(this.element.find("div.e-monthheader")[j]).addClass("e-monthdateshighlight");
                        else
                            $(this.element.find("div.e-monthheader")[j]).removeClass("e-monthdateshighlight");
                    }
                }
                k++;
                if ((i + 1) % 7 == 0) {
                    k = resCount;
                    resCount = resCount + ((!ej.isNullOrUndefined(this.model.group) ? this.res1.length : 1) * 7);
                    start = Globalize.format(new Date(dateRender[i - 6]), "MMM dd");
                    end = Globalize.format(new Date(dateRender[i]), "MMM dd");
                    $(this.element.find(".e-timecelldivs"))[timeCellIndex].innerHTML = start + " - " + end;
                    timeCellIndex++;
                }
        }
        this.element.find(".e-timecells").addClass("e-dateheaderselect").height(this.element.find(".e-monthcells").height());
        if (j != 6) this.element.find(".e-timecells").addClass("e-timecellpadding");
    },
    /**
    * Section For handle the date navigation of the schedule.
    * @private
    */
    _navigateClick: function (e) {
        var data, currentAction;
        var oldDate = new Date(this.currentDate());
        data = { currentDate: new Date(this.currentDate()), target: e, requestType: "dateNavigate" };
        if (this._trigger("actionBegin", data))
            return false;
        if (e != null && !this._setCurrentDate) {
            if ($(e.currentTarget).hasClass("e-disable")) { return false; }
            var dat = new Date(this.currentDate());
            var day = this.currentView() === "day" ? 1 : this.currentView() === "customview" ? this._dateRender.length : 7;
            if ($(e.currentTarget).hasClass("e-navigateprevious")) {
                if (this._isCustomView()) {
                    var todayDate = new Date(this._dateRender[0]), weekDate = new Date(this._dateRender[0]);
                    weekDate.setTime(todayDate.getTime() - (this._dateRender.length * 24 * 3600000));
                    this.currentDate(new Date(weekDate));
                }
                else
                    this.currentDate((this.currentView() === "month" ? new Date(dat.setMonth(new Date(this.currentDate()).getMonth() - 1)) : new Date(dat.setDate(new Date(this.currentDate()).getDate() - day))));
                this.element.find(".e-navigateprevious").attr("tabIndex", 0).focus();
                currentAction = "Previous";
            }
            else if ($(e.currentTarget).hasClass("e-navigatenext")) {
                if (this._isCustomView()) {
                    var todayDate = new Date(this._dateRender[0]), weekDate = new Date(this._dateRender[0]);
                    weekDate.setTime(todayDate.getTime() + (this._dateRender.length * 24 * 3600000));
                    this.currentDate(new Date(weekDate));
                }
                else
                    this.currentDate((this.currentView() === "month" ? new Date(dat.setMonth(new Date(this.currentDate()).getMonth() + 1)) : new Date(dat.setDate(new Date(this.currentDate()).getDate() + day))));
                this.element.find(".e-navigatenext").attr("tabIndex", 0).focus();
                currentAction = "Next";
            }
          
        }
        this.element.find(".e-workcells,.e-alldaycells,.e-monthcells").removeClass("e-selectedCell");
        this.element.find('.e-selectedAppointment').removeClass("e-selectedAppointment"); this.element.find(".e-appsoverflow").remove();
        this.element.find(".e-monthcells").removeClass("e-monthcurrenttime");
        if (this.model.showCurrentTimeIndicator) $(".e-highlightcurrenttimeline").remove(); 
        this.model.showQuickWindow && (this._quickAppointWindow.ejDialog("close") && this._quickAppDetailsWindow.ejDialog("close"));
        //  this.element.find("td.e-workcells").removeClass("icon-AddGrad");
        if (this.currentView() === "month" || (this._isCustomView())) {
            this._navigate = true;
            this._renderCurrentView(currentAction);
        }
        else {
            this._renderHeaderDays();
            if (!ej.isNullOrUndefined(this.dataSource())) {
            if(this.model.enableLoadOnDemand)
                this._bindAppointmentsData(currentAction);
            else {
                this._dataProcessing(this._currentAppointmentData);
                this._renderAppointmentAll();
                }
            }
            (this.model.highlightBusinessHours) ? this._highlightBusinessHours() : this.element.find(".e-workcells").removeClass("e-businesshighlightworkcells");
            this._highlightCurrentTime(this.model.showCurrentTimeIndicator);
        }
        if (e != null)
        if ($(e.currentTarget).hasClass("e-navigateprevious") || $(e.currentTarget).hasClass("e-navigatenext"))
            data = { prevDate: oldDate, currentDate: dat, target: e, type: "navigatedate" };
        if (this._trigger("navigation", data))
            return false;
        this._validateMinMaxDate();
        this._setCurrentDate = false;
        if (this._mediaQuery) {
            var value = ($(e.currentTarget).hasClass("e-navigateprevious")) ? this.element.width() : ($(e.currentTarget).hasClass("e-navigatenext") || (e.type == "select")) ? -this.element.width() : 0;
            this.element.find(".e-headeralldaydiv,.e-draggableworkarea,.e-vscroll").toggle();
            this.element.find(".e-headeralldaydiv,.e-draggableworkarea,.e-vscroll").css("margin-left", -value).css("margin-right", value).toggle().animate({ "margin-left": 0, "margin-right": 0 }, 500);
        }
        this._trigger("actionComplete", { data: data, requestType: "dateNavigate" });
    },
    _validateMinMaxDate: function () {
        this.element.find(".e-navigateprevious").removeClass("e-disable");
        this.element.find(".e-navigatenext").removeClass("e-disable");
        var currDate = new Date(this.currentDate());
        var renderDate = (this.model.orientation == "horizontal" && this.model.currentView == "month") ? this.monthDays : this.model.orientation == "vertical" ? this.dateRender : this._dateRender;
        var firstWeekDate = new Date(renderDate[0]);
        var lastWeekDate = new Date(renderDate[renderDate.length - 1]);
		if (this.currentView() == "workweek")
        {
            firstWeekDate = firstWeekDate.setDate(firstWeekDate.getDate() - 1);
            lastWeekDate = lastWeekDate.setDate(lastWeekDate.getDate() + 1);
        }
        currDate = firstWeekDate//firstWeekDate <= this.model.minDate && this.currentView() != "day" ? firstWeekDate : currDate;
        if (currDate <= this.model.minDate)
            this.element.find(".e-navigateprevious").addClass("e-disable");
        else
            this.element.find(".e-navigateprevious").removeClass("e-disable");
        currDate =lastWeekDate// lastWeekDate >= this.model.maxDate && this.currentView() != "day" ? lastWeekDate : currDate;
        if (currDate >= this.model.maxDate)
            this.element.find(".e-navigatenext").addClass("e-disable");
        else
            this.element.find(".e-navigatenext").removeClass("e-disable");
    },
    /**
    * Section For handle the resize of the schedule.
    * @private
    */

    _onScheduleResize: function () {
        var temp = this._mediaQuery;
        this._mediaQuery = (window.innerWidth < 361 || ej.isDevice());
        var scrollerObj = this.element.find(".e-scroller").data("ejScroller");
        var cols = this.currentView() == "workweek" ? 5 : this.currentView() == "day" ? 1 : (this.currentView() === "customview" && this._renderDays <= 7) ? this._dateRender.length : 7;
        var col = (!ej.isNullOrUndefined(this.model.group) && !ej.isNullOrUndefined(this.model.resources)) ? (this.res1.length * cols) : cols;
        var overallWidth = parseInt(this.model.cellWidth) * col;
        scrollerObj.model.width = (this.model.orientation === "vertical" && !this.model.enableRTL) ? this.element.outerWidth() - (this.element.find('.e-draggableworkarea').offset().left - this.element.offset().left) : (this.model.orientation == "horizontal") && (!ej.isNullOrUndefined(this.model.group) && !ej.isNullOrUndefined(this.model.resources) && !this.model.enableRTL) ? this.element.width() - this.element.find(".e-resourceheadertable").width() : (this.model.enableRTL) ? this.element.width() - this.element.find('.e-scrolltimecells').parent().width() : this.element.width();
        scrollerObj.model.height = this.scHeight - (this.element.find('.e-draggableworkarea').offset().top - this.element.offset().top)
        scrollerObj.refresh();
        if (this.model.orientation == "vertical") {
            if (this.model.cellWidth && !this._mediaQuery)
                this.element.find(".e-draggableworkarea").width((this.element.width() > overallWidth + this.element.find(".e-scrolltimecells").parent().width() + 18) ? overallWidth : scrollerObj.model.width - 18);
            else if (this._mediaQuery && this.res1.length > 1 && this.model.group.resources.length == 1)
                this.element.find(".e-draggableworkarea").width(this.element.find(".e-draggableworkarea").width() * this.res1.length);
            this.element.find(".e-headrealldaytable").parent().width(this.element.find(".e-draggableworkarea").width());
            this.element.find(".e-datecommondiv").parent().width(this.element.width());
            this.element.find(".e-headrealldaytable").css("left", -(this.element.find(".e-draggableworkarea").scrollLeft()) + "px");
        }
        else 
            $(this.element.find(".e-horizontaltimecells").find("table tr")[2]).css("left", -(scrollerObj.model.scrollLeft) + "px");
        

        if (this.currentView() != "month" && !(this._isCustomView()) && this.model.orientation == "vertical") {
            this.element.find("div.e-alldayappointment").remove();
            this._renderAllDayAppointments();
            this._unWireResizeEvents(); // Unwire appointments resize events.
            this._wireResizeEvents(); // wire appointments resize events.
			this._dragdropAppointments();
        }
        else {
            this._renderCurrentView("ScheduleResize");
        }
        if (this.model.showCurrentTimeIndicator) $(".e-highlightcurrenttimeline").remove();
        this.element.find(".e-scrolltimecells").css("top", -(this.element.find(".e-draggableworkarea").scrollTop()) + "px");
        this._highlightCurrentTime(this.model.showCurrentTimeIndicator);
        var flag = (this._mediaQuery == temp) ? false : true;
        (this._mediaQuery) && $("#" + this._id + "navDrawer").css("left", (window.innerWidth - 1) + "px");
        if (this._mediaQuery) {
            this.element.find(".e-vscroll").css("left", window.innerWidth - 18);
            this.element.find(".e-mobileNavigation").css("left", window.innerWidth - 36);
        }
        if (flag) {
            this.model.enableAppointmentNavigation = flag && !this._mediaQuery;
            if (!this.model.enableAppointmentNavigation)
                this.element.find(".e-prev,.e-next").remove();
            else {
                this._nextPrevAppointment(this.model.enableAppointmentNavigation);
            }
            var header = this.element.find(".e-scheduleheader");
            header.empty();
            this._renderHeaderBar(header);
            this.element.find("#" + this._id + "_navigator").ejDatePicker({ enableRTL: this.model.enableRTL, buttonText: this._getLocalizedLabels("Today"), select: $.proxy(this._onselect, this), locale: this.model.locale, cssClass: this.model.cssClass });
            this.element.find(".e-datecommondiv").find(".e-datewidget").css("display", "none");
            (this._mediaQuery) && this._renderNavigationDrawer();
            //$("#navDrawer").click(function () {
            //    $("#navpane").ejNavigationDrawer("open");
            //});
            $(".e-" + this.currentView()).addClass("e-activeview");
            this._businessHourScroller();
            this.model.showQuickWindow = !this._mediaQuery;
            this.model.showQuickWindow && (this._renderQuickAppWindow() || this._renderQuickAppDetailsView());
            this._destorySubControls($("#" + this._id + "_AddEditForm"));
            this._destorySubControls($("#" + this._id + "_RecurForm"));
            $("#" + this._id + "AppointmentAddEditWindow_wrapper").remove();
            this._renderAppointmentWindow();
            if (this._mediaQuery)
                this._phoneChanges();
            this._renderAppointmentAll();
            this._wireEvents();
        }
    },

    
    /**
    * Section For render the templates used in the schedule.
    * @private
    */
    _renderTemplates: function () {
        //content area template
        if (this.model.orientation == "vertical") {
            this.workcellTemp = $.templates(this._createTemplate(workCellsTemplate(), "_WorkCells"));
            this.monthcellTemp = $.templates(this._createTemplate(monthCellsTemplate(), "_MonthCells"));
            //timecells template rendering
            this.timeCellTemplate = $.templates(this._createTemplate(timeCellsTemplate(), "_TimeCells"));
            //header day template rendering
            this.headTemplate = $.templates(this._createTemplate(headerTemplate(), "_HeaderDate"));
            //allday template rendering
            this.alldayTemp = $.templates(this._createTemplate(alldayTemplate(), "_AlldayCells"));
            this.leftIndent = $.templates(this._createTemplate(leftHeaderTemplate(), "_LeftIndentCells"));
        }
        if (ej.scheduleFeatures.resources && !ej.isNullOrUndefined(this.model.resources))
            this._renderResourcesTemplate();        

        // appointment template rendering
        this.appTemplate = $.templates(this._createTemplate(appointmentTemplate(), "_Appointment"));

        //horizontal header template
        if (ej.scheduleFeatures.horizontal && this.model.orientation === "horizontal")
            this._renderHorizontalTemplates();
        if (!ej.isNullOrUndefined(this.model.categorizeSettings) && this.model.categorizeSettings.enable ) {
            this._renderCategorizeTemplate();
            this._categorizeMultipleTemplate = $.templates(this._createTemplate(categorizeMultipleTemplate(), "_CategorizeMultiple"));
        }
    },
        /**
        * To configure start and end hour of the schedule		
    * @private
    */
    _setNewStartEndHours: function () {
        if (this.currentView() !== "month" && !(this._isCustomView())) {
            this.wTR.children().remove();
            this._renderContentAreaTemplate();
            this._renderScroller();
            this.element.find(".e-ampmdisplay").height(this.element.find(".e-workcells").height());
            (this.model.highlightBusinessHours) ? this._highlightBusinessHours() : this.element.find(".e-workcells").addClass("e-businesshighlightworkcells");
            if (this.model.showCurrentTimeIndicator) $(".e-highlightcurrenttimeline").remove(); 
            this._highlightCurrentTime(this.model.showCurrentTimeIndicator);
            this._renderAppointmentAll();
        }
    },
    /**
    * Section For render the schedule control initially.
    * @private
    */
    _renderInitSchedule: function () {
        this._mediaQuery = (window.innerWidth < 361 || ej.isDevice());
        this.model.showQuickWindow = !this._mediaQuery;
		var culture = Globalize.culture(this.model.locale);
        var localizeAmPm = culture.calendar;
        this._timeMode = (this.model.timeMode== null) ? (localizeAmPm.AM == null && localizeAmPm.PM == null) ? "24" : "12" :this.model.timeMode;
        if(this.model.timeMode==null){this._pattern=culture.calendar.patterns;}
        else this._pattern.t=(this._timeMode=="12")?"h:mm:tt":"HH:mm";
        this.scrollWidth = this.model.width; this.scrollHeight=this.model.height;
        this.model.width = this.model.width ? this.element.width(this.model.width).width() : this.element.width();
        this.model.height = (this._mediaQuery) ? $(document).height() : this.model.height ? this.element.height(this.model.height).height() : this.element.height();
        this.scWidth = this._scWidth ? parseInt(this._scWidth) : parseInt(this.model.width);
        this.scHeight = this._scHeight ? parseInt(this._scHeight) : parseInt(this.model.height);
        (this.currentDate() < this.model.minDate) && this.currentDate(this.model.minDate);
        (this.currentDate() > this.model.maxDate) && this.currentDate(this.model.maxDate);
        this.element.addClass("e-scheduleouter").height(this.scrollHeight).width(this.scrollWidth).attr("role", "presentation");
        $(this.element).attr("tabIndex", 1);
        var $scheduleDiv = ej.buildTag('div', "", {}, { height: this.scHeight, width: this.scWidth });
        var $scheduleTable = ej.buildTag('table.e-table', "", {}, { cellpadding: "0px", cellspacing: "0px" }).addClass("e-scheduleoutertable");
        var $tBody = ej.buildTag('tbody');
        var hTR = ej.buildTag("tr.e-scheduleheader");
        this.aTR = ej.buildTag("tr");
        this.model.views.toString().toLowerCase().split(',').indexOf(this.currentView()) == -1 && this.currentView(this.model.views[0].toLowerCase()); 
        this._calculateCustomDays();
        this._getRenderDates();
        this.wTR = ej.buildTag("tr.e-contentarearow");
        this._renderTemplates();
        this._renderHeaderBar(hTR); //header dates div(prev & next)
        this._renderHeaderAllDayTemplate(); //header and all-day div
        this._renderContentAreaTemplate(); //contentarea div

        $scheduleDiv.append($scheduleTable.append($tBody.append(hTR).append(this.aTR).append(this.wTR)));
        this.element.append($scheduleDiv);
        this.element.find(".e-" + this.currentView()).addClass("e-activeview");
        this.element.find("#" + this._id + "_navigator").ejDatePicker({ enableRTL: this.model.enableRTL, buttonText: this._getLocalizedLabels("Today"), select: $.proxy(this._onselect, this), locale: this.model.locale, cssClass: this.model.cssClass });
        this.element.find("span.e-datewidget").css("display", "none");
        if(this.model.orientation == "vertical"){
            this._headerbarWidth(); (this.currentView() === "month" || (this._isCustomView())) && this._renderMonthTimeCells();
        }
        this.element.find(".e-headercells").addClass("e-dateheaderselect");
        (this.model.highlightBusinessHours) ? this._highlightBusinessHours() : this.element.find(".e-workcells").removeClass("e-businesshighlightworkcells");
        this._renderAppointmentWindow();
        (this._mediaQuery) && this._renderNavigationDrawer();
        //Render Recurrence edit dialog.
        this._renderRecurEditWindow();
        this.model.showQuickWindow && (this._renderQuickAppWindow() || this._renderQuickAppDetailsView());
        this.element.find(".e-schedulesettings").html(this._getLocalizedLabels("AllDay"));
        (this.element.find('.e-workcells').width() < this.element.find('.e-dateheadercell').width() && this.model.orientation == "horizontal" && this.model.cellWidth == "") ? this.element.find('.e-workcells').width(this.model.currentView == "month" || (this._isCustomView()) ? this.element.find('.e-horizontmonthheaderdaytd').width() : this.element.find('.e-horizontaltimetd ').width()) : "";
        // render scroller
        this._renderScroller();
        this.model.currentView == "month" || (this._isCustomView()) ? this.element.find(".e-timecells").height($(this.element.find(".e-monthcells")).height()) : this.element.find(".e-ampmdisplay").height($(this.element.find(".e-workcells")).height());
        this._highlightCurrentTime(this.model.showCurrentTimeIndicator);
        this._validateMinMaxDate();
        this._showContextMenu(this.model.contextMenuSettings.enable);
        if (this.model.orientation == "horizontal" && ej.scheduleFeatures.horizontal)
            this._moveScroller();
        (this._dateRender.length > 60 || (parseInt(this.model.cellHeight) < 35 && this.model.cellHeight !== "20px") && this.model.orientation == "vertical") ? this.element.find('td.e-timecells .e-timecelldivs').addClass('e-timedivcells') : "";
        if (this._mediaQuery)
            this._phoneChanges();
    },

    _phoneChanges: function () {
        this._appointmentAddWindow.ejDialog({
            //height: window.innerHeight - 20,
            allowDraggable: false,
            position: { X: "0", Y: "0" }
        });
    },
    _calculateCustomDays: function(){
        if (!ej.isNullOrUndefined(this.model.renderDates) && this.currentView() == "customview" && !this._navigate) {
            var startdate = $.type(this.model.renderDates.start) != "date" ? new Date(Globalize.parseDate(this.model.renderDates.start, this._datepattern())) : new Date(this.model.renderDates.start); var enddate = $.type(this.model.renderDates.end) != "date" ? new Date(Globalize.parseDate(this.model.renderDates.end, this._datepattern())) : new Date(this.model.renderDates.end);
            this._renderStart = new Date(startdate.getFullYear(), startdate.getMonth(), startdate.getDate()); // this._formatTime(this.model.renderDates.start); //.toLocaleDateString();
            this._renderEnd = new Date(enddate.getFullYear(), enddate.getMonth(), enddate.getDate()); //this._formatTime(this.model.renderDates.end); //.toLocaleDateString();
            this.currentDate(new Date(this._renderStart));
            this._renderDays = Math.round((this._renderEnd - this._renderStart) / 86400000) + 1;
            if (this._renderDays > 7) {
                var firstDay = this.model.orientation == "vertical" ? new Date(this._firstweekdate(this._renderStart)) : new Date(this._renderStart);
                var endDay = new Date(this._renderEnd); var day = endDay.getDay();
                if (day != 6)
                    endDay.setDate(new Date(this._renderEnd).getDate() + (6 - day));
                endDay = this.model.orientation == "vertical" ? endDay : new Date(this._renderEnd);
                this._numDays = Math.round((endDay - firstDay) / 86400000) + 1;
            }
        }
    },

    _isCustomView: function () {
        if (this.currentView() == "customview" && this._renderDays > 7)
            return true;
    },

    _headerbarWidth: function () {
        var cols = this.currentView() == "workweek" ? 5 : this.currentView() == "day" ? 1 : (this.currentView() === "customview" && this._renderDays <= 7) ? this._dateRender.length : 7;
        var col = (!ej.isNullOrUndefined(this.model.group) && !ej.isNullOrUndefined(this.model.resources)) ? (this.res1.length * cols) : cols;
        this.element.find(".e-headrealldaytable").width(this.model.cellWidth ? (parseInt(this.model.cellWidth) * col) + col : "100%");

    },
    /**
    * Section For render the scroller of the schedule.
    * @private
    */
    _renderScroller: function () {
        var _scrollDiv = $('div#' + this._id + "_scroller");
        var hghtdiff = this.scHeight - (this.element.find('.e-draggableworkarea').offset().top - this.element.offset().top);
        var proxy = this; var wdthdiff = (this.currentView() === "month") ? 0 : 4;
        var scrollWidth = (this.model.orientation === "vertical" && !this.model.enableRTL) ? this.element.outerWidth() - (this.element.find('.e-draggableworkarea').offset().left - this.element.offset().left) : (this.model.orientation == "horizontal") && (!ej.isNullOrUndefined(this.model.group) && !ej.isNullOrUndefined(this.model.resources) && !this.model.enableRTL) ? this.element.width() - this.element.find(".e-resourceheadertable").width() : (this.model.enableRTL) ? this.element.width() - this.element.find('.e-scrolltimecells').parent().width() : this.element.width();
        _scrollDiv.ejScroller({
            enableRTL: this.model.enableRTL, height: hghtdiff, width: scrollWidth, cssClass: this.model.cssClass,
            thumbStart: function (e) {
                var target = $(e.originalEvent.target);
                if ((this._mediaQuery) && target.hasClass("e-workcells") || target.parents(".e-appointment").hasClass("e-appointment") || target.parents(".e-monthappointment").hasClass("e-monthappointment") || target.hasClass("e-categorybar")) return false;
            },
            scroll: function (e) {
                (proxy.model.orientation === "vertical") ? proxy.element.find(".e-scrolltimecells").css("top", (-e.scrollTop) + "px") : (proxy.currentView() !== "month" && !(proxy._isCustomView())) ? $(proxy.element.find(".e-horizontaltimecells").find("table tr")[2]).css("left", (-e.scrollLeft) + "px") : proxy.element.find(".e-headerdays").css("left", (-e.scrollLeft) + "px"); // proxy.element.find(".e-horizontaltimecells").css("left", (-e.scrollLeft) + "px");
                if (proxy.element.find('.e-vhandle').length == 1)
                    proxy.element.find(".e-horires").css("top", (-e.scrollTop) + "px");
                if (proxy.model.orientation == "vertical") {
                    proxy.element.find(".e-headrealldaytable").css("left", (-e.scrollLeft) + "px");
                    //  changing AM/PM label while scrolling
                    if (proxy._timeMode === "12" && (proxy.currentView() !== "month" && !(proxy._isCustomView()))) {
                        var top = (e.scrollTop / (proxy.element.find(".e-workcells").height() * 2));
                        top = (Math.round(top) < top) ? Math.round(top) + 1 : Math.round(top);
                        var localizeAmPm = Globalize.culture(proxy.model.locale).calendar;
                        if (localizeAmPm.AM && localizeAmPm.PM) {
                            proxy.element.find('.e-ampmstyle').each(function (i, val) {
                                if (i == (top))
                                    (parseInt($(val)[0].id) < 12) ? $(val).text(localizeAmPm.AM[0]) : $(val).text(localizeAmPm.PM[0]);
                                else if (($(val).text() == localizeAmPm.AM[0] && i > 0) || ($(val).text() == localizeAmPm.PM[0] && parseInt($(val)[0].id) > 12))
                                    $(val).text("00");
                            });
                        }
                    }
                }
                else if (ej.scheduleFeatures.horizontal && proxy.model.orientation == "horizontal")
                    proxy._horizontalScroll(e, proxy);
            }
        });
        (!this._mediaQuery) && this._nextPrevAppointment(this.model.enableAppointmentNavigation);
        this._renderHoriVerticalScroll();
        this.element.find(".e-vscroll").css("left", window.innerWidth - 18);
        this.element.find(".e-mobileNavigation").css("left", window.innerWidth - 36);
    },
        _renderHoriVerticalScroll: function () {
        var _scrollDiv = $('div#' + this._id + "_scroller");
        var wdthdiff = (this.currentView() === "month") ? 0 : 4;
        var scrollWidth = (this.model.orientation === "vertical" && !this.model.enableRTL) ? this.element.outerWidth() - (this.element.find('.e-draggableworkarea').offset().left - this.element.offset().left) : (this.model.orientation == "horizontal") && (!ej.isNullOrUndefined(this.model.group) && !ej.isNullOrUndefined(this.model.resources) && !this.model.enableRTL) ? this.element.width() - this.element.find(".e-resourceheadertable").width() : (this.model.enableRTL) ? this.element.width() - this.element.find('.e-scrolltimecells').parent().width() : this.element.width();
        var hghtdiff = this.scHeight - (this.element.find('.e-draggableworkarea').offset().top - this.element.offset().top);
        var cols = this.currentView() == "workweek" ? 5 : this.currentView() == "day" ? 1 : (this.currentView() === "customview" && this._renderDays <= 7) ? this._dateRender.length : 7;
        var col = (!ej.isNullOrUndefined(this.model.group) && !ej.isNullOrUndefined(this.model.resources)) ? (this.res1.length * cols) : cols;
        if (this.model.orientation == "vertical") {
            _scrollDiv.ejScroller("isVScroll") ? this.element.find(".e-emptytd,.e-emptyalldaytd").show() : this.element.find(".e-emptytd,.e-emptyalldaytd").hide();
            if (this.model.cellWidth) {
                (this.currentView() == "day") && this.element.find(".e-headerdaydisplay").css("width", this.model.cellWidth);

                var rows = this._dateRender.length / 7;
                var overallWidth = parseInt(this.model.cellWidth) * col;
                var overallHeight = parseInt(this.model.cellHeight) * rows;
                var dragWidth = this.scWidth - this.element.find(".e-scrolltimecells").width() + wdthdiff;
                var dragHeight = hghtdiff;

                if (this.currentView() == "month" || (this._isCustomView())) {
                    this.element.find(".e-draggableworkarea").width((this.element.width() > overallWidth + this.element.find(".e-scrolltimecells").width() + 18) ? overallWidth : _scrollDiv.ejScroller("isVScroll") ? scrollWidth - 18 : scrollWidth);
                    this.element.find(".e-draggableworkarea").height(this.model.cellHeight != "20px" ? overallHeight : _scrollDiv.ejScroller("isHScroll") ? dragHeight - 18 : dragHeight);
                    this.element.find(".e-emptytd").show();
                }
                else
                    this.element.find(".e-draggableworkarea").width((this.element.width() > overallWidth + this.element.find(".e-scrolltimecells").width() + 18) ? overallWidth : scrollWidth - 18);
                (this.model.cellWidth) && this.element.find(".e-datecommondiv").parent().width(this.element.width());
                this.element.find(".e-headrealldaytable").parent().width(this.element.find(".e-draggableworkarea").width());
            }
            else {
                this.element.find(".e-draggableworkarea").height(hghtdiff);                             					
                if (_scrollDiv.ejScroller("isVScroll") && !this._mediaQuery)
                    this.element.find(".e-draggableworkarea").width(scrollWidth - 18);
                else if (this.currentView() == "month" || (this._isCustomView()))
                    this.element.find(".e-draggableworkarea").width(scrollWidth);
                else if (this._mediaQuery && this.res1.length > 1 && this.model.group.resources.length == 1)
                    this.element.find(".e-draggableworkarea").width(this.element.find(".e-draggableworkarea").width() * this.res1.length);
                this.element.find(".e-headrealldaytable").parent().width(this.element.find(".e-draggableworkarea").width());
                this.element.find(".e-scrolltimecells").height(this.element.find('.e-draggableworkarea').height());
            }
        }
        else {
            !(_scrollDiv.ejScroller("isHScroll")) ? this.element.find(".e-draggableworkarea").css("height", "100%") && this.element.find(".e-resfootertr").css("height", "0px") : "";
            !(_scrollDiv.ejScroller("isVScroll")) && !(_scrollDiv.ejScroller("isHScroll")) ? "":!(_scrollDiv.ejScroller("isVScroll"))? this.element.find(".e-draggableworkarea").css("height", hghtdiff - 18) : "";
            if ((this.currentView() == "month") && !(_scrollDiv.ejScroller("isHScroll")) && !(_scrollDiv.ejScroller("isVScroll")))
                this.element.find(".e-draggableworkarea").css("height", "100%");
            this.element.find(".e-horizontresdiv").height(this.element.find('.e-draggableworkarea').height());
        }
    },
    /**
    * Section For handle the business hour highlight of the schedule.
    * @private
    */

    _highlightBusinessHours: function () {
        if (this.currentView() !== "month" && !(this._isCustomView())) {
            this.element.find(".e-workcells").removeClass("e-businesshighlightworkcells");
            var renderDates = this.dateRender;
            var target = this.element.find(".e-workcells");
            var b_startHour = this.model.businessStartHour >= this.model.startHour ? this.model.businessStartHour - this.model.startHour : 0;
            var b_endHour = this.model.businessEndHour <= this.model.endHour ? this.model.businessEndHour - this.model.startHour : this.model.endHour - this.model.startHour;
            var timeRowsCount = 60 / 30;
            this.res1 = (!ej.isNullOrUndefined(this.model.group) && !ej.isNullOrUndefined(this.model.resources)) ? this.res1 : [0];
            var colCount = this.currentView() === "week" ? 7 * this.res1.length : this.currentView() === "workweek" ? 5 * this.res1.length : (this.currentView() === "customview" && this._renderDays <= 7) ? this._dateRender.length * this.res1.length : 1 * this.res1.length;
            if (this.model.orientation == "vertical") {
                for (var i = (b_startHour * timeRowsCount) ; i < (b_endHour * timeRowsCount) ; i++) {
                    for (var j = 0; j < colCount; j++) {
                        if (new Date(renderDates[j]).getDay() !== 0 && new Date(renderDates[j]).getDay() !== 6)
                            $(target[(i * colCount) + j]).addClass("e-businesshighlightworkcells");
                    }
                }
                this._businessHourScroller();    
            }
            else
                this._horizontalBusinessHighlight(this._dateRender, b_startHour, b_endHour, timeRowsCount, target);
        }
        else {
            var target, monthDays;
            if (this.model.orientation == "vertical") {
                monthDays = this.dateRender;
                target = this.element.find(".e-monthcells");
                target.removeClass("e-monthcellhighlight");
                for (var i = 0; i < monthDays.length; i++) {
                    if (new Date(monthDays[i]).getDay() !== 0 && new Date(monthDays[i]).getDay() !== 6)
                        $(target[i]).addClass("e-monthcellhighlight");
                }
            }
            else
                this._horizontalBusinessHighlight(null, null, null, null, null);
        }
    },
    /**
    * Section For handle the calendar date select and change the current date of the schedule.
    * @private
    */
    _onselect: function (e) {
        var proxy = this, data;
        data = { currentDate: new Date(this.currentDate()), target: e, requestType: "dateNavigate" };
        if (this._trigger("actionBegin", data))
            return false;
        var currentdate = new Date(this.currentDate());
        var selectdate = Globalize.parseDate(e.value, this._pattern.d);
        this.currentDate(selectdate);
        data = { prevDate: currentdate, currentDate: this.currentDate(), target: e };
        if (this._trigger("navigation", data))
            return false;
        proxy._navigateClick(e);
        this._trigger("actionComplete", { data: data, requestType: "dateNavigate" });
    },
    /**
    * Section For render the header bar of the schedule.
    * @private
    */
    _renderHeaderBar: function (hTR) {
        var colsVal = this.model.orientation == "vertical" ? 1 : 2;
        this.hTD = ej.buildTag('td', "", {}, { colspan: colsVal });
        if (this._mediaQuery) {
            var commonDiv = ej.buildTag('div.e-datecommondiv').append(ej.buildTag('div.e-icon e-navigateprevious', "", {}, { title: this._getLocalizedLabels("Previous") })).append(ej.buildTag('div.e-icon e-navigatenext', "", {}, { title: this._getLocalizedLabels("Next") }).css("margin-left", "5px")).append(ej.buildTag('div', "", {}, { "aria-live": "assertive", tabindex: 0 }).html(this._getCurrentDateHeaderValue()).addClass("e-datedisplay").css("font-size", "18px")).append(ej.buildTag("input#" + this._id + "_navigator").css("display", "none").addClass("dateCalendar"));
            var menuIcon = ej.buildTag('div#navDrawer.e-mobileNavigation e-icon');
            hTR.append(this.hTD.append(ej.buildTag("div").css("width", "100%").append(commonDiv).append(menuIcon)));
        }
        else {
            var commonDiv = ej.buildTag('div.e-datecommondiv').append(ej.buildTag('div.e-icon e-navigateprevious', "", {}, { title: this._getLocalizedLabels("Previous") })).append(ej.buildTag('div', "", {}, { "aria-live": "assertive", tabindex: 0 }).html(this._getCurrentDateHeaderValue()).addClass("e-datedisplay")).append(ej.buildTag("input#" + this._id + "_navigator").css("display", "none").addClass("dateCalendar")).append(ej.buildTag('div.e-icon e-navigatenext', "", {}, { title: this._getLocalizedLabels("Next") }));
            var buttonsDiv = ej.buildTag('div.e-viewsdiv');
            hTR.append(this.hTD.append(ej.buildTag("div").css("width", "100%").append(commonDiv).append(buttonsDiv.append(this._renderViewNavigation(this.model.views)))));
        }
    },
    /**
    * Section For render the views of the schedule.
    * @private
    */
    _renderViewNavigation: function (views) {
        var $viewTable = ej.buildTag('table.e-table e-viewstable', "", {}, { cellspacing: '0px', cellpadding: '0px' });
        var $viewBody = ej.buildTag('tbody');
        var $viewTR = ej.buildTag('tr');
        var _viewCollection = views, viewClassname; //this.model.views; // ["Day", "Week", "WorkWeek", "Month", "Agenda"];
        for (var i = 0; i < _viewCollection.length; i++) {
            viewClassname = (_viewCollection.length == 1) ? "e-" + _viewCollection[i].toLowerCase() + " e-singleview" : (i == 0) ? "e-" + _viewCollection[i].toLowerCase() + " e-firstview" : i == (_viewCollection.length - 1) ? "e-" + _viewCollection[i].toLowerCase() + " e-lastview" : "e-" + _viewCollection[i].toLowerCase();
            $viewTR.append(ej.buildTag('td').append(ej.buildTag('div', this._getLocalizedLabels(_viewCollection[i]), {}, {}).addClass("e-commonviewbutton").addClass(viewClassname)));
        }
        $viewTable.append($viewBody.append($viewTR))
        return $viewTable;
    },

    _emptyCell: function () {
         var _scrollDiv = $('div#' + this._id + "_scroller");
        if(this.currentView()!="month" && (!this._isCustomView())){
            var emptyCell = "<table cellspacing='0' cellpadding='0'><tbody>";
            if (!ej.isNullOrUndefined(this.model.resources))
                emptyCell += "<tr><td class='e-emptytd e-headerresourcecells' style='height: 27px'></td></tr>";
            if (!ej.isNullOrUndefined(this.model.group) && this.model.group.resources.length > 1)
                emptyCell += "<tr><td class='e-emptytd e-headerresourcecells' style='height: 27px'></td></tr>";
            emptyCell += "<tr><td class='e-emptytd' style='height:29px'></td></tr><tr><td class='e-emptyalldaytd' style='height:27px'></td></tr></tbody></table>";
        }
        else if((this.currentView()=="month" || this._isCustomView()) && _scrollDiv.ejScroller("isVScroll"))
            var emptyCell = "<td class='e-emptytd' style='height:29px'></td>";
        return emptyCell;
    
    },

    /**
    * Section For render the recurrence window of the schedule.
    * @private
    */
    _recurrenceWindow: function () {
        var recurtype = ["Daily", "Weekly", "Monthly", "Yearly", "EveryWeekDay"];
        var culture = Globalize.culture(this.model.locale);
        var weekshort = this._dayShortNames;
        var weekfull = this._dayFullNames;
        var months = this._monthNames;
        var startday = ["First", "Second", "Third", "Fourth", "Last"];
        if (this._mediaQuery) {
            var $recurWin = "<div class='e-recurwindow e-windowmargin' style='display:none'>" +
                        "<form id='" + this._id + "_RecurForm'><table class='e-table' width='100%' cellpadding='7'><tbody>";
            $recurWin += "<tr><td width='16%' class='e-textlabel'>" + this._getLocalizedLabels("Recurrence") + ":</td>" +
                        "<td><input class='recurtype' id='recurtype' type='text' name='RecurrenceType' value='" + this._getLocalizedLabels(recurtype[0]) + "' /><div id='recurtypelist'><ul>";
            for (var type = 0; type < recurtype.length; type++) {
                $recurWin += "<li>" + this._getLocalizedLabels(recurtype[type]) + "</li>";
            }
            $recurWin += "</ul></div></td></tr>";
            $recurWin += "<tr id='" + this._id + "repeatEvery'><td class='e-textlabel'>" + this._getLocalizedLabels("Every") + ":</td><td><table><tr><td><div class='e-floatleft'><input id='recurevery' class='e-recurevery' type='text' /></div></td>" +
                        "<td><div id='" + this._id + "recurtypes' class='e-appcheckbox'>" + this._getLocalizedLabels("RecurrenceDay") + "</div></td></tr></table></td></tr>";

            $recurWin += "<tr id='" + this._id + "weeklyrecur' class='" + this._id + "weeklyrecur' style='display:none'><td colspan='2' id='recurweek' class='e-textlabel'><div>" + this._getLocalizedLabels("RepeatOn") + ":</div></td></tr><tr class='" + this._id + "weeklyrecur'>" +
                        "<td colspan='2' id='recurweekcount'><table class='e-table' cellpadding='3'><tr>";
            for (var weekcount = 0; weekcount < weekshort.length; weekcount++) {
                $recurWin += "<td><div class='e-weekday e-_" + weekshort[weekcount] + "'><input id='" + weekshort[weekcount] + "' class='weekdays e-weekly" + this._dayNames[weekcount] + "'name='weekdays' type='checkbox'/><label class='e-textmargin' for='" + weekshort[weekcount] + "'>" + weekshort[weekcount] + "</label></div></td>";
            }
            $recurWin += "</tr></table></td></tr>";
            $recurWin += "<tr id='" + this._id + "monthlyrecur' class='" + this._id + "monthlyrecur' style='display:none'><td colspan='2' id='recurmonthtext' class='e-recurendslabel'><div class='e-recurendsalign'>" + this._getLocalizedLabels("RepeatBy") + ":</div></td></tr><tr class='" + this._id + "monthlyrecur'>" +
                        "<td colspan='2' id='recurmonthcount'><table class='e-table' cellpadding='3'><tr><td><div><input id='" + this._id + "monthday' class='e-monthdaytype' name='monthday' type='radio'/><label class='e-textmargin' for='" + this._id + "monthday'>" + this._getLocalizedLabels("Day") + "</label></div></td>" +
                        "<td><div><input id='monthdate' class='e-monthdate' type='text'/></div></td></tr>" +
                        "<tr><td><div><input id='" + this._id + "monthon' class='e-monthposition' name='monthday' type='radio'/><label class='e-textmargin' for='" + this._id + "monthon'>" + this._getLocalizedLabels("The") + "</label></div></td>" +
                        "<td><div><input id='monthsrt' class='monthsrt' type='text' name='monthsrt' value=''/><div id='monthsrtlist'><ul>";
            for (var day = 0; day < startday.length; day++) {
                $recurWin += "<li>" + this._getLocalizedLabels(startday[day]) + "</li>";
            }
            $recurWin += "</div></div></td>";
            $recurWin += "<td><div class='e-appcheckbox'><input id='monthsrtday' class='e-monthsrtday' type='text' name='monthsrtday' value=''/>" +
                "<div id='monthsrtdaylist'><ul>";
            for (var monthday = 0; monthday < weekfull.length; monthday++) {
                $recurWin += "<li>" + weekfull[monthday] + "</li>";
            }
            $recurWin += "</div></div></td></tr></table></td></tr>";
            $recurWin += "<tr id='" + this._id + "yearlyrecur' class='" + this._id + "yearlyrecur' style='display:none'><td colspan='2' id='recuryeartext' class='e-recurendslabel'><div class='e-recurendsalign'>" + this._getLocalizedLabels("RepeatBy") + ":</div></td></tr><tr class='" + this._id + "yearlyrecur'>" +
                        "<td colspan='2' id='recuryearcount' ><table class='e-table' cellpadding='3'><tr>" +
                        "<td><div><input id='" + this._id + "yearday' class='e-yearrecurday' name='yearday' type='radio'/><label class='e-textmargin' for='" + this._id + "yearday'>" + this._getLocalizedLabels("The") + "</label></div></td>" +
                        "<td><div class='e-controlalign'><input id='yearmonth' class='yearmonth' type='text' name='yearmonth' value=''/></div></td>" +
                        "<div id='yearmonthlist'><ul>";
            for (var monthcount = 0; monthcount < (months.length - 1) ; monthcount++) {
                $recurWin += "<li>" + months[monthcount] + "</li>";
            }
            $recurWin += "</ul></div><td><input id='yeardate' class='yeardate' text='text'/></td></tr>" +
                    "<tr><td><div><input id='" + this._id + "yearother' class='e-yearrecurposi' name='yearday' type='radio'/><label class='e-textmargin' for='" + this._id + "yearother'>" + this._getLocalizedLabels("The") + "</label></div></td>" +
                    "<td><div><input id='yearsrt' class='yearsrt' type='text' name='yearsrt' value=''/><div id='yearsrtlist'><ul>";
            for (var yearstartday = 0; yearstartday < startday.length; yearstartday++) {
                $recurWin += "<li>" + this._getLocalizedLabels(startday[yearstartday]) + "</li>";
            }
            $recurWin += "</ul></div></div></td><td><div class='e-controlalign'><input id='yearsrtday' class='yearsrtday' type='text' name='yearsrtday' value=''/>" +
                "<div id='yearsrtdaylist'><ul>";
            for (var yearweek = 0; yearweek < weekfull.length; yearweek++) {
                $recurWin += "<li>" + weekfull[yearweek] + "</li>";
            }
            $recurWin += "</ul></div></div></td><td><div><span>" + this._getLocalizedLabels("OfEvery").split(" ")[0] + "</span></div></td></tr><tr><td></td><td><div><input id='yearsrtmonth' class='yearsrtmonth' type='text' name='yearsrtmonth' value=''/>" +
                    "<div id='yearsrtmonthlist'><ul>";
            for (var yearmonth = 0; yearmonth < (months.length - 1) ; yearmonth++) {
                $recurWin += "<li>" + months[yearmonth] + "</li>";
            }
            $recurWin += "</ul></div></div></td></tr></table></td></tr>";
            $recurWin += "<tr><td colspan='2' class='e-textlabel'>" + this._getLocalizedLabels("StartsOn") + ":</td></tr><tr>" +
                        "<td colspan='2'><input id='recurstartdate' class='recurstartdate' type='text' name='RecurStartDate' value=''/></td></tr>";
            $recurWin += "<tr><td colspan='2' class='e-recurendslabel'><div class='e-recurendsalign'>" + this._getLocalizedLabels("Ends") + ":</div></td></tr><tr>" +
                        "<td colspan='2'><table class='e-table' cellpadding='3'><tr><td><div><input id='repeatendnever' class='recurends e-recurnoend' type='radio' name='repeatend' value='Never'/><label class='e-textmargin' for='repeatendnever'>" + this._getLocalizedLabels("Never") + "</label></div></td></tr>" +
                        "<tr><td><div><input id='" + this._id + "repeatendafter' class='recurends e-recurafter' type='radio' name='repeatend'/><label class='e-textmargin' for='" + this._id + "repeatendafter'>" + this._getLocalizedLabels("After") + "</label>" +
                        "</div></td><td><div><input id='dailyoccurance' class='e-recurcount' type='text'/></div></td>" +
                        "<td><span style='margin-left: -80px;'>" + this._getLocalizedLabels("Occurence") + "</span></td></tr>" +
                        "<td><div><input id='" + this._id + "repeatendon' class='recurends e-recuruntil' type='radio' name='repeatend'/><label class='e-textmargin' for='" + this._id + "repeatendon'>" + this._getLocalizedLabels("On") + "</label></div></td>" +
                        "<td><input id='daily' class='e-until' type='text' name='daily' value=''/></td></tr></table></td></tr>";
            $recurWin += "<tr style='display:none'><td><span class='e-textlabel'>" + this._getLocalizedLabels("Summary") + ":</span></td><td><span class=e-recurRule></span></td></tr></tbody></table></form>";
            $recurWin += "<div class='e-floatright'><table class='e-table' cellpadding='5'><tr><td><div class='e-btnmargin e-floatleft'><button id='donerecur' class='recurbutton'>" + this._getLocalizedLabels("Done") + "</button></div></td>" +
                        "<td><div class='e-btnmargin e-floatleft'><button id='cancelrecur' class='e-cancelrecur recurbutton'>" + this._getLocalizedLabels("Cancel") + "</button></div></td></tr></tabled></div></div>";
            return $recurWin;
        }
        else {
            var $recurWin = "<div class='e-recurwindow e-windowmargin' style='display:none'>" +
                    "<form id='" + this._id + "_RecurForm'><table class='e-table' width='100%' cellpadding='7'><tbody>";
            $recurWin += "<tr><td width='16%' class='e-textlabel'>" + this._getLocalizedLabels("Recurrence") + ":</td>" +
                    "<td><input class='recurtype' id='recurtype' type='text' name='RecurrenceType' value='" + this._getLocalizedLabels(recurtype[0]) + "' /><div id='recurtypelist'><ul>";
            for (var type = 0; type < recurtype.length; type++) {
                $recurWin += "<li>" + this._getLocalizedLabels(recurtype[type]) + "</li>";
            }
            $recurWin += "</ul></div></td></tr>";
            $recurWin += "<tr id='" + this._id + "repeatEvery'><td class='e-textlabel'>" + this._getLocalizedLabels("Every") + ":</td><td><table><tr><td><div class='e-floatleft'><input id='recurevery' class='e-recurevery' type='text' /></div></td>" +
                    "<td><div id='" + this._id + "recurtypes' class='e-appcheckbox'>" + this._getLocalizedLabels("RecurrenceDay") + "</div></td></tr></table></td></tr>";

            $recurWin += "<tr id='" + this._id + "weeklyrecur' class='" + this._id + "weeklyrecur' style='display:none'><td id='recurweek' class='e-textlabel'><div>" + this._getLocalizedLabels("RepeatOn") + ":</div></td>" +
                    "<td id='recurweekcount'><table class='e-table' cellpadding='3'><tr>";
            for (var weekcount = 0; weekcount < weekshort.length; weekcount++) {
                $recurWin += "<td><div class='e-weekday e-_" + weekshort[weekcount] + "'><input id='" + weekshort[weekcount] + "' class='weekdays e-weekly" + this._dayNames[weekcount] + "'name='weekdays' type='checkbox'/><label class='e-textmargin' for='" + weekshort[weekcount] + "'>" + weekshort[weekcount] + "</label></div></td>";
            }
            $recurWin += "</tr></table></td></tr>";
            $recurWin += "<tr id='" + this._id + "monthlyrecur' class='" + this._id + "monthlyrecur' style='display:none'><td id='recurmonthtext' class='e-recurendslabel'><div class='e-recurendsalign'>" + this._getLocalizedLabels("RepeatBy") + ":</div></td>" +
                    "<td id='recurmonthcount'><table class='e-table' cellpadding='3'><tr><td><div><input id='" + this._id + "monthday' class='e-monthdaytype' name='monthday' type='radio'/><label class='e-textmargin' for='" + this._id + "monthday'>" + this._getLocalizedLabels("Day") + "</label></div></td>" +
                    "<td><div><input id='monthdate' class='e-monthdate' type='text'/></div></td></tr>" +
                    "<tr><td><div><input id='" + this._id + "monthon' class='e-monthposition' name='monthday' type='radio'/><label class='e-textmargin' for='" + this._id + "monthon'>" + this._getLocalizedLabels("The") + "</label></div></td>" +
                    "<td><div><input id='monthsrt' class='monthsrt' type='text' name='monthsrt' value=''/><div id='monthsrtlist'><ul>";
            for (var day = 0; day < startday.length; day++) {
                $recurWin += "<li>" + this._getLocalizedLabels(startday[day]) + "</li>";
            }
            $recurWin += "</div></div></td>";
            $recurWin += "<td><div class='e-appcheckbox'><input id='monthsrtday' class='e-monthsrtday' type='text' name='monthsrtday' value=''/>" +
                "<div id='monthsrtdaylist'><ul>";
            for (var monthday = 0; monthday < weekfull.length; monthday++) {
                $recurWin += "<li>" + weekfull[monthday] + "</li>";
            }
            $recurWin += "</div></div></td></tr></table></td></tr>";
            $recurWin += "<tr id='" + this._id + "yearlyrecur' class='" + this._id + "yearlyrecur' style='display:none'><td id='recuryeartext' class='e-recurendslabel'><div class='e-recurendsalign'>" + this._getLocalizedLabels("RepeatBy") + ":</div></td>" +
                    "<td id='recuryearcount' ><table class='e-table' cellpadding='3'><tr>" +
                    "<td><div><input id='" + this._id + "yearday' class='e-yearrecurday' name='yearday' type='radio'/><label class='e-textmargin' for='" + this._id + "yearday'>" + this._getLocalizedLabels("The") + "</label></div></td>" +
                    "<td><div class='e-controlalign'><input id='yearmonth' class='yearmonth' type='text' name='yearmonth' value=''/></div></td>" +
                    "<div id='yearmonthlist'><ul>";
            for (var monthcount = 0; monthcount < (months.length - 1); monthcount++) {
                $recurWin += "<li>" + months[monthcount] + "</li>";
            }
            $recurWin += "</ul></div><td><input id='yeardate' class='yeardate' text='text'/></td></tr>" +
                    "<tr><td><div><input id='" + this._id + "yearother' class='e-yearrecurposi' name='yearday' type='radio'/><label class='e-textmargin' for='" + this._id + "yearother'>" + this._getLocalizedLabels("The") + "</label></div></td>" +
                    "<td><div><input id='yearsrt' class='yearsrt' type='text' name='yearsrt' value=''/><div id='yearsrtlist'><ul>";
            for (var yearstartday = 0; yearstartday < startday.length; yearstartday++) {
                $recurWin += "<li>" + this._getLocalizedLabels(startday[yearstartday]) + "</li>";
            }
            $recurWin += "</ul></div></div></td><td><div class='e-controlalign'><input id='yearsrtday' class='yearsrtday' type='text' name='yearsrtday' value=''/>" +
                "<div id='yearsrtdaylist'><ul>";
            for (var yearweek = 0; yearweek < weekfull.length; yearweek++) {
                $recurWin += "<li>" + weekfull[yearweek] + "</li>";
            }
            $recurWin += "</ul></div></div></td><td><div><span>" + this._getLocalizedLabels("OfEvery").split(" ")[0] + "</span></div></td><td><div><input id='yearsrtmonth' class='yearsrtmonth' type='text' name='yearsrtmonth' value=''/>" +
                    "<div id='yearsrtmonthlist'><ul>";
            for (var yearmonth = 0; yearmonth < (months.length - 1); yearmonth++) {
                $recurWin += "<li>" + months[yearmonth] + "</li>";
            }
            $recurWin += "</ul></div></div></td></tr></table></td></tr>";
            $recurWin += "<tr><td class='e-textlabel'>" + this._getLocalizedLabels("StartsOn") + ":</td>" +
                   "<td><input id='recurstartdate' class='recurstartdate' type='text' name='RecurStartDate' value=''/></td></tr>";
            $recurWin += "<tr><td class='e-recurendslabel'><div class='e-recurendsalign'>" + this._getLocalizedLabels("Ends") + ":</div></td>" +
                    "<td><table class='e-table' cellpadding='3'><tr><td><div><input id='repeatendnever' class='recurends e-recurnoend' type='radio' name='repeatend' value='Never'/><label class='e-textmargin' for='repeatendnever'>" + this._getLocalizedLabels("Never") + "</label></div></td></tr>" +
                    "<tr><td><div><input id='" + this._id + "repeatendafter' class='recurends e-recurafter' type='radio' name='repeatend'/><label class='e-textmargin' for='" + this._id + "repeatendafter'>" + this._getLocalizedLabels("After") + "</label>" +
                    "</div></td><td><div><input id='dailyoccurance' class='e-recurcount' type='text'/></div></td>" +
                    "<td><span style='margin-left: -80px;'>" + this._getLocalizedLabels("Occurence") + "</span></td></tr>" +
                    "<td><div><input id='" + this._id + "repeatendon' class='recurends e-recuruntil' type='radio' name='repeatend'/><label class='e-textmargin' for='" + this._id + "repeatendon'>" + this._getLocalizedLabels("On") + "</label></div></td>" +
                    "<td><input id='daily' class='e-until' type='text' name='daily' value=''/></td></tr></table></td></tr>";
            $recurWin += "<tr style='display:none'><td><span class='e-textlabel'>" + this._getLocalizedLabels("Summary") + ":</span></td><td><span class=e-recurRule></span></td></tr></tbody></table></form>";
            $recurWin += "<div class='e-floatright'><table class='e-table' cellpadding='5'><tr><td><div class='e-btnmargin e-floatleft'><button id='donerecur' class='recurbutton'>" + this._getLocalizedLabels("Done") + "</button></div></td>" +
                    "<td><div class='e-btnmargin e-floatleft'><button id='cancelrecur' class='e-cancelrecur recurbutton'>" + this._getLocalizedLabels("Cancel") + "</button></div></td></tr></tabled></div></div>";
            return $recurWin;
    }
    },

    _renderNavigationDrawer: function () {
        this._scheduleDrawer = ej.buildTag('div#' + this._id + 'navDrawer.navDrawerMenu');
        var $scheduleDrawer = "<ul><li class='e-icon e-mAddEvent' id='addEvent'><span>Add Event</span></li>";
        $scheduleDrawer+="<li class='e-icon e-mDayView' id='dayView'><span>Day View</span></li>";
        $scheduleDrawer += "<li class='e-icon e-mWeekView' id='weekView'><span>Week View</span></li>";
        $scheduleDrawer += "<li class='e-icon e-mWorkWeek' id='workWeekView'><span>Work Week</span></li>";
        $scheduleDrawer += "<li class='e-icon e-mMonthView' id='monthView'><span>Month View</span></li></ul>";
        this._scheduleDrawer.append($scheduleDrawer);
        this.element.append(this._scheduleDrawer);
        this._scheduleDrawer.ejNavigationDrawer({ type: "overlay", direction: "right", enableListView: true, listViewSettings: { width: 100, mouseDown: $.proxy(this._slideMenuClick,this) }, position: "fixed" });
    },

    _slideMenuClick: function (e) {
        this._scheduleDrawer.ejNavigationDrawer("close");
        var menu = (e.index == 1) ? "day" : (e.index == 2) ? "week" : (e.index == 3) ? "workweek" : (e.index == 4) ? "month" : "open";
        if (menu != "open") {
            this._navView = true;
            (this.currentView() != menu) && this._viewChange(null, this.currentView(), menu);
        }
        else {
            var element = this.element.find(".e-highlightcurrenttimeline").offset();
            var row = Math.round((element.top - $(".e-scheduleheader").height() - $(".e-navigate").height()) / $(".e-workcells").height()) * 2;
            var column = Math.round((element.left - $(".e-timecelltable").width()) / $(".e-workcells").width());
            var targetElement = $(this.element.find(".e-workcellstab tr")[row]).find("td")[column];
            $(targetElement).addClass(".e-selectedCell").trigger($.Event('tap'));
            this._appointmentWindow({ target: targetElement });
        }
    },


    /**
    * Section For render the appointment window of the schedule.
    * @private
    */
    _renderAppointmentWindow: function () {
        if (this._mediaQuery) {
            this._appointmentAddWindow = ej.buildTag('div.e-scheduledialog#' + this._id + "AppointmentAddEditWindow");
            var $appWindow = "<div class='e-appwindow e-windowmargin'>" +
                                "<form id='" + this._id + "_AddEditForm'><table class='e-table' width='100%' cellpadding='7'><tbody>";
            $appWindow += "<tr><td colspan='3' class='e-leftfields e-textlabel'>" + this._getLocalizedLabels("AppointmentSubject") + ":</td></tr><tr><td colspan='3' class='e-rightfields'>" +
                              "<input id='" + this._id + "subject' tabIndex='0' class='subject e-inputtext' name='" + this.model.appointmentSettings["subject"] + "' type='text' /><input id='id' class='id' type='text' name='" + this.model.appointmentSettings["id"] + "' value='' style='display: none'/></td></tr>";
            $appWindow += "<tr><td class='e-textlabel' colspan='3'>" + this._getLocalizedLabels("StartTime") + ":</td></tr><tr><td width='37%'><input id='" + this._id + "startdate' class='startenddate' type='text' name='StartDate' value='' /></td><td width=31%'><input type='text' id='" + this._id + "starttime' class='startendtime' name='StartTime'/></td>" +
                              "<td width='31%'><input id='startutc' class='startutc' type='text' value=''/><div id='Timezoneliststr'></div></td></tr>";
            $appWindow += "<tr><td class='e-textlabel' colspan='3'>" + this._getLocalizedLabels("EndTime") + ":</td></tr><tr><td><input id='" + this._id + "enddate' class='startenddate' type='text' name='EndDate' value='' /></td><td><input type=''text' id='" + this._id + "endtime' class='startendtime' name='EndTime'/></td>" +
                              "<td><input id='endutc' class='endutc' type='text' value=''/><div id='Timezonelistend'></div></td></tr>";
            $appWindow += "<tr><td colspan='3'><table class='e-table' cellpadding='3'><tr><td><div class='e-allday e-checkboxmargin'><input id='" + this._id + "allday' tabIndex='0' class='allday' type='checkbox' name='" + this.model.appointmentSettings["allDay"] + "'/></div></td><td><div class='e-alldaytext'>" +
                              "<label for='" + this._id + "allday'>" + this._getLocalizedLabels("AllDay") + "</label></div></td><td><div class='e-checkboxmargin e-recurrence'>" +
                              "<input id='" + this._id + "recurrence' tabIndex='0' class='recurrence' type='checkbox' name='" + this.model.appointmentSettings["recurrence"] + "' value='recurrence'/></div></td><td><label class='e-repeatlbl' for='" + this._id + "recurrence'>" +
                              this._getLocalizedLabels("Recurrence") + "</label></td></tr></table></td></tr>";
            $appWindow += "<tr id='" + this._id + "summary' class='" + this._id + "summary' style='display:none'><td class='e-textlabel'><label>" + this._getLocalizedLabels("Summary") + ":</label></td></tr><tr class='" + this._id + "summary' style='display:none'><td colspan='4'><table><tr><td><label class='e-recurFinalRule'></label></td><td><div class='e-recuredit'><a class='e-recuredit' href='#'>" + this._getLocalizedLabels("Edit") + "</a><span class='e-icon e-scheduleedit'></span></div></td></tr></table></td></tr>";
            if (this.model.categorizeSettings.enable) {
                $appWindow += "<tr><td class='e-leftfields e-textlabel' colspan='3'>" + this._getLocalizedLabels("Categorize") + ":</td></tr><tr><td colspan='3' class='e-rightfields'>" + "<input id= '" + this._id + "_categorize' class='e-categorizevalue' type='text' value=''/><div id='ownerlist'></div></td></tr>";
            }
            if (!ej.isNullOrUndefined(this.model.resources) && this.model.resources.length > 0 && ej.scheduleFeatures.resources)
                $appWindow = this._renderResourceElements($appWindow);
            $appWindow += "<tr><td colspan='3'><b>Description:</b></td></tr><tr><td colspan='3'><textarea class='e-description e-inputtext' id='description' name='" + this.model.appointmentSettings["description"] + "'></textarea></td></tr>";
            $appWindow += "</tbody></table></form>";
            $appWindow += "<div class='e-floatright'><table class='e-table' cellpadding='5'><tr><td><div class='e-btnmargin e-floatleft'><button id='mDelete' class='e-btndelete e-appdelete'>Delete</button></div></td><td><div class='e-btnmargin e-floatleft'><button id='done' class='e-btndone e-appsave'>" + this._getLocalizedLabels("Done") + "</button></div></td>" +
                          "<td><div class='e-btnmargin e-floatleft'><button id='cancel' class='e-appointcancel cancel'>" + this._getLocalizedLabels("Cancel") + "</button></div></td></tr></table></div></div>";
            this._appointmentAddWindow.append($appWindow).append(this._recurrenceWindow());

        }
        else {
            this._appointmentAddWindow = ej.buildTag('div.e-scheduledialog#' + this._id + "AppointmentAddEditWindow");
            var $appWindow = "<div class='e-appwindow e-windowmargin'>" +
                                "<form id='" + this._id + "_AddEditForm'><table class='e-table' width='100%' cellpadding='7'><tbody>";
            $appWindow += "<tr><td class='e-leftfields e-textlabel'>" + this._getLocalizedLabels("AppointmentSubject") + ":</td><td colspan='3' class='e-rightfields'>" +
                              "<input id='" + this._id + "subject' tabIndex='0' class='subject e-inputtext' name='" + this.model.appointmentSettings["subject"] + "' type='text' /><input id='id' class='id' type='text' name='" + this.model.appointmentSettings["id"] + "' value='' style='display: none'/></td></tr>";
            $appWindow += "<tr><td class='e-textlabel'>" + this._getLocalizedLabels("StartTime") + ":</td><td width='25%'><input id='" + this._id + "startdate' class='startenddate' type='text' name='StartDate' value='' /></td><td width=22%'><input type='text' id='" + this._id + "starttime' class='startendtime' name='StartTime'/></td>" +
                              "<td width='28%'><input id='startutc' class='startutc' type='text' value=''/><div id='Timezoneliststr'></div></td></tr>";
            $appWindow += "<tr><td class='e-textlabel'>" + this._getLocalizedLabels("EndTime") + ":</td><td><input id='" + this._id + "enddate' class='startenddate' type='text' name='EndDate' value='' /></td><td><input type=''text' id='" + this._id + "endtime' class='startendtime' name='EndTime'/></td>" +
                              "<td><input id='endutc' class='endutc' type='text' value=''/><div id='Timezonelistend'></div></td></tr>";
            $appWindow += "<tr><td colspan='4'><table class='e-table' cellpadding='3'><tr><td><div class='e-allday e-checkboxmargin'><input id='" + this._id + "allday' tabIndex='0' class='allday' type='checkbox' name='" + this.model.appointmentSettings["allDay"] + "'/></div></td><td><div class='e-alldaytext'>" +
                              "<label for='" + this._id + "allday'>" + this._getLocalizedLabels("AllDay") + "</label></div></td><td><div class='e-checkboxmargin e-recurrence'>" +
                              "<input id='" + this._id + "recurrence' tabIndex='0' class='recurrence' type='checkbox' name='" + this.model.appointmentSettings["recurrence"] + "' value='recurrence'/></div></td><td><label class='e-repeatlbl' for='" + this._id + "recurrence'>" +
                              this._getLocalizedLabels("Recurrence") + "</label></td></tr></table></td></tr>";
            $appWindow += "<tr id='" + this._id + "summary' class='" + this._id + "summary' style='display:none'><td class='e-textlabel'><label>" + this._getLocalizedLabels("Summary") + ":</label></td><td colspan='3'><table><tr><td><label class='e-recurFinalRule'></label></td><td><div class='e-recuredit'><a class='e-recuredit' href='#'>" + this._getLocalizedLabels("Edit") + "</a><span class='e-icon e-scheduleedit'></span></div></td></tr></table></td></tr>";
            if (this.model.categorizeSettings.enable) {
                $appWindow += "<tr><td class='e-leftfields e-textlabel'>" + this._getLocalizedLabels("Categorize") + ":</td><td colspan='3' class='e-rightfields'>" + "<input id= '" + this._id + "_categorize' class='e-categorizevalue' type='text' value=''/><div id='ownerlist'></div></td></tr>";
            }

            if (!ej.isNullOrUndefined(this.model.resources) && this.model.resources.length > 0 && ej.scheduleFeatures.resources)
                $appWindow = this._renderResourceElements($appWindow);
            $appWindow += "<tr><td colspan='4'><textarea class='e-description e-inputtext' id='description' name='" + this.model.appointmentSettings["description"] + "'></textarea></td></tr>";
            $appWindow += "</tbody></table></form>";
            $appWindow += "<div class='e-floatright'><table class='e-table' cellpadding='5'><tr><td><div class='e-btnmargin e-floatleft'><button id='done' class='e-btndone e-appsave'>" + this._getLocalizedLabels("Done") + "</button></div></td>" +
                          "<td><div class='e-btnmargin e-floatleft'><button id='cancel' class='e-appointcancel cancel'>" + this._getLocalizedLabels("Cancel") + "</button></div></td></tr></table></div></div>";
            this._appointmentAddWindow.append($appWindow).append(this._recurrenceWindow());
        }
        this.element.append(this._appointmentAddWindow);
        this._renderControls();
        this._appointmentAddWindow.ejDialog({
            width: (this._mediaQuery) ? "100%" : 600,
            cssClass: this.model.cssClass,
            showOnInit: false,
            enableRTL: this.model.enableRTL, enableModal: true,
            title: this._getLocalizedLabels("CreateAppointmentTitle"),
            content: "#" + this._id,
            enableResize: false,
            allowKeyboardNavigation: false,
            close: $.proxy(this._onclose, this)
        });
        $("#" + this._id + "AppointmentAddEditWindow_wrapper").appendTo("body").addClass("e-scheduledialog").find(".e-titlebar").addClass("e-dialogheader");
        this._on(this._appointmentAddWindow, "click", "a.e-recuredit", $.proxy(this._editRecurrence, this));
    },
    /**
    * Section For render the quick window.
    * @private
    */
    _renderQuickAppWindow: function () {
        this._quickAppointWindow = ej.buildTag('div.e-scheduledialog#' + this._id + "AppointmentQuickWindow");
        var $quickWin = "<div id='" + this._id + "_quickAppwindow' class='e-tableAppoint'>" +
                    "<table cellpadding='7' class='e-qappwindow'><tbody>";
        $quickWin += "<tr><td colspan='2'><div class='e-quickstartend'></div> <div title='" + this._getLocalizedLabels("Close") + "'class='e-icon e-scheduleclose e-schedclosemargin e-pointercursor'></div></td></tr><tr><td class='e-subjectlabel'>" + this._getLocalizedLabels("Event") + ":</td><td colspan='2' class='e-rightfields'>" +
                          "<input id='" + this._id + "subject' class='subject e-inputtext' style='height:22px;' type='text' /></td></tr></tbody></table>";
        $quickWin += "<div style='margin-top:5px; padding-bottom: 30px;'><div tabIndex='0' class='e-detailedapp e-detailedwindow'> " + this._getLocalizedLabels("Detailed") + " >></div><div style='margin-right:-3px;' class='e-floatright'><div class='e-quickAppDone'><button id='done' class='e-btndone qAppDone' style='font-size:12px !important;'>" + this._getLocalizedLabels("CreateAppointmentTitle") + "</button></div>" +
                          "</div></div></div>";
        this._quickAppointWindow.append($quickWin);
        this.element.append(this._quickAppointWindow);
        this._quickAppointWindow.append(ej.buildTag("div.e-quickarrow").append("<div class='e-outerarrowline'></div>").append("<div class='e-innerarrow'></div>"));
        var control = this._quickAppointWindow;
        //control.find('.subject').ejMaskEdit({ name: "Subject", inputMode: ej.inputMode.Text, width: "100%", height: "25px", cssClass: this.model.cssClass });
        control.find('.e-btndone').ejButton({ showRoundedCorner: true, width: "130px", click: $.proxy(this._saveAppointment, this), cssClass: this.model.cssClass, enableRTL: this.model.enableRTL });
        this._on(control.find('.e-scheduleclose'), "click", $.proxy(this._quickWindowClose, this));
        this._on(control.find('.e-detailedapp'), "click", $.proxy(this._appointmentWindow, this));
        this._quickAppointWindow.ejDialog({
            width: 330,
            cssClass: this.model.cssClass,
            enableRTL: this.model.enableRTL,
            showOnInit: false,
            enableResize: false,
            allowDraggable: false, showHeader: false,
            allowKeyboardNavigation: false
        });
        $("#" + this._id + "AppointmentQuickWindow_wrapper").addClass("e-scheduledialog").find("#" + this._id + "AppointmentQuickWindow").addClass("e-dialogouter");
    },
    /**
    * Section For handle the details of quick app window.
    * @private
    */
    _renderQuickAppDetailsView: function () {
        this._quickAppDetailsWindow = ej.buildTag('div.e-scheduledialog#' + this._id + "AppDetailsWindow");
        var $quickAppWin = "<div id='" + this._id + "_quickAppDetailswindow' class='e-tableAppoint e-appdetails'>" +
                          "<table cellpadding='1' class='e-qappwindow'><tbody>";
        $quickAppWin += "<tr><td colspan='2'><div class='e-quicksubject'></div> <div title='" + this._getLocalizedLabels("Close") + "' class='e-icon e-scheduleclose e-schedclosemargin e-pointercursor'></div></td></tr><tr><td colspan='2' class='e-rightfields'>" +
                          "</td></tr><tr><td colspan='2'><div class='e-quickstartendtime'></div></td></tr></tbody></table>";
        $quickAppWin += "<div style='margin-top:5px;'><div title='" + this._getLocalizedLabels("Delete") + "' class='e-icon e-scheduledelete e-pointercursor' tabIndex='0'></div><div class='e-floatright'><div class='e-editevents'><div class='e-editevent e-textellipsis' tabIndex='0'>" + this._getLocalizedLabels("Editevent") + " | " + "</div><div class='e-editseries e-textellipsis' tabIndex='0'>" + this._getLocalizedLabels("Editseries") + " >></div> </div>" +
                          "</div></div></div>";
        this._quickAppDetailsWindow.append($quickAppWin);
        this.element.append(this._quickAppDetailsWindow);
        this._quickAppDetailsWindow.append(ej.buildTag("div.e-quickarrow").append("<div class='e-outerarrowline'></div>").append("<div class='e-innerarrow'></div>"));
        this._on(this._quickAppDetailsWindow.find('.e-scheduleclose'), "click", $.proxy(this._quickAppDetailWindowClose, this));
        this._on(this._quickAppDetailsWindow.find('.e-scheduledelete'), "click", $.proxy(this._deleteAppoint, this));
        this._on(this._quickAppDetailsWindow.find('.e-editevent,.e-editseries'), "click", $.proxy(this._editClick, this));
        this._quickAppDetailsWindow.ejDialog({
            width: 270,
            cssClass: this.model.cssClass,
            enableRTL: this.model.enableRTL,
            showOnInit: false,
            enableResize: false,
            allowDraggable: false, showHeader: false,
            allowKeyboardNavigation: false
        });
        $("#" + this._id + "AppDetailsWindow_wrapper").addClass("e-scheduledialog").find("#" + this._id + "AppDetailsWindow").addClass("e-dialogouter");
    },
    /**
    * Section For edit click in quick window of the schedule.
    * @private
    */
    _editClick: function (e) {
        var query = new ej.Query().where(this.model.appointmentSettings["id"], ej.FilterOperators.equal, this._appId);
        var templist = new ej.DataManager(this._processed).executeLocal(query);
        if ($(e.target).hasClass("e-editevent")) {
            if (templist[0][this.model.appointmentSettings["recurrence"]] == 1) {
                this._parentId = templist[0]["ParentId"];
                this._currentAction = ej.Schedule.Actions.EditOcurrence;
                this._showAppointmentDetails(this._appId, true);
            }
            else if (ej.isNullOrUndefined(templist[0][this.model.appointmentSettings["recurrence"]])) {
                this._currentAction = ej.Schedule.Actions.Save;
                this._showAppointmentDetails(this._appId, false);
            }
            else {
                this._currentAction = ej.Schedule.Actions.Save;
                this._showAppointmentDetails(templist[0]["ParentId"]);
            }
        }
        else if ($(e.target).hasClass("e-editseries")) {
            if (templist[0][this.model.appointmentSettings["recurrence"]] == 1) {
                this._parentId = templist[0]["ParentId"];
                this._currentAction = ej.Schedule.Actions.EditSeries;
                this._showAppointmentDetails(this._parentId);
            }

        }
        this.model.showQuickWindow && this._quickAppDetailsWindow.ejDialog("close");
    },
    /**
    * Section For handle the delete appointments of the schedule.
    * @private
    */
    _deleteAppoint: function () {
	    if (!this.model.readOnly) {
            if (this._appId) {
                this._currentAction = ej.Schedule.Actions.Delete;
                var parentData = this._getAppointmentByParentId(this._appId);
                if (ej.isNullOrUndefined(parentData[this.model.appointmentSettings["recurrenceRule"]]))
                    this._deleteApp(parseInt(this._appId));
                else {
                    this._parentId = parseInt(parentData[this.model.appointmentSettings["id"]]);
                    this._recurEditWindow.find(".e-editonly").ejRadioButton({ checked: true });
                    this._recurEditWindow.ejDialog("open");
                    this._recurEditWindow.focus();
                }
            }
            this.model.showQuickWindow && this._quickAppDetailsWindow.ejDialog("close");
	    }
    },
    /**
    * Section For handle the quick window close of the schedule.
    * @private
    */
    _quickAppDetailWindowClose: function () {
        this._quickAppDetailsWindow.ejDialog("close");
        this._processFocus();
    },
    /**
    * Section For handle the all day option check in the appoinment window.
    * @private
    */
    _alldayCheck: function () {
        if (this._appointmentAddWindow.find(".allday").ejCheckBox("option", "checked")) {
           this._appointmentAddWindow.find("#" + this._id + "starttime").ejTimePicker({value:(this._timeMode=="12")?"12:00 AM":"00:00", enabled: false });
           this._appointmentAddWindow.find("#" + this._id + "endtime").ejTimePicker({value:(this._timeMode=="12")?"11:59 PM":"23:30", enabled: false });
           this._appointmentAddWindow.find(".startutc,.endutc").ejDropDownList({ enabled: false });
        }
        else {
            this._appointmentAddWindow.find(".startendtime").ejTimePicker({ enabled: true });
            this._appointmentAddWindow.find(".startutc,.endutc").ejDropDownList({ enabled: true });
        }
    },
    /**
    * Section For render the recurrence edit window of the schedule .
    * @private
    */
    //Render Recurrence window 
    _renderRecurEditWindow: function () {
        this._recurEditWindow = ej.buildTag('div.e-scheduledialog#' + this._id + "RecurrenceEdit")
        var title = ej.buildTag('div.e-recurtitle', this._getLocalizedLabels("RecurrenceEditTitle"));
        title.append(ej.buildTag('div.e-icon e-scheduleclose e-schedclosemargin e-pointercursor', "", {}, { title: this._getLocalizedLabels("Close") }));
        this._recurEditWindow.append(title);
        var msgDiv = ej.buildTag('div.e-recureditmsg', this._getLocalizedLabels("RecurrenceEditMessage"));
        //<input type="radio" value="Never" name="repeatend" class="recurends e-radiobtn e-js e-input" id="repeatendnever" tabindex="">
        var editOnly = ej.buildTag('div.e-recureditopt').append(ej.buildTag('input.e-editonly', "", {}, { type: "radio", name: "recurEdit", id: this._id + "_editOnly" })).append(ej.buildTag('label.e-recureditlbl', this._getLocalizedLabels("RecurrenceEditOnly"), {}, { "for": this._id + "_editOnly" }));
        var editSer = ej.buildTag('div.e-recureditopt').append(ej.buildTag('input.e-editseries', "", {}, { type: "radio", name: "recurEdit", id: this._id + "_editSeries" })).append(ej.buildTag('label.e-recureditlbl', this._getLocalizedLabels("RecurrenceEditSeries"), {}, { "for": this._id + "_editSeries" }));
        var btns = ej.buildTag('div.e-recureditbtns').append(ej.buildTag('button.e-recurdone', this._getLocalizedLabels("Done"), {}, { name: "done", value: this._getLocalizedLabels("Done") })).append(ej.buildTag('button.e-recurcancel', this._getLocalizedLabels("Cancel"), {}, { name: "cancel", value: this._getLocalizedLabels("Cancel") }));
        this._recurEditWindow.append(msgDiv).append(editOnly).append(editSer).append(btns);
        this._recurEditWindow.find('.e-editonly,.e-editseries').ejRadioButton({ cssClass: this.model.cssClass });
        btns.find('.e-recurdone,.e-recurcancel').ejButton({ cssClass: this.model.cssClass, enableRTL: this.model.enableRTL });
        this._on(this._recurEditWindow, "click", ".e-recurdone,.e-recurcancel", $.proxy(this._recurBtnClick, this));
        this._on(this._recurEditWindow, "click", "div.e-scheduleclose", $.proxy(this._recrConformClose, this));
        this._recurEditWindow.appendTo(this.element);
        this._recurEditWindow.ejDialog({
            width: (this._mediaQuery) ? "90%" : 360,
            cssClass: this.model.cssClass,
            enableRTL: this.model.enableRTL,
            showOnInit: false,
            enableModal: true,
            enableResize: false,
            showHeader: false,
            content: "#" + this._id,
            allowKeyboardNavigation: false,
            close: $.proxy(this._processFocus, this)
        });
        $("#" + this._id + "RecurrenceEdit_wrapper").appendTo("body");
    },
    /**
    * Section For handle the recurrence window close.
    * @private
    */
    // Recurrence Conform window close
    _recrConformClose: function () {
        this._recurEditWindow.ejDialog("close");
        this._processFocus();
    },
    /**
    * Section For handle the recurrence edit click in the appointment window.
    * @private
    */
    //Recurrence edit button click events
    _recurBtnClick: function (args) {
        if ($(args.target).hasClass("e-recurdone")) {
            if (this._recurEditWindow.find(".e-editonly").ejRadioButton("option", "checked")) {
                if (this._currentAction == ej.Schedule.Actions.Delete) {
                    var _newAddList = new ej.DataManager(this._processed).executeLocal(new ej.Query().where(this.model.appointmentSettings["id"], ej.FilterOperators.equal, parseInt(this._appId)))[0];
                    if (_newAddList[this.model.appointmentSettings["recurrenceRule"]].toString().indexOf("RECUREDITID") != -1)
                        this._deleteApp(parseInt(this._appId));
                    else {
                        var deleApp = this._deleteOcurrence(this._parentId, _newAddList[this.model.appointmentSettings["startTime"]]);
                        var temp = this._timeZoneConversion(deleApp[0]);
                        var promise = this._dataManager.update(this.model.appointmentSettings["id"], temp);
                        var updateTemp = (this._reverseTimeZoneConversion(temp));
                        new ej.DataManager(this._currentAppointmentData).update(this.model.appointmentSettings["id"], updateTemp);
                        var proxy = this;
                        if (promise && $.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                            promise.done(function (e) {
                                if (proxy._trigger("actionBegin", { id: proxy._appId, requestType: "appointmentDelete" }))
                                    return false;
                                new ej.DataManager(proxy._processed).remove(proxy.model.appointmentSettings["id"], parseInt(proxy._appId));
                                proxy.element.find("#Appointment_" + proxy._appId).remove();
                                proxy.element.find("#categorybar_" + proxy._appId).remove();
                                proxy._trigger("appointmentDeleted", { appointment: _newAddList });
                                proxy._trigger("actionComplete", { appointment: _newAddList, requestType: "appointmentDelete" });
                            });
                            promise.fail(function (e) {
                            });
                        }
                        else {
                            if (this._trigger("actionBegin", { id: this._appId, requestType: "appointmentDelete" }))
                                return false;
                            var dele = new ej.DataManager(this._processed).remove(this.model.appointmentSettings["id"], parseInt(this._appId));
                            this.element.find("#Appointment_" + this._appId).remove();
                            this.element.find("#categorybar_" + this._appId).remove();
                            this._trigger("appointmentDeleted", { appointment: _newAddList });
                            this._trigger("actionComplete", { appointment: _newAddList, requestType: "appointmentDelete" });
                        }
						this._getApps();
                        if (this._app.length < 1) {
                             if (this.model.enableAppointmentNavigation)
                                 this._nextPrevButton(this._app);
                            }
                    }
                }
                else {
                    this._currentAction = ej.Schedule.Actions.EditOcurrence;
                    this._showAppointmentDetails(this._appId, true);
                }
            }
            else {
                if (this._currentAction == ej.Schedule.Actions.Delete)
                    this._deleteApp(parseInt(this._parentId));
                else {
                    this._currentAction = ej.Schedule.Actions.EditSeries;
                    this._showAppointmentDetails(this._parentId);
                }
            }
        }
        this._recurEditWindow.ejDialog("close");
    },
    /**
    * Section For handle the recurrence select in the appointment window.
    * @private
    */
    _repeat: function (e) {
        if (e.isChecked || this._recurChecked) {
            if (this._currentAction == ej.Schedule.Actions.EditSeries || this._appointmentAddWindow.find(".e-recurFinalRule").html() != "") {
                this._appointmentAddWindow.find("." + this._id + "summary").css("display", "table-row");
            }
            else {
                (this._mediaQuery) && this._appointmentAddWindow.parent().parent().find(".e-dialog-icon").css("display", "none");
                this._appointmentAddWindow.find(".e-appwindow").toggle();
                this._appointmentAddWindow.find(".e-recurwindow").css("margin-left", 700).toggle().animate({ "margin-left": 10 }, 400);
                this._recurClearFields();
                var strDate = new Date(this._appointmentAddWindow.find('.startenddate').ejDatePicker("option", "value"));
                this._appointmentAddWindow.find('.recurtype').ejDropDownList({ selectedItemIndex: 0 });
                this._appointmentAddWindow.find('.recurtype').ejDropDownList({ selectedItemIndex: 1 });
                this._appointmentAddWindow.find(".recurstartdate").ejDatePicker({ value: strDate });
                this._appointmentAddWindow.find('.e-until').ejDatePicker({ value: new Date(strDate.setDate(strDate.getDate() + 7 * 10)) });
                    this._appointmentAddWindow.find(".e-recurnoend").ejRadioButton({ checked: true });
                }
            }
            else
                (this._currentAction == ej.Schedule.Actions.EditSeries || this._appointmentAddWindow.find(".e-recurFinalRule").html() != "") && this._appointmentAddWindow.find("." + this._id + "summary").css("display", "none");
            this._recurChecked = false;
        },
    /**
    * Section For handle the recurrence type change in the recurrence window.
    * @private
    */
    _recurtype: function (e) {
        this._rRuleFreq = "";
        var _rule = "";
        var strDate = new Date(this._appointmentAddWindow.find("#" + this._id + "startdate").ejDatePicker("option", "value"));
        if (e.itemId != null) {
            this._appointmentAddWindow.find("#" + this._id + "repeatEvery").css("display", "table-row");
            if (e.itemId == 0) {
                this._appointmentAddWindow.find("#" + this._id + "recurtypes").get(0).innerHTML = this._getLocalizedLabels("RecurrenceDay");
                this._appointmentAddWindow.find("." + this._id + "weeklyrecur,." + this._id + "monthlyrecur,." + this._id + "yearlyrecur").css("display", "none");
                this._appointmentAddWindow.find("#" + this._id + "dailyrecur").css("display", "table-row");
                this._rRuleFreq = "DAILY";
                _rule = this._getLocalizedLabels("RecurrenceDay").toLowerCase();
            }
            else if (e.itemId == 1) {
                //_rule = this._weeklyRecurrnce();
                this._appointmentAddWindow.find("#" + this._id + "recurtypes").get(0).innerHTML = this._getLocalizedLabels("RecurrenceWeek");
                var curDay = this._dayNames[strDate.getDay()];
                this._appointmentAddWindow.find(".e-weekly" + curDay).ejCheckBox({ checked: true });
                _rule = this._getLocalizedLabels("RecurrenceWeek").toLowerCase() + " " + this._getLocalizedLabels("On").toLowerCase() + " " + this._dayFullNames[strDate.getDay()];
                this._rRuleFreq = "WEEKLY";
                this._appointmentAddWindow.find("." + this._id + "monthlyrecur,." + this._id + "yearlyrecur,#" + this._id + "dailyrecur").css("display", "none");
                this._appointmentAddWindow.find("." + this._id + "weeklyrecur").css("display", "table-row");
            }
            else if (e.itemId == 2) {
                this._appointmentAddWindow.find("#" + this._id + "recurtypes").get(0).innerHTML = this._getLocalizedLabels("RecurrenceMonth");
                this._appointmentAddWindow.find("." + this._id + "weeklyrecur,." + this._id + "yearlyrecur,#" + this._id + "dailyrecur").css("display", "none");
                this._appointmentAddWindow.find("." + this._id + "monthlyrecur").css("display", "table-row");
                this._appointmentAddWindow.find('.e-monthdate').ejNumericTextbox({ value: strDate.getDate() });
                this._appointmentAddWindow.find('.e-monthsrtday').ejDropDownList({ selectedItemIndex: strDate.getDay() });
                this._appointmentAddWindow.find('.monthsrt').ejDropDownList({ selectedItemIndex: this._getWeekIndex(strDate) });
                this._appointmentAddWindow.find('.e-monthdaytype').ejRadioButton({ checked: true });
                //var index = this._getWeekIndex(strDate); 
                this._rRuleFreq = "MONTHLY";
                _rule = this._getLocalizedLabels("RecurrenceMonth").toLowerCase();
            }
            else if (e.itemId == 3) {
                this._appointmentAddWindow.find("#" + this._id + "recurtypes").get(0).innerHTML = this._getLocalizedLabels("RecurrenceYear");
                this._appointmentAddWindow.find("." + this._id + "weeklyrecur,." + this._id + "monthlyrecur,#" + this._id + "dailyrecur").css("display", "none");
                this._appointmentAddWindow.find("." + this._id + "yearlyrecur").css("display", "table-row");
                this._appointmentAddWindow.find('.yearmonth').ejDropDownList({ selectedItemIndex: strDate.getMonth() });
                this._appointmentAddWindow.find('.yeardate').ejNumericTextbox({ value: strDate.getDate() });
                this._appointmentAddWindow.find('.yearsrtday').ejDropDownList({ selectedItemIndex: strDate.getDay() });
                this._appointmentAddWindow.find('.yearsrtmonth').ejDropDownList({ selectedItemIndex: strDate.getMonth() });
                this._appointmentAddWindow.find('.yearsrt').ejDropDownList({ selectedItemIndex: this._getWeekIndex(strDate) });
                this._appointmentAddWindow.find('.e-yearrecurday').ejRadioButton({ checked: true });
                this._rRuleFreq = "YEARLY";
                _rule = this._getLocalizedLabels("RecurrenceYear").toLowerCase();
            }
            else if (e.itemId == 4) {
                this._rRuleFreq = "WEEKDAYS";
                this._appointmentAddWindow.find("." + this._id + "weeklyrecur,." + this._id + "yearlyrecur,#" + this._id + "dailyrecur,#" + this._id + "repeatEvery,." + this._id + "monthlyrecur").css("display", "none");
                _rule = e.text;
            }
            this._appointmentAddWindow.find(".e-recurRule").html(_rule);
        }
    },
    /**
    * Section For generate the dates for all the view of the schedule.
    * @private
    */
    _getRenderDates: function () {
        this._dateRender = []; var firstDay, endDay, newDate;
        if (this.currentView() === "week" || this.currentView() === "workweek") {
            firstDay = this._firstweekdate(this.currentDate());
            for (var i = 0; i < 7; i++) {
                newDate = new Date(firstDay);
                newDate.setDate(firstDay.getDate() + i);
                this._dateRender.push(new Date(newDate.getFullYear(), newDate.getMonth(), newDate.getDate()).getTime());
            }
            if (this.currentView() === "workweek")
                this._dateRender = this._dateRender.slice(1, 6);
        }
        else if (this.currentView() === "month") {
            this._dateRender = this._monthdates();
        }
        else if (this.currentView() === "customview") {
            var newDate, daysRender = this._renderDays <= 7 ? this._renderDays : this._numDays;
            var firstDay = this._renderDays <= 7 ? new Date(this.currentDate()) : this.model.orientation == "vertical" ? this._firstweekdate(this.currentDate()) : new Date(this.currentDate());
            for (var i = 0; i < daysRender; i++) {
                newDate = new Date(this.currentDate());
                newDate.setDate(firstDay.getDate() + i);
                this._dateRender.push(new Date(newDate.getFullYear(), newDate.getMonth(), newDate.getDate()).getTime());
            }
        }
        else {
            this._dateRender.push(this.currentDate());
        }
        return this._dateRender;
    },
    /**
    * Section For render the current date/date period in the header bar.
    * @private
    */
    _getCurrentDateHeaderValue: function () {
        var localizedDay = Globalize.culture(this.model.locale);
        var dateValue, value = this._dateRender;
        if (this.currentView() === "day")
            dateValue = localizedDay.calendar.days.names[new Date(value[0]).getDay()].slice(0, 3) + " " + new Date(value[0]).getDate() + " " + Globalize.format(new Date(value[0]), "MMM") + " " + new Date(value[0]).getFullYear(); //  Globalize.format(new Date(value[0]), "MMMM dd yyyy");
        else if (this.currentView() === "week" || this.currentView() === "workweek") {
            if (new Date(value[0]).getYear() === new Date(value[value.length - 1]).getYear()) {
                if (new Date(value[0]).getMonth() === new Date(value[value.length - 1]).getMonth()) {
                    dateValue = Globalize.format(new Date(value[0]), "dd") + " - " + Globalize.format(new Date(value[value.length - 1]), "dd MMM yyyy");
                }
                else if (new Date(value[0]).getMonth() !== new Date(value[value.length - 1]).getMonth()) {
                    dateValue = this.model.enableRTL ? Globalize.format(new Date(value[value.length - 1]), "MMM dd") + " - " + Globalize.format(new Date(value[0]), "dd MMM yyyy") :
                           Globalize.format(new Date(value[0]), "dd MMM") + " - " + Globalize.format(new Date(value[value.length - 1]), "dd MMM yyyy");
                }
            }
            else {
                dateValue = Globalize.format(new Date(value[0]), "MMM dd yyyy") + " - " + Globalize.format(new Date(value[value.length - 1]), "MMM dd yyyy");
            }
            //  dateValue = new Date(value[0]).getDate() + " " + Globalize.format(new Date(value[0]), "MMM") + (new Date(value[0]).getFullYear) + "/" + " - " + localizedDay.calendar.days.names[new Date(value[value.length - 1]).getDay()].slice(0, 3) + " " + (new Date(value[value.length - 1]).getMonth() + 1) + "/" + new Date(value[value.length - 1]).getDate();
        }
        else if (this.currentView() === "customview") {
            if(value.length == 1)
                dateValue = localizedDay.calendar.days.names[new Date(value[0]).getDay()].slice(0, 3) + " " + new Date(value[0]).getDate() + " " + Globalize.format(new Date(value[0]), "MMM") + " " + new Date(value[0]).getFullYear(); //  Globalize.format(new Date(value[0]), "MMMM dd yyyy");
            else if (value.length > 1 && value.length <= 7) {
                if (new Date(value[0]).getYear() === new Date(value[value.length - 1]).getYear()) {
                    if (new Date(value[0]).getMonth() === new Date(value[value.length - 1]).getMonth()) {
                        dateValue = Globalize.format(new Date(value[0]), "dd") + " - " + Globalize.format(new Date(value[value.length - 1]), "dd MMM yyyy");
                    }
                    else if (new Date(value[0]).getMonth() !== new Date(value[value.length - 1]).getMonth()) {
                        dateValue = this.model.enableRTL ? Globalize.format(new Date(value[value.length - 1]), "MMM dd") + " - " + Globalize.format(new Date(value[0]), "dd MMM yyyy") :
                               Globalize.format(new Date(value[0]), "dd MMM") + " - " + Globalize.format(new Date(value[value.length - 1]), "dd MMM yyyy");
                    }
                }
                else {
                    dateValue = Globalize.format(new Date(value[0]), "MMM dd yyyy") + " - " + Globalize.format(new Date(value[value.length - 1]), "MMM dd yyyy");
                }
            }
            else {
                if (new Date(value[0]).getFullYear() == new Date(value[value.length - 1]).getFullYear()) {
                    if (new Date(value[0]).getMonth() == new Date(value[value.length - 1]).getMonth())
                        dateValue = Globalize.format(new Date(this.currentDate()), "MMM yyyy");
                    else
                        dateValue = Globalize.format(new Date(value[0]), "MMM") + " - " + Globalize.format(new Date(value[value.length - 1]), "MMM yyyy");
                }
                else {
                    dateValue = Globalize.format(new Date(value[0]), "MMM yyyy") + " - " + Globalize.format(new Date(value[value.length - 1]), "MMM yyyy");
                }
            }
        }
        else {
            dateValue = Globalize.format(new Date(this.currentDate()), "MMM yyyy");
        }
        return dateValue;
    },

    /**
    * Section For find the first day of the week.
    * @private
    */
    _firstweekdate: function (currentDate) {
        var firstdayofweek = new Date(currentDate);
        var day = firstdayofweek.getDay();
        if (day != 0) {
            firstdayofweek.setDate(firstdayofweek.getDate() - day);
        }
        return firstdayofweek;
    },
    /**
    * Section For generate the allday cell counts of the schedule.
    * @private
        */
    _getHeaderAllDayCellsCount: function () {
            var weekcols = Globalize.culture(this.model.locale);
            var temp, count, cols, resCount = 1, curday; this.dateRender = [];
            cols = [];
            if (this.model.orientation == "vertical") {
                count = this._getColumnCount().length; // this.model.currentView === "month" ? dateRender.length / 5 : dateRender.length;
                if (!ej.isNullOrUndefined(this.model.resources) && !ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources) {
                    var getCount = this.__getMultipleResourceCellsCount(count);
                    resCount = getCount.resCount; count = getCount.count;
                }
                for (var i = 0; i < resCount; i++) {
                    for (var j = 0; j < this._dateRender.length; j++)
                        this.dateRender.push(this._dateRender[j]);
                }
                for (var i = 0; i < count; i++) {
                    curday = (this.currentView() === "month" || this.currentView() === "day" || (this._isCustomView())) ? (ej.isNullOrUndefined(this.model.resources) && ej.isNullOrUndefined(this.model.group)) ? weekcols.calendar.days.names[new Date(this.dateRender[i]).getDay()] : weekcols.calendar.days.names[new Date(this.dateRender[i]).getDay()].slice(0, 3) : weekcols.calendar.days.names[new Date(this.dateRender[i]).getDay()].slice(0, 3);
                    var headerCellClass = (Globalize.format(new Date(this.dateRender[i]), this._pattern.d) === Globalize.format(new Date(), this._pattern.d)) ? "e-headerToday" : "";
                    temp = (this.currentView() === "month" || (this._isCustomView())) ? { currentDay: curday, currentDateClass: "", cellToday: headerCellClass } : this.currentView() === "day" ? (ej.isNullOrUndefined(this.model.resources) && ej.isNullOrUndefined(this.model.group)) ? { currentDay: curday + " " + Globalize.format(new Date(this.dateRender[i]), "dd MMMM yyyy"), currentDateClass: "", cellToday: headerCellClass } : { currentDay: curday + " " + Globalize.format(new Date(this.dateRender[i]), "dd MMM yy"), currentDateClass: "", cellToday: headerCellClass } : { currentDay: curday + " " + new Date(this.dateRender[i]).getDate(), currentDateClass: new Date(this.dateRender[i]).getDate() === new Date(this.currentDate()).getDate() ? "e-activeview" : "", cellToday: headerCellClass };
                    cols.push(temp);
                }
            }
            else 
                cols = this._getHorizontalheaderCellCount(weekcols);
            return cols;
        },

        _findResourceIndex: function (data, attr, value) {
            for (var i = 0; i < data.length; i++) {
                if (data[i][attr] === value) {
                    return i;
                }
            }
        },

        /**
        * Section For render all day header template.
        * @private
        */
        _renderHeaderAllDayTemplate: function () {
            if (ej.scheduleFeatures.horizontal && this.model.orientation == "horizontal") {
                if (!ej.isNullOrUndefined(this.model.resources) && ej.scheduleFeatures.resources)
                    this._renderMultipleResourceHeaderTemplate(null, null);
                this._renderHorizontalHeaderBar();
            }
            else {
                var headerDiv = ej.buildTag('div.e-headeralldaydiv', "", {}, { height: "100%" }).css("position", "relative").css("overflow", "hidden");
                var resCount = 0;
                var table = ej.buildTag('table.e-table e-headrealldaytable', "", {}, { cellspacing: "0px", cellpadding: "0px" });
                var tbody = ej.buildTag('tbody');
                var headTR = ej.buildTag('tr.e-dateheader');
                var cols = this._getHeaderAllDayCellsCount();
                var html = this.headTemplate.render({ cols: cols, view: this.currentView(), colspan: 1 });
                //multiple resources
                if (!ej.isNullOrUndefined(this.model.resources) && ej.scheduleFeatures.resources) {
                    tbody = this._renderMultipleResourceHeaderTemplate(tbody, cols);
                    resCount = !ej.isNullOrUndefined(this.model.group) ? this.model.group.resources.length : 0;
                }
                var tempNavigate = ej.buildTag('div.e-navigate', "", {}, {});
                var inner_table = ej.buildTag('table.e-table e-headertable', "", {}, { cellspacing: "0px", cellpadding: "0px" });
                var tb = ej.buildTag('tbody');
                var headT = ej.buildTag('tr.e-headertr');

                headTrCount = (this.currentView() == "month") || (this._isCustomView()) ? 1 : 2;
                var rowCount = resCount + headTrCount; var rows = [];
                for (var i = 0; i < rowCount; i++) {
                    if (this.currentView() == "month" || (this._isCustomView()))
                        rows.push({ tdClass: (i == rowCount - 1) ? "e-monthleftcells" : "e-resourceheadercells", divClass: (i == rowCount - 1) ? "e-dateheadercell" : "" });
                    else
                        rows.push({ tdClass: (i == rowCount - 1) ? "e-leftindent" : (i == rowCount - 2) ? "e-settingsindent" : "e-resourceheadercells", divClass: (i == rowCount - 1) ? "e-schedulesettings e-textellipsis" : (i == rowCount - 2) ? "e-dateheadercell" : "" });
                }
                var widths = (this._mediaQuery) ? this.currentView() == "month" || (this._isCustomView()) ? "50px" : "30px" : this.currentView() == "month" || (this._isCustomView()) ? "50px" : "56px";
                var leftIndentHtml = this.leftIndent.render({ trs: rows, cswidth: widths });

                this.aTR.append(ej.buildTag('td').append(tempNavigate.append(inner_table.append(tb.append(headT.append(ej.buildTag('td.empty', "", {}, { width: (this._mediaQuery) ? this.currentView() == "month" || (this._isCustomView()) ? "0px" : "30px" : (this.currentView() == "month" || this._isCustomView()) ? "50px" : "56px" }).css("border-bottom", (this.currentView() != "month" && !this._isCustomView()) ? "1px solid #bbbcbb" : "").addClass((this.currentView() == "month") ? "monthempty" : "").append(leftIndentHtml)).append(ej.buildTag('td').append(headerDiv.append(table.append(tbody.append(headTR.append(html)))))).append(ej.buildTag('td', "", {}, { width: (this.currentView() == "month" || this._isCustomView()) ? "0px" : (this._mediaQuery) ? "0px" : "18px" }).append(this._emptyCell())))))));
                if (this.currentView() !== "month" && !(this._isCustomView())) {
                    var alldayTR = ej.buildTag('tr');
                    var allHtml = this.alldayTemp.render({ cols: cols, colspan: 1 });
                    tbody.append(alldayTR.append(allHtml));
                }
            }
        },
    /**
    * Section For generate the current month dates with previous and next month exceeding dates.
    * @private
    */
    _monthdates: function () {
        var currentDate = new Date(this.currentDate());
        var header = new Date(currentDate.getFullYear(), currentDate.getMonth(), 1);
        var day = header.getDay() + 1;
        header.setDate(header.getDate() - day);
        //nextmonth days.
        var daysInMonth = new Date(currentDate.getFullYear(), currentDate.getMonth() + 1, 0).getDate();
            var daysInNextMonth = (day + daysInMonth) % 7 != 0 ? (7 - (day + daysInMonth) % 7) : 0;
            var rows = parseInt((day + daysInMonth + daysInNextMonth) / 7);
            var dates = [];
            for (var row = 0; row < (rows * 7); row++) {
                dates.push(new Date(header.setDate(header.getDate() + 1)));
            }
            return dates;
    },
    /**
    * Section For get the start and end time of the schedule.
    * @private
    */
    _getStartEndTime: function () {
        var timerows, startendTimes = [], timelist;
        var localizeAmPm = Globalize.culture(this.model.locale).calendar;
        if (this.model.orientation === "vertical") {
            if (this.currentView() == "month" || (this._isCustomView())) {
                var row = this._dateRender.length;
                for (var i = 0; i < (row / 7) ; i++) {
                    startendTimes.push(i);
                }
            }
            else {
                for (var i = this.model.startHour; i < this.model.endHour; i++) {
                    if (this._timeMode === "12") {
                        timelist = ((i === this.model.startHour || i === 12) && (localizeAmPm.AM && localizeAmPm.PM)) ? Globalize.format(new Date(new Date().setHours(i)), "hh tt") : Globalize.format(new Date(new Date().setHours(i)), "hh 00");
                        startendTimes.push({ time: timelist, id: i });
                    }
                    else
                        startendTimes.push({ time: (i <= 9 ? "0" + i : i) + " 00" });
                }
            }
        }
        else if (this.model.orientation == "horizontal" && ej.scheduleFeatures.horizontal)
            startendTimes = this._getHoriStartEndTime(localizeAmPm);
        return startendTimes;
    },
    /**
    * Section For get the work cells count of the schedule.
    * @private
    */
    _getWorkCellsCount: function () {
            var workcells = [];
            if (this.currentView() == "month" || (this._isCustomView())) {
                var row = this._dateRender.length;
                for (var i = 0; i < (row / 7) ; i++) {
                    workcells.push({ crow: i, cwidth: this.model.cellWidth, cheight: this.model.cellHeight });
                }
            }
            else {
                var strEndTime = this._getStartEndTime();
                for (var i = 0; i < (2 * strEndTime.length) ; i++) {
                    workcells.push({ crow: i, cwidth: this.model.cellWidth, cheight: this.model.cellHeight });
                }
            }
        return workcells;
    },
    /**
    * Section For render the content area template of the schedule.
    * @private
    */
    _renderContentAreaTemplate: function () {
        var $contentAreaDiv = ej.buildTag('div.e-workareadiv');
        var $contentTable = ej.buildTag('table.e-table e-worktable', "", {}, { height: "100%", cellpadding: "0px", cellspacing: "0px", width: "100%" });
        var $contentBody = ej.buildTag('tbody');
        var $contentTR = ej.buildTag('tr');
        var $WorkCellTD = ej.buildTag('td');
        var $scrollerbarDiv = ej.buildTag('div#' + this._id + "_scroller");
        this.$WorkCellDiv = ej.buildTag('div').css('position', "relative").attr('class', 'e-draggableworkarea').css("height", "100%");
        
        if (ej.scheduleFeatures.horizontal && this.model.orientation == "horizontal")
            this._renderHorizontalContent($contentAreaDiv, $contentTable, $contentBody, $contentTR, $WorkCellTD, $scrollerbarDiv);
        else {
      //      this.$WorkCellDiv.css("height", "100%");
            var timeCellClassName = this.currentView() === "month" || (this._isCustomView()) ? "e-monthleftindent" : "e-workleftindent";
            this.$TimeCellTD = ej.buildTag('td', "", {}, {}).addClass(timeCellClassName);
            
            var colspan = [], index;
            var cols = this.currentView() === "month" || (this._isCustomView()) ? 7 : this._getRenderDates().length; 
            if (!ej.isNullOrUndefined(this.model.resources) && !ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources)
                cols = this._getMultipleResourceColsCount(cols);
            for (var i = 0; i < cols; i++) colspan.push(i);

            //time cells
            var timeCellhtml;
            var viewclass = this.currentView() == "month" || (this._isCustomView()) ? 1 : 0; //"e-monthtimecells" : "e-timecelldivs";
            timeCellhtml = this.timeCellTemplate.render({ timerows: this._getStartEndTime(), cols1: [1, 2], viewclass: viewclass });

            //Work cells
            var workCellhtml;
            if (this.currentView() !== "month" && !(this._isCustomView()))
                workCellhtml = this.workcellTemp.render({ cellrows: this._getWorkCellsCount(), cols1: colspan, orientation: this.model.orientation });
            else {
                workCellhtml = this.monthcellTemp.render({ cellrows: this._getWorkCellsCount(), cols1: colspan, orientation: this.model.orientation });
            }
            this.wTR.append(ej.buildTag('td').append($contentAreaDiv.append($contentTable.append($contentBody.append($contentTR.append(this.$TimeCellTD.append(timeCellhtml)).append($WorkCellTD.append($scrollerbarDiv.append(this.$WorkCellDiv.append(workCellhtml)))))))));
        }
        
    },
    /**
    * Section For get the column count of the schedule.
    * @private
    */
    _getColumnCount: function () {
        var weekcells = [];
        var daysCount = this.currentView() === "month" || (this._isCustomView()) ? 7 : this._getRenderDates().length;
        for (var i = 0; i < daysCount; i++) weekcells.push(i);
        return weekcells;
        },
        
        /**
        * To configure the dataSource values
        * @private
        */
    _bindAppointmentsData: function (currentAction) {
        if (!ej.isNullOrUndefined(this.model.appointmentSettings) && this.dataSource() != null) {
            if (this.model.enablePersistence)
                this.model.appointmentSettings.query = new ej.Query();
            if (!this.dataSource() instanceof ej.DataManager && this.dataSource().dataSource.offline)
                this._dateFormat(this.dataSource());
            if (this.dataSource() instanceof ej.DataManager && !this.dataSource().dataSource.offline) {
                this._initDataSource(currentAction); //Code to bind fields from database
            }
            else {
                var tempstarttime, tempendtime, localutc, obj;
                localutc = new Date().getTimezoneOffset();
                if (this.model.timeZone == null)
                    obj = this._minToHour(localutc);
                else {
                    //var timezone = this.model.timeZone.split(" ")[1].split(":");
                    if (ej.isNullOrUndefined(this.model.timeZone.split(" ")[1])) {
                        obj = this._minToHour(0);
                    }
                    else {
                        var timezone = this.model.timeZone.split(" ")[1].split(":");
                        var hour = parseInt(timezone[0]);
                        var mins = parseInt(timezone[1]);
                        obj = this._minToHour(-(hour * 60) + mins);
                    }
                }
                for (var a = 0; a < this.dataSource().length; a++) {
                    tempstarttime = new Date(this.dataSource()[a][this.model.appointmentSettings["startTime"]]);
                    tempendtime = new Date(this.dataSource()[a][this.model.appointmentSettings["endTime"]]);
                    this.dataSource()[a][this.model.appointmentSettings["startTime"]] = new Date(tempstarttime.setHours(tempstarttime.getHours() - obj.h, tempstarttime.getMinutes() - obj.m));
                    this.dataSource()[a][this.model.appointmentSettings["endTime"]] = new Date(tempendtime.setHours(tempendtime.getHours() - obj.h, tempendtime.getMinutes() - obj.m));
                }
                this._currentAppointmentData = this.dataSource();
                !ej.isNullOrUndefined(this.dataSource().dataSource) && this.dataSource().dataSource.json && (this._currentAppointmentData = this.dataSource().dataSource.json);
                this._dataCount = this._currentAppointmentData.length;
                this._dataProcessing(this._currentAppointmentData);
                this._renderAppointmentAll();
            }
        }
    },
        /**
        * To configure the dataSource values to the fields.
        * @private
        */
    _initDataSource: function (currentAction) {
        var query = this._columnToSelect(this.model.appointmentSettings, currentAction);
        var proxy = this;
        var queryPromise = this.dataSource().executeQuery(query);
        queryPromise.done(function (e) {
            //utc timezone conversion
            var tempstarttime, tempendtime, localutc, obj;
            localutc = new Date().getTimezoneOffset();
            if (proxy.model.timeZone == null)
                obj = proxy._minToHour(localutc);
            else {
                if (ej.isNullOrUndefined(proxy.model.timeZone.split(" ")[1])) {
                    obj = proxy._minToHour(0);
                }
                else {
                    var timezone = proxy.model.timeZone.split(" ")[1].split(":");
                    var hour = parseInt(timezone[0]);
                    var mins = parseInt(timezone[1]);
                    obj = proxy._minToHour(-(hour * 60) + mins);
                }
            }
            for (var a = 0; a < e.result.length; a++) {
                tempstarttime = new Date(e.result[a][proxy.model.appointmentSettings["startTime"]]);
                tempendtime = new Date(e.result[a][proxy.model.appointmentSettings["endTime"]]);
                e.result[a][proxy.model.appointmentSettings["startTime"]] = new Date(tempstarttime.setHours(tempstarttime.getHours() - obj.h, tempstarttime.getMinutes() - obj.m));
                e.result[a][proxy.model.appointmentSettings["endTime"]] = new Date(tempendtime.setHours(tempendtime.getHours() - obj.h, tempendtime.getMinutes() - obj.m));
            }
            proxy._currentAppointmentData = e.result;
            //proxy._dataManager = ej.DataManager(e.result);
            proxy._dataCount = e.result.length;
            proxy._overlapList = [];
            proxy._dataProcessing(e.result);
            proxy._renderAppointmentAll();
        });
    },

    _dateFormat: function (appointments) {
        if (new Date(appointments[0][this.model.appointmentSettings["startTime"]]).toString() == "Invalid Date") {
            for (var i = 0; i < appointments.length; i++) {
                if (new Date(appointments[i][this.model.appointmentSettings["startTime"]]).toString() == "Invalid Date" || new Date(appointments[i][this.model.appointmentSettings["startTime"]]).toString() == "NaN")
                    appointments[i][this.model.appointmentSettings["startTime"]] = new Date(parseInt(appointments[i][this.model.appointmentSettings["startTime"]].match(/\d+/).toString()));
                else
                    appointments[i][this.model.appointmentSettings["startTime"]] = new Date(appointments[i][this.model.appointmentSettings["startTime"]]);
                if (new Date(appointments[i][this.model.appointmentSettings["endTime"]]).toString() == "Invalid Date")
                    appointments[i][this.model.appointmentSettings["endTime"]] = new Date(parseInt(appointments[i][this.model.appointmentSettings["endTime"]].match(/\d+/).toString()));
                else
                    appointments[i][this.model.appointmentSettings["endTime"]] = new Date(appointments[i][this.model.appointmentSettings["endTime"]]);
            }
        }
    },

    _timeZoneConversion: function (appointment) {
        var appoint=$.extend(true,{},appointment);
        var tempstarttime, tempendtime, localutc, obj;
        localutc = new Date().getTimezoneOffset();
        if (this.model.timeZone == null)
            obj = this._minToHour(localutc);
        else {
            if (ej.isNullOrUndefined(this.model.timeZone.split(" ")[1])) {
                obj = this._minToHour(0);
            }
            else {
                var timezone = this.model.timeZone.split(" ")[1].split(":");
                var hour = parseInt(timezone[0]);
                var mins = parseInt(timezone[1]);
                obj = this._minToHour(-(hour * 60) + mins);
            }
        }
        tempstarttime = new Date(appoint[this.model.appointmentSettings["startTime"]]);
        tempendtime = new Date(appoint[this.model.appointmentSettings["endTime"]]);
        appoint[this.model.appointmentSettings["startTime"]] = new Date(tempstarttime.setHours(tempstarttime.getHours() + obj.h, tempstarttime.getMinutes() + obj.m));
        appoint[this.model.appointmentSettings["endTime"]] = new Date(tempendtime.setHours(tempendtime.getHours() + obj.h, tempendtime.getMinutes() + obj.m));
        return appoint;
    },

    _reverseTimeZoneConversion: function (appointment) {
        var appoint = $.extend(true, {}, appointment);
        var tempstarttime, tempendtime, localutc, obj;
        localutc = new Date().getTimezoneOffset();
        if (this.model.timeZone == null)
            obj = this._minToHour(localutc);
        else {
            if (ej.isNullOrUndefined(this.model.timeZone.split(" ")[1])) {
                obj = this._minToHour(0);
            }
            else {
                var timezone = this.model.timeZone.split(" ")[1].split(":");
                var hour = parseInt(timezone[0]);
                var mins = parseInt(timezone[1]);
                obj = this._minToHour(-(hour * 60) + mins);
            }
        }
        tempstarttime = new Date(appoint[this.model.appointmentSettings["startTime"]]);
        tempendtime = new Date(appoint[this.model.appointmentSettings["endTime"]]);
        appoint[this.model.appointmentSettings["startTime"]] = new Date(tempstarttime.setHours(tempstarttime.getHours() - obj.h, tempstarttime.getMinutes() - obj.m));
        appoint[this.model.appointmentSettings["endTime"]] = new Date(tempendtime.setHours(tempendtime.getHours() - obj.h, tempendtime.getMinutes() - obj.m));
        return appoint;
    },

    /**
    * To configure the column values of the table
    * @private
    */
    _columnToSelect: function (mapper, currentAction) {
        var column = [], queryManager = ej.Query();
        if (ej.isNullOrUndefined(mapper.query)) {
            column = this._getColumns(mapper);
            if (column.length > 0)
                queryManager.select(column);
            if (!ej.isNullOrUndefined(this.dataSource())) {
                if (!this.dataSource().dataSource.url.match(mapper.tableName + "$"))
                    !ej.isNullOrUndefined(mapper.tableName) && queryManager.from(mapper.tableName);
            }
        }
        else
            queryManager = mapper.query;
        return queryManager && ej.Query().addParams("CurrentDate",this.currentDate()).addParams("CurrentView",this.model.currentView).addParams("CurrentAction", currentAction);
    },
    /**
    * returns the columns name in array list.
    * @private
    */
    _getColumns: function (mapper) {
        var column = []
        for (var col in mapper) {
            if (col !== "tableName" && col !== "query" && col !== "dataSource")
                column.push(mapper[col]);
        }
        return column;
    },
    /**
    * Section For sort the appointments based on the appointment id.
    * @private
    */
    _sortAppById: function (appointments) {

        var proxy = this;
        appointments.sort(function (a, b) {
            var x = a[proxy.model.appointmentSettings["id"]]; var y = b[proxy.model.appointmentSettings["id"]];
            return ((x < y) ? -1 : ((x > y) ? 1 : 0));
        });
        return appointments;
    },
    /**
    * Section For handle the datasource dataprocessing.
    * @private
    */
    _dataProcessing: function (appointments) {
        this._processed = [];
        if(appointments.length > 0){
            var appId = this._sortAppById(appointments);
            this._maxId = appId[appId.length - 1][this.model.appointmentSettings["id"]] + 1;
            var recurEndDate;
            for (var app = 0; app < appointments.length; app++) {
                this._appointmentProcessing(appointments[app]);
            }
            //this._maxId = null;
            this._processed = this._sortAppById(this._processed);
            return this._processed;
        }
    },
    /**
    * Section For processing the appointments.
    * @private
    */
    _appointmentProcessing: function (appointment) {
        var day_start = new Date(appointment[this.model.appointmentSettings["startTime"]]);
        var duration=((new Date(appointment[this.model.appointmentSettings["endTime"]]) - new Date(appointment[this.model.appointmentSettings["startTime"]])) / 1000);
        var hours = Math.floor(duration / 3600);
        var minutes = Math.floor((duration % 3600) / 60);
        this._rRule = {}, _count = 0, _lastDay = false;
        (!ej.isNullOrUndefined(appointment[this.model.appointmentSettings["recurrenceRule"]])) && this.recurrenceRuleSplit(appointment[this.model.appointmentSettings["recurrenceRule"]]);
        if (appointment[this.model.appointmentSettings["recurrence"]] == 1 && ej.isNullOrUndefined(this._rRule.recurEditId)) {
            appointment.ParentId = appointment[this.model.appointmentSettings["id"]];
            var byDay = "", _interval = ej.isNullOrUndefined(this._rRule.interval) ? 1 : this._rRule.interval;
            !ej.isNullOrUndefined(this._rRule.weekDays) && (byDay = this._rRule.weekDays.split(','));
            // Find Recurrence End date:
            if (!ej.isNullOrUndefined(this._rRule.until)) {
                recurEndDate = new Date(this._rRule.until);
                recurEndDate.setDate(recurEndDate.getDate() + 1);
                }
                else if (!ej.isNullOrUndefined(this._rRule.count))
                    switch (this._rRule.freq) {
                    case "DAILY":
                        recurEndDate = new Date(new Date(day_start).setDate(day_start.getDate() + this._rRule.count * (_interval)));
                        break;
                    case "WEEKLY":
                        var dayCount = day_start.getDate() + (((this._rRule.count / byDay.length) * 7)) * (_interval);
                        recurEndDate = new Date(new Date(day_start).setDate(Math.round(dayCount) < dayCount ? dayCount + 1 : dayCount));
                        break;
                    case "MONTHLY":
                        recurEndDate = new Date(new Date(day_start).setMonth(day_start.getMonth() + this._rRule.count * (_interval)));
                        break;
                    case "YEARLY":
                        recurEndDate = new Date(new Date(day_start).setFullYear(day_start.getFullYear() + this._rRule.count * (_interval)));
                        break;
                }
                else {
                    recurEndDate = new Date(new Date(this.currentDate()).setDate(day_start.getDate() + 42 * (_interval)));
                }
            switch (this._rRule.freq) {
                case "WEEKLY":
                    byDay = this._rRule.weekDays.split(',');
                    if (byDay.indexOf(this._dayNames[new Date(day_start).getDay()]) == -1)
                        day_start = this._weeklyDayFind(day_start, byDay);
                    break;
                case "MONTHLY":
                    if (!ej.isNullOrUndefined(this._rRule.monthDay)) {
                        _lastDay = new Date(day_start).getDate() == new Date(day_start.getFullYear(), day_start.getMonth() + 1, 0).getDate() ? true : false;
                        while (new Date(day_start).getDate() != this._rRule.monthDay) {
                            day_start = new Date(day_start.setDate(day_start.getDate() + 1));
                        }
                    }
                    else
                        day_start = new Date((this._getWeekIndex(day_start) + 1) > this._rRule.setPositions && this._rRule.setPositions != -1 ? new Date(day_start.getFullYear(), day_start.getMonth() + 1, 1) : day_start);
                    break;
                case "YEARLY":
                    if (!ej.isNullOrUndefined(this._rRule.monthDay)) {
                        day_start = (day_start.getMonth() + 1 >= this._rRule.month) && day_start.getDate() > this._rRule.monthDay ? new Date(day_start.getFullYear() + 1, this._rRule.month - 1, this._rRule.monthDay) : new Date(day_start.getFullYear(), this._rRule.month - 1, this._rRule.monthDay);
                    }
                    else if (!ej.isNullOrUndefined(this._rRule.setPositions)) {
                        day_start = new Date(day_start.getFullYear(), this._rRule.month - 1, day_start.getDate());
                        day_start = new Date((this._getWeekIndex(day_start) + 1) > this._rRule.setPositions ? new Date(day_start.getFullYear(), day_start.getMonth() + 1, 1) : day_start);
                    }
                    break;
            }

            while (day_start <= recurEndDate) {
                var orgStrTime = appointment[this.model.appointmentSettings["startTime"]];
                var newAppointment = {}, orgEndTime = appointment[this.model.appointmentSettings["endTime"]];
                ((this._rRule.freq == "MONTHLY" || this._rRule.freq == "YEARLY") && !ej.isNullOrUndefined(this._rRule.setPositions)) && (day_start = this._dayOfWeekInMonth(day_start, this._rRule.weekDays, this._rRule.setPositions));
                var strTime = new Date(day_start.getFullYear(), day_start.getMonth(), day_start.getDate(), orgStrTime.getHours(), orgStrTime.getMinutes(), 0);
                var endTime = new Date(day_start.getFullYear(), day_start.getMonth(), day_start.getDate(), orgStrTime.getHours() + hours, orgStrTime.getMinutes() + minutes, 0);
                if (!ej.isNullOrUndefined(this._rRule.exDate)) {
                    if (this._rRule.exDate.indexOf(Globalize.format(new Date(day_start), this._pattern.d)) == -1) {
                        newAppointment = this._addAppData(appointment, this._maxId, strTime, endTime, appointment[this.model.appointmentSettings["id"]]);
                    }
                }
                else
                    newAppointment = this._addAppData(appointment, this._maxId, strTime, endTime, appointment[this.model.appointmentSettings["id"]]);
                switch (this._rRule.freq) {
                    case "DAILY":
                        day_start = new Date(day_start.setDate(day_start.getDate() + _interval));
                        break;
                    case "WEEKLY":
                        var curDay = this._dayNames[new Date(day_start).getDay()];
                        if (byDay.length - 1 != byDay.indexOf(curDay)) {
                            day_start = this._weeklyDayFind(day_start, byDay);
                        }
                        else {
                            day_start = new Date(day_start.setDate(day_start.getDate() + (day_start.getDay() * -1)));
                            day_start = new Date(day_start.setDate(day_start.getDate() + (_interval * 7) - 1));
                            day_start = this._weeklyDayFind(day_start, byDay);
                        }
                        break;
                    case "MONTHLY":
                        day_start = _lastDay ? new Date(day_start.getFullYear(), (day_start.getMonth() + _interval) + 1, 0) :
                            ej.isNullOrUndefined(this._rRule.setPositions) ? new Date(day_start.setMonth(day_start.getMonth() + _interval)) : new Date(day_start.getFullYear(), day_start.getMonth() + _interval, 1);
                        break;
                    case "YEARLY":
                        day_start = new Date(day_start.setFullYear(day_start.getFullYear() + _interval));
                        break;
                }
                if ((Globalize.format(appointment[this.model.appointmentSettings["startTime"]], this._pattern.d) < Globalize.format(appointment[this.model.appointmentSettings["endTime"]], this._pattern.d)) && (((appointment[this.model.appointmentSettings["endTime"]] - appointment[this.model.appointmentSettings["startTime"]]) / 3600000) < 24) && (appointment[this.model.appointmentSettings["allDay"]] !== true)) {
                   // endTime.setDate(endTime.getDate() + 1);

                    this._multipleDayApp(newAppointment, this._maxId, newAppointment[this.model.appointmentSettings["startTime"]], endTime);

                }
                else
                    (!$.isEmptyObject(newAppointment)) && this._processed.push(newAppointment);
                this._maxId++;
                _count++;
                if (!ej.isNullOrUndefined(this._rRule.count) && _count == this._rRule.count)
                    break;
            }
        }

        if ((Globalize.format(appointment[this.model.appointmentSettings["startTime"]], this._pattern.d) < Globalize.format(appointment[this.model.appointmentSettings["endTime"]], this._pattern.d)) && (((appointment[this.model.appointmentSettings["endTime"]] - appointment[this.model.appointmentSettings["startTime"]]) / 3600000) < 24) && (appointment[this.model.appointmentSettings["allDay"]] !== true) && appointment[this.model.appointmentSettings["recurrence"]] != 1) {
            ej.isNullOrUndefined(appointment.ParentId) && (appointment.ParentId = appointment[this.model.appointmentSettings["id"]]);
            this._multipleDayApp(appointment, this._maxId, appointment[this.model.appointmentSettings["startTime"]], appointment[this.model.appointmentSettings["endTime"]]);
        }
        else if ((((appointment[this.model.appointmentSettings["endTime"]] - appointment[this.model.appointmentSettings["startTime"]]) / 3600000) > 24) && ej.isNullOrUndefined(this._rRule.recurEditId)) {
            if (((appointment[this.model.appointmentSettings["allDay"]] === true) || ((appointment[this.model.appointmentSettings["allDay"]] !== true) && ((appointment[this.model.appointmentSettings["endTime"]] - appointment[this.model.appointmentSettings["startTime"]]) / 3600000) > 24))&& appointment[this.model.appointmentSettings["recurrence"]] != 1)  {
                    this._multipleSplit(appointment, this._maxId, appointment[this.model.appointmentSettings["startTime"]], appointment[this.model.appointmentSettings["endTime"]]);              
            }
        }
        else if ((appointment[this.model.appointmentSettings["recurrence"]] == 0 || !ej.isNullOrUndefined(this._rRule.recurEditId))) {
            ej.isNullOrUndefined(appointment.ParentId) && (appointment.ParentId = appointment[this.model.appointmentSettings["id"]]);
            (!ej.isNullOrUndefined(this._rRule.recurEditId)) && (appointment.ParentId = this._rRule.recurEditId);
            this._processed.push(appointment);
        }
        else if ((appointment[this.model.appointmentSettings["recurrence"]] == undefined) || (appointment[this.model.appointmentSettings["allDay"]] == undefined)) {
            this._processed.push(appointment);
        }
    },

    /**
    * Section For split the multiple day appointment.
    * @private
    */
    //Split two appointments for multiple day.
    _multipleDayApp: function (app, maxId, startTime, endTime) {
        var day_start = new Date(startTime);
        var nextDay = new Date(new Date(startTime).getFullYear(), new Date(startTime).getMonth(), new Date(startTime).getDate());
        var day_end = new Date(new Date(nextDay).setHours(new Date(nextDay).getHours() + 24));
        day_end = new Date(new Date(day_end).setMinutes(new Date(day_end).getMinutes() - 1));

        while (day_start >= new Date(startTime) && day_start <= day_end && day_end <= new Date(endTime)) {
            appointment = this._addAppData(app, maxId, day_start, day_end, app.ParentId);
            this._processed.push(appointment);
            day_start = new Date(new Date(day_end).setMinutes(new Date(day_end).getMinutes() + 1));
            day_end = app[this.model.appointmentSettings["endTime"]];
            maxId++;
            this._maxId = maxId;
        }
    },
    _multipleSplit: function(app, maxId, startTime, endTime){	
        var startTime = new Date(startTime);
        if(this.currentView()=="workweek"){
        var sunday = new Date((new Date(startTime)).setDate(startTime.getDate() + 1));
        var saturday = new Date((new Date(startTime)).setDate(startTime.getDate() + 2));
        startTime = (new Date(startTime).getDay() == 0) ? sunday : (new Date(startTime).getDay() == 6) ? saturday : new Date(startTime);}   
        this.starttime = (new Date(this._dateRender[0]) <= startTime) ? new Date(new Date(startTime).getFullYear(), new Date(startTime).getMonth(), new Date(startTime).getDate(), new Date(startTime).getHours(), new Date(startTime).getMinutes(), new Date(startTime).getSeconds()) : new Date(this._dateRender[0]);
      var end = new Date(new Date(endTime).getFullYear(), new Date(endTime).getMonth(), new Date(endTime).getDate());
      var next = 0;
       while (this.starttime<=end) 
       {
        var differDate = 0;       
        var day_start = this.starttime;
         if((this.model.orientation =="horizontal" && this.currentView()=="month"))
             differDate = new Date(day_start.getFullYear(), day_start.getMonth() + 1, 0).getDate() - (day_start.getDate());
         else if (this.currentView() == "customview" && (this._renderDays <= 7 || this.model.orientation == "horizontal")) {
             this.starttime = (new Date(new Date(day_start).getFullYear(), new Date(day_start).getMonth(), new Date(day_start).getDate()));
              differDate = (this._dateRender.length - 1) - this._dateRender.indexOf(this.starttime.getTime());
         }
	     else if(this.currentView()!=="day")
		      differDate = 6 - day_start.getDay();
	     var nextDay = new Date(new Date(this.starttime).getFullYear(), new Date(this.starttime).getMonth(), new Date(this.starttime).getDate() + differDate);
         var day_end = (new Date(nextDay).getDate()==new Date(end).getDate()&& this.currentView()!=="month") ? new Date(new Date(nextDay).setHours(new Date(endTime).getHours())):new Date(new Date(nextDay).setHours(23));
         day_end = (new Date(nextDay).getDate()==new Date(end).getDate() && this.currentView()!=="month") ? new Date(new Date(day_end).setMinutes(new Date(endTime.getMinutes()))):new Date(new Date(day_end).setMinutes(59));
	     if ((day_end >= new Date(endTime)) && this.currentView!=="day")
                day_end = app[this.model.appointmentSettings["endTime"]];
         else if ((day_end.getDay() == 6 && this.currentView()=="workweek" ) || (day_end.getDay() == 7 && this.currentView()=="workweek" )) {
                var sunday = new Date((new Date(day_end)).setDate(day_end.getDate() - 2));
                var saturday = new Date((new Date(day_end)).setDate(day_end.getDate() - 1));
                day_end = (new Date(day_end).getDay() == 6) ? saturday : sunday;
            }
             else 
                day_end = day_end; 
                 
             appointment = this._addAppData(app, maxId, day_start, day_end, app[this.model.appointmentSettings["id"]]);
             this._processed.push(appointment);
              maxId++;
             this._maxId = maxId;
             next = (this.currentView()=="workweek")? 3: 1;
             this.starttime = new Date(new Date(day_end).getFullYear(), new Date(day_end).getMonth(), new Date(day_end).getDate() + next);
             if (new Date(this._dateRender[this._dateRender.length - 1]) <= this.starttime)
                 break;
          }
	},

    /**
    * Section For handle the recurrence appointment delete.
    * @private
    */
    //Delete ocurrence 
    _deleteOcurrence: function (appId, date) {
        var query = new ej.Query().where(this.model.appointmentSettings["id"], ej.FilterOperators.equal, appId);
        var _editApp = new ej.DataManager(this._currentAppointmentData).executeLocal(query);
        if (!ej.isNullOrUndefined(_editApp) && !ej.isNullOrUndefined(_editApp[0][this.model.appointmentSettings["recurrenceRule"]])) {
            var _rRule = _editApp[0][this.model.appointmentSettings["recurrenceRule"]];
            this.recurrenceRuleSplit(_rRule);
            if (ej.isNullOrUndefined(this._rRule.exDate)) {
                _editApp[0][this.model.appointmentSettings["recurrenceRule"]] = _rRule + ";EXDATE=" + Globalize.format(new Date(date), this._pattern.d);
            }
            else {
                var _rules = _rRule.split(';');
                recurRule = "";
                for (var i = 0; i < _rules.length; i++) {
                    if (recurRule != "")
                        recurRule += ";";
                    var keyValuePair = _rules[i].replace(/ /g, '').split('=');
                    if (keyValuePair[0] == "EXDATE") {
                        _rules[i] = _rules[i] + "," + Globalize.format(new Date(date), this._pattern.d);
                    }
                    recurRule += _rules[i];
                }
                _editApp[0][this.model.appointmentSettings["recurrenceRule"]] = recurRule;
            }
            return _editApp;
        }
    },
    /**
    * Section For get the week index of the month.
    * @private
    */
    //Find week index in a month.
    _getWeekIndex: function (curDate) {
        var index = 0;
        var firstDate = new Date(curDate.getFullYear(), curDate.getMonth(), 1);
        var dayIndex = curDate.getDay();
        if (dayIndex != firstDate.getDay())
            do {
                firstDate = new Date(firstDate.setDate(firstDate.getDate() + 1));
            } while (dayIndex != firstDate.getDay())
        while (firstDate.getDate() != curDate.getDate()) {
            firstDate = new Date(firstDate.setDate(firstDate.getDate() + 7));
            index++;
        }
        return index;
    },
    /**
    * create the appointment data with JSON object.
    * @private
    */
    //create the appointment data with JSON object.
    _addAppData: function (app, id, startTime, endTime, parentId) {
        var data = {};
        for (var item in this.model.appointmentSettings) {
            if (item != "dataSource" && item != "query" && item != "tableName" && item != "resourceFields")
                data[this.model.appointmentSettings[item]] = app[this.model.appointmentSettings[item]];
                if(item == "resourceFields"){
                    for(var val in !ej.isNullOrUndefined(this.model.appointmentSettings.resourceFields) && this.model.appointmentSettings.resourceFields.split(','))
                    data[this.model.appointmentSettings.resourceFields.split(',')[val]] = app[this.model.appointmentSettings.resourceFields.split(',')[val]];
                }
        }
        (!ej.isNullOrUndefined(id)) && (data[this.model.appointmentSettings["id"]] = id);
        (!ej.isNullOrUndefined(startTime)) && (data[this.model.appointmentSettings["startTime"]] = startTime);
        (!ej.isNullOrUndefined(endTime)) && (data[this.model.appointmentSettings["endTime"]] = endTime);
        (!ej.isNullOrUndefined(parentId)) && (data["ParentId"] = parentId);
        var appdata = $.extend({}, app, data);
        return appdata;
    },
    /**
    * Section for find the number of week and the day name.
    * @private
    */
    // find the number week with day name.
    _dayOfWeekInMonth: function (strDate, dayName, weekIndex) {
        var dayIndex = this._dayNames.indexOf(dayName);
        var curDate = weekIndex == -1 ? new Date(strDate.getFullYear(), strDate.getMonth() + 1, 0) : new Date(strDate.getFullYear(), strDate.getMonth(), 1);
        while (curDate.getDay() != dayIndex) {
            curDate = new Date(weekIndex == -1 ? curDate.setDate(curDate.getDate() - 1) : curDate.setDate(curDate.getDate() + 1));
        }
        return new Date(weekIndex == 1 || weekIndex == -1 ? curDate : curDate.setDate(curDate.getDate() + ((weekIndex - 1) * 7)));
    },
    /**
    * Section for find the day name.
    * @private
    */
    // Find the day name 
    _weeklyDayFind: function (strDate, days) {
        var newdayStr = strDate;
        do {
            newdayStr = new Date(newdayStr.setDate(newdayStr.getDate() + 1));
            curDay = this._dayNames[new Date(newdayStr).getDay()];
        } while (days.indexOf(curDay) == -1);
        return newdayStr;
    },
    /**
    * Section for render the appointments.
    * @private
    */
	_renderAppointments: function () {
        var dateCount = this._dateRender;
        this._tempapp = [];
        this.cellwidth = this.element.find(".e-workcells").width();
        var appointments = this._currentAppointmentData;
        this.leftPosition = 0;
            //else
            var appointmentsList = this._processed;
            this._filtered = [];
            if (!this.model.group) this.res1 = ["0"];
            this.resIndex = 0; //this._categorybar = true;	
            for (var res = 0; res < this.res1.length; res++) {
                //if (ej.scheduleFeatures.horizontal && this.model.orientation == "horizontal" && ej.scheduleFeatures.resources && !ej.isNullOrUndefined(this.model.group) && !ej.isNullOrUndefined(this.model.resources) && this.model.group.resources.length > 1) {
                //    if(this.resIndex != this.res1[res][this.model.resources[this.model.resources.length-1].resourceSettings.id])
                //        this._categorybar = true;
                //    this.resIndex = this.res1[res][this.model.resources[this.model.resources.length - 1].resourceSettings.id]
                //}
				var day = 0, diff, count = dateCount.length;
                if (new Date(this._dateRender[0]) < this.model.minDate)
                    day = Math.floor((new Date(this.model.minDate) - new Date(this._dateRender[0])) / (1000 * 60 * 60 * 24));
                if (new Date(this._dateRender[this._dateRender.length - 1]) > this.model.maxDate) {
                    diff = Math.floor((new Date(this._dateRender[this._dateRender.length - 1]) - new Date(this.model.maxDate)) / (1000 * 60 * 60 * 24));
                    count = this._dateRender.length - diff;
                }
                for (day; day < count; day++) {
                    this._getDayAppointments(day, res);
                    //this._appList = [];
                    //for (var app = 0; app < appointmentsList.length; app++) {
                    //    if (!ej.isNullOrUndefined(this.model.group)) {
                    //        if ((Globalize.format(new Date(appointmentsList[app][this.model.appointmentSettings["startTime"]]), this._pattern.d) <= Globalize.format(new Date(dateCount[day]), this._pattern.d)) && (appointmentsList[app][this.model.appointmentSettings[this.model.resources[this.model.resources.length - 1].field]] == this.res1[res].id) && (Globalize.format(new Date(appointmentsList[app][this.model.appointmentSettings["endTime"]]), this._pattern.d) >= Globalize.format(new Date(dateCount[day]), this._pattern.d)) && (Globalize.format(new Date(appointmentsList[app][this.model.appointmentSettings["startTime"]]), this._pattern.d) == Globalize.format(new Date(appointmentsList[app][this.model.appointmentSettings["endTime"]]), this._pattern.d)) && (appointmentsList[app][this.model.appointmentSettings["allDay"]] === false) && (Globalize.format(new Date(appointmentsList[app][this.model.appointmentSettings["startTime"]]), this._pattern.d) <= Globalize.format(new Date(appointmentsList[app][this.model.appointmentSettings["endTime"]]), this._pattern.d))) {
                    //            this._appList.push(appointmentsList[app]);
                    //        }
                    //    }
                    //    else {
                    //        if ((Globalize.format(new Date(appointmentsList[app][this.model.appointmentSettings["startTime"]]), this._pattern.d) <= Globalize.format(new Date(dateCount[day]), this._pattern.d)) && (Globalize.format(new Date(appointmentsList[app][this.model.appointmentSettings["endTime"]]), this._pattern.d) >= Globalize.format(new Date(dateCount[day]), this._pattern.d)) && (Globalize.format(new Date(appointmentsList[app][this.model.appointmentSettings["startTime"]]), this._pattern.d) == Globalize.format(new Date(appointmentsList[app][this.model.appointmentSettings["endTime"]]), this._pattern.d)) && (appointmentsList[app][this.model.appointmentSettings["allDay"]] === false) && (Globalize.format(new Date(appointmentsList[app][this.model.appointmentSettings["startTime"]]), this._pattern.d) <= Globalize.format(new Date(appointmentsList[app][this.model.appointmentSettings["endTime"]]), this._pattern.d))) {
                    //            this._appList.push(appointmentsList[app]);
                    //        }
                    //    }
                    //}

                    for (var i = 0; i < this._appList.length; i++) {
                        this._renderApp(this._appList[i], day, res);
                        this._filtered.push(this._appList[i]);
                    }
                }
              }
        },

    _getDayAppointments: function (day, res) {
        this._appList = [];
        var dateCount = this._dateRender, appointmentsList = this._processed;
        if (this.model.orientation == "vertical") {
            for (var app = 0; app < appointmentsList.length; app++) {
                if (!ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources)
                    this._getMultipleResourceAppList(app, dateCount, appointmentsList, res, day);
                else {
                    var allDayCheck = appointmentsList[app][this.model.appointmentSettings["allDay"]];
                if ((Globalize.format(new Date(appointmentsList[app][this.model.appointmentSettings["startTime"]]), this._pattern.d) <= Globalize.format(new Date(dateCount[day]), this._pattern.d)) && (Globalize.format(new Date(appointmentsList[app][this.model.appointmentSettings["endTime"]]), this._pattern.d) >= Globalize.format(new Date(dateCount[day]), this._pattern.d)) && (Globalize.format(new Date(appointmentsList[app][this.model.appointmentSettings["startTime"]]), this._pattern.d) == Globalize.format(new Date(appointmentsList[app][this.model.appointmentSettings["endTime"]]), this._pattern.d)) && (((ej.isNullOrUndefined(allDayCheck)||allDayCheck == "")? false:allDayCheck=== true ? true:allDayCheck.toLowerCase()==='false'? false : allDayCheck) === false) && (Globalize.format(new Date(appointmentsList[app][this.model.appointmentSettings["startTime"]]), this._pattern.d) <= Globalize.format(new Date(appointmentsList[app][this.model.appointmentSettings["endTime"]]), this._pattern.d))) {
                    var id = (appointmentsList[app][this.model.appointmentSettings["recurrence"]] == undefined || appointmentsList[app].ParentId == undefined) ? this._processed[app].Id : this._processed[app].ParentId;
                    var query = new ej.Query().where(this.model.appointmentSettings["id"], ej.FilterOperators.equal, parseInt(id));
                    var list = this._currentAppointmentData;
                    var templist = new ej.DataManager(list).executeLocal(query);
                    (((new Date(templist[0][this.model.appointmentSettings["endTime"]]) - new Date(templist[0][this.model.appointmentSettings["startTime"]])) / 3600000) > 24) ? this._setAllDayPos(appointmentsList[app], day, res) : this._appList.push(appointmentsList[app]);
                   }
                }
            }
        }
        else if (this.model.orientation == "horizontal" && ej.scheduleFeatures.horizontal)
            this._getHorizontalDayAppointments(appointmentsList, dateCount, day, res);
    },

        /**
    * Section for handle the utc drop down.
    * @private
    */
    _startUtc: function (e) {
        (!ej.isNullOrUndefined(this.startutcValue) && ej.isNullOrUndefined(this.tempValue)) ? this._utcValue(e, "startUtc") : e.model.value == "" ? "" : ((e.model.value == this._appointmentAddWindow.find('#endutc').ejDropDownList('model.value') && this._appointmentAddWindow.find('#startutc').attr('aria-expanded') == "true")) ? this._appointmentAddWindow.find("#endutc").ejDropDownList("option", { text: e.text, value: e.value }) : this._appointmentAddWindow.find("#endutc").val(e.text);
    },
    _endUtc: function (e) {
        (ej.isNullOrUndefined(this.tempValue) && this._appointmentAddWindow.find('#endutc').attr('aria-expanded') == "true") ? this._utcValue(e, "endUtc") : "";
    },
    _utcValue: function (temp, getValue)
    {
           getValue == "endUtc" ? this._appointmentAddWindow.find('.endutc').val(temp.text) : "";
           var utcValue = new Date(this._appointmentAddWindow.find("#" + this._id + "startdate").val() + " " + this._appointmentAddWindow.find("#" + this._id + "starttime").ejTimePicker("model.value"));
           var utcendValue = new Date(this._appointmentAddWindow.find("#" + this._id + "enddate").val() + " " + this._appointmentAddWindow.find("#" + this._id + "endtime").ejTimePicker("model.value"));
           var utcEnd = getValue == "Appoint" ? temp.endutc : getValue == "endUtc" ? temp.value : this._appointmentAddWindow.find("#endutc").ejDropDownList("model.value");
           var utcStart = getValue == "Appoint" ? temp.startutc : getValue == "startUtc" ? temp.value : this._appointmentAddWindow.find("#startutc").ejDropDownList("model.value");
           utcStart = utcStart == "" ? Globalize.format(new Date(), "zzz") : utcStart;
           utcEnd = utcEnd == "" ? Globalize.format(new Date(), "zzz") : utcEnd;
            utcEnd = utcEnd.indexOf("UTC") != -1 ? utcEnd.split(" ")[1].split(":") : utcEnd.split(":");
            var hour = parseInt(utcEnd[0]);
            var minutes = parseInt(utcEnd[1]);
            var local = ((hour * 60) + minutes);
            utcStart = utcStart.indexOf("UTC") != -1 ? utcStart.split(" ")[1].split(":") : utcStart.split(":");
            var hour = parseInt(utcStart[0]);
            var minutes = parseInt(utcStart[1]);
            var startUTC = ((hour * 60) + minutes);
            var startendUtc = local - startUTC;
            utcValue = new Date(utcValue.setMinutes(utcValue.getMinutes() + startendUtc));
            utcendValue = getValue == "Appoint" || getValue == "endUtc" ? new Date(utcendValue.setMinutes(utcendValue.getMinutes() + startendUtc)) : utcValue;
            var different = this._timeMode == "12" ? Globalize.format(new Date(utcValue), this._pattern.t) : Globalize.format(new Date(utcValue), "HH:mm");
            var value = this._timeMode == "12" ? Globalize.format(new Date(utcendValue), this._pattern.t) : Globalize.format(new Date(utcendValue), "HH:mm");
            this._appointmentAddWindow.find('#Schedule1endtime').ejTimePicker({ minTime: different, value: value });
            this.startutcValue = 1;
           
    },
    /**
    * Section to create handle for appointments in row wise.
    * @private
    */
    _rowHandlesOver: function (e) {
        $(e.target).addClass("e-rowcursor");
    },
    /**
    * Section to create handle for appointments in column wise.
    * @private
    */
    _colHandlesOver: function (e) {
        $(e.target).addClass("e-columncursor");
    },
    /**
        * Section for render the appointments from dataSource.
        * @private
        */
    _renderApp: function (record, day, res) {
        var cellHeight = this.element.find(".e-workcells").outerHeight();
        var timeScaleRowCount = (60 / 30);
        var startHour = parseInt(this.model.startHour) < parseInt(this.model.endHour) ? parseInt(this.model.startHour) : 0;
        var endHour = parseInt(this.model.startHour) < parseInt(this.model.endHour) ? parseInt(this.model.endHour) : 24;
        var dateCount = this._dateRender;
        var rStartTime = record[this.model.appointmentSettings["startTime"]];
        var rEndTime = record[this.model.appointmentSettings["endTime"]];

        if (this.model.orientation == "vertical") {         
            var appWidth, appHeight;
           
            if (rStartTime <= rEndTime) {
                var startTime = ((new Date(rStartTime).getHours()) < startHour) ? (new Date(rStartTime).getHours() + (-new Date(rStartTime).getHours()) + (-new Date(rStartTime).getMinutes())) : (new Date(rStartTime).getHours() + (-startHour));
                var endTime = ((new Date(rEndTime).getHours()) > endHour) ? (new Date(rEndTime).getHours() + (-new Date(rEndTime).getHours() + (endHour - startHour)) + (-new Date(rEndTime).getMinutes())) : (new Date(rEndTime).getHours() + (-startHour));
                endTime = (new Date(rEndTime).getHours() == endHour) ? (new Date(endTime).getMinutes() + (-new Date(rEndTime).getMinutes())) : endTime;

                if (endHour <= rEndTime.getHours()) {
                    var endDate = new Date(rEndTime.setHours(endHour, 00, 00));
                    appHeight = (parseFloat(((new Date(endDate).getHours() * 60) + (new Date(endDate).getMinutes())) - ((new Date(rStartTime).getHours() * 60) + (new Date(rStartTime).getMinutes()))) * ((cellHeight) * timeScaleRowCount) / 60) - 3;
                }
                else
                    appHeight = (parseFloat(((new Date(rEndTime).getHours() * 60) + (new Date(rEndTime).getMinutes())) - ((new Date(rStartTime).getHours() * 60) + (new Date(rStartTime).getMinutes()))) * ((cellHeight) * timeScaleRowCount) / 60) - 2;
                var topPosition = parseFloat((new Date(rStartTime).getMinutes())) * (cellHeight) * timeScaleRowCount / 60;

                if (this.model.startHour <= new Date(rStartTime).getHours()) {

                    var overlapList = this._overlapApp(record[this.model.appointmentSettings["id"]], record[this.model.appointmentSettings["startTime"]], record[this.model.appointmentSettings["endTime"]], null);
                    var proxy = this;
                    if (overlapList.length > 1) {
                        //overlapList.push(record);
                        overlapList.sort(function (a, b) {
                        var d1 = a[proxy.model.appointmentSettings["startTime"]];
                        var d2 = b[proxy.model.appointmentSettings["startTime"]];
                            return d1 - d2;
                        });
                        var index = overlapList.indexOf(record);
                        appWidth = (100 / overlapList.length) + 2;
                        this.currentView() === "day" || (this.currentView() == "customview" && this._renderDays == 1) ? appWidth -= 7 : appWidth;
                        this.leftPosition = ((100 / overlapList.length) * (index)) + "%";
                    }
                    else {
                        this.leftPosition = "0";
                        appWidth = 95;
                    }

                    appWidth = (this.currentView() === "week" || this.currentView() === "workweek" || (this.currentView() == "customview" && this._renderDays <= 7)) ? (appWidth - 10) + "%" : appWidth + "%";

                var colorAppointment = this._appointmentColor(record);
                //user-defined Template data rendering
                var userAppTemplId = (this.model.appointmentTemplateId) ? true : false;
                var userTempHtml = this._getUserAppointmentTemplate(record);
                var startTimeDisp = this._timeMode == "12" ? Globalize.format(record[this.model.appointmentSettings["startTime"]], this._pattern.t) : Globalize.format(record[this.model.appointmentSettings["startTime"]], "HH:mm");
                var endTimeDisp = this._timeMode == "12" ? Globalize.format(record[this.model.appointmentSettings["endTime"]], this._pattern.t) : Globalize.format(record[this.model.appointmentSettings["endTime"]], "HH:mm");

                    //   var category = "e-" + record[this.model.appointmentSettings["categorize"]];
                var timeCellhtml = this.appTemplate.render({ id: record[this.model.appointmentSettings["id"]], appHeight: appHeight, rtl: this.model.enableRTL, subject: record[this.model.appointmentSettings["subject"]], startTime: startTimeDisp, endTime: endTimeDisp, left: this.leftPosition, top: topPosition, appWidth: appWidth, userAppTemplId: userAppTemplId, userTemplate: userTempHtml, appClass: "e-appointment", appointData: colorAppointment.appointColor.appointData, appointCustomcss: colorAppointment.appointColor.appointCustomcss, appointtextcolor: colorAppointment.appointColor.appointtextcolor, value: colorAppointment.value, multiDiv: colorAppointment.multiDiv, orientation: this.model.orientation });
                    $(this.element.find("div.e-appointwrapper")[(startTime * 2 * dateCount.length * this.res1.length) + day + (dateCount.length * res)]).append(timeCellhtml);
                }
                //                $(this.element.find("td.e-workcells")[(startTime * 2 * dateCount.length) + day]).addClass("icon-AddGrad");
            }
        }
        else if (this.model.orientation == "horizontal" && ej.scheduleFeatures.horizontal)
            this._renderHorizontalApp(rStartTime, rEndTime, record, day, cellHeight, timeScaleRowCount, startHour, endHour);
    },

    /**
    * Section for get the appointments template from user.
    * @private
    */
    _getUserAppointmentTemplate: function (record) {
        var userTemp = $.templates($(this.model.appointmentTemplateId).html());
        var userTempHtml = userTemp.render(record);
        return userTempHtml;
    },
    /**
    * Section for handle the overlap appointments.
    * @private
    */
    _overlapApp: function (id, appStartTime, appEndTime, resValue) {
        this.overlapList = [];
        if (this.model.orientation == "vertical") {
            for (var i = 0; i < this._appList.length; i++) {

                if ((new Date(this._appList[i][this.model.appointmentSettings["endTime"]]) > new Date(appStartTime)) && (new Date(this._appList[i][this.model.appointmentSettings["startTime"]]) < new Date(appEndTime))
                    && (Globalize.format(new Date(this._appList[i][this.model.appointmentSettings["startTime"]]), this._pattern.d) === Globalize.format(new Date(appStartTime), this._pattern.d))) {
                    this.overlapList.push(this._appList[i]);
                }
            }
        }
        else if (this.model.orientation == "horizontal" && ej.scheduleFeatures.horizontal) {
            for (var i = 0; i < this._appList.length; i++) {
                if (ej.scheduleFeatures.resources && !ej.isNullOrUndefined(this.model.resources)) {
                    if ((new Date(this._appList[i][this.model.appointmentSettings["endTime"]]) > new Date(appStartTime)) && (new Date(this._appList[i][this.model.appointmentSettings["startTime"]]) < new Date(appEndTime))
                        && (this._appList[i][this.model.resources[this.model.resources.length - 1]["field"]] == resValue)
                        && (Globalize.format(new Date(this._appList[i][this.model.appointmentSettings["startTime"]]), this._pattern.d) === Globalize.format(new Date(appStartTime), this._pattern.d))) {
                        this.overlapList.push(this._appList[i]);
                    }
                }
                else {
                    if ((new Date(this._appList[i][this.model.appointmentSettings["endTime"]]) > new Date(appStartTime)) && (new Date(this._appList[i][this.model.appointmentSettings["startTime"]]) < new Date(appEndTime))
                        && (Globalize.format(new Date(this._appList[i][this.model.appointmentSettings["startTime"]]), this._pattern.d) === Globalize.format(new Date(appStartTime), this._pattern.d))) {
                        this.overlapList.push(this._appList[i]);
                    }
                }
            }
        }
        return this.overlapList;
    },
    /**
    * Section for render allday appointments of the schedule.
    * @private
    */
    _renderAllDayAppointments: function () {
        var appHeight = 16;
            var appWidth = this.cellwidth - 20;
            var renderDate = this._dateRender;
            var level = 1; this.level = 0;
            if (!this.model.group) this.res1 = ["0"];
            for (var res = 0; res < this.res1.length; res++) {   
                var day = 0, diff, count = renderDate.length;			
                if (new Date(this._dateRender[0]) < this.model.minDate)
                    day = Math.floor((new Date(this.model.minDate) - new Date(this._dateRender[0])) / (1000 * 60 * 60 * 24));
                if (new Date(this._dateRender[this._dateRender.length - 1]) > this.model.maxDate) {
                    diff = Math.floor((new Date(this._dateRender[this._dateRender.length - 1]) - new Date(this.model.maxDate)) / (1000 * 60 * 60 * 24));
                    count = this._dateRender.length - diff;
                }
                for (day; day < count; day++) {
                    for (var i = 0; i < this._processed.length; i++) {
                        if (!ej.isNullOrUndefined(this.model.resources) && !ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources)
                            this._getMultipleResourceAlldayApp(renderDate, day, res, i);
                        else {
                            if ((Globalize.format(new Date(renderDate[day]), this._pattern.d) == Globalize.format(new Date(this._processed[i][this.model.appointmentSettings["startTime"]]), this._pattern.d)) &&
                    (this._processed[i][this.model.appointmentSettings["allDay"]] === true || (((new Date(this._processed[i][this.model.appointmentSettings["endTime"]]) - new Date(this._processed[i][this.model.appointmentSettings["startTime"]])) / 3600000) > 24))) {
                                this._setAllDayPos(this._processed[i], day, res);
								this._filtered.push(this._processed[i]);
                            }
                        }
                    }
                }
            }
    },
    /**
    * Section for get the overlap appointments count of the schedule.
    * @private
    */
    _getOverlapCount: function (record, day, dateRender, resValue) {
        var len = dateRender.length;
        var appointments = this._processed;
        var filterData = [];
        if (this.model.orientation == "vertical") {
            for (var i = 0; i < appointments.length; i++) {
                if ((Globalize.format(new Date(appointments[i][this.model.appointmentSettings["startTime"]]), this._pattern.d) <= Globalize.format(new Date(dateRender[day]), this._pattern.d)) &&
                (Globalize.format(new Date(appointments[i][this.model.appointmentSettings["endTime"]]), this._pattern.d) >= Globalize.format(new Date(dateRender[day]), this._pattern.d)) &&
                (appointments[i][this.model.appointmentSettings["allDay"]] == true || (Globalize.format(new Date(appointments[i][this.model.appointmentSettings["startTime"]]), this._pattern.d) < Globalize.format(new Date(appointments[i][this.model.appointmentSettings["endTime"]]), this._pattern.d))) &&
                (Globalize.format(new Date(appointments[i][this.model.appointmentSettings["startTime"]]), this._pattern.d) <= Globalize.format(new Date(appointments[i][this.model.appointmentSettings["endTime"]]), this._pattern.d))) {
                    filterData.push(appointments[i]);
                }
            }
        }
        else if (this.model.orientation == "horizontal" && ej.scheduleFeatures.horizontal)
            filterData = this._getHorizontalOverlapCount(appointments, dateRender, day, record, resValue);
        var proxy = this;
        filterData.sort(function (a, b) {
            var d1 = a[proxy.model.appointmentSettings["startTime"]];
            var d2 = b[proxy.model.appointmentSettings["startTime"]];
            return d1 - d2;
        });
        var index = filterData.length > 0 ? filterData.indexOf(record) : 0;
        return index == -1 ? 0 : index;
    },
    /**
        * Section for handle the allday appointments position.
        * @private
        */
        _setAllDayPos: function (record, day, res) {
            var level = this._getOverlapCount(record, day, this._dateRender, null);
            var start = record[this.model.appointmentSettings["startTime"]];
            var end = record[this.model.appointmentSettings["endTime"]];
        if (new Date(start) <= new Date(end)) {
            var dateRender = this._dateRender;
            var appWidth, left = 0, top = 15, appHeight = 15;
            var r_start = new Date(dateRender[0]);
            var r_end = new Date(dateRender[dateRender.length - 1]);
            r_end.setHours(23, 59, 59);
            end = new Date(end) > new Date(r_end) ? r_end : end;
                var noOfDays = Math.ceil((new Date(start) - new Date(r_start)) / (1000 * 3600) / 24);
                var diffInDays = Math.ceil((new Date(end) - new Date(start)) / (1000 * 3600) / 24);
                var cellWidth = this.element.find(".e-alldaycells").width();
                var daysCount = this.currentView() === "week" ? 7 : this.currentView() === "workweek" ? 5 : (this.currentView() == "customview" && this._renderDays <= 7) ? this._renderDays : 1;
                var alldayTr = (!ej.isNullOrUndefined(this.model.group) && !ej.isNullOrUndefined(this.model.resources)) ? this.model.group.resources.length : 0;
                var start_time = (new Date(new Date(start).getFullYear(), new Date(start).getMonth(), new Date(start).getDate()));
                var tdIndex = this.currentView() === "day" ? 0 : this.currentView() === "workweek" ? new Date(start).getDay() - 1 : (this.currentView() == "customview" && (this._renderDays <= 7 || this.model.orientation == "horizontal")) ? this._dateRender.indexOf(start_time.getTime()) : new Date(start).getDay();
				if(!ej.isNullOrUndefined( this.element.find(".e-alldaycells")[tdIndex + (res * daysCount)]))  
                left = (this.model.enableRTL) ? this.element.find(".e-headrealldaytable").width() - this.element.find(".e-alldaycells")[tdIndex + (res * daysCount)].offsetLeft - this.element.find(".e-alldaycells").width() : this.element.find(".e-alldaycells")[tdIndex + (res * daysCount)].offsetLeft;
                appWidth = (diffInDays * cellWidth) - ((diffInDays * cellWidth)*(4/100)); 
                top = (level * top) + (3 * (level + 1)) + this.element.find(".e-headercells").height() + 3 + (alldayTr * $($(".e-headerbar")[0]).height());

                var colorAppointment = this._appointmentColor(record);

                //user-defined Template data rendering
                var userAppTemplId = (this.model.appointmentTemplateId) ? true : false;
            var userTempHtml = this._getUserAppointmentTemplate(record);
               
               var startTimeDisp = this._timeMode == "12" ? Globalize.format(record[this.model.appointmentSettings["startTime"]], this._pattern.t) : Globalize.format(record[this.model.appointmentSettings["startTime"]], "HH:mm");
                var endTimeDisp = this._timeMode == "12" ? Globalize.format(record[this.model.appointmentSettings["endTime"]], this._pattern.t) : Globalize.format(record[this.model.appointmentSettings["endTime"]], "HH:mm");
        //    var category = "e-" + record[this.model.appointmentSettings["categorize"]];
            var alldayCellhtml = this.appTemplate.render({ id: record[this.model.appointmentSettings["id"]], top: top, appHeight: appHeight, rtl: this.model.enableRTL, subject: record[this.model.appointmentSettings["subject"]], startTime: startTimeDisp, endTime: endTimeDisp , appWidth: appWidth + "px", allday: true, left: left + "px", userAppTemplId: userAppTemplId, userTemplate: userTempHtml, appClass: "e-alldayappointment", appointData: colorAppointment.appointColor.appointData, appointCustomcss: colorAppointment.appointColor.appointCustomcss, appointtextcolor: colorAppointment.appointColor.appointtextcolor, value: colorAppointment.value, multiDiv: colorAppointment.multiDiv, orientation: this.model.orientation });
            if (this.level < level) {
                var cellHeight = (level + 1) * (appHeight + 3) + 3;
                this.element.find(".e-alldaycells").css('height', cellHeight + "px");
                this.element.find(".e-emptyalldaytd").css('height', cellHeight + "px");
            }
            this.element.find(".e-headrealldaytable").append(alldayCellhtml);
            this.level = this.level < level ? level : this.level;
        }
        if (level > 0)
            this._reRenderScroller();
        var id = (record[this.model.appointmentSettings["recurrence"]] == undefined || record.ParentId == undefined) ? record.Id : record.ParentId;
        var query = new ej.Query().where(this.model.appointmentSettings["id"], ej.FilterOperators.equal, parseInt(id));
        var list = this._currentAppointmentData;
        var templist = new ej.DataManager(list).executeLocal(query);
        if ((new Date(record[this.model.appointmentSettings["endTime"]])) < (templist[0][this.model.appointmentSettings["endTime"]])) {
            this.element.find(".e-alldayappointment").children(".e-righthandle").remove();
        }
        if ((new Date(record[this.model.appointmentSettings["startTime"]])) > (templist[0][this.model.appointmentSettings["startTime"]])) {
            this.element.find(".e-alldayappointment").children(".e-lefthandle").remove();
        }
        },
        _reRenderScroller: function () {
            var scrollerObj = this.element.find(".e-scroller").data("ejScroller");
            scrollerObj.model.width = this.element.width() - this.element.find(".e-workleftindent").width();
            scrollerObj.model.height = this.scHeight - (this.element.find('.e-draggableworkarea').offset().top - this.element.offset().top)
            scrollerObj.refresh();
            var wdthdiff = (this.currentView() === "month" || (this._isCustomView())) ? 0 : 4;
            var cols = this.currentView() == "workweek" ? 5 : this.currentView() == "day" ? 1 : (this.currentView() == "customview" && this._renderDays <= 7) ? this._renderDays : 7;
            var col = (!ej.isNullOrUndefined(this.model.group) && !ej.isNullOrUndefined(this.model.resources)) ? (this.res1.length * cols) : cols;
            this.element.find(".e-draggableworkarea").width(((this.scWidth > (parseInt(this.model.cellWidth) * col) + this.element.find(".e-scrolltimecells").width() + 18) ? (parseInt(this.model.cellWidth) * col) : this.scWidth - this.element.find(".e-scrolltimecells").width() + wdthdiff - 18));
        },
    /**
    * Section for render the appointments in the month view of schedule.
    * @private
    */
    _renderMonthAppointment: function () {
        this.filterData = []; var filtered = [];
        var renderDate = (this.model.orientation == "vertical") ? this._dateRender : this.monthDays;
        
            // var appointments = this.model.appointmentSettings["dataSource"];
            var appointments = this._processed; //this._dataProcessing(this.dataSource());
            if (!this.model.group) this.res1 = ["0"];
            for (var res = 0; res < this.res1.length; res++) {   
			var day = 0, diff, count = renderDate.length;
                if (new Date(renderDate[0]) < this.model.minDate) 
                    day = Math.floor((new Date(this.model.minDate) - new Date(renderDate[0])) / (1000 * 60 * 60 * 24));
                if (new Date(renderDate[renderDate.length - 1]) > this.model.maxDate) {
                    diff = Math.floor((new Date(renderDate[renderDate.length - 1]) - new Date(this.model.maxDate)) / (1000 * 60 * 60 * 24));
                    count = renderDate.length - diff;
                }
                for (day; day < count ; day++) {
                    this.filterData = [];
                    for (var app = 0; app < appointments.length; app++) {
                        if (!ej.isNullOrUndefined(this.model.resources) && !ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources)
                            this._getMonthAppList(renderDate, day, appointments, app, res);
                        else {
                            if ((appointments[app][this.model.appointmentSettings["allDay"]] == true) || (((new Date(appointments[app][this.model.appointmentSettings["endTime"]]) - new Date(appointments[app][this.model.appointmentSettings["startTime"]])) / 3600000) > 24)) {
                                if ((Globalize.format(new Date(renderDate[day]), this._pattern.d) == Globalize.format(new Date(appointments[app][this.model.appointmentSettings["startTime"]]), this._pattern.d)) &&
                    (Globalize.format(new Date(renderDate[day]), this._pattern.S) <= Globalize.format(new Date(appointments[app][this.model.appointmentSettings["endTime"]]), this._pattern.S)) &&
                    (Globalize.format(new Date(appointments[app][this.model.appointmentSettings["startTime"]]), this._pattern.S) <= Globalize.format(new Date(appointments[app][this.model.appointmentSettings["endTime"]]), this._pattern.S))) {
                                    this.filterData.push(appointments[app]);
                                }
                            } else {
                                if ((Globalize.format(new Date(renderDate[day]), this._pattern.d) == Globalize.format(new Date(appointments[app][this.model.appointmentSettings["startTime"]]), this._pattern.d)) &&
         (Globalize.format(new Date(renderDate[day]), this._pattern.d) <= Globalize.format(new Date(appointments[app][this.model.appointmentSettings["endTime"]]), this._pattern.d)) &&
         (Globalize.format(new Date(appointments[app][this.model.appointmentSettings["startTime"]]), this._pattern.d) <= Globalize.format(new Date(appointments[app][this.model.appointmentSettings["endTime"]]), this._pattern.d))) {
                                    this.filterData.push(appointments[app]);
                                }
                            }
                        }
                    }
                    for (var i = 0; i < this.filterData.length; i++) {
                        //var level = this._getIndex(day, filterData[i], renderDate, appointments);
                        this._renderAppointmentMonth(this.filterData[i], day, res);
                        filtered.push(this.filterData[i]);
                    }
                }
            }
            if(this.model.enableAppointmentNavigation)
                this._nextPrevButton(filtered);
        },
        /**
    * Wiring the events to resize appointments .
    * @private
    */
    _wireResizeEvents: function () {
        if (this.model.enableAppointmentResize && !this.model.readOnly) {
            this._on(this.element.find("div.e-lefthandle,div.e-righthandle,div.e-tophandle,div.e-bottomhandle"), "mousedown", $.proxy(this._appointmentResizeStart, this));
            this._on(this.element.find("div.e-lefthandle,div.e-righthandle"), "mouseover", $.proxy(this._colHandlesOver, this));
            this._on(this.element.find("div.e-tophandle,div.e-bottomhandle"), "mouseover", $.proxy(this._rowHandlesOver, this));
        }
    },
    /**
    * Unwiring the events to resize appointments .
    * @private
    */
    _unWireResizeEvents: function () {
        if (this.model.enableAppointmentResize) {
            //Unwire events 
            this._off(this.element.find("div.e-lefthandle,div.e-righthandle,div.e-tophandle,div.e-bottomhandle"), "mousedown", $.proxy(this._appointmentResizeStart, this));
            this._off(this.element.find("div.e-lefthandle,div.e-righthandle"), "mouseover", $.proxy(this._colHandlesOver, this));
            this._off(this.element.find("div.e-tophandle,div.e-bottomhandle"), "mouseover", $.proxy(this._rowHandlesOver, this));
        }
    },
    /**
    * Section for get the index to render the appointment.
    * @private
    */
    _getIndex: function (day, record, dateRender, appointments, resValue) {
        var proxy = this;
        appointments.sort(function (a, b) {
            var d1 = a[proxy.model.appointmentSettings["startTime"]];
            var d2 = b[proxy.model.appointmentSettings["startTime"]];
            return d1 - d2;
        });
        var len = dateRender.length;
        var data = [];
        for (var app = 0; app < appointments.length; app++) {
            if (this.model.orientation == "horizontal" && ej.scheduleFeatures.resources && !ej.isNullOrUndefined(this.model.group)) {
                if ((Globalize.format(new Date(appointments[app][this.model.appointmentSettings["startTime"]]), this._pattern.d) <= Globalize.format(new Date(dateRender[day]), this._pattern.d)) &&
                (Globalize.format(new Date(appointments[app][this.model.appointmentSettings["endTime"]]), this._pattern.d) >= Globalize.format(new Date(dateRender[day]), this._pattern.d)) &&
                (appointments[app][this.model.resources[this.model.resources.length - 1]["field"]] == resValue) &&
                (Globalize.format(new Date(appointments[app][this.model.appointmentSettings["startTime"]]), this._pattern.d) <= Globalize.format(new Date(appointments[app][this.model.appointmentSettings["endTime"]]), this._pattern.d))) {
                    data.push(appointments[app]);
                }
            }
            else {
                if ((Globalize.format(new Date(appointments[app][this.model.appointmentSettings["startTime"]]), this._pattern.d) <= Globalize.format(new Date(dateRender[day]), this._pattern.d)) &&
                (Globalize.format(new Date(appointments[app][this.model.appointmentSettings["endTime"]]), this._pattern.d) >= Globalize.format(new Date(dateRender[day]), this._pattern.d)) &&
                (Globalize.format(new Date(appointments[app][this.model.appointmentSettings["startTime"]]), this._pattern.d) <= Globalize.format(new Date(appointments[app][this.model.appointmentSettings["endTime"]]), this._pattern.d))) {
                    data.push(appointments[app]);
                }
            }
        }
        this.overlapList = data;
        var index = data.length > 0 ? data.indexOf(record) : 0;
        return index;
    },
    /**
        * Render the appointments in the month view.
        * @private
        */
    _renderAppointmentMonth: function (record, day, res) {

        // var renderDate = this._dateRender;
        var renderDate = (this.model.orientation == "vertical") ? this._dateRender : this.monthDays;
        var overlapCount = (ej.scheduleFeatures.resources && !ej.isNullOrUndefined(this.model.group) && !ej.isNullOrUndefined(this.model.resources)) ? this._getIndex(day, record, renderDate, this._processed, record[this.model.appointmentSettings.resourceFields.toString().split(',')[this.model.resources.length - 1]]) : this._getIndex(day, record, renderDate, this._processed, null);
        var startTime = new Date(record[this.model.appointmentSettings["startTime"]]);
        var endTime = new Date(record[this.model.appointmentSettings["endTime"]]);
        var appHeight = 18;
        var appWidth, topPosition = 0;
        this.leftPosition = 0;
        this.CellWidth = this.model.orientation == "vertical" ? this.element.find(".e-monthcells").width() : this.element.find(".e-workcells").width();
        this.CellHeight = this.model.orientation == "vertical" ? this.element.find(".e-monthcells").height() : this.element.find(".e-workcells").height();

        var start = (Globalize.format(startTime, this._pattern.d));
        var end = (Globalize.format(endTime, this._pattern.d));
        var r_end = new Date(renderDate[renderDate.length - 1]);
        end = new Date(end) > new Date(r_end) ? r_end : end;
        var maxDays = 7 - (new Date(start).getDay());
        var diffInDays = Math.ceil((new Date(end) - new Date(start)) / (1000 * 3600) / 24) + 1;
        

        if (startTime <= endTime) {
            if (this.model.orientation == "vertical") {
                diffInDays = diffInDays >= maxDays ? maxDays : diffInDays;
                var rowPosition = Math.ceil((day + 1) / 7);
                if (Globalize.format(startTime, this._pattern.d) != Globalize.format(endTime, this._pattern.d))
                    appWidth = (diffInDays * this.CellWidth) - 15 - diffInDays;
                else
                    appWidth = (this.CellWidth * 6) / 7;
            }
            else
                appWidth = (diffInDays * this.CellWidth);
             var resIndex = (!ej.isNullOrUndefined(this.model.resources) && !ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources) ? this._findResourceIndex(this.res1, this.model.resources[this.model.resources.length - 1].resourceSettings.id, record[this.model.appointmentSettings.resourceFields.toString().split(',')[this.model.resources.length - 1]]) : 0;
            var cellId = this.model.orientation == "vertical" ? (resIndex * (7) + (new Date(startTime).getDay() + 1)) + ((rowPosition - 1) * (this.res1.length * 7)) : day + 1;    // (7 * (rowPosition - 1)) + (new Date(startTime).getDay() + 1);

            topPosition = (overlapCount * appHeight);
            this.leftPosition = 0;

            if(!ej.isNullOrUndefined(this.model.resources))
            var newResCollection = this._getResourceCollection();
            //var groupIndex = this._findResourceIndex(newResCollection[0].dataSource, "id", record[this.model.appointmentSettings.resourceFields.toString().split(',')[this.model.resources.length - 2]]);
            //var resValue = this._findResourceIndex(this.level_Resources, "id", record[this.model.appointmentSettings.resourceFields.toString().split(',')[this.model.resources.length - 1]]);
            var groupIndex = (!ej.isNullOrUndefined(this.model.group) && this.model.group.resources.length > 1) ? this._findResourceIndex(newResCollection[0].dataSource, newResCollection[0].id, record[this.model.appointmentSettings.resourceFields.toString().split(',')[this.model.resources.length - 2]]) + 1 : 0;
            var resValue = (!ej.isNullOrUndefined(this.model.group) && !ej.isNullOrUndefined(this.model.resources)) ? this._findResourceIndex(this.level_Resources, this.model.resources[this.model.resources.length - 1].resourceSettings.id, record[this.model.appointmentSettings.resourceFields.toString().split(',')[this.model.resources.length - 1]]) + 1 : 1;
            var colorAppointment = this._appointmentColor(record);
            if ((this._isCustomView() && this.model.orientation == "vertical" ? this.element.find('.e-monthcells').height() > this.element.find('.e-monthheader').height() + appHeight : (overlapCount * (appHeight + 21)) < (this.CellHeight))) {
                appHeight -= 2;
                if (topPosition > 1) topPosition -= 1;
                if (this.leftPosition > 1) this.leftPosition -= 1;

                

                //user-defined Template data rendering
                var userAppTemplId = (this.model.appointmentTemplateId) ? true : false;
                var userTempHtml = this._getUserAppointmentTemplate(record);

                var startTimeDisp = this._timeMode == "12" ? Globalize.format(record[this.model.appointmentSettings["startTime"]], this._pattern.t) : Globalize.format(record[this.model.appointmentSettings["startTime"]], "HH:mm");
                var endTimeDisp = this._timeMode == "12" ? Globalize.format(record[this.model.appointmentSettings["endTime"]], this._pattern.t) : Globalize.format(record[this.model.appointmentSettings["endTime"]], "HH:mm");
                //   var category = "e-" + record[this.model.appointmentSettings["categorize"]];
                var timeCellhtml = this.appTemplate.render({ id: record[this.model.appointmentSettings["id"]], appHeight: appHeight, rtl: this.model.enableRTL, subject: record[this.model.appointmentSettings["subject"]], startTime: startTimeDisp, endTime: endTimeDisp, left: this.leftPosition + "px", top: topPosition, appWidth: appWidth + "px", userAppTemplId: userAppTemplId, userTemplate: userTempHtml, appClass: "e-monthappointment", appointData: colorAppointment.appointColor.appointData, appointCustomcss: colorAppointment.appointColor.appointCustomcss, appointtextcolor: colorAppointment.appointColor.appointtextcolor, value: colorAppointment.value, multiDiv: colorAppointment.multiDiv });
                if (this.model.orientation == "vertical")
                    $(this.element.find("div.e-appointwrapper")[cellId - 1]).append(timeCellhtml);
                else if (this.model.orientation == "horizontal" && ej.scheduleFeatures.horizontal) {
                    $($(this.element.find(".e-workcellstab tr")[resValue + groupIndex - 1]).find("div.e-appointwrapper")[cellId - 1]).append(timeCellhtml);
                    if (!ej.isNullOrUndefined(this.model.group) && this.model.group.resources.length > 0) {
                        var appointColor = this._getResourceColor(record);
						var categoryClass= (appointColor.appointData == "")?"e-categorycolor":"";
                        $($($(this.element.find(".e-workcellstab tr").find("td.e-resourceheadercells")).parent()[groupIndex - 1]).find("div.e-appointwrapper")[cellId - 1]).append("<div class='e-categorybar "+categoryClass+"' id='categorybar_'" + record[this.model.appointmentSettings["id"]] + " style='position:absolute;height:" + (this.CellHeight - 3) + "px;background:" + appointColor.appointData + ";width:" + (appWidth + 1) + "px;left:" + this.leftPosition + "px;'></div>");
                    }
                }
                //this.element.find("div.e-draggableworkarea").append(timeCellhtml);
                timeCellhtml = "";
            }
            else {
                if ($("#" + this._id + "_" + Globalize.format(new Date(record[this.model.appointmentSettings["startTime"]]), "MM_dd_yyyy") + "_" + (resValue + groupIndex - 1) + "_" + (cellId - 1)).length == 0) {
                    if (this.model.orientation == "vertical") {
                        $(this.element.find("div.e-appointwrapper")[cellId - 1]).append('<div id="' + this._id + "_" + Globalize.format(new Date(record[this.model.appointmentSettings["startTime"]]), "MM_dd_yyyy") + "_" + (resValue + groupIndex - 1) + "_" + (cellId - 1) + '" class="e-icon e-appsoverflow"></div>');
                        topPosition = this.element.find('.e-monthcells').height() < 30 ? this.element.find('.e-monthcells').height() - (this.element.find('.e-monthheader').height() + (this.element.find('.e-appsoverflow').height() - 7)) : topPosition;
                    }
                    else {
                        $($(this.element.find(".e-workcellstab tr")[resValue + groupIndex - 1]).find("div.e-appointwrapper")[cellId - 1]).append('<div id="' + this._id + "_" + Globalize.format(new Date(record[this.model.appointmentSettings["startTime"]]), "MM_dd_yyyy") + "_" + (resValue + groupIndex - 1) + "_" + (cellId - 1) + '" class="e-icon e-appsoverflow"></div>');
                    }
                    this.element.find("#" + this._id + "_" + Globalize.format(new Date(record[this.model.appointmentSettings["startTime"]]), "MM_dd_yyyy") + "_" + (resValue + groupIndex - 1) + "_" + (cellId - 1)).css(this.model.enableRTL ? "right" : "left", (this.CellWidth + this.leftPosition - 25) + "px").css("top", topPosition + "px");
                }
            }
        }
        if (!record[this.model.appointmentSettings["recurrence"]]) {
            var id = (record.ParentId == undefined) ? record.Id : record.ParentId;
            var query = new ej.Query().where(this.model.appointmentSettings["id"], ej.FilterOperators.equal, id);
            var templist = new ej.DataManager(this._currentAppointmentData).executeLocal(query);
            if ((new Date(record[this.model.appointmentSettings["endTime"]])) < (templist[0][this.model.appointmentSettings["endTime"]])) {
                $(this.element.find("div.e-appointwrapper")[cellId - 1]).find(".e-monthappointment").children(".e-righthandle").remove();
            }
            if ((new Date(record[this.model.appointmentSettings["startTime"]])) > (templist[0][this.model.appointmentSettings["startTime"]])) {
                $(this.element.find("div.e-appointwrapper")[cellId - 1]).find(".e-monthappointment").children(".e-lefthandle").remove()
            }
        }
    },
    
    /**
    * Section for handle the quick window close.
    * @private
    */
    _quickWindowClose: function () {
        this._quickAppointWindow.ejDialog("close");
        this._processFocus();
    },
    /**
    * Section for create the appointment window.
    * @private
    */
    _appointmentWindow: function (e) {
        var event = { startTime: new Date(this.cur_StartTime), endTime: this.cur_EndTime, target: e };
        var startTime, endTime, _target = !ej.isNullOrUndefined(e.target) ? $(e.target) : $(e);
        if (this._trigger("cellDoubleClick", event) || _target.hasClass("e-categorybar"))
            return false;
        if ((_target.hasClass("e-workcells") || _target.hasClass("e-alldaycells") || _target.hasClass("e-monthcells") || this._cellClick || _target.hasClass("e-detailedapp")) && !_target.hasClass("e-resourceheadercells")) {
            this._currentAction = ej.Schedule.Actions.Add;
            this._appointmentAddWindow.find(".e-recurwindow").css("display", "none");
            this._appointmentAddWindow.find(".e-appwindow").css("display", "block");
            var index = this._cellIndex;
            var renderDate = (this.model.orientation == "horizontal" && this.model.currentView == "month") ? this.monthDays : this.model.orientation == "vertical" ? this.dateRender : this._dateRender;
            var curDate = new Date(renderDate[index]);
            if ((this.model.minDate > curDate || this.model.maxDate < curDate)) { return false; }
            if (!this._cellClick) {
                this.currentDate(new Date(this.dateRender[index]));
                if (_target.hasClass("e-workcells")) {
                    var time = this.model.startHour + (_target.parent().index() / 2);
                    var timemin = time.toString().split(".");
                    startTime = new Date(this.currentDate()).setHours(parseInt(timemin[0]), parseInt(timemin[1]) == 5 ? 30 : 00);
                    endTime = new Date(new Date(startTime).setMinutes(new Date(startTime).getMinutes() + 30));
                }
                else if (_target.hasClass("e-monthcells")) {
                    startTime = new Date(new Date(this.currentDate()).setHours(9));
                    startTime = new Date(startTime).setMinutes(00); //.setHours(00)).setMinutes(00);
                    endTime = new Date(new Date(startTime).setMinutes(30)); //.setHours(23)).setMinutes(59));
                }
                else {
                    startTime = new Date(this.currentDate()); //.setHours(00)).setMinutes(00);
                    endTime = new Date(startTime); //.setHours(23)).setMinutes(59));
                    this._appointmentAddWindow.find(".allday ").ejCheckBox({ checked: true });
                }
            } else {
                startTime = new Date(this.cur_StartTime);
                endTime = new Date(this.cur_EndTime);
            }
            if (this._trigger("appointmentWindowOpen", event))
                return false;
            this._appointmentAddWindow.find("#" + this._id + "subject").val(this.model.showQuickWindow ? this._quickAppointWindow.find(".subject").val() : "");
            this._appointmentAddWindow.find("#" + this._id + "startdate").ejDatePicker("option", { value: Globalize.format(new Date(startTime), this._datepattern()), minDate: this.model.minDate, maxDate: this.model.maxDate });
            this._appointmentAddWindow.find("#" + this._id + "enddate").ejDatePicker("option", { value: Globalize.format(new Date(endTime), this._datepattern()), minDate: this.model.minDate, maxDate: this.model.maxDate });
            this._appointmentAddWindow.find("#" + this._id + "starttime").ejTimePicker("option", "value", Globalize.format(new Date(startTime), this._pattern.t));
            this._appointmentAddWindow.find("#" + this._id + "endtime").ejTimePicker("option", "value", Globalize.format(new Date(endTime), this._pattern.t));
            ($(e.currentTarget).hasClass("e-alldaycells") || this.currentView() == "month" || (this._isCustomView())) && this._appointmentAddWindow.find(".allday").ejCheckBox({ checked: true });            
            this._timeZoneCollection(null);
            this._alldayCheck();           
            if (ej.scheduleFeatures.resources && !ej.isNullOrUndefined(this.model.resources))
                this._renderResourceData(_target, this._cellIndex);
            if (!this.model.readOnly)
            { 
                this._appointmentAddWindow.find(".e-appsave,#donerecur").ejButton("enable", true);
                (this._mediaQuery) && this._appointmentAddWindow.find(".e-btndelete").css("display", "none");
                this._appointmentAddWindow.ejDialog("open");
            }
            (!this._mediaQuery) && this._appointmentAddWindow.find(".subject").focus();
            this._cellClick = false;
        }
        else {
            if (!_target.hasClass("e-resourceheadercells")) {
			if(_target.hasClass("e-monthheader")) return false;
                var target = (this._editKey) ? $(e) : _target.hasClass("e-appointment") || _target.hasClass("e-monthappointment") || _target.hasClass("e-alldayappointment") ? _target : _target.parents('.e-monthappointment,.e-appointment,.e-alldayappointment');
                if (!ej.isNullOrUndefined(target[0].id)) {
                    this._currentAction = ej.Schedule.Actions.Save;
                    this._appId = parseInt(target[0].id.split("_")[1]);
                    var query = new ej.Query().where(this.model.appointmentSettings["id"], ej.FilterOperators.equal, this._appId);
                    var templist = new ej.DataManager(this._processed).executeLocal(query);
                    if (templist[0][this.model.appointmentSettings["recurrence"]] == 1) {
                        this._parentId = templist[0]["ParentId"];
                        this._recurEditWindow.find(".e-editonly").ejRadioButton({ checked: true });
                        this._recurEditWindow.ejDialog("open");
                        this._recurEditWindow.focus();
                    }
                    else {
                        var query = new ej.Query().where(this.model.appointmentSettings["id"], ej.FilterOperators.equal, this._appId);
                        var temp = new ej.DataManager(this._processed).executeLocal(query);
                        this._appId = temp[0].ParentId;
                        this._showAppointmentDetails(this._appId);
                    }
                    this.model.showQuickWindow && this._quickAppDetailsWindow.ejDialog("close");
                }
                this._editKey = false;
            }
        }
        this.model.showQuickWindow && this._quickAppointWindow.ejDialog("close");
    },
    /**
    * Section for toggle the appointment window.
    * @private
    */
    _editRecurrence: function (args) {
        this._appointmentAddWindow.find(".e-appwindow").toggle();
        (this._mediaQuery) && this._appointmentAddWindow.parent().parent().find(".e-dialog-icon").css("display", "none");
        this._appointmentAddWindow.find(".e-recurwindow").css("margin-left", 700).toggle().animate({ "margin-left": 10 }, 300);
    },
    /**
    * Section for show all the required details to the window while editing.
    * @private
    */
    _showAppointmentDetails: function (appId, editOcurrence) {
        var query = new ej.Query().where(this.model.appointmentSettings["id"], ej.FilterOperators.equal, parseInt(appId));
        var list = editOcurrence == true ? this._processed : this._currentAppointmentData;
        var templist = new ej.DataManager(list).executeLocal(query);
        this._appointmentAddWindow.find('.subject').val(templist[0][this.model.appointmentSettings["subject"]]);
        this._appointmentAddWindow.find('.id').val(templist[0][this.model.appointmentSettings["id"]]);
        this._appointmentAddWindow.find('.e-description').val(templist[0][this.model.appointmentSettings["description"]] ? templist[0][this.model.appointmentSettings["description"]] : "");
        var temp = templist[0];
        this._appointmentAddWindow.find("#" + this._id + "startdate").ejDatePicker("option", "value", Globalize.format(temp[this.model.appointmentSettings["startTime"]], this._datepattern()));
        this._appointmentAddWindow.find("#" + this._id + "enddate").ejDatePicker("option", "value", Globalize.format(temp[this.model.appointmentSettings["endTime"]], this._datepattern()));
        this._appointmentAddWindow.find("#" + this._id + "starttime").ejTimePicker("option", "value", Globalize.format(temp[this.model.appointmentSettings["startTime"]], this._pattern.t));
        this._appointmentAddWindow.find("#" + this._id + "endtime").ejTimePicker("option", "value", Globalize.format(temp[this.model.appointmentSettings["endTime"]], this._pattern.t));

        this._timeZoneCollection(temp);

        templist[0][this.model.appointmentSettings["allDay"]] == 1 && (this._appointmentAddWindow.find(".allday ").ejCheckBox({ checked: true }));
        if (templist[0][this.model.appointmentSettings["recurrence"]] == 1) {
            if (editOcurrence == true) {
                (!ej.isNullOrUndefined(templist[0][this.model.appointmentSettings["recurrenceRule"]]) && templist[0][this.model.appointmentSettings["recurrenceRule"]].toString().indexOf("RECUREDITID") != -1) && (this._currentAction = ej.Schedule.Actions.Save);
                this._appointmentAddWindow.find(".recurrence").ejCheckBox({ checked: true, enabled: false });
                this._appointmentAddWindow.find(".e-repeatlbl").addClass('e-disable');
                this._appointmentAddWindow.find("." + this._id + "summary").css("display", "none");
                this._appointmentAddWindow.find(".e-recurFinalRule").html("");
                this._recRule = templist[0][this.model.appointmentSettings["recurrenceRule"]];
            }
            else {
                this.recurrenceRuleSplit(templist[0][this.model.appointmentSettings["recurrenceRule"]]);
                this._appointmentAddWindow.find(".recurstartdate").ejDatePicker({ value: Globalize.format(temp[this.model.appointmentSettings["startTime"]], this._datepattern()) });
                this._appointmentAddWindow.find("." + this._id + "summary").css("display", "table-row");
                this._appointmentAddWindow.find(".e-recurFinalRule").html(this._showRecurrenceFields(appId));
                this._appointmentAddWindow.find(".recurrence").ejCheckBox({ checked: true });
                    this._appointmentAddWindow.find(".e-recuredit").css("display", "inline");
                }
            }
        if (this.model.categorizeSettings.enable && !ej.isNullOrUndefined(temp[this.model.appointmentSettings["categorize"]])) {
            this._showCategorizeDetails(temp);
        }
            if (!ej.isNullOrUndefined(this.model.resources) && ej.scheduleFeatures.resources)
                this._showMultipleResourceDetails(temp);
            var data = { appointment: templist[0], edit: editOcurrence };
            if (this._trigger("appointmentWindowOpen", data))
                return false;
        this._alldayCheck();
	    var enableDisable = (this.model.readOnly) ? "disable" : "enable";
	    this._appointmentAddWindow.find(".e-appsave,#donerecur").ejButton(enableDisable, true);
	    (this._mediaQuery) && this._appointmentAddWindow.find(".e-btndelete").css("display", "block");
        this._appointmentAddWindow.ejDialog("open");
        (!this._mediaQuery) && this._appointmentAddWindow.find(".subject").focus();
    },
    /**
    * Section for show the recurrence details in the recurrence window.
    * @private
    */
    _showRecurrenceFields: function (appId) {
        var _recurRule = "", _recurOpt = "", _recurType = this._appointmentAddWindow.find('.recurtype');
        _recurRule = ej.isNullOrUndefined(this._rRule.interval) ? this._getLocalizedLabels("Every") + " " : this._getLocalizedLabels("Every") + " " + this._rRule.interval + " ";
        switch (this._rRule.freq) {
            case "DAILY":
                _recurType.ejDropDownList({ selectedItemIndex: 0 });
                _recurRule += this._getLocalizedLabels("RecurrenceDay").toLowerCase();
                break;
            case "WEEKLY":
                _recurType.ejDropDownList({ selectedItemIndex: 1 });
                this._appointmentAddWindow.find('.weekdays').ejCheckBox({ checked: false });
                var _days = this._rRule.weekDays.split(',');
                for (var i = 0; i < _days.length; i++) {
                    this._appointmentAddWindow.find('.e-weekly' + _days[i]).ejCheckBox({ checked: true });
                    _recurOpt += this._dayShortNames[this._dayNames.indexOf(_days[i])] + (i == _days.length - 1 ? "" : ", ");
                }
                _recurRule += this._getLocalizedLabels("RecurrenceWeek").toLowerCase() + " " + this._getLocalizedLabels("On").toLowerCase() + " " + _recurOpt;
                break;
            case "MONTHLY":
                _recurType.ejDropDownList({ selectedItemIndex: 2 });
                if (!ej.isNullOrUndefined(this._rRule.monthDay)) {
                    this._appointmentAddWindow.find('.e-monthdaytype').ejRadioButton({ checked: true });
                    this._appointmentAddWindow.find('.e-monthdate').ejNumericTextbox({ value: parseInt(this._rRule.monthDay) });
                    _recurOpt = parseInt(this._rRule.monthDay);
                }
                else {
                    this._appointmentAddWindow.find('.e-monthposition').ejRadioButton({ checked: true });
                    this._appointmentAddWindow.find('.e-monthsrtday').ejDropDownList({ selectedItemIndex: this._dayNames.indexOf(this._rRule.weekDays) });
                    this._appointmentAddWindow.find('.monthsrt').ejDropDownList({ selectedItemIndex: this._rRule.setPositions - 1 });
                    _recurOpt = this._appointmentAddWindow.find('.monthsrt').ejDropDownList("option", "value").toLowerCase() + " " + this._dayFullNames[this._dayNames.indexOf(this._rRule.weekDays)];
                }
                _recurRule += this._getLocalizedLabels("RecurrenceMonth").toLowerCase() + " " + this._getLocalizedLabels("On").toLowerCase() + " " + _recurOpt;
                break;
            case "YEARLY":
                _recurType.ejDropDownList({ selectedItemIndex: 3 });
                if (!ej.isNullOrUndefined(this._rRule.monthDay)) {
                    this._appointmentAddWindow.find('.e-yearrecurday').ejRadioButton({ checked: true });
                    this._appointmentAddWindow.find('.yearmonth').ejDropDownList({ selectedItemIndex: this._rRule.month - 1 });
                    this._appointmentAddWindow.find('.yeardate').ejNumericTextbox({ value: parseInt(this._rRule.monthDay) });
                    _recurOpt = this._monthNames[this._rRule.month - 1] + " " + parseInt(this._rRule.monthDay);
                }
                else {
                    this._appointmentAddWindow.find('.e-yearrecurposi').ejRadioButton({ checked: true });
                    this._appointmentAddWindow.find('.yearsrtday').ejDropDownList({ selectedItemIndex: this._dayNames.indexOf(this._rRule.weekDays) });
                    this._appointmentAddWindow.find('.yearsrtmonth').ejDropDownList({ selectedItemIndex: this._rRule.month - 1 });
                    this._appointmentAddWindow.find('.yearsrt').ejDropDownList({ selectedItemIndex: this._rRule.setPositions - 1 });
                    _recurOpt = this._appointmentAddWindow.find('.yearsrt').ejDropDownList("option", "value").toLowerCase() + " " + this._dayFullNames[this._dayNames.indexOf(this._rRule.weekDays)] + " " + this._monthNames[this._rRule.month - 1];
                }
                _recurRule += this._getLocalizedLabels("RecurrenceYear").toLowerCase() + " " + this._getLocalizedLabels("On").toLowerCase() + " " + _recurOpt;
                break;
        }
        // Recurrence interavel
        this._appointmentAddWindow.find('.e-recurevery').ejNumericTextbox({ value: ej.isNullOrUndefined(this._rRule.interval) ? 1 : this._rRule.interval });

        //Recurrence end 
        if (!ej.isNullOrUndefined(this._rRule.count)) {
            this._appointmentAddWindow.find(".e-recurafter").ejRadioButton({ checked: true });
            this._appointmentAddWindow.find('.e-recurcount').ejNumericTextbox({ value: this._rRule.count });
            _recurRule += ", " + this._rRule.count + this._getLocalizedLabels("Times").toLowerCase();
        }
        else if (!ej.isNullOrUndefined(this._rRule.until)) {
            this._appointmentAddWindow.find(".e-recuruntil").ejRadioButton({ checked: true });
            this._appointmentAddWindow.find('.e-until').ejDatePicker({ value: new Date(this._rRule.until) });
            _recurRule += " " + this._getLocalizedLabels("Until").toLowerCase() + " " + Globalize.format(new Date(this._rRule.until), this._datepattern());
        }
        else
            this._appointmentAddWindow.find(".e-recurnoend").ejRadioButton({ checked: true });

        return _recurRule;
    },
    /**
    * Section for handle the closing of recurrence window.
    * @private
    */
    _closerecur: function (args) {
        if (args.model.text == "Cancel") {
            this._appointmentAddWindow.find(".e-recurFinalRule").html() == "" && this._appointmentAddWindow.find("#" + this._id + "recurrence").ejCheckBox({ checked: false });
        }
        else {
            var interval, monthDate, endRecur = "", recurOption = "";
            interval = this._findInterval(this._appointmentAddWindow.find('.e-recurevery'));
            switch (this._rRuleFreq) {
                case "DAILY":
                    this._recRule = "FREQ=" + this._rRuleFreq + ";INTERVAL=" + interval;
                    break;
                case "WEEKDAYS":
                    this._recRule = "FREQ=WEEKLY;BYDAY=MO,TU,WE,TH,FR";
                    break;
                case "WEEKLY":
                    var _weekChkList = this._appointmentAddWindow.find("input[name='weekdays']");
                    var _weekRule = "", _dayName = "", _byDay = "";
                    for (var i = 0; i < _weekChkList.length; i++) {
                        $(_weekChkList[i]).ejCheckBox("option", "checked") == true ? _weekRule += (_weekRule != "" ? "," : "") + this._dayNames[i].toUpperCase() : "";
                        $(_weekChkList[i]).ejCheckBox("option", "checked") == true ? _dayName += (_dayName != "" ? ", " : "") + this._dayShortNames[i] : "";
                    }
                    if (_weekRule == "") {
                       var date =this._appointmentAddWindow.find('.recurstartdate').ejDatePicker("option","value");
                       _weekRule = this._dayNames[date.getDay()].toUpperCase();
                    }
                    var _rule = this._getLocalizedLabels("RecurrenceWeek").toLowerCase() + " on " + _dayName;
                    this._appointmentAddWindow.find(".e-recurRule").html(_rule);
                    this._recRule = "FREQ=" + this._rRuleFreq + ";INTERVAL=" + interval + ";" + "BYDAY=" + _weekRule;
                    break;
                case "MONTHLY":
                    if (this._appointmentAddWindow.find('.e-monthdaytype').ejRadioButton("option", "checked")) {
                        monthDate = this._appointmentAddWindow.find('.e-monthdate').ejNumericTextbox("option", "value");
                        this._recRule = "FREQ=" + this._rRuleFreq + ";BYMONTHDAY=" + monthDate + ";INTERVAL=" + interval
                        recurOption = " " + this._getLocalizedLabels("On").toLowerCase() + " " + monthDate;
                    }
                    else {
                        var _setPos = this._appointmentAddWindow.find('.monthsrt').ejDropDownList("option", "selectedItemIndex");
                        var dayName = this._appointmentAddWindow.find('.e-monthsrtday').ejDropDownList("option", "selectedItemIndex");
                        _setPos = _setPos < 4 ? (_setPos + 1) : -1;
                        this._recRule = "FREQ=" + this._rRuleFreq + ";BYDAY=" + this._dayNames[dayName] + ";BYSETPOS=" + _setPos + ";INTERVAL=" + interval;
                        recurOption = " " + this._getLocalizedLabels("On").toLowerCase() + " " + this._appointmentAddWindow.find('.monthsrt').ejDropDownList("option", "value").toLowerCase() + " " + this._dayFullNames[dayName];
                    }
                    break;
                case "YEARLY":
                    if (this._appointmentAddWindow.find("#" + this._id + "yearday").ejRadioButton("option", "checked")) {
                        var _monthIndex = this._appointmentAddWindow.find('.yearmonth').ejDropDownList("option", "selectedItemIndex");
                        var _monthDate = this._findInterval(this._appointmentAddWindow.find('.yeardate'));
                        this._recRule = "FREQ=" + this._rRuleFreq + ";BYMONTHDAY=" + _monthDate + ";BYMONTH=" + (_monthIndex + 1) + ";INTERVAL=" + interval;
                        recurOption = " " + this._getLocalizedLabels("On").toLowerCase() + " " + this._monthNames[_monthIndex] + " " + _monthDate;
                    }
                    else {
                        var _setPos = this._appointmentAddWindow.find('.yearsrt').ejDropDownList("option", "selectedItemIndex");
                        var _monthIndex = this._appointmentAddWindow.find('.yearsrtmonth').ejDropDownList("option", "selectedItemIndex");
                        var dayName = this._appointmentAddWindow.find('.yearsrtday').ejDropDownList("option", "selectedItemIndex");
                        _setPos = _setPos < 4 ? (_setPos + 1) : -1;
                        this._recRule = "FREQ=" + this._rRuleFreq + ";BYDAY=" + this._dayNames[dayName] + ";BYMONTH=" + (_monthIndex + 1) + ";BYSETPOS=" + _setPos + ";INTERVAL=" + interval;
                        recurOption = " " + this._getLocalizedLabels("On").toLowerCase() + " " + this._appointmentAddWindow.find('.yearsrt').ejDropDownList("option", "value").toLowerCase() + " " + this._dayFullNames[dayName] + " " + this._monthNames[_monthIndex];
                    }
                    break;
            }
            if (this._appointmentAddWindow.find('.e-recurafter').ejRadioButton("option", "checked")) {
                var _count = this._findInterval(this._appointmentAddWindow.find('.e-recurcount'));
                this._recRule += ";COUNT=" + _count;
                endRecur = _count ? ", " + _count + " " + this._getLocalizedLabels("Times") : ", ";
            }
            else if (this._appointmentAddWindow.find('.e-recuruntil').ejRadioButton("option", "checked")) {
                var date = Globalize.format(new Date(this._appointmentAddWindow.find('.e-until').ejDatePicker("option", "value")), this._pattern.d);
                this._recRule += ";UNTIL=" + date;
                endRecur = " " + this._getLocalizedLabels("Until").toLowerCase() + " " + date;
            }
            var _every = (this._rRuleFreq != "WEEKDAYS" ? this._getLocalizedLabels("Every") : "") + " " + (interval > 1 ? interval + " " : "");
            var _rRuleStr = _every + this._appointmentAddWindow.find(".e-recurRule").html() + recurOption + endRecur;
            this._appointmentAddWindow.find("." + this._id + "summary").css("display", "table-row");
            this._appointmentAddWindow.find(".e-recurFinalRule").html(_rRuleStr);
            this._appointmentAddWindow.find(".e-recuredit").css("display", "inline");
            recurOption = "";
        }
        this._appointmentAddWindow.find(".e-recurwindow").toggle();
        this._appointmentAddWindow.find(".e-appwindow").css("margin-left", 700).toggle().animate({ "margin-left": 10 }, 300);
        (this._mediaQuery) && this._appointmentAddWindow.parent().parent().find(".e-dialog-icon").css("display", "block");
        this._appointmentAddWindow.find('.done').focus();
    },
    /**
    Recurrence startdate value change
    @private
    */
    _recurDateChange: function (args) {
        this._appointmentAddWindow.find("#" + this._id + "startdate").ejDatePicker("option", "value", args.value);
        this._appointmentAddWindow.find("#" + this._id + "enddate").ejDatePicker("option", "value", args.value);
    },

    /**
    * Section to find the interval.
    * @private
    */
    _findInterval: function (numericElement) {
        var interval;
        interval = numericElement.ejNumericTextbox("option", "value");
        return interval = ej.isNullOrUndefined(interval) ? 0 : interval;
    },
    /**
    * Section for cancel the appointment window.
    * @private
    */
    _cancel: function () {
        this._appointmentAddWindow.ejDialog("close");
    },
    /**
    * Section for handle the start and end time in appointment window.
    * @private
    */
    _timeChange: function (e) {
        if (this._currentAction != ej.Schedule.Actions.Add) return false;         
            var obj = this._appointmentAddWindow.find("#" + this._id + "starttime").data("ejTimePicker");
            if (obj.showDropdown && obj._id == this._id + "starttime") {
                if (this._appointmentAddWindow.find('.startutc').val() != this._appointmentAddWindow.find('.endutc').val()) {
                    this._utcValue("","starttime");
                }
                else {
                    var endtime = $("#" + this._id + "starttime_popup").find("li.e-active").next("li").html();
                    if (!ej.isNullOrUndefined(endtime)) document.getElementById(this._id + "endtime").value = endtime;
                    else document.getElementById(this._id + "endtime").value = e.value;
                }
            }
    },
    /**
    * Section for render all the controls used in the schedule.
    * @private
    */
    _renderControls: function (e) {
        var control = this._appointmentAddWindow;
        //control.find('.subject').ejMaskEdit({ enableRTL: this.model.rtl, name: this.model.appointmentSettings["subject"], inputMode: ej.inputMode.Text, width: "100%", cssClass: this.model.cssClass });
        control.find('.allday').ejCheckBox({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, change: $.proxy(this._alldayCheck, this) });
        control.find('.startenddate').ejDatePicker({ enableRTL: this.model.enableRTL, width: '100%', value: this.currentDate(), locale: this.model.locale, dateFormat: this.model.dateFormat, cssClass: this.model.cssClass });
        control.find("#" + this._id + "starttime").ejTimePicker({ enableRTL: this.model.enableRTL, width: "100%", value: this.currentDate(), locale: this.model.locale, change: $.proxy(this._timeChange, this), cssClass: this.model.cssClass, timeFormat: (this._timeMode == "12") ? this._pattern.t : "HH:mm" });
        control.find("#" + this._id + "endtime").ejTimePicker({ enableRTL: this.model.enableRTL, width: "100%", value: this.currentDate(), locale: this.model.locale, change: $.proxy(this._timeChange, this), cssClass: this.model.cssClass, timeFormat: (this._timeMode == "12") ? this._pattern.t : "HH:mm" });

        control.find('.startutc').ejDropDownList({ enableRTL: this.model.enableRTL, dataSource: this.model.timezoneCollection.dataSource, fields: { text: "text", id: "id", value: "value" }, width: "100%", change: $.proxy(this._startUtc, this), cssClass: this.model.cssClass });
        control.find('.endutc').ejDropDownList({ enableRTL: this.model.enableRTL, dataSource: this.model.timezoneCollection.dataSource, fields: { text: "text", id: "id", value: "value" }, width: "100%", change: $.proxy(this._endUtc, this), cssClass: this.model.cssClass });
        if (!ej.isNullOrUndefined(this.model.resources) && ej.scheduleFeatures.resources) 
            this._renderAppWindowResources(control);
        if (this.model.categorizeSettings.enable)
            this._renderCategoryItems(control);
        control.find('.recurrence').ejCheckBox({ enableRTL: this.model.enableRTL, change: $.proxy(this._repeat, this), cssClass: this.model.cssClass });
        control.find('.e-btndone').ejButton({ enableRTL: this.model.enableRTL, showRoundedCorner: true, width: "100px", height: "27px", click: $.proxy(this._saveAppointment, this), cssClass: this.model.cssClass });
        control.find('.cancel').ejButton({ enableRTL: this.model.enableRTL, showRoundedCorner: true, width: "100px", height: "27px", click: $.proxy(this._cancel, this), cssClass: this.model.cssClass });
        control.find('.recurtype').ejDropDownList({ enableRTL: this.model.enableRTL, targetID: "recurtypelist", width: "100%", select: $.proxy(this._recurtype, this), cssClass: this.model.cssClass });
        control.find('.dailyrecurtype').ejRadioButton({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass });
        control.find('.e-dailyeveryday').ejRadioButton({ enableRTL: this.model.enableRTL, checked: true, cssClass: this.model.cssClass });
        control.find('.everydaycount').ejNumericTextbox({ enableRTL: this.model.enableRTL, name: "everydaycount", minValue: 1, value: 1, width: "100px", float: "left", cssClass: this.model.cssClass });
        control.find('.recurends').ejRadioButton({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass });
        control.find('.e-recurcount').ejNumericTextbox({ enableRTL: this.model.enableRTL, name: "dailyoccurance", minValue: 1, value: 10, width: "65px", cssClass: this.model.cssClass, change: $.proxy(this._endAfterChange, this) });
        control.find('.weekcount').ejNumericTextbox({ enableRTL: this.model.enableRTL, name: "weekcount", minValue: 1, value: 1, width: "100px", cssClass: this.model.cssClass });
        control.find('.e-recurevery').ejNumericTextbox({ enableRTL: this.model.enableRTL, name: "recurevery", minValue: 1, value: 1, width: "100px", cssClass: this.model.cssClass });
        control.find('.weekdays').ejCheckBox({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass });
        control.find('.e-monthposition').ejRadioButton({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass });
        control.find('.e-monthdaytype').ejRadioButton({ enableRTL: this.model.enableRTL, checked: true, cssClass: this.model.cssClass });
        control.find('.e-monthdate').ejNumericTextbox({ enableRTL: this.model.enableRTL, name: "monthdate", minValue: 1, maxValue: 31, value: 1, width: "70px", cssClass: this.model.cssClass, change: $.proxy(this._monthDateChange, this) });
        control.find('.monthnumber').ejNumericTextbox({ enableRTL: this.model.enableRTL, name: "monthnumber", minValue: 1, value: 1, width: "70px", cssClass: this.model.cssClass });
        control.find('.yearcount').ejNumericTextbox({ enableRTL: this.model.enableRTL, name: "yearcount", minValue: 1, value: 1, width: "50px", cssClass: this.model.cssClass });
        control.find('.e-yearrecurposi,.e-yearrecurday').ejRadioButton({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass });
        control.find('.yeardate').ejNumericTextbox({ enableRTL: this.model.enableRTL, name: "yeardate", minValue: 1, maxValue: 31, value: 1, width: "70px", cssClass: this.model.cssClass, change: $.proxy(this._yearDateChange, this) });
        control.find('.recurbutton').ejButton({ enableRTL: this.model.enableRTL, showRoundedCorner: true, width: "100px", height: "27px", click: $.proxy(this._closerecur, this), cssClass: this.model.cssClass });
        control.find('.monthsrt').ejDropDownList({ enableRTL: this.model.enableRTL, targetID: "monthsrtlist", width: "100px", cssClass: this.model.cssClass, change: $.proxy(this._monthDayChange, this) });
        control.find('.e-monthsrtday').ejDropDownList({ enableRTL: this.model.enableRTL, targetID: "monthsrtdaylist", width: "100px", cssClass: this.model.cssClass, change: $.proxy(this._monthDayChange, this) });
        control.find('.yearsrt').ejDropDownList({ enableRTL: this.model.enableRTL, targetID: "yearsrtlist", width: "100px", cssClass: this.model.cssClass, change: $.proxy(this._yearDayChange, this) });
        control.find('.yearmonth').ejDropDownList({ enableRTL: this.model.enableRTL, targetID: "yearmonthlist", width: "100px", cssClass: this.model.cssClass, change: $.proxy(this._yearDateChange, this) });
        control.find('.yearsrtday').ejDropDownList({ enableRTL: this.model.enableRTL, targetID: "yearsrtdaylist", width: "100px", cssClass: this.model.cssClass, change: $.proxy(this._yearDayChange, this) });
        control.find('.yearsrtmonth').ejDropDownList({ enableRTL: this.model.enableRTL, targetID: "yearsrtmonthlist", width: "100px", cssClass: this.model.cssClass, change: $.proxy(this._yearDayChange, this) });
        control.find('.recurstartdate').ejDatePicker({ enableRTL: this.model.enableRTL, locale: this.model.locale, cssClass: this.model.cssClass, dateFormat: this.model.dateFormat, change: $.proxy(this._recurDateChange, this) });
        control.find('.e-until').ejDatePicker({ enableRTL: this.model.enableRTL, locale: this.model.locale, cssClass: this.model.cssClass, dateFormat: this.model.dateFormat, change: $.proxy(this._endOnChange, this) });
        (this._mediaQuery) && control.find('.e-btndelete').ejButton({ enableRTL: this.model.enableRTL, showRoundedCorner: true, width: "100px", height: "27px", click: $.proxy(this._mobileAppDelete, this), cssClass: this.model.cssClass });
    },

    _mobileAppDelete: function () {
        this._deleteAppoint();
        this._appointmentAddWindow.ejDialog("close");
    },

    _renderCategoryItems: function (control) {
        if (this.model.categorizeSettings.allowMultiple) {
            control.find('.e-categorizevalue').ejAutocomplete({
                enableRTL: this.model.enableRTL,
                showPopupButton: true,
                width: "100%", cssClass: this.model.cssClass,
                multiSelectMode: "visualmode",
                dataSource: this.model.categorizeSettings.dataSource, fields: { text: "text", value: "color", key: "id", fontColor: "fontColor" },
                template: this._categorizeTemplate,
            });
        }
        else {
            control.find('.e-categorizevalue').ejAutocomplete({
                enableRTL: this.model.enableRTL,
                showPopupButton: true,
                width: "100%", cssClass: this.model.cssClass,
                multiSelectMode: "none",
                dataSource: this.model.categorizeSettings.dataSource, fields: { text: "text", value: "color", key: "id", fontColor: "fontColor" },
                template: this._categorizeTemplate,
            });
        }
    },
    _appointmentColor: function(record){
        var appointColor = (this.model.categorizeSettings.enable && !ej.isNullOrUndefined(record[this.model.appointmentSettings["categorize"]]) && record[this.model.appointmentSettings["categorize"]] != "") ? this._getCategorizeColor(record) : (!ej.isNullOrUndefined(this.model.resources) && ej.scheduleFeatures.resources) ? this._getResourceColor(record) : { appointData: "", appointCustomcss: "", appointtextcolor: "" };

        if (this.model.categorizeSettings.enable && this.model.categorizeSettings.allowMultiple && !ej.isNullOrUndefined(record[this.model.appointmentSettings["categorize"]])) 
        {
            var categorizeItems = record[this.model.appointmentSettings["categorize"]].split(",");
            var categorizeItemsLength = categorizeItems.length;
            var value = (categorizeItemsLength > 1) ? true : false;
            var multiDiv = this._categorizeMultipleDiv(record, categorizeItems, categorizeItemsLength);
        }
        if (!ej.isNullOrUndefined(multiDiv) && appointColor.appointData.length > 0 && this.model.categorizeSettings.allowMultiple)
            return { appointColor: appointColor, value: value, multiDiv: multiDiv };
        else if (appointColor.appointData.length > 0 && !this.model.categorizeSettings.allowMultiple || !ej.isNullOrUndefined(this.model.resources) && ej.scheduleFeatures.resources)
            return { appointColor: appointColor };
        else {
            appointData = "", appointCustomcss = "", appointtextcolor = "", value = "", appointColor = "";
            return { appointColor: appointColor, value: value, multiDiv: multiDiv };
        }
    },
    _categorizeMultipleDiv: function (record, categorizeItems, categorizeItemsLength)
    {
        //var categorizeItems = record[this.model.appointmentSettings["categorize"]].split(",");
        //var categorizeItemsLength = categorizeItems.length - 1; 
        var renderData = [];
        for (i = 0; i <= categorizeItemsLength-1; i++)
        {
            if (i != categorizeItemsLength-1)
            {
                var dataSet = this.model.categorizeSettings;
                var categorizeDataIndex = this._findResourceIndex(dataSet.dataSource, "id", categorizeItems[i]);
                (ej.isNullOrUndefined(categorizeDataIndex)) && (categorizeDataIndex = this._findResourceIndex(dataSet.dataSource, "id", parseInt(categorizeItems[i])));
                if (ej.isNullOrUndefined(categorizeDataIndex)) {
                    record[this.model.appointmentSettings["categorize"]] = "";
                    return null;
                }
                else
                renderData.push({ text: dataSet.dataSource[categorizeDataIndex][dataSet.text], value: dataSet.dataSource[categorizeDataIndex][dataSet.color], key: dataSet.dataSource[categorizeDataIndex][dataSet.id], fontColor: dataSet.dataSource[categorizeDataIndex][dataSet.fontColor] })
                
            }           
        }
        var template = this._categorizeMultipleTemplate.render({renderData:renderData});
        return template;
    },
    _getResCategorySaveData: function (categorizeVal, autoVal, obj, maxId, temp, starttime, endtime) {
        var args = [], newAppointment, data, prevdata;       
        newAppointment = this._addAppData(obj, maxId, new Date(obj[this.model.appointmentSettings["startTime"]]), new Date(obj[this.model.appointmentSettings["endTime"]]), maxId);
        if (categorizeVal.length > 0) {
            var categorizeItemsLength = categorizeVal[categorizeVal.length - 1].length - 1; var idValue = "";
            for (var i = 0; i <= categorizeItemsLength; i++) {
                var getId = categorizeVal[categorizeVal.length - 1][i].id;
                idValue = (i != categorizeItemsLength) ? idValue + getId.toString() + "," : idValue + getId.toString();
            }
            newAppointment[this.model.appointmentSettings["categorize"]] = idValue;
            newAppointment.startutc = obj.startutc;
            newAppointment.endutc = obj.endutc;
        }
        if (autoVal.length > 0) {
            var categorizeVar = newAppointment[this.model.appointmentSettings["categorize"]];
            var resources = this.model.appointmentSettings.resourceFields.toString().split(',');
            var newResCollection = this._getResourceCollection();
            if (autoVal[autoVal.length - 1].length > 0) {
                for (var j = 0; j < autoVal[autoVal.length - 1].length; j++) {

                    newAppointment = this._addAppData(obj, maxId, new Date(obj[this.model.appointmentSettings["startTime"]]), new Date(obj[this.model.appointmentSettings["endTime"]]), maxId);
                    newAppointment[this.model.appointmentSettings["categorize"]] = categorizeVar;

                    if (autoVal[autoVal.length - 1].length > 1) {
                        obj[this.model.appointmentSettings["id"]] = maxId;
                        maxId++;
                    }
					var query = new ej.Query().where(this.model.appointmentSettings["id"], ej.FilterOperators.equal, maxId);
					var templist = new ej.DataManager(this._processed).executeLocal(query);
					maxId = (templist.length ==0 )? maxId: this._processed[this._processed.length -1][this.model.appointmentSettings['id']] +1;
					newAppointment[resources[resources.length - 1]] = autoVal[resources.length - 1][j].value;
					newAppointment.startutc = obj.startutc;
					newAppointment.endutc = obj.endutc;
                    var id = autoVal[resources.length - 1][j].value;
                    for (var i = resources.length - 1; i > 0; i--) {
                        data = this.render_Resources[i] instanceof ej.DataManager ? this.render_Resources[i] : ej.DataManager(this.render_Resources[i]);
                        query = new ej.Query().where(newResCollection[i].id, ej.FilterOperators.equal, id);
                        appointId = data.executeLocal(query);
                        prevdata = this.render_Resources[i - 1] instanceof ej.DataManager ? this.render_Resources[i - 1] : ej.DataManager(this.render_Resources[i - 1]);
                        query1 = new ej.Query().where(newResCollection[i - 1].id, ej.FilterOperators.equal, appointId[0][newResCollection[i].groupId]);
                        appointGroupId = prevdata.executeLocal(query1);
                        id = appointGroupId[0][newResCollection[i - 1].id];
                        newAppointment[resources[i - 1]] = id;

                    }
                    args.push(newAppointment);
                }
            }
            else {
                var resources = this.model.appointmentSettings.resourceFields.toString().split(',');
                newAppointment = this._addAppData(obj, maxId, new Date(obj[this.model.appointmentSettings["startTime"]]), new Date(obj[this.model.appointmentSettings["endTime"]]), maxId);
                newAppointment[this.model.appointmentSettings["categorize"]] = categorizeVar;
                if (resources.length > 1) {
                    for (i = 0; i < resources.length; i++) {
                        newAppointment[resources[i]] = this.model.resources[i].resourceSettings.dataSource[0].id
                    }
                }
                else
                    newAppointment[resources[resources.length - 1]] = this.model.resources[0].resourceSettings.dataSource[0].id;
                args.push(newAppointment);
            }
        }
        
        if (autoVal.length == 0 && categorizeVal.length > 0)
            args.push(newAppointment);
        return args;
    },
    _timeZoneCollection: function (temp) {
        this.startutcValue = null;
        this.tempValue = null;
        if (temp !== null && temp.startutc !== temp.endutc) {
            this._utcValue(temp, "Appoint");
            this.tempValue = 1;
        }
        if (this.model.timeInfo != null) {
            var value = this._findResourceIndex(this.model.timezoneCollection.dataSource, "id", this.model.timeInfo);
        }
        else {
            var value1 = (this.model.timeZone == null) ? Globalize.format(new Date(), "zzz") : this.model.timeZone;
            var firstValue1 = this.model.timezoneCollection.dataSource[0][this.model.timezoneCollection["value"]];
            var firstValue = (firstValue1.indexOf('UTC') == -1) && (value1.indexOf('UTC') != -1) ? value1.split(" ")[1] : (firstValue1.indexOf('UTC') != -1) && (value1.indexOf('UTC') == -1) ? 'UTC ' + value1 : value1;
            firstValue = !ej.isNullOrUndefined(firstValue1.split(':')[2]) && !ej.isNullOrUndefined(value1.split(':')[2]) || ej.isNullOrUndefined(firstValue1.split(':')[2]) && ej.isNullOrUndefined(value1.split(':')[2]) ? firstValue : ej.isNullOrUndefined(firstValue1.split(':')[2]) && !ej.isNullOrUndefined(value1.split(':')[2]) ? firstValue.split(':')[0] + ':' + firstValue.split(':')[1] : firstValue + ':00';
            var value = this._findResourceIndex(this.model.timezoneCollection.dataSource, "value", firstValue);
            value = ej.isNullOrUndefined(value) ? this._findResourceIndex(this.model.timezoneCollection.dataSource, "value", firstValue.replace('+', '')) : value;
            value = (!ej.isNullOrUndefined(value)) ? value : 0;
        }
        if (this.model.timeZone == null && value == 0) {
            this._appointmentAddWindow.find("#startutc").val("UTC " + Globalize.format(new Date(), "zzz")) && this._appointmentAddWindow.find("#startutc_hidden").val("UTC " + Globalize.format(new Date(), "zzz"));
            this._appointmentAddWindow.find("#endutc").val("UTC " + Globalize.format(new Date(), "zzz") ) && this._appointmentAddWindow.find("#endutc_hidden").val("UTC " + Globalize.format(new Date(), "zzz"));
        }
        else {
            this._appointmentAddWindow.find("#startutc").ejDropDownList("option", { text: this.model.timezoneCollection.dataSource[value][this.model.timezoneCollection["text"]], value: this.model.timezoneCollection.dataSource[value][this.model.timezoneCollection["value"]] });
            this._appointmentAddWindow.find("#endutc").ejDropDownList("option", { text: this.model.timezoneCollection.dataSource[value][this.model.timezoneCollection["text"]], value: this.model.timezoneCollection.dataSource[value][this.model.timezoneCollection["value"]] });
        }
        if (temp !== null && !ej.isNullOrUndefined(temp.startutc)) {
            this._appointmentAddWindow.find("#startutc").ejDropDownList("option", { value: (temp !== null && temp.endutc)?temp.startutc:this.model.timezoneCollection.dataSource[value][this.model.timezoneCollection["value"]] });
            this._appointmentAddWindow.find("#endutc").ejDropDownList("option", { value: (temp !== null && temp.endutc) ? temp.endutc : this.model.timezoneCollection.dataSource[value][this.model.timezoneCollection["value"]] });
        }
        

    },
   _showCategorizeDetails: function (temp)
   {
       var categorizeItems = temp[this.model.appointmentSettings["categorize"]].split(",");
       var key;
        for (i = 0; i < categorizeItems.length; i++) {
            key = $.type(categorizeItems[i]) == 'string' ? categorizeItems[i] : parseInt(categorizeItems[i]);
            this._appointmentAddWindow.find('.e-categorizevalue').data("ejAutocomplete").selectValueByKey(key);
            }        
    },
    _renderCategorizeTemplate: function () {

        if (!ej.isNullOrUndefined(this.model.categorizeSettings))
            this._categorizeTemplate = "<div class='e-categorizeTemplate' style='height:15px;margin-right:5px;margin-top:3px;float:left;width:15px;background-color: ${color}'></div> <div>${text}</div>";
    },
    _getCategorizeColor: function (record)
    {
        var categorizeDataIndex = null, appointData = "", appointCustomcss = "", appointtextcolor="";
        var categorizeItems = record[this.model.appointmentSettings["categorize"]].split(",");
        var categorizeItemsLength = categorizeItems.length - 1;
        var dataSet = this.model.categorizeSettings;
        categorizeDataIndex = this._findResourceIndex(dataSet.dataSource, "id", categorizeItems[categorizeItemsLength]);
		  (ej.isNullOrUndefined(categorizeDataIndex)) && (categorizeDataIndex = this._findResourceIndex(dataSet.dataSource, "id", parseInt(categorizeItems[categorizeItemsLength])));
        if (ej.isNullOrUndefined(categorizeDataIndex)) {
            record[this.model.appointmentSettings["categorize"]] = "";
            return { appointData: appointData, appointCustomcss: appointCustomcss, appointtextcolor: appointtextcolor };                
        }
        else {
                appointData = !ej.isNullOrUndefined(dataSet.dataSource[categorizeDataIndex][dataSet.color]) ? dataSet.dataSource[categorizeDataIndex][dataSet.color] : appointData;
                appointtextcolor = !ej.isNullOrUndefined(dataSet.dataSource[categorizeDataIndex][dataSet.fontColor]) ? dataSet.dataSource[categorizeDataIndex][dataSet.fontColor] : appointtextcolor;
           }
        
            return { appointData: appointData, appointCustomcss: appointCustomcss, appointtextcolor: appointtextcolor }
    },
    _currentDateFormat:function(option){
        if (!ej.isNullOrUndefined(option) && ($.type(this.currentDate()) != "date" || $.type(this.model.minDate) != "date" || $.type(this.model.maxDate) != "date")) {
            var date = Globalize.parseDate(this.currentDate(), this.model.dateFormat);
            var minDate = Globalize.parseDate(this.model.minDate, this.model.dateFormat);
            var maxDate = Globalize.parseDate(this.model.maxDate, this.model.dateFormat);
            (!ej.isNullOrUndefined(date)) ? this.currentDate(date) : this.currentDate();
            this.model.minDate = (!ej.isNullOrUndefined(minDate)) ? minDate : this.model.minDate;
            this.model.maxDate = (!ej.isNullOrUndefined(maxDate)) ? maxDate : this.model.maxDate;
        }
        else if (option == "MM/dd/yyyy" && ($.type(this.currentDate()) != "date" || $.type(this.model.minDate) != "date" || $.type(this.model.maxDate) != "date"))
		{		      
			 var curntDate = Globalize.parseDate(this.currentDate());
		    var minDate = Globalize.parseDate(this.model.minDate);
		    var maxDate = Globalize.parseDate(this.model.maxDate);
		    (!ej.isNullOrUndefined(curntDate)) ? this.currentDate(curntDate) : this.currentDate(new Date());
		    this.model.minDate = (!ej.isNullOrUndefined(minDate)) ? minDate : this.model.minDate;
		    this.model.maxDate = (!ej.isNullOrUndefined(maxDate)) ? maxDate : this.model.maxDate;
		 
		  }
    },
    _datepattern: function () {
        return (this.model.dateFormat != "" && !ej.isNullOrUndefined(this.model.dateFormat)) ? this.model.dateFormat : this._pattern.d;
    },
    _businessHourScroller: function () {
	    var highScrol;
        if (this.model.orientation == "vertical"){		
             highScrol = this.element.find('.e-businesshighlightworkcells').length != 0 && this.model.highlightBusinessHours ==true ? this.element.find('.e-businesshighlightworkcells').first().parent()[0].rowIndex * this.element.find('.e-workcells').height():0;
             $('div#' + this._id + "_scroller").ejScroller({ scrollTop: highScrol });
            this.element.find('.e-scrolltimecells').css('top', -(this.element.find('.e-draggableworkarea').scrollTop()) + 'px');
            }
        else if (this.model.orientation == "horizontal"){
            if (this.element.find('.e-businesshighlightworkcells').length != 0 && this.model.highlightBusinessHours == true && this.currentView() != "month") {
            if (this.currentView() === "week" || this.currentView() === "workweek" || (this.currentView() === "customview" && this._renderDays <= 7)) {
                var currentDateIndex = this.element.find('.e-activeview.e-horizontalheaderdiv').parent().index();
                if (!ej.isNullOrUndefined(currentDateIndex) && currentDateIndex >= 0) {
                    this.currentDate(this._getRenderDates()[currentDateIndex]);
                    dateRender = new Date(this._getRenderDates()[currentDateIndex]).getDay();
                    highScrol = this.element.find(".e-workcells")[currentDateIndex * 48].offsetLeft;
                }
               if (this.currentView() === "week" && [0, 6].indexOf(dateRender) == -1 )
                    highScrol = this.model.businessStartHour * 2 * this.element.find(".e-workcells").width() + (highScrol - this.element.find('.e-workcells').width());
				else if(this.currentView() === "workweek")
                    highScrol = this.model.businessStartHour * 2 * this.element.find(".e-workcells").width() + (highScrol - this.element.find('.e-workcells').width());				
            }
            else
                 highScrol = this.element.find('.e-businesshighlightworkcells')[0].cellIndex * this.element.find('.e-workcells').width();
            }
            else{
                 highScrol = (this.element.find('.e-activeview.e-horizontalheaderdiv').parent().index()!=-1)? this.element.find(".e-workcells")[(this.element.find('.e-activeview.e-horizontalheaderdiv').parent().index()) * 48].offsetLeft:0;

            }
            $('div#' + this._id + "_scroller").ejScroller({ scrollLeft: highScrol });
            $(this.element.find(".e-horizontaltimecells").find("table tr")[2]).css("left", (-this.element.find('.e-draggableworkarea').scrollLeft()) + "px");
            }    
			},

    /**
    * To check the radio button while change the year date.
    * @private
    */
    _yearDateChange: function (e) {
        this._appointmentAddWindow.find("#" + this._id + "yearday").ejRadioButton("option", "checked", true);
    },
    /**
    * To check the radio button while change the year day.
    * @private
    */
    _yearDayChange: function (e) {
        this._appointmentAddWindow.find("#" + this._id + "yearother").ejRadioButton("option", "checked", true);
    },
    /**
    * To check the radio button while change the month date.
    * @private
    */
    _monthDateChange: function (e) {
        this._appointmentAddWindow.find("#" + this._id + "monthday").ejRadioButton("option", "checked", true);
    },
    /**
    * To check the radio button while change the month day.
    * @private
    */
    _monthDayChange: function (e) {
        this._appointmentAddWindow.find("#" + this._id + "monthon").ejRadioButton("option", "checked", true);
    },
    /**
    * To check the radio button while change the end after value.
    * @private
    */
    _endAfterChange: function (e) {
        this._appointmentAddWindow.find("#" + this._id + "repeatendafter").ejRadioButton("option", "checked", true);
    },
    /**
    * To check the radio button while change the end date in recurrence window.
    * @private
    */
    _endOnChange: function (e) {
        this._appointmentAddWindow.find("#" + this._id + "repeatendon").ejRadioButton("option", "checked", true);
    },
    /**
    * Section to convert the minutes to hours.
    * @private
    */
    _minToHour: function (mins) {
        var hours = parseInt(mins / 60);
        var mins = mins % 60;
        var obj = {
            "h": hours,
            "m": mins
        };
        return obj;
    },
    /**
    * Section for handle the closing of appointment window.
    * @private
    */
    _onclose: function (args) {
        this._appointmentAddWindow.find(".e-recurwindow").hide();
        this._appointmentAddWindow.find(".e-appwindow").css("margin-left", 700).show().animate({ "margin-left": 10 }, 300);
        this._clearFields();
        this._processFocus();
    },
    
    /**
    * Section for handle printing of appointment save of schedule.
    * @private
        */
        _printAppointment: function (){
            var $element = ej.buildTag("div");
            var query = new ej.Query().where(this.model.appointmentSettings["id"], ej.FilterOperators.equal, this._appId);
            var templist = new ej.DataManager(this._processed).executeLocal(query);
            var appointmentTable = "<table align='center' style='margin-top:50px;margin-left:50;'>";
            var proxy = this;
            $.each(templist[0], function (i, val) {
                if (i != "ParentId" && !ej.isNullOrUndefined(val) && !ej.isNullOrUndefined(i) && i != "null") {
                    if (i == proxy.model.appointmentSettings.startTime || i == proxy.model.appointmentSettings.endTime)
                        val = val;
                    appointmentTable += "<tr style='height:30px'><td style='width:300px'><b>" + i + ":</b></td><td  style='width:600px'>" + val + "</td></tr>";
                }
            });
            appointmentTable += "</table>";
            var ownerTextName = "";
            if (!ej.isNullOrUndefined(this.model.appointmentSettings.resourceFields) && this.model.appointmentSettings.resourceFields != "") {
                var s = proxy.model.appointmentSettings.resourceFields.split(',');
                $.each(this.model.resources[this.model.resources.length - 1].resourceSettings.dataSource, function (i, val) {
                    if (val.id == templist[0][s[s.length - 1]])
                        ownerTextName = val.text;
                });
            }
            ownerTextName = (ownerTextName == "") ? "Unknown" : ownerTextName;
            var appointmentWindowData = "<font size='20' style='margin-top:50px;margin-left:50;font-family:Times New Roman'><b>" + ownerTextName + "</b></font></br><hr style='margin-left:50' size='10'>"
            var printElement = appointmentWindowData + appointmentTable;
            $element.append(printElement);
            ej.print($element);
            return false;
    },
    /**
    * Section for handle the appointment save of schedule.
    * @private
        */
        _saveAppointment: function () {
            var appointments = this._sortAppById(this._processed), maxId, query, query1, appointId, appointGroupId, _editApp;
            if (this._cellClick && this.model.showQuickWindow) {
                var obj = {};
                maxId = appointments.length > 0 ? appointments[appointments.length - 1][this.model.appointmentSettings["id"]] + 1 : 1;
                obj[this.model.appointmentSettings["id"]] = maxId;
                obj["ParentId"] = maxId;
            obj[this.model.appointmentSettings["subject"]] = this._quickAppointWindow.find('.subject').val();
            obj[this.model.appointmentSettings["startTime"]] = new Date(this.cur_StartTime);
            obj[this.model.appointmentSettings["endTime"]] = new Date(this.cur_EndTime);
            if (this.currentView() === "month" || (new Date(this.cur_StartTime).getHours() == 0 && new Date(this.cur_EndTime).getHours() == 23 && new Date(this.cur_EndTime).getMinutes() == 59) || (this._isCustomView()))
                obj[this.model.appointmentSettings["allDay"]] = true;
            else
                obj[this.model.appointmentSettings["allDay"]] = false;
            obj[this.model.appointmentSettings["recurrence"]] = false;
            if(!ej.isNullOrUndefined(this.model.group) || !ej.isNullOrUndefined(this.model.resources) && ej.scheduleFeatures.resources)
                obj = this._getResourceFields(obj);
            var args = { appointment: obj };
            if (this._trigger("actionBegin", { data:args.appointment, requestType: "appointmentSave" })) {
                this._quickAppointWindow.ejDialog("close");
                return false;
            }
            if (this._trigger("appointmentSaved", args)) {
                this._quickAppointWindow.ejDialog("close");
                return false;
            }
            this._currentAction == ej.Schedule.Actions.Add;
            var temp = this._timeZoneConversion(args.appointment);
            promise = this._dataManager.insert(temp); // Add new appointment
            new ej.DataManager(this._currentAppointmentData).update(this.model.appointmentSettings["id"], args.appointment);
            var proxy = this;
            if ($.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                    promise.done(function (e) {
                        //proxy._appointmentProcessing(args.appointment);
                        proxy._processed.push(args.appointment);
                        proxy._currentAppointmentData.push(args.appointment);
                        proxy._renderSingleApp(obj, args.appointment);
                        proxy._trigger("actionComplete", { data: args.appointment, requestType: "appointmentSave" });
                    });
                    promise.fail(function (e) {
                    });
            }
            else {
                this._processed.push(args.appointment);
                this._renderSingleApp(obj, args.appointment);
                this._trigger("actionComplete", { data: args.appointment, requestType: "appointmentSave" });
            }
                //this._dataManager.insert(args.appointment); // Add new appointment
                //this._processed.push(args.appointment);
            this._cellClick = false;
            this._quickAppointWindow.ejDialog("close");
        }
        else {
            var formelement;
            obj = {};
                temp = {};
                //var appId = this._sortAppById(appointments);
                maxId = (this._currentAction == ej.Schedule.Actions.Add || this._currentAction == ej.Schedule.Actions.EditOcurrence) && appointments.length > 0 ? appointments[appointments.length - 1][this.model.appointmentSettings["id"]] + 1 : parseInt(this._appId);
            formelement = $("#" + this._id + "AppointmentAddEditWindow").find("#" + this._id + "_AddEditForm").get(0); var autoVal = []; var categorizeVal = [];
                for (var index = 0; index < formelement.length; index++) {
                    var columnName = formelement[index].name, $element = $(formelement[index]);
                    if (columnName != undefined) {
                    if (columnName == "" )
					 (($element.attr("id") != this._id + "_categorize") &&(columnName = formelement[index].id.replace(this._id, "")));
                    var value = formelement[index].value;
					if ((columnName != "" && obj[columnName] == null) && (columnName != this._id + "_categorize")) {   
                        if (columnName == "Id") {
                            if (value == "")
                                value = parseInt(maxId);
                            else
                                value = parseInt(value);
                        }
                        if ($(formelement[index]).hasClass("e-datepicker"))
                            value = $element.ejDatePicker("option", "value");
                        else if ($(formelement[index]).hasClass("e-datepicker"))
                                value = $element.ejTimePicker("option", "value");
                            else if ($element.data("ejDropDownList"))
                                value = $element.ejDropDownList("model.value");
                            else if ($element.data("ejAutocomplete")) {
                                autoVal.push($element.data("ejAutocomplete").getSelectedItems());
                            }
                            if (columnName != "StartDate" && columnName != "EndDate" && columnName != "StartTime" && columnName != "EndTime") {
                                if (formelement[index].type != "checkbox")
                                    obj[columnName] = value;
                            else
                                obj[columnName] = $(formelement[index]).is(':checked');
                        }
                        else {
                                temp[columnName] = columnName == "StartDate" || columnName == "EndDate" ? new Date(value) : value;
                        }
                    }
                    else {
                        if ($element.data("ejAutocomplete")) {
						if ($element.attr("id") == this._id + "_categorize")
                            {
                                categorizeVal.push($element.data("ejAutocomplete").getSelectedItems());
                                if (!this.model.categorizeSettings.allowMultiple)
                                {
                                    if (value.length!=0)
                                    {
                                        var dataSet = this.model.categorizeSettings;
                                        categorizeDataIndex = this._findResourceIndex(dataSet.dataSource, "text", value);
                                        categorizeVal[0].push({ text: dataSet.dataSource[categorizeDataIndex][dataSet.text], color: dataSet.dataSource[categorizeDataIndex][dataSet.color], id: dataSet.dataSource[categorizeDataIndex][dataSet.id], fontColor: dataSet.dataSource[categorizeDataIndex][dataSet.fontColor] });
                                        categorizeVal[0].shift();
                                    }
										
                                }									  
                            }
                            else {
                                autoVal.push($element.data("ejAutocomplete").getSelectedItems());
                            }
                        }
                    }
                }}
                var starttime = this._timeFormat(temp.StartTime).split(":");
            var endtime = this._timeFormat(temp.EndTime).split(":");
            obj[this.model.appointmentSettings["startTime"]] = new Date(temp.StartDate.setHours(parseInt(starttime[0]), parseInt(starttime[1])));
            obj[this.model.appointmentSettings["endTime"]] = new Date(temp.EndDate.setHours(parseInt(endtime[0]), parseInt(endtime[1])));
            (obj[this.model.appointmentSettings["recurrence"]]) && (obj[this.model.appointmentSettings["recurrenceRule"]] = this._recRule);
            // timezone calculation
            if (obj.startutc != "") {
                var utc = obj.startutc.indexOf("UTC") != -1 ? obj.startutc.split(" ")[1].split(":") : obj.startutc.split(":");
                var hour = parseInt(utc[0]);
                var minutes = parseInt(utc[1]);
                var calcualtevalue = (hour * 60) + minutes;
                if (this.model.timeZone == null) {
                    var localtime = new Date().getTimezoneOffset();
                    var local = this._minToHour(localtime + ((hour * 60) + minutes));
                }
                else {
                    var timezone = this.model.timeZone.indexOf("UTC") != -1 ? this.model.timeZone.split(" ")[1].split(":") : this.model.timeZone.split(":");
                    var local = this._minToHour((hour * 60) + minutes);
                    local.h = (parseInt(timezone[0])) - local.h;
                    local.m = (parseInt(timezone[1])) - local.m;
                }
                new Date(obj.StartTime.setHours(obj.StartTime.getHours() + local.h, obj.StartTime.getMinutes() + local.m));
                if (obj.startutc != obj.endutc) {
                    this.startutcValue = null;
                    this.tempValue = null;
                    var utc1 = obj.endutc.indexOf("UTC") != -1 ? obj.endutc.split(" ")[1].split(":") : obj.endutc.split(":");
                    var hour1 = parseInt(utc1[0]);
                    var minutes1 = parseInt(utc1[1]);
                    var calculateend = (hour1 * 60) + minutes1;
                    calcualtevalue = this.model.timeZone ? calculateend - (parseInt(timezone[0]) * 60 + parseInt(timezone[1])) : calculateend - calcualtevalue;
                    var tempStart = new Date(temp.StartDate);
                    var CloneStart = new Date(obj.StartTime);
                    var cloneEnd = new Date(temp.EndDate);
                    duration = new Date(CloneStart.setMinutes(CloneStart.getMinutes() + calcualtevalue));
                    var differ = ((temp.EndDate.getHours() * 60) + temp.EndDate.getMinutes()) - ((duration.getHours() * 60) + duration.getMinutes());
                    var cloneEnddiffer = new Date(cloneEnd.setHours(tempStart.getHours(), tempStart.getMinutes() + differ));
                }
                else
                    new Date(obj.EndTime.setHours(obj.EndTime.getHours() + (local.h), obj.EndTime.getMinutes() + local.m));
            }
            //Update the edited date
            if (this._currentAction == ej.Schedule.Actions.EditOcurrence) {
                var query = new ej.Query().where(this.model.appointmentSettings["id"], ej.FilterOperators.equal, obj[this.model.appointmentSettings["id"]]);
                var _editApps = new ej.DataManager(this._processed).executeLocal(query);
                var _editApp = this._deleteOcurrence(this._parentId, new Date(_editApps[0][this.model.appointmentSettings["startTime"]]));
                new ej.DataManager(this._processed).remove(this.model.appointmentSettings["id"], this._appId);
                obj[this.model.appointmentSettings["recurrence"]] = 1;
                obj[this.model.appointmentSettings["recurrenceRule"]] = _editApp[0][this.model.appointmentSettings["recurrenceRule"]] + ";RECUREDITID=" + _editApp[0][this.model.appointmentSettings["id"]];
            }
            else if (this._currentAction == ej.Schedule.Actions.EditSeries) {
                var query = new ej.Query().where(this.model.appointmentSettings["id"], ej.FilterOperators.equal, this._parentId);
                var _editApp = new ej.DataManager(this._currentAppointmentData).executeLocal(query);
                obj[this.model.appointmentSettings["id"]] = _editApp[0][this.model.appointmentSettings["id"]]; maxId = _editApp[0][this.model.appointmentSettings["id"]]; 
                obj[this.model.appointmentSettings["recurrenceRule"]] = (ej.isNullOrUndefined(this._recRule) || this._recRule == "") ? _editApp[0][this.model.appointmentSettings["recurrenceRule"]] : this._recRule;
            }
            if (this._currentAction != ej.Schedule.Actions.Add) {
                if (this._trigger("actionBegin", {data:obj,requestType:"appointmentEdit"})) {
                    this._appointmentAddWindow.ejDialog("close");
                    return false;
                }
                if (this._trigger("appointmentEdited", { appointment: obj })) {
                    this._appointmentAddWindow.ejDialog("close");
                    return false;
                }
            }
            else {
                if (this._trigger("actionBegin", { data: obj, requestType: "appointmentSave" })) {
                    this._appointmentAddWindow.ejDialog("close");
                    return false;
                }
                if (this._trigger("appointmentSaved", { appointment: obj })) {
                    this._appointmentAddWindow.ejDialog("close");
                        return false;
                    }
                }
                var args = [], newAppointment;
                (obj.startutc != obj.endutc) ? obj[this.model.appointmentSettings["endTime"]] = cloneEnddiffer : "";
				if (!ej.isNullOrUndefined(this.model.categorizeSettings) && categorizeVal.length >0 ||!ej.isNullOrUndefined(this.model.resources) && ej.scheduleFeatures.resources)              
				    args = this._getResCategorySaveData(categorizeVal,autoVal, obj, maxId, temp, starttime, endtime);       
                else {
                    var parId = this._currentAction == ej.Schedule.Actions.EditOcurrence || (!ej.isNullOrUndefined(obj[this.model.appointmentSettings["recurrenceRule"]]) && obj[this.model.appointmentSettings["recurrenceRule"]].toString().indexOf("RECUREDITID") != -1) ? this._parentId: (((new Date(obj[this.model.appointmentSettings["endTime"]]) - new Date(obj[this.model.appointmentSettings["startTime"]])) / 3600000) > 24)  ? obj[this.model.appointmentSettings["id"]] : maxId;
                    this._maxId = (((new Date(obj[this.model.appointmentSettings["endTime"]]) - new Date(obj[this.model.appointmentSettings["startTime"]])) / 3600000) > 24) ? parId : maxId;                    
                    newAppointment = this._addAppData(obj, this._maxId, new Date(obj[this.model.appointmentSettings["startTime"]]), new Date(obj[this.model.appointmentSettings["endTime"]]), parId);
                    newAppointment.startutc = obj.startutc;
                    newAppointment.endutc = obj.endutc;
                    args.push(newAppointment);
                }
				if (this._currentAction == ej.Schedule.Actions.Add || this._currentAction == ej.Schedule.Actions.EditOcurrence) {
				    this._maxId = maxId;
                    var proxy = this, promise,temp=[];
                    for (var a = 0; a < args.length; a++) {
                        temp.push(this._timeZoneConversion(args[a]));
                    }
                    for (var b = 0; b < args.length; b++) {
                        new ej.DataManager(this._currentAppointmentData).update(this.model.appointmentSettings["id"], args[b]);
                    }
                    var _editApp = [];
                    if (this._currentAction == ej.Schedule.Actions.EditOcurrence) {
                        var query = new ej.Query().where(this.model.appointmentSettings["id"], ej.FilterOperators.equal, this._parentId);
                        var _App = new ej.DataManager(this._currentAppointmentData).executeLocal(query);
                        new ej.DataManager(this._currentAppointmentData).update(this.model.appointmentSettings["id"], _App[0]);
                        _editApp.push(this._timeZoneConversion(_App[0]));
                    }
                    else
                        _editApp = [];
                    promise = this._dataManager.saveChanges({ added: temp, changed: _editApp, deleted: [] },this.model.appointmentSettings["id"]);
                    var updateTempNew = [];
                    for (var c = 0; c < temp.length; c++) {
                        updateTempNew = this._reverseTimeZoneConversion(temp[c]);
                        new ej.DataManager(this._currentAppointmentData).update(this.model.appointmentSettings["id"], updateTempNew);
                    }
                    var updateTempNew2 = [];
                    for (var c = 0; c < _editApp.length; c++) {
                        updateTempNew2 = this._reverseTimeZoneConversion(_editApp[c]);
                        new ej.DataManager(this._currentAppointmentData).update(this.model.appointmentSettings["id"], updateTempNew2);
                    }
                    if ($.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                        promise.done(function (e) {
                            for (var i = 0; i < args.length; i++) {
                                proxy._processed.push(args[i]);
                                proxy._currentAppointmentData.push(args[i]);
                                proxy._renderSingleApp(obj, args[i]);

                            }
                            proxy._trigger("actionComplete", { data: args, requestType: "appointmentSave" });
                        });
                        promise.fail(function (e) {
                        });
                    }
                    else {
                        for (var i = 0; i < args.length; i++) {
                            this._appointmentProcessing(args[i]);
                            !(this.dataSource() instanceof ej.DataManager) && this._renderSingleApp(obj, args[i]);
                        }
                        this._trigger("actionComplete", { data: args, requestType: "appointmentSave" });
                    }
                }
                else if (this._currentAction == ej.Schedule.Actions.Save || this._currentAction == ej.Schedule.Actions.EditSeries) {
                    var newApp = [], editedApp = [], deleted = [];
					for (var i = 0; i < args.length; i++) {
                        query = new ej.Query().where(this.model.appointmentSettings["id"], ej.FilterOperators.equal, args[i].ParentId);
                        _editApp = new ej.DataManager(this._currentAppointmentData).executeLocal(query);//this.dataSource() instanceof ej.DataManager ? ej.DataManager(this._processed).executeLocal(query) : this._dataManager.executeLocal(query);
                        (!ej.isNullOrUndefined(_editApp) && _editApp.length > 0) ? editedApp.push(args[i]) : newApp.push(args[i]);
                    }
                    if (this._currentAction == ej.Schedule.Actions.EditSeries) {
                        var query, dele;
                        for (var i = 0; i < editedApp.length; i++) {
                            query = ej.Query().where(ej.Predicate(this.model.appointmentSettings["recurrenceRule"], ej.FilterOperators.contains, "RECUREDITID=" + args[i].ParentId, true));
                            dele = new ej.DataManager(this._currentAppointmentData).executeLocal(query);
                            deleted = deleted.concat(dele);
                            this._appointmentAddWindow.find('.recurbutton').click();
                            editedApp[i][this.model.appointmentSettings["recurrenceRule"]] = this._recRule;
                            }
                        }
                    var proxy = this, promise, newTemp = [], editTemp = [];
                    for (var a = 0; a < newApp.length; a++) {
                        newTemp.push(this._timeZoneConversion(newApp[a]));
                    }
                    for (var b = 0; b < editedApp.length; b++) {
                        editTemp.push(this._timeZoneConversion(editedApp[b]));
                    }
                    var promise = this._dataManager.saveChanges({ added: newTemp, changed: editTemp, deleted: deleted }, this.model.appointmentSettings["id"]);
					var updateTempNew;
                    for (var c = 0; c < newTemp.length; c++) {
					updateTempNew = this._reverseTimeZoneConversion(newTemp[c]);
                    new ej.DataManager(this._currentAppointmentData).update(this.model.appointmentSettings["id"], updateTempNew);
                    }
                    var updateTemp;
                    for (var d = 0; d < editTemp.length; d++) {
                        updateTemp = this._reverseTimeZoneConversion(editTemp[d]);
                        new ej.DataManager(this._currentAppointmentData).update(this.model.appointmentSettings["id"], updateTemp);
                    }
                    if (editedApp.length > 0) { //updating edited appointments
                        var proxy = this;
                        if ($.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                            promise.done(function (e) {
                                for (var i = 0; i < editedApp.length; i++) {
                                    (editedApp[i][proxy.model.appointmentSettings["recurrence"]] || (Globalize.format(new Date(editedApp[i][proxy.model.appointmentSettings["startTime"]]), proxy._pattern.d) < Globalize.format(new Date(editedApp[i][proxy.model.appointmentSettings["endTime"]]), proxy._pattern.d)) && (((new Date(editedApp[i][proxy.model.appointmentSettings["endTime"]]) - new Date(editedApp[i][proxy.model.appointmentSettings["startTime"]])) / 3600000) < 24) && (editedApp[i][proxy.model.appointmentSettings["allDay"]] !== true)) ? proxy._dataProcessing(proxy._currentAppointmentData) : new ej.DataManager(proxy._processed).update(proxy.model.appointmentSettings["id"], editedApp[i]) && proxy.element.find("#Appointment_" + proxy._appId).remove() && proxy.element.find("#categorybar_" + proxy._appId).remove();
                                    proxy._renderSingleApp(editedApp[i], editedApp[i]);
                                }
                                proxy._trigger("actionComplete", { data: editedApp, requestType: "appointmentEdit" });
                            });
                            promise.fail(function (e) {
                            });
                        }
                        else {
                            for (var i = 0; i < editedApp.length; i++) {
                                if (!(editedApp[i][this.model.appointmentSettings["recurrence"]] || (Globalize.format(new Date(editedApp[i][this.model.appointmentSettings["startTime"]]), this._pattern.d) < Globalize.format(new Date(editedApp[i][this.model.appointmentSettings["endTime"]]), this._pattern.d)) && (((new Date(editedApp[i][this.model.appointmentSettings["endTime"]]) - new Date(editedApp[i][this.model.appointmentSettings["startTime"]])) / 3600000) < 24) && (editedApp[i][this.model.appointmentSettings["allDay"]] !== true)))
                                    new ej.DataManager(this._processed).update(this.model.appointmentSettings["id"], editedApp[i]) && this.element.find("#Appointment_" + this._appId).remove();
                                else
                                    proxy._dataProcessing(proxy._currentAppointmentData);
								(((new Date(obj[this.model.appointmentSettings["endTime"]]) - new Date(obj[this.model.appointmentSettings["startTime"]])) / 3600000) > 24)? this._dataProcessing(this._currentAppointmentData):"";
                                proxy.element.find("#categorybar_" + proxy._appId).remove()
                                proxy._renderSingleApp(editedApp[i], editedApp[i]);
                            }
                            this._trigger("actionComplete", { data: editedApp, requestType: "appointmentEdit" });
                        }
                    }
                    if (newApp.length > 0) { // for newly added appointments during editing
                        if ($.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                            promise.done(function (e) {
                                for (var i = 0; i < newApp.length; i++) {
                                    proxy._processed.push(newApp[i]);
                                    proxy._renderSingleApp(newApp[i], newApp[i]);
                                }
                            });
                            promise.fail(function (e) {
                            });
                        }
                        else {
                            for (var i = 0; i < newApp.length; i++) {
                                this._appointmentProcessing(newApp[i]);
                                !(this.dataSource() instanceof ej.DataManager) && this._renderSingleApp(newApp[i], newApp[i]);
                            }
                        }
                    }
                }
            }
            this._clearFields();
            this._appointmentAddWindow.ejDialog("close");
            if (this.element.find('div.e-draggableworkarea tr').find('td').hasClass("e-selectedCell"))
            this._processFocus();
        this._recRule = "";

    },

    _renderSingleApp: function (obj, args) {
	var isBigApp = ((Globalize.format(obj[this.model.appointmentSettings["startTime"]], this._pattern.d) < Globalize.format(obj[this.model.appointmentSettings["endTime"]], this._pattern.d)) && (((obj[this.model.appointmentSettings["endTime"]] - obj[this.model.appointmentSettings["startTime"]]) / 3600000) < 24) && (obj[this.model.appointmentSettings["allDay"]] !== true) && obj[this.model.appointmentSettings["recurrence"]] != 1);
    this.element.find(".e-prev,.e-next").css("display", "none");
    if (obj[this.model.appointmentSettings["recurrence"]] || isBigApp || this.currentView() === "month" || (this._isCustomView()) || (((obj[this.model.appointmentSettings["endTime"]] - obj[this.model.appointmentSettings["startTime"]]) / 3600000) > 24)) {
        this._dataProcessing(this._currentAppointmentData);
        this._renderAppointmentAll();
    }
    else {
        var strDate = obj[this.model.appointmentSettings["startTime"]];
        var index = this.currentView() === "day" ? 0 : $.inArray(new Date(strDate.getFullYear(), strDate.getMonth(), strDate.getDate()).getTime(), this._dateRender);
        var resIndex = (!ej.isNullOrUndefined(this.model.resources) && !ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources) ? this._findResourceIndex(this.res1, "id", args[this.model.appointmentSettings.resourceFields.toString().split(',')[this.model.resources.length - 1]]) : 0;
        this._getDayAppointments(index, resIndex);
        ((this.currentView() !== "month" && !(this._isCustomView())) ? (index >= 0 && obj[this.model.appointmentSettings["allDay"]] && this.model.orientation == "vertical" ? this._setAllDayPos(args, index, resIndex) : this._renderApp(args, index, resIndex)) : this._renderAppointmentMonth(args, this._cellIndex));
        if (this.overlapList.length > 1) {
            //                    this._categorybar = true;
            for (var i = 0; i < this.overlapList.length; i++) {
                this.element.find("#Appointment_" + this.overlapList[i][this.model.appointmentSettings["id"]]).remove();
                this.element.find("#categorybar_" + this.overlapList[i][this.model.appointmentSettings["id"]]).remove();
                this.currentView() == "month" || (this._isCustomView()) ? this._renderAppointmentMonth(this.overlapList[i], this._cellIndex) : this._renderApp(this.overlapList[i], index, resIndex);
            }
        }
        this._unWireResizeEvents(); // Unwire appointments resize events.
        this._wireResizeEvents(); // wire appointments resize events.
        this._dragdropAppointments(); // Wire appointments  Drag events.
    }
    },

    /**
    * Convert timeformat into 24 hour mode.
    * @private
    */
    _timeFormat: function (time) {
        var culture = Globalize.culture(this.model.locale);
        var hours = Number(time.match(/^(\d+)/)[1]);
        var minutes = Number(time.match(/:(\d+)/)[1]);
        if (!ej.isNullOrUndefined(time.split(" ")[1])) {
            var AMPM = time.match(/\s(.*)$/)[1];
            if (AMPM == culture.calendar.PM[0] && hours < 12) hours = hours + 12;
            if (AMPM == culture.calendar.AM[0] && hours == 12) hours = hours - 12;
        }
        var sHours = hours.toString();
        var sMinutes = minutes.toString();
        if (hours < 10) sHours = "0" + sHours;
        if (minutes < 10) sMinutes = "0" + sMinutes;
        return sHours + ":" + sMinutes;
    },
    /**
    * Section for handle the escape key process.
    * @private
    */
    _processEscapeKey: function () {
        this._processFocus();
        this.element.find("#" + this._id + "_navigator").ejDatePicker("hide");
    },
    /**
    * Section for handle the focus process of the schedule.
    * @private
    */
    _processFocus: function () {
        var selectApp = this.element.find("div.e-selectedAppointment");
        if (selectApp.length != 0)
            selectApp.focus();
        if (this.element.find("td.e-selectedCell").hasClass("e-workcells")) {
            var oRowCell = this.element.find('div.e-draggableworkarea tr');
            var rowcount = oRowCell.length - 1; // this.get_RowCount();
            var omincolIndex, omaxcolIndex, rowInx, maxrowInx, checkcolindex;
            var curr_View = this.currentView();
            var proxy = this;
            this.element.find('td.e-selectedCell').each(function (index, tdItem) {
                var targetId = $(tdItem).index();
                if (targetId != null && !isNaN(targetId)) {
                    if (omincolIndex == null) {
                        omincolIndex = targetId;
                        rowInx = $(tdItem).parent()[0].rowIndex;
                    }
                    else if (omincolIndex < targetId) {
                        omincolIndex = omincolIndex;
                    }
                    else {
                        if (omincolIndex != targetId) {
                            omincolIndex = targetId;
                            rowInx = $(tdItem).parent()[0].rowIndex;
                        }
                    }
                    if (omaxcolIndex == null) {
                        omaxcolIndex = targetId;
                        if (curr_View != "month") {
                            checkcolindex = parseInt(omaxcolIndex);
                            for (var i = 0; i <= rowcount; i++) {
                                if ($(oRowCell[i].cells[checkcolindex]).hasClass("e-selectedCell")) {
                                    maxrowInx = i;

                                }
                            }
                        }
                    }
                    else if (omaxcolIndex > targetId) {
                        omaxcolIndex = omaxcolIndex;
                    }
                    else {
                        if (omaxcolIndex != targetId) {
                            omaxcolIndex = targetId;
                            if (curr_View != "month") {
                                checkcolindex = parseInt(omaxcolIndex);
                                for (var i = 0; i <= rowcount; i++) {
                                    if ($(oRowCell[i].cells[checkcolindex]).hasClass("e-selectedCell")) {
                                        maxrowInx = i;

                                    }
                                }
                            }
                        }
                    }
                }
            });
            if (curr_View != "month") {
                $(oRowCell[maxrowInx].cells[omaxcolIndex]).attr("tabIndex", 0).focus();
            }
            else {
                var tdsel = oRowCell.find('td.e-selectedCell');
                var tdlen = parseInt(tdsel.length) - 1;
                $(tdsel[tdlen]).attr("tabIndex", 0).focus();
            }
        }
        else {
            this.element.focus();
            this.element.find("td.e-selectedCell").attr("tabIndex", 0).focus();
        }
    },
    /**
    * Section to clear all the fields of apointment window.
    * @private
    */
    _clearFields: function () {
        this._appointmentAddWindow.find('.subject').val("");
        this._appointmentAddWindow.find('.e-description').val("");
        this._appointmentAddWindow.find("#" + this._id + "startdate").ejDatePicker("option", "value", Globalize.format(new Date(), this._pattern.d));
        this._appointmentAddWindow.find("#" + this._id + "enddate").ejDatePicker("option", "value", Globalize.format(new Date(), this._pattern.d));
        this._appointmentAddWindow.find('.startendtime').ejTimePicker({ enabled: true });
        this._appointmentAddWindow.find("#" + this._id + "starttime").ejTimePicker("option", "value", Globalize.format(new Date(), this._pattern.t));
        this._appointmentAddWindow.find("#" + this._id + "endtime").ejTimePicker("option", "value", Globalize.format(new Date(), this._pattern.t));
        this._appointmentAddWindow.find(".recurrence,.weekdays").ejCheckBox({ checked: false, enabled: true });
        this._appointmentAddWindow.find(".e-repeatlbl").removeClass('e-disable');
        this._appointmentAddWindow.find(".allday").ejCheckBox({ checked: false });
        this._appointmentAddWindow.find(".startutc,.endutc").ejDropDownList("clearText");
        this._appointmentAddWindow.find("." + this._id + "summary").css("display", "none");
        this._appointmentAddWindow.find(".e-recurFinalRule").html("");
        this._appointmentAddWindow.find(".e-recuredit").hide();
        this._appointmentAddWindow.find(".e-categorizevalue").ejAutocomplete("clearText");
    },
    /**
    * To configure the model for numeric text box.
    * @private
    */
    _getNumericModel: function () {
        return numericModel = {
            width: "100px",
            minValue: 1,
            value: 1,
            cssClass: this.model.cssClass,
            enableRTL: this.model.enableRTL,
            localize: this.model.locale
        };
    },
    /**
    * Section to clear all the recurrence fields.
    * @private
    */
    _recurClearFields: function () {
        var list = this._appointmentAddWindow.find("input[name='weekdays']");
        for (var i = 0; i < list.length; i++) {
            $(list[i]).ejCheckBox({ checked: false });
        }
        this._appointmentAddWindow.find('.e-recurevery').ejNumericTextbox({ value: 1 });
        this._appointmentAddWindow.find('.e-recurcount').ejNumericTextbox({ value: 10 });
        this._appointmentAddWindow.find(".e-recurRule").html("");
    },
    /**
    * Section to delete the appointment.
    * @private
    */
    _getApps: function () {
        var dateCount = this._dateRender;
        this._app = [];var appointmentsList = this._processed;
        for (var res = 0; res < this.res1.length; res++) {
            for (var day = 0; day < dateCount.length; day++) {
                for (var app = 0; app < appointmentsList.length; app++) {
                    if ((Globalize.format(new Date(appointmentsList[app][this.model.appointmentSettings["startTime"]]), this._pattern.d) <= Globalize.format(new Date(dateCount[day]), this._pattern.d)) && (Globalize.format(new Date(appointmentsList[app][this.model.appointmentSettings["endTime"]]), this._pattern.d) >= Globalize.format(new Date(dateCount[day]), this._pattern.d)) && (Globalize.format(new Date(appointmentsList[app][this.model.appointmentSettings["startTime"]]), this._pattern.d) == Globalize.format(new Date(appointmentsList[app][this.model.appointmentSettings["endTime"]]), this._pattern.d)) && (Globalize.format(new Date(appointmentsList[app][this.model.appointmentSettings["startTime"]]), this._pattern.d) <= Globalize.format(new Date(appointmentsList[app][this.model.appointmentSettings["endTime"]]), this._pattern.d))) {
                        this._app.push(appointmentsList[app]);

                    }
                }
            }
        }

    },
    _deleteApp: function (id) {
        var args;
        if (this._trigger("actionBegin", { id:id, requestType: "appointmentDelete" }))
            return false;
        var query = new ej.Query().where(this.model.appointmentSettings["id"], ej.FilterOperators.equal, id);
        var removeItem = ej.DataManager(this._processed).executeLocal(query);
        var p_id = removeItem.length == 0 ? id : this._getAppointmentByParentId(id);
        var promise = this._dataManager.remove(this.model.appointmentSettings["id"], id);
        if(ej.isNullOrUndefined(promise)) { promise = this._dataManager.remove(this.model.appointmentSettings["id"], p_id); }
        var proxy = this;
        if (!ej.isNullOrUndefined(promise)) {
            if ($.isFunction(promise.promise)) {
                promise.done(function (e) {
                    //       removeItem = e;
                    var query = new ej.Query().where(proxy.model.appointmentSettings["id"], ej.FilterOperators.equal, p_id);
                    removeItem = removeItem.length == 0 ?  new ej.DataManager(proxy._currentAppointmentData).executeLocal(query) : removeItem;
                    (removeItem[0][proxy.model.appointmentSettings["recurrence"]]) && proxy._deleteRecurrence(id);
                    new ej.DataManager(proxy._currentAppointmentData).remove(proxy.model.appointmentSettings["id"], id);
                    (removeItem[0][proxy.model.appointmentSettings["recurrence"]]) ? proxy._dataProcessing(proxy._currentAppointmentData) && proxy._renderAppointmentAll() : new ej.DataManager(proxy._processed).remove(proxy.model.appointmentSettings["id"], id) && proxy.element.find("#Appointment_" + id).remove() && proxy.element.find("#categorybar_" + id).remove();;
                    proxy._trigger("actionComplete", { data: e, requestType: "appointmentDelete" });
                });
                promise.fail(function (e) {
                });
            }
            else {
                (promise[0][this.model.appointmentSettings["recurrence"]]) && this._deleteRecurrence(id);
                ((promise[0][this.model.appointmentSettings["recurrence"]]) || (((new Date(promise[0][this.model.appointmentSettings["endTime"]]) - new Date(promise[0][this.model.appointmentSettings["startTime"]])) / 3600000) > 24)) ? this._dataProcessing(this._currentAppointmentData) && this._renderAppointmentAll() : new ej.DataManager(this._processed).remove(this.model.appointmentSettings["id"], id) && this.element.find("#Appointment_" + id).remove() && this.element.find("#categorybar_" + id).remove();;
                this._trigger("actionComplete", { data: removeItem, requestType: "appointmentDelete" });
            }
        }
        this._getApps();
        if (this._app.length < 1) {
            if (this.model.enableAppointmentNavigation)
                this._nextPrevButton(this._app);
        }
        args = { appointment: promise };
        this._trigger("appointmentDeleted", args);
    },

    _deleteRecurrence: function (id) {
        var query = ej.Query().where(ej.Predicate(this.model.appointmentSettings["recurrenceRule"], ej.FilterOperators.contains, "RECUREDITID=" + id, true));
        var _newAddList = new ej.DataManager(this._processed).executeLocal(query);
        for (var i = 0; i < _newAddList.length; i++) {
            this._deleteApp(_newAddList[i][this.model.appointmentSettings["id"]]);
            this.element.find("#Appointment_" + id).remove();
            this.element.find("#categorybar_" + id).remove();
        }
    },


    /**
    * Section for handle the appointment resize start process.
    * @private
    */
    _appointmentResizeStart: function (e) {
        if (this.model.enableAppointmentResize) {
            var data = { element: $(e.target).parent() };
			this._appointdata= $(e.target).parent();
            if (this._trigger("actionBegin", { data: data, requestType: "appointmentResize" }))
                return false;
            if (this._trigger("resizeStart", data))
                return false;
            e.preventDefault();
            this.model.showQuickWindow && this._quickAppointWindow.ejDialog("close") && this._quickAppDetailsWindow.ejDialog("close");
            this.resizeStart = true;
            if ($(e.target).hasClass("e-lefthandle") || $(e.target).hasClass("e-righthandle")) {
                this.resize = e.pageX;
                this.appoint_width = $(e.target).parent().width();
                this.appoint_left = parseInt($(e.target).parent()[0].style.left);
                this._appointleft = parseInt($($(e.target).parent()[0]).offset().left);
                $(e.target).hasClass("e-lefthandle") ? this._leftResizing = true : this._rightResizing = true;
            }
            else if ($(e.target).hasClass("e-tophandle") || $(e.target).hasClass("e-bottomhandle")) {
                this.resize = e.pageY;
                this.appoint_height = $(e.target).parent().height();
                this.appoint_top = parseInt($(e.target).parent()[0].style.top);
                $(e.target).hasClass("e-tophandle") ? this._topResizing = true : this._bottomResizing = true;
            }
            this._curElmt = $(e.target).parent();
            this.element.find(".e-workcells").removeClass("e-selectedCell");
            this.element.find(".e-workcells").removeClass("e-mousehover");
            this._on($(document), ej.eventType.mouseMove, $.proxy(this._appointmentResizing, this));
            this._on($(document), ej.eventType.mouseUp, $.proxy(this._appointmentResizeStop, this));
            if ($(e.target).hasClass("e-rowcursor") || $(e.target).hasClass("e-columncursor")) // to prevent the drag n drop functionality
                return false;
        }
    },
    /**
    * Section for handle the appointments while resizing.
    * @private
    */
    _appointmentResizing: function (e) {
		var target = $(e.target);
        var data = { element: target.parent() };
		var appointDiv = $(e.target).hasClass("e-appointment") || $(e.target).hasClass("e-monthappointment") || $(e.target).hasClass("e-workcells")|| $(e.target).hasClass("e-monthcells") || $(e.target).hasClass("e-alldayappointment") || $(e.target).hasClass("e-alldaycells")? $(e.target) : $(e.target).parents(".e-appointment,.e-alldayappointment,.e-monthappointment");
        var cellHeight = this.element.find(".e-workcells").height();
		var appointcellCount = ($(appointDiv[0]).height() / cellHeight);		
		if (this._trigger("resize", data))
            return false;
        if (this._topResizing) {
        if (appointcellCount>0 && !$(e.target).hasClass("e-alldaycells")&&!$(e.target).hasClass("e-apptext")){
            this._curElmt.height(this.appoint_height + this.resize - e.pageY + 3);
            this._curElmt.css("top", this.appoint_top - (this.resize - e.pageY) - 3);
         }
          }
        else if (this._bottomResizing) {
            this._curElmt.height(this.appoint_height + (e.pageY - this.resize) + 2);
        }
        else if (this._rightResizing) {
            this._curElmt.width(this.appoint_width + (e.pageX - this.resize) + 2);
        }
        else if (this._leftResizing) {
            this._curElmt.width(this.appoint_width + this.resize - e.pageX + 3);
            this._curElmt.css("left", this.appoint_left - (this.resize - e.pageX) - 3);
        }
    },
    /**
    * Section for handle the appointment after stop the resize.
    * @private
    */
    _appointmentResizeStop: function (e) {
        try {
            var dragArea = this.element.find(".e-draggableworkarea");
            this.resizeStart = false;
            $(document).unbind(ej.eventType.mouseMove);
            $(document).unbind(ej.eventType.mouseUp);
            var model = this.model.appointmentSettings;
            var appList = this._currentAppointmentData;
			var workcell = this.element.find(".e-workcellstab");
            var scheduleHeight=workcell.find("tr").length*this.element.find(".e-workcells").height();
            var appointDiv = $(e.target).hasClass("e-appointment") || $(e.target).hasClass("e-monthappointment") || $(e.target).hasClass("e-alldayappointment") ? $(e.target) : $(e.target).parents(".e-appointment,.e-alldayappointment,.e-monthappointment");
            if (appointDiv.length!=0){
			var appId = appointDiv[0].id.split("_")[1];
			}
			else{
			 var appointDiv=this._appointdata;
             var appId = appointDiv[0].id.split("_")[1];
			}
            var tempApp = new ej.DataManager(this._processed).executeLocal(new ej.Query().where(this.model.appointmentSettings["id"], ej.FilterOperators.equal, appId));
            var appoint = ((tempApp[0][model["recurrence"]] && tempApp[0][model["recurrenceRule"]].toString().indexOf("RECUREDITID") == -1)) ? this._getAppointmentByParentId(appId) : (tempApp[0][model["recurrence"]] ? tempApp[0] : this._getAppointmentByParentId(appId));
            //var appoint = this._getAppointmentByParentId(appId);
            var noOfDays = this.model.currentView === "week" || this.model.currentView === "month" || this._isCustomView() ? 7 : this.model.currentView === "workweek" ? 5 : 1;
            noOfDays = (this.currentView() == "customview" && this._renderDays <= 7) ? this._renderDays : noOfDays;

            if (appoint != null || appoint !== undefined) {
                var bigApps = appoint[this.model.appointmentSettings["startTime"]].getDate() < new Date(appoint[this.model.appointmentSettings["endTime"]]).getDate() ? true : false;
                var newStartTime = new Date(appoint[this.model.appointmentSettings["startTime"]]);
                var newEndTime = new Date(appoint[this.model.appointmentSettings["endTime"]]);
                if (tempApp[0][model["recurrence"]]) {
                     newStartTime = new Date(tempApp[0][this.model.appointmentSettings["startTime"]]);
                     newEndTime = new Date(tempApp[0][this.model.appointmentSettings["endTime"]]);
                }
                var StartTime = appoint[this.model.appointmentSettings["startTime"]];
                var EndTime = appoint[this.model.appointmentSettings["endTime"]];
                var resizeElmntHeight = $(appointDiv[0]).height();

                if (this.currentView() !== "month" && !(this._isCustomView())) {
                    var appTop = $(appointDiv[0]).offset().top; 
                    var cellHeight = this.element.find(".e-workcells").height();
                    var resizeMax = dragArea.height() + dragArea.scrollTop();
                    var topPos = appTop - dragArea.offset().top + dragArea.scrollTop();
                    var resizeMaxTop = (topPos - (cellHeight / ((60 / 30)))) < resizeMax ? topPos : resizeMax - resizeElmntHeight;
                }
					var apptotheight=resizeMaxTop+appointDiv.height();
                if (this._topResizing) {

                    if (resizeMaxTop > 0) {
                        var newTopTime;
                        newTopTime = resizeMaxTop * 60 / ((60 / 30) * (cellHeight + 1));
                        newStartTime.setHours(parseInt(this.model.startHour) + parseInt(newTopTime / 60));
                        newStartTime.setMinutes(parseInt(newTopTime % 60));
                        newStartTime.setMinutes((Math.round(newStartTime.getMinutes() / 10.0) * 10));
                    }
					else
                    {
                       newStartTime.setHours(0,0,0);
                     }
                    this._topResizing = false;
                }
                else if (this._bottomResizing) {
                    if (resizeMaxTop >= 0 && apptotheight<=scheduleHeight)  {
                        var newTopTime;
                        var newcellCount = ($(appointDiv[0]).height() / cellHeight);
                        newTopTime = (resizeMaxTop + (newcellCount * cellHeight)) * 60 / ((60 / 30) * (cellHeight + 1));
                        newEndTime.setHours(parseInt(this.model.startHour) + parseInt(newTopTime / 60));
                        newEndTime.setMinutes(parseInt(newTopTime % 60));
                        newEndTime.setMinutes((Math.round(newEndTime.getMinutes() / 10.0) * 10));
                    }
					else
                   {
                       newEndTime.setHours(23,59,59);
                   }
                    this._bottomResizing = false;
                }
                else if (this._leftResizing) {
                    if (this.model.orientation == "vertical") {
                        var index = (!this.model.group) ? 0 : this._findResourceIndex(this.res1, "id", appoint[this.model.appointmentSettings.resourceFields.split(',')[this.model.resources.length - 1]]);
                        if (this.currentView() !== "month" && !(this._isCustomView())) {
                            if ($(appointDiv[0]).offset().left > $($(".e-alldaycells")[index * noOfDays]).offset().left) {
                                newStartTime = new Date(this._dateRender[0]);
                                var diffLeft = $(appointDiv[0]).offset().left - $(this.element.find(".e-alldaycells")[index * noOfDays]).offset().left;
                                var diffDays = Math.round(diffLeft / (this.element.find(".e-alldaycells").width() + 1));
                                newStartTime.setDate(new Date(newStartTime).getDate() + diffDays);
                                newStartTime.setHours(new Date(StartTime).getHours());
                                newStartTime.setMinutes(new Date(StartTime).getMinutes());
                            }
                        }
                        else {
                            if ($(appointDiv[0]).offset().left > $($(".e-monthcells")[index * noOfDays]).offset().left) {
                                newStartTime = new Date(this._firstweekdate(new Date(tempApp[0][model["startTime"]])));
                                //var diffDays = Math.round($(appointDiv[0]).offset().left / (this.element.find(".e-monthcells").width() + 1)) - (index * noOfDays);
                                var diffDays = Math.round(($(appointDiv[0]).offset().left - $($(".e-monthcells")[index * noOfDays]).offset().left) / this.element.find(".e-monthcells").width());
                                newStartTime.setDate(newStartTime.getDate() + diffDays);
                                newStartTime.setHours(new Date(StartTime).getHours());
                                newStartTime.setMinutes(new Date(StartTime).getMinutes());
                            }
                        }
                    }
                    else {
                        var newStartTime = new Date(appoint[this.model.appointmentSettings["startTime"]]);
                        var diffLeft = $(appointDiv[0]).offset().left - this._appointleft;
                        if (this.currentView() == "month" || (this._isCustomView())) {
                            newStartTime = new Date(tempApp[0][model["startTime"]]);
                            var diffDays = Math.round(diffLeft / (this.element.find(".e-workcells").width() + 1));
                            newStartTime.setDate(new Date(newStartTime).getDate() + diffDays);
                            //newEndTime = new Date(tempApp[0][model["endTime"]]);
                        }
                        else {
                            var diffMinutes = (diffLeft * 60) / ((this.element.find(".e-workcells").width() * 2) + 1);
                            newStartTime.setHours(parseInt(new Date(newStartTime).getHours()) + parseInt(diffMinutes / 60));
                            newStartTime.setMinutes(new Date(newStartTime).getMinutes() + parseInt(diffMinutes % 60));
                            newStartTime.setMinutes(Math.round(newStartTime.getMinutes() / 10.0) * 10);
                        }
                        newStartTime = new Date(newStartTime);
                    }
                    this._leftResizing = false;
                }
                else if (this._rightResizing) {
                    if (this.model.orientation == "vertical") {
                        var index = (!this.model.group) ? 0 : this._findResourceIndex(this.res1, "id", appoint[this.model.appointmentSettings.resourceFields.split(',')[this.model.resources.length - 1]]);
                        if (this.currentView() !== "month" && !(this._isCustomView())) {
                            var diffLeft = appointDiv[0].offsetLeft + $(appointDiv[0]).width(); //  ($(appointDiv[0]).offset().left - $(this.element.find(".e-alldaycells")[(index + 1) * noOfDays]).offset().left) + $(appointDiv[0]).width();
                            var diffDays = Math.floor(diffLeft / (this.element.find(".e-alldaycells").width())) - (index * noOfDays);
                            var cellsLeft = (index == this.res1.length - 1) ? $(this.element.find(".e-alldaycells")[(index + 1) * noOfDays - 1]).offset().left + this.element.find(".e-alldaycells").width() : $(this.element.find(".e-alldaycells")[(index + 1) * noOfDays]).offset().left;
                            if (cellsLeft >= diffLeft) {
                                newEndTime = new Date(this._dateRender[0]);
                                newEndTime.setDate(new Date(newEndTime).getDate() + diffDays);
                                newEndTime.setHours(new Date(EndTime).getHours(), new Date(EndTime).getMinutes());
                            }
                        }
                        else {
                            var appWidth = $(appointDiv[0]).offset().left + $(appointDiv[0]).width();
                            var diffWidth = $(appointDiv[0]).width() - this.appoint_width;
                            var diffDays = Math.round(diffWidth / (this.element.find(".e-monthcells").width()));
                            var diffLeft = $(this.element.find(".e-monthcells")[(index) * noOfDays]).offset().left;
                            newEndTime = new Date(tempApp[0][model["endTime"]]);
                            if (appWidth > diffLeft)
                                newEndTime.setDate(new Date(newEndTime).getDate() + diffDays);
                            newEndTime.setHours(new Date(EndTime).getHours(), new Date(EndTime).getMinutes());
                        }
                    }
                    else {
                        var newEndTime = new Date(EndTime);
                        var diffWidth = $(appointDiv[0]).width() - this.appoint_width;
                        if (this.currentView() == "month" || (this._isCustomView())) {
                            //newStartTime = new Date(tempApp[0][model["startTime"]]);
                            newEndTime = new Date(tempApp[0][model["endTime"]]);
                            var diffDays = Math.round(diffWidth / (this.element.find(".e-workcells").width() + 1));
                            newEndTime.setDate(new Date(newEndTime).getDate() + diffDays);
                        }
                        else {
                            var diffMinutes = (diffWidth * 60) / ((this.element.find(".e-workcells").width() * 2) + 1);
                            newEndTime.setHours(new Date(newEndTime).getHours() + parseInt(diffMinutes / 60));
                            newEndTime.setMinutes(new Date(newEndTime).getMinutes() + parseInt(diffMinutes % 60));
                            newEndTime.setMinutes(Math.round(newEndTime.getMinutes() / 10.0) * 10);
                        }
                        newEndTime = new Date(newEndTime);
                    }
                    this._rightResizing = false;
                }

                //Recurrence applointment
                if (appoint[model["recurrence"]] == 1 && appoint[model["recurrenceRule"]].toString().indexOf("RECUREDITID") == -1) {
                    var _newAddList = {}, _resizeStrTime, _resizeEndTime;
                    var query = new ej.Query().where(this.model.appointmentSettings["id"], ej.FilterOperators.equal, appId);
                    var _appList = new ej.DataManager(this._processed).executeLocal(query)[0];
                    $.extend(_newAddList, appoint);
                    var maxdate = new Date(new Date(this.model.maxDate).getTime());
                    maxdate.setHours(23, 59, 59);
                    if ((newEndTime >= new Date(this.model.minDate)) && (newEndTime <= maxdate)) {
                        this._deleteOcurrence(parseInt(this._getAppointmentByParentId(appId)[model["id"]]), new Date(_appList[model["startTime"]]));
                        this._processed = this._sortAppById(this._processed);
                        var maxId = this._processed.length > 0 ? this._processed[this._processed.length - 1][model["id"]] + 1 : 1;
                        _newAddList[model["recurrenceRule"]] = tempApp[0][model["recurrenceRule"]] + ";RECUREDITID=" + _newAddList[model["id"]];
                        var data = { appointment: _newAddList, target: e };
						prvStartTime=_newAddList[model["startTime"]];
						prvEndTime=_newAddList[model["endTime"]];
						_newAddList[model["startTime"]] = new Date(newStartTime);
                        _newAddList[model["endTime"]] = new Date(newEndTime);
                        if (this._trigger("resizeStop", data)) {
                            _newAddList[model["startTime"]] = new Date(prvStartTime);
                            _newAddList[model["endTime"]] = new Date(prvEndTime);
                        }
                        _newAddList[model["id"]] = maxId;
                        var args = { data: _newAddList };
                        var temp = [];
                        temp.push(this._timeZoneConversion(args.data));

                        var _editApp = [];

                        var query = new ej.Query().where(this.model.appointmentSettings["id"], ej.FilterOperators.equal, _newAddList.ParentId);
                        var _App = new ej.DataManager(this._currentAppointmentData).executeLocal(query);
                        new ej.DataManager(this._currentAppointmentData).update(this.model.appointmentSettings["id"], _App[0]);
                        _editApp.push(this._timeZoneConversion(_App[0]));

                        promise = this._dataManager.saveChanges({ added: temp, changed: _editApp, deleted: []},this.model.appointmentSettings["id"]);
                        var updateTempNew = [];
                        for (var c = 0; c < temp.length; c++) {
                            updateTempNew = this._reverseTimeZoneConversion(temp[c]);
                            new ej.DataManager(this._currentAppointmentData).update(this.model.appointmentSettings["id"], updateTempNew);
                        }
                        var updateTempNew1 = [];
                        for (var c = 0; c < _editApp.length; c++) {
                            updateTempNew1 = this._reverseTimeZoneConversion(_editApp[c]);
                            new ej.DataManager(this._currentAppointmentData).update(this.model.appointmentSettings["id"], updateTempNew1);
                        }
                        var proxy = this;
                        if ($.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                            promise.done(function (e) {
                                proxy._processed.splice(proxy._processed.indexOf(_appList), 1);
                                proxy._processed.push(args.data);
                                proxy._currentAppointmentData.push(args.data);
                                proxy._renderSingleApp(_newAddList, _newAddList);
                                proxy._trigger("actionComplete", { data: _newAddList, requestType: "appointmentResize" });
                            });
                            promise.fail(function (e) {
                                proxy._renderAppointmentAll();
                            });
                        }
                        else {
                            this._processed.splice(this._processed.indexOf(_appList), 1);
                            this._processed.push(args.data);
                            this._renderSingleApp(_newAddList, _newAddList);
                            this._trigger("actionComplete", { data: _newAddList, requestType: "appointmentResize" });
                        }
                    }
                    else this._renderAppointmentAll();
                }
                else {
                    var query = new ej.Query().where(this.model.appointmentSettings["id"], ej.FilterOperators.equal, appoint[this.model.appointmentSettings["id"]]);
                    var _updateList = {}, object = new ej.DataManager(this._currentAppointmentData).executeLocal(query);
                    $.extend(_updateList, object);
                    var maxdate = new Date(new Date(this.model.maxDate).getTime());
                    maxdate.setHours(23, 59, 59);
					if (this.model.orientation == "horizontal" && !ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources)
                    this.element.find("#categorybar_" + appoint[this.model.appointmentSettings["id"]]).remove();
                    if ((newEndTime >= new Date(this.model.minDate)) && (newEndTime <= maxdate)) {
                        var data = { appointment: _updateList[0], target: e };
						prevStartTime=_updateList[0][this.model.appointmentSettings["startTime"]];
						prevEndTime= _updateList[0][this.model.appointmentSettings["endTime"]];
						_updateList[0][this.model.appointmentSettings["startTime"]] = newStartTime;
                        _updateList[0][this.model.appointmentSettings["endTime"]] = newEndTime;
                        if (this._trigger("resizeStop", data)) {
                            _updateList[0][this.model.appointmentSettings["startTime"]] = prevStartTime;
                            _updateList[0][this.model.appointmentSettings["endTime"]] = prevEndTime;
                        }
                        var temp = this._timeZoneConversion(_updateList[0]);                        
                        promise = this._dataManager.update(this.model.appointmentSettings["id"], temp);
                        var updateTemp = this._reverseTimeZoneConversion(temp);
                        new ej.DataManager(this._currentAppointmentData).update(this.model.appointmentSettings["id"], updateTemp);
                    }
                    var proxy = this;
                    if (promise && $.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                        promise.done(function (e) {
                            new ej.DataManager(proxy._processed).update(proxy.model.appointmentSettings["id"], _updateList);
                            proxy.element.find("#Appointment_" + _updateList[0][proxy.model.appointmentSettings["id"]]).remove();
                            proxy.element.find("#categorybar_" + _updateList[0][proxy.model.appointmentSettings["id"]]).remove();
                            proxy._renderSingleApp(_updateList[0], _updateList[0]);
                            proxy._trigger("actionComplete", { data: _updateList, requestType: "appointmentResize" });
                        });
                        promise.fail(function (e) {
                            proxy._renderAppointmentAll();
                        });
                    }
                    else {
                        new ej.DataManager(this._processed).update(proxy.model.appointmentSettings["id"], _updateList[0]);
                        this.element.find("#Appointment_" + appId).remove();
                        if (((tempApp[0][model["endTime"]] - tempApp[0][model["startTime"]]) / 3600000) > 24) {
                            proxy._dataProcessing(appList);
                        }
                        proxy._renderSingleApp(_updateList[0], _updateList[0]);
                        this._trigger("actionComplete", { data: _updateList, requestType: "appointmentResize" });
                    }

                }
                //this._dataProcessing(appList);
                //this._renderSingleApp(appList[0], { data: appList });
                //this._renderAppointmentAll();
            }
            this.element.find("div.e-tophandle,div.e-bottomhandle").removeClass("e-rowcursor");
            this.element.find("div.e-lefthandle,div.e-righthandle").removeClass("e-columncursor");
        } catch (e) {

        }
    },
    /**
    * Split the Recurrence rule string.
    * @private
    */
    // Split the Recurrence rule string 
    recurrenceRuleSplit: function (rRule) {
	this._rRule={};
        var _rule, _rRuleSplit = rRule.split(";");
        for (var r = 0; r < _rRuleSplit.length; r++) {
            _rule = _rRuleSplit[r].split("=");
            switch ($.trim(_rule[0]).toUpperCase()) {
                case "FREQ":
                    this._rRule.freq = $.trim(_rule[1]).toUpperCase();
                    break;
                case "INTERVAL":
                    this._rRule.interval = parseInt(_rule[1], 10);
                    break;
                case "COUNT":
                    this._rRule.count = parseInt(_rule[1], 10);
                    break;
                case "UNTIL":
                    this._rRule.until = new Date(_rule[1]);
                    break;
                case "BYDAY":
                    this._rRule.weekDays = _rule[1];
                    break;
                case "BYMONTHDAY":
                    this._rRule.monthDay = parseInt(_rule[1], 10);
                    break;
                case "BYMONTH":
                    this._rRule.month = parseInt(_rule[1], 10);
                    break;
                case "BYSETPOS":
                    this._rRule.setPositions = parseInt(_rule[1], 10);
                    break;
                case "WKST":
                    this._rRule.weekStart = _rule[1];
                    break;
                case "EXDATE":
                    var _exDates = _rule[1].split(",");
                    this._rRule.exDate = [];
                    for (var i = 0; i < _exDates.length; i++) {
                        this._rRule.exDate[i] = Globalize.format(new Date(_exDates[i]), this._pattern.d);
                    }
                    //this._rRule.exDate = _rule[1];
                    break;
                case "RECUREDITID":
                    this._rRule.recurEditId = parseInt(_rule[1]);
                    break;
            }
        }
        return this._rRule;
    },
    /**
    * Section for handle the drag and drop appointments.
    * @private
    */
    _dragdropAppointments: function () {
	    if (this.model.readOnly)
            return false;
        this._topResizing = false;
        this._bottomResizing = false;
        this._leftResizing = false;
        this._rightResizing = false;
        if (this.model.allowDragDrop) {
            var proxy = this;

            // normal appointments
            var $dragableElements = this.element.find(".e-appointment");
            $dragableElements.ejDraggable({
                handle: ".e-appointment",
                dragArea: proxy.element.find("div.e-draggableworkarea"),
                cursorAt: { top: 20, left: 0 },
                dragStart: function (args) {
                    proxy._dragStart(args);
                },
                drag: function (args) {
                    proxy._dragOver(args);
                },
                dragStop: function (args) {
                    proxy._dragStop(args);
                },
                helper: function (event, ui) {
                    var appointdiv = $(event.sender.target).hasClass("e-appointment") ? $(event.sender.target) : $(event.sender.target).parents(".e-appointment");
                    if (appointdiv.hasClass("e-appointment"))
                        return appointdiv.addClass("e-draggableAppointment").css("width", appointdiv[0].offsetWidth + "px").appendTo(proxy.element);
                }

            });

            // allday appointments
                var $dragableElements = this.element.find(".e-alldayappointment");
                $dragableElements.ejDraggable({
                    handle: ".e-alldayappointment",
                    dragArea: proxy.element.find(".e-headrealldaytable tr")[(!ej.isNullOrUndefined(this.model.group) && !ej.isNullOrUndefined(this.model.resources)) ? this.model.group.resources.length + 1 : 2],
                    cursorAt: { top: 17, left: 0 },
                    dragStart: function (args) {
                        proxy._dragStart(args);
                },
                drag: function (args) {
                    proxy._dragOver(args);
                },
                dragStop: function (args) {
                    proxy._dragStop(args);
                },
                helper: function (event, ui) {
                    var appointdiv = $(event.sender.target).hasClass("e-alldayappointment") ? $(event.sender.target) : $(event.sender.target).parents(".e-alldayappointment");
                    if (appointdiv.hasClass("e-alldayappointment"))
                        return appointdiv.addClass("e-draggableAppointment").css("width", appointdiv[0].offsetWidth + "px").appendTo(proxy.element);
                }

            });

            // month appointments
            var $dragableElements = this.element.find(".e-monthappointment");
            $dragableElements.ejDraggable({
                handle: ".e-monthappointment",
                dragArea: proxy.element.find(".e-workareadiv"),
                cursorAt: { top: 17, left: 0 },
                dragStart: function (args) {
                    proxy._dragStart(args);
                },
                drag: function (args) {
                    proxy._dragOver(args);
                },
                dragStop: function (args) {
                    proxy._dragStop(args);
                },
                helper: function (event, ui) {
                    var appointdiv = $(event.sender.target).hasClass("e-monthappointment") ? $(event.sender.target) : $(event.sender.target).parents(".e-monthappointment");
                    if (appointdiv.hasClass("e-monthappointment"))
                        return appointdiv.addClass("e-draggableAppointment").css("width", appointdiv[0].offsetWidth + "px").appendTo(proxy.element);
                }

            });
        }
    },
    /**
    * Section for handle the drag start of appointment.
    * @private
    */
    _dragStart: function (args) {
        var parTarget = $(args.target);
        if (parTarget.parents(".e-appointment").hasClass("e-appointment") || parTarget.parents(".e-monthappointment").hasClass("e-monthappointment") || parTarget.parents(".e-alldayappointment").hasClass("e-alldayappointment") || parTarget.hasClass("e-appointment") || parTarget.hasClass("e-monthappointment") || parTarget.hasClass("e-alldayappointment")) {
            var target = args.element;
            var data = { target: target };
            if (this._trigger("actionBegin", { data: data, requestType: "appointmentDrag" }))
                return false;
            if (this._trigger("dragStart", data))
                return false;
        }
        else
            args.cancel = true;
        this.model.showQuickWindow && (this._quickAppointWindow.ejDialog("close") && this._quickAppDetailsWindow.ejDialog("close"));
    },
    /**
    * Section for handle the drag over of appointment.
    * @private
    */
    _dragOver: function (args) {
        var $target = $(args.element);
        var data = { target: $target };
        this._trigger("drag", data);
        this.element.find(".e-workcells").removeClass("e-selectedCell");
        this.element.find(".e-workcells").removeClass("e-mousehover");
    },
    /**
    * Section for handle the drag stop of appointment.
        * @private
        */
    _dragStop: function (args) {
            this.model.showQuickWindow && (this._quickAppDetailsWindow.ejDialog("close"));
            var proxy = this;
            var model = proxy.model.appointmentSettings; var dragArea = proxy.element.find(".e-draggableworkarea");;
            var appId = args.element[0].id.split("_")[1];
            var tempApp = new ej.DataManager(this._processed).executeLocal(new ej.Query().where(this.model.appointmentSettings["id"], ej.FilterOperators.equal, appId));
            var appoint = ((tempApp[0][model["recurrence"]] && tempApp[0][model["recurrenceRule"]].toString().indexOf("RECUREDITID") == -1) || (((tempApp[0][model["endTime"]] - tempApp[0][model["startTime"]]) / 3600000) > 24)) ? this._getAppointmentByParentId(appId) : tempApp[0];
            //var appoint = proxy._getAppointmentByParentId(appId);
            var appList = this._currentAppointmentData;
            if (this.model.orientation == "vertical") {
                if ($(args.element[0]).hasClass("e-appointment")) {
                    var dragMax = dragArea.height() + dragArea.scrollTop();
                    var dragElmntHeight = args.element[0].offsetHeight;
                    var cellHeight = this.element.find(".e-workcells").height();
                    var topPos = $(args.element[0]).offset().top - dragArea.offset().top + dragArea.scrollTop();
                    var dragMaxTop = (topPos - (cellHeight / (60 / 30))) < dragMax ? topPos : dragMax - dragElmntHeight;
                    if (dragMaxTop > 0) {
                        var newTopTime;
                        newTopTime = dragMaxTop * 60 / ((60 / 30) * (cellHeight + 1));

                        var twoDayApps = appoint[proxy.model.appointmentSettings["startTime"]].getDate() < appoint[proxy.model.appointmentSettings["endTime"]].getDate() ? true : false;
                        var startTime = appoint[proxy.model.appointmentSettings["startTime"]];
                        var endTime = appoint[proxy.model.appointmentSettings["endTime"]];
                        var duration = (endTime - startTime) / 1000;
                        var hours = Math.floor(duration / 3600);
                        var minutes = Math.floor((duration % 3600) / 60);
                        var newStartTime, newEndTime, cellstrtime, cellendtime;

                        if (proxy.currentView() !== "month" && !(proxy._isCustomView())) {
                            var firstDayOfWeek = new Date(proxy._firstweekdate(proxy.currentDate()));
                            if (proxy.currentView() === "workweek" || (proxy.currentView() == "customview" && proxy._renderDays == 5)) {
                                var _day = new Date(firstDayOfWeek).getDay();
                                var _dayAdd = _day == 0 ? 1 : 0;
                                firstDayOfWeek.setDate(firstDayOfWeek.getDate() + _dayAdd);
                            }
                            newStartTime = firstDayOfWeek;

                            //finding cellindex by left calculation
                            var dragAreaLength = dragArea.width();
                            var noOfCols = proxy.currentView() === "week" ? 7 : proxy.currentView() === "workweek" ? 5 : proxy.currentView() == "customview" ? proxy._renderDays : 1;
                            noOfCols = !ej.isNullOrUndefined(proxy.model.group) ? noOfCols * proxy.res1.length : noOfCols;
                            var cellWidth = Math.round(dragAreaLength / noOfCols);
                            var originalLeft = $(args.element[0]).offset().left - dragArea.offset().left;
                            var cellIndex = Math.round(originalLeft / cellWidth);
                            newStartTime = (this.model.enableRTL)?new Date(this.dateRender[noOfCols-cellIndex-1]):new Date(this.dateRender[cellIndex]);
                            newEndTime = newStartTime;
                        }
                        else {
                            newStartTime = appoint[proxy.model.appointmentSettings["startTime"]];
                            newEndTime = new Date(newStartTime);
                        }

                        if (twoDayApps) {
                            newStartTime = proxy._getNewStartTime(newTopTime, newStartTime);
                            cellstrtime = new Date(newStartTime);
                            newEndTime = proxy._getNewEndTime(newStartTime, hours, minutes);
                            cellendtime = new Date(newEndTime);
                        }
                        else {
                            newStartTime.setHours(parseInt(proxy.model.startHour) + Math.round(newTopTime / 60));
                            newStartTime.setMinutes(parseInt(newTopTime % 60));
                            newStartTime = (new Date(newStartTime).getMinutes() >= 30) ? new Date(new Date(newStartTime).setHours(new Date(newStartTime).getHours() - 1)) : new Date(newStartTime);
                            newStartTime.setMinutes(Math.round(newStartTime.getMinutes() / 10.0) * 10);
                            cellstrtime = new Date(newStartTime);

                            var totMin = (appoint[proxy.model.appointmentSettings["endTime"]].getHours() * 60 + appoint[proxy.model.appointmentSettings["endTime"]].getMinutes()) -
                     (appoint[proxy.model.appointmentSettings["startTime"]].getHours() * 60 + appoint[proxy.model.appointmentSettings["startTime"]].getMinutes());


                            newEndTime.setHours(new Date(newStartTime).getHours() + parseInt(totMin / 60));
                            newEndTime.setMinutes(new Date(newStartTime).getMinutes() + parseInt(totMin % 60));
                            newEndTime.setMinutes(Math.round(newEndTime.getMinutes() / 10.0) * 10);
                            cellendtime = new Date(newEndTime);
                        }
                    }
                    else {
                        var dragAreaLength = dragArea.width();
                        var noOfCols = proxy.currentView() === "week" ? 7 : proxy.currentView() === "workweek" ? 5 : proxy.currentView() == "customview" ? proxy._renderDays : 1;
                        noOfCols = !ej.isNullOrUndefined(proxy.model.group) ? noOfCols * proxy.res1.length : noOfCols;
                        var cellWidth = Math.round(dragAreaLength / noOfCols);
                        var originalLeft = args.element[0].offsetLeft - dragArea.offset().left;
                        var cellIndex = Math.round(originalLeft / cellWidth);
                        newStartTime = (this.model.enableRTL) ? new Date(this.dateRender[noOfCols - cellIndex - 1]) : new Date(this.dateRender[cellIndex]);
                        newStartTime.setHours(0);
                        newStartTime.setMinutes(0);
                        cellstrtime = new Date(newStartTime);
                        newEndTime = newStartTime;
                        newEndTime.setHours(23);
                        newEndTime.setMinutes(59);
                        cellendtime = new Date(newEndTime);
                        var allday = true;
                    }
                }
                else if ($(args.element[0]).hasClass("e-alldayappointment")) {

                    var appoint = proxy._getAppointmentByParentId(appId);
                    newStartTime = appoint[this.model.appointmentSettings["startTime"]];
                    newEndTime = appoint[this.model.appointmentSettings["endTime"]];
                    if ((tempApp[0][model["recurrence"]] && tempApp[0][model["recurrenceRule"]].toString().indexOf("RECUREDITID") == -1)) {
                        newStartTime = tempApp[0][this.model.appointmentSettings["startTime"]];
                        newEndTime = tempApp[0][this.model.appointmentSettings["endTime"]];
                    }
                    else if ((tempApp[0][model["recurrence"]] && tempApp[0][model["recurrenceRule"]].toString().indexOf("RECUREDITID") > 0)) {
                        appoint = tempApp[0];
                        newStartTime = tempApp[0][this.model.appointmentSettings["startTime"]];
                        newEndTime = tempApp[0][this.model.appointmentSettings["endTime"]];
                    }
                    var diffLeft = args.element[0].offsetLeft - this.element.find(".e-alldaycells").offset().left - 1; // ui.position.left - ui.originalPosition.left;
                    diffLeft = (this.model.enableRTL) ? Math.abs(diffLeft) : diffLeft;
                    var cellIndex = Math.round(diffLeft / (this.element.find(".e-alldaycells").width() + 1));
                    var count = Math.round($(args.element[0]).width() / (this.element.find(".e-alldaycells").width() + 1));
                    var overall = Math.ceil((newEndTime - newStartTime) / (1000 * 60 * 60 * 24));
                    var endInd = Math.round($(args.element[0]).width() / (this.element.find(".e-alldaycells").width() + 1));
                    var cols = proxy.currentView() === "week" ? 7 : proxy.currentView() === "workweek" ? 5 : proxy.currentView() == "customview" ? proxy._renderDays : 1;
                    if (cellIndex < 0) {
                        if (newStartTime <= new Date(this._dateRender[0])) {
                            cellstrtime = new Date(newStartTime);
                            cellstrtime.setDate(cellstrtime.getDate() + cellIndex);
                            cellstrtime.setHours(new Date(appoint[proxy.model.appointmentSettings["startTime"]]).getHours());
                            cellstrtime.setMinutes(new Date(appoint[proxy.model.appointmentSettings["startTime"]]).getMinutes());
                            cellstrtime = new Date(cellstrtime);
                        }
                        else {
                            var startdate = new Date(proxy._dateRender[0]);
                            startdate.setDate(startdate.getDate() + cellIndex);
                            startdate.setHours(new Date(appoint[proxy.model.appointmentSettings["startTime"]]).getHours());
                            startdate.setMinutes(new Date(appoint[proxy.model.appointmentSettings["startTime"]]).getMinutes());
                            cellstrtime = new Date(startdate);
                        }
                    } else {
                        if (newStartTime < new Date(this._dateRender[0])) {
                            var Index = (cellIndex > cols - 1) ? (cellIndex % cols) : cellIndex;
                            newStartTime.setDate(new Date(appoint[proxy.model.appointmentSettings["startTime"]]).getDate() + Index);
                            newStartTime.setHours(new Date(appoint[proxy.model.appointmentSettings["startTime"]]).getHours());
                            newStartTime.setMinutes(new Date(appoint[proxy.model.appointmentSettings["startTime"]]).getMinutes());
                            cellstrtime = new Date(newStartTime);
                        }
                        else { 
                            var Index = (cellIndex > cols - 1) ? (cellIndex % cols) : cellIndex;
                            cellstrtime = new Date(new Date(this._dateRender[Index]));
                            cellstrtime.setHours(new Date(appoint[proxy.model.appointmentSettings["startTime"]]).getHours());
                            cellstrtime.setMinutes(new Date(appoint[proxy.model.appointmentSettings["startTime"]]).getMinutes());
                        }
                    }
                    var starttime = new Date(cellstrtime);
                    starttime.setDate(starttime.getDate() + overall - 1);
                    starttime.setHours(new Date(appoint[proxy.model.appointmentSettings["endTime"]]).getHours());
                    starttime.setMinutes(new Date(appoint[proxy.model.appointmentSettings["endTime"]]).getMinutes());
                    cellendtime = new Date(starttime);
                }

                else if ($(args.element[0]).hasClass("e-monthappointment")) {
                    var oldStartTime = appoint[proxy.model.appointmentSettings["startTime"]];
                    var oldEndTime = appoint[proxy.model.appointmentSettings["endTime"]];
                    if ((tempApp[0][model["recurrence"]] && tempApp[0][model["recurrenceRule"]].toString().indexOf("RECUREDITID") == -1)) {
                        oldStartTime = tempApp[0][this.model.appointmentSettings["startTime"]];
                        oldEndTime = tempApp[0][this.model.appointmentSettings["endTime"]];
                    }
                    else if ((tempApp[0][model["recurrence"]] && tempApp[0][model["recurrenceRule"]].toString().indexOf("RECUREDITID") >0))
                    {
                        appoint = tempApp[0];
                        oldStartTime = tempApp[0][this.model.appointmentSettings["startTime"]];
                        oldEndTime = tempApp[0][this.model.appointmentSettings["endTime"]];
                    }
                    newStartTime = new Date(new Date(proxy.model.currentDate).getFullYear(),
                                              new Date(proxy.model.currentDate).getMonth(), 1);
                    var daysInPrevMonth = newStartTime.getDay();
                    newStartTime.setDate(newStartTime.getDate() - daysInPrevMonth);
                    var cellIndex = Math.floor((args.element[0].offsetLeft - dragArea.offset().left) / this.element.find(".e-monthcells").width());
                    cellIndex = (this.model.enableRTL) ? 7 - cellIndex - 1 : cellIndex;
                    var newTopDate = Math.floor((args.element[0].offsetTop - dragArea.offset().top) / (this.element.find(".e-monthcells").outerHeight()));
                    //if (!ej.isNullOrUndefined(this.model.group)) {
                    //    cellIndex = cellIndex - 1; newTopDate = newTopDate - 2;
                    //}
                    var index = (newTopDate * 7) + (cellIndex - (Math.floor(cellIndex / 7) * 7));
                    newStartTime = new Date(proxy._dateRender[index]);
                    newStartTime.setHours(oldStartTime.getHours(), oldStartTime.getMinutes(), oldStartTime.getSeconds());
                    cellstrtime = new Date(newStartTime);
                    var diffTime = newStartTime.getTime() - new Date(oldStartTime).getTime();
                    newEndTime = new Date(new Date(oldEndTime).getTime() + diffTime);
                    cellendtime = new Date(newEndTime);
                }
            }
            else if (this.model.orientation == "horizontal" && ej.scheduleFeatures.horizontal) {
                var diffTimeLeft;
                var cellstrtime = new Date(appoint[proxy.model.appointmentSettings["startTime"]]);
                var cellendtime = new Date(appoint[proxy.model.appointmentSettings["endTime"]]);
                var colIndex = Math.floor((args.element[0].offsetLeft + dragArea.scrollLeft() - dragArea.offset().left) / this.element.find(".e-workcells").width());
                var rowIndex = Math.floor((args.element[0].offsetTop + dragArea.scrollTop() - dragArea.offset().top) / (this.element.find(".e-workcells").outerHeight()));
                var target = $(this.element.find(".e-workcellstab tr")[rowIndex]).find("td")[colIndex];

                if (!$(target).hasClass("e-resourceheadercells") && !ej.isNullOrUndefined(target)) {
                    var newStartTime = new Date(this._dateRender[0]); // new Date(appoint[proxy.model.appointmentSettings["startTime"]]);

                    diffTimeLeft = ((args.element[0].offsetLeft + dragArea.scrollLeft() - dragArea.offset().left) * (30)) / this.element.find(".e-workcells").outerWidth();

                    newStartTime.setHours(parseInt(proxy.model.startHour) + Math.round(diffTimeLeft / 60));
                    newStartTime.setMinutes(parseInt(diffTimeLeft % 60));
                    newStartTime = (new Date(newStartTime).getMinutes() >= 30) ? new Date(new Date(newStartTime).setHours(new Date(newStartTime).getHours() - 1)) : new Date(newStartTime);
                    newStartTime.setMinutes(Math.round(newStartTime.getMinutes() / 10.0) * 10);
                    cellstrtime = new Date(newStartTime);

                    var startTime = appoint[proxy.model.appointmentSettings["startTime"]];
                    var endTime = appoint[proxy.model.appointmentSettings["endTime"]];
                    var duration = (endTime - startTime) / 1000;
                    var hours = Math.floor(duration / 3600);
                    var minutes = Math.floor((duration % 3600) / 60);
                    newEndTime = proxy._getNewEndTime(newStartTime, hours, minutes);
                    cellendtime = new Date(newEndTime);

                    this._cellIndex = Math.floor((args.element[0].offsetLeft + dragArea.scrollLeft() - dragArea.offset().left) / this.element.find(".e-workcells").width());
                    var cellIndex = rowIndex;
                    if ($(args.element[0]).hasClass("e-monthappointment")) {
                        var oldStartTime = new Date(appoint[proxy.model.appointmentSettings["startTime"]]);
                        var oldEndTime = new Date(appoint[proxy.model.appointmentSettings["endTime"]]);
                        if ((tempApp[0][model["recurrence"]] && tempApp[0][model["recurrenceRule"]].toString().indexOf("RECUREDITID") == -1)) {
                        oldStartTime = tempApp[0][this.model.appointmentSettings["startTime"]];
                        oldEndTime = tempApp[0][this.model.appointmentSettings["endTime"]];
                    }
                    else if ((tempApp[0][model["recurrence"]] && tempApp[0][model["recurrenceRule"]].toString().indexOf("RECUREDITID") > 0)) {
                        appoint = tempApp[0];
                        oldStartTime = tempApp[0][this.model.appointmentSettings["startTime"]];
                        oldEndTime = tempApp[0][this.model.appointmentSettings["endTime"]];
                    }
                        newStartTime = new Date(proxy.monthDays[this._cellIndex]);
                        newStartTime.setHours(oldStartTime.getHours(), oldStartTime.getMinutes(), oldStartTime.getSeconds());
                        cellstrtime = new Date(newStartTime);
                        var diffTime = newStartTime.getTime() - new Date(oldStartTime).getTime();
                        newEndTime = new Date(new Date(oldEndTime).getTime() + diffTime);
                        cellendtime = new Date(newEndTime);
                    }
                }
            }
        //Recurrence appointment
            //appoint = ((tempApp[0][model["recurrence"]] == 1 && tempApp[0][model["recurrenceRule"]].toString().indexOf("RECUREDITID") == -1)) || (tempApp[0][model["recurrence"]] == 0 && (((tempApp[0][model["endTime"]] - tempApp[0][model["startTime"]]) / 3600000) > 24)) ? appoint : tempApp[0];
            if (appoint[model["recurrence"]] == 1 && appoint[model["recurrenceRule"]].indexOf("RECUREDITID") == -1) {
                var query = new ej.Query().where(this.model.appointmentSettings["id"], ej.FilterOperators.equal, appId);
                var _appList = new ej.DataManager(this._processed).executeLocal(query)[0];
                var _newAddList = {};
                $.extend(_newAddList, appoint);
                var maxdate = new Date(new Date(this.model.maxDate).getTime());
                maxdate.setHours(23, 59, 59);
                if ((cellendtime >= new Date(this.model.minDate)) && (cellendtime <= maxdate)) {
                    proxy._deleteOcurrence(parseInt(appoint[model["id"]]), _appList[model["startTime"]]);
                    this._processed = this._sortAppById(this._processed);
                    var maxId = this._processed.length > 0 ? this._processed[this._processed.length - 1][model["id"]] + 1 : 1;
                    _newAddList[model["recurrenceRule"]] = appoint[model["recurrenceRule"]] + ";RECUREDITID=" + _newAddList[model["id"]];
                     precellstrtime=_newAddList[model["startTime"]];
					 precellendtime=_newAddList[model["endTime"]];
				    _newAddList[model["startTime"]] = cellstrtime;
                    _newAddList[model["endTime"]] = cellendtime;
					if(proxy._trigger("dragStop", { appointment: _newAddList })){
                        _newAddList[model["startTime"]] = precellstrtime;
                        _newAddList[model["endTime"]] = precellendtime;
                    }
                    _newAddList[model["id"]] = maxId;
                    //_newAddList["ParentId"] = maxId;
                    if (!ej.isNullOrUndefined(allday)) _newAddList[model["allDay"]] = allday;
                    if (!ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources)
                        _newAddList = this._getDragDropResourceData(proxy, cellIndex, _newAddList);
                    var argsAdd = { data: _newAddList };
                    var temp = [];
                    temp.push(this._timeZoneConversion(argsAdd.data));

                    var _editApp = [];

                    var query = new ej.Query().where(this.model.appointmentSettings["id"], ej.FilterOperators.equal, _newAddList.ParentId);
                    var _App = new ej.DataManager(this._currentAppointmentData).executeLocal(query);
                    new ej.DataManager(this._currentAppointmentData).update(this.model.appointmentSettings["id"], _App[0]);
                    _editApp.push(this._timeZoneConversion(_App[0]));

                    promise = this._dataManager.saveChanges({ added: temp, changed: _editApp, deleted: [] },this.model.appointmentSettings["id"]);
                    var updateTempNew = [];
                    for (var c = 0; c < temp.length; c++) {
                        updateTempNew = this._reverseTimeZoneConversion(temp[c]);
                        new ej.DataManager(this._currentAppointmentData).update(this.model.appointmentSettings["id"], updateTempNew);
                    }
                    var updateTempNew1 = [];
                    for (var c = 0; c < _editApp.length; c++) {
                        updateTempNew1 = this._reverseTimeZoneConversion(_editApp[c]);
                        new ej.DataManager(this._currentAppointmentData).update(this.model.appointmentSettings["id"], updateTempNew1);
                    }
                    //promise = proxy._dataManager.insert(temp);
                    //new ej.DataManager(this._currentAppointmentData).update(this.model.appointmentSettings["id"], argsAdd.data);
                    if ($.isFunction(promise.promise) && proxy.dataSource() instanceof ej.DataManager) {
                        promise.done(function (e) {
                            proxy._processed.splice(proxy._processed.indexOf(_appList), 1);
                            proxy._processed.push(argsAdd.data);
                            proxy._currentAppointmentData.push(argsAdd.data);
                            //proxy._appointmentProcessing(_newAddList);
                            proxy._renderSingleApp(_newAddList, argsAdd.data);
                            proxy._trigger("actionComplete", { appointment: _newAddList, requestType: "appointmentDrag" });
                        });
                        promise.fail(function (e) {
                            proxy._renderAppointmentAll();
                        });
                    }
                    else {
                        proxy._processed.splice(proxy._processed.indexOf(_appList), 1);
                        this._processed.push(argsAdd.data);
                        this._renderSingleApp(_newAddList, argsAdd.data);
                        proxy._trigger("actionComplete", { appointment: _newAddList, requestType: "appointmentDrag" });
                    }
                }
                else this._renderAppointmentAll();
            }
            else {
				var parentquery = new ej.Query().where(proxy.model.appointmentSettings["id"], ej.FilterOperators.equal, appoint["ParentId"]);
                var object = new ej.DataManager(this._currentAppointmentData).executeLocal(parentquery);
                var diff = object[0][proxy.model.appointmentSettings["endTime"]].getTime() - object[0][proxy.model.appointmentSettings["startTime"]].getTime();
				var prvcellstrtime=object[0][proxy.model.appointmentSettings["startTime"]];
                var prvcellendtime=object[0][proxy.model.appointmentSettings["endTime"]];
				if ((Globalize.format( object[0][this.model.appointmentSettings["startTime"]], this._pattern.d) < Globalize.format(object[0][this.model.appointmentSettings["endTime"]], this._pattern.d)) && (((object[0][this.model.appointmentSettings["endTime"]] - object[0][this.model.appointmentSettings["startTime"]]) / 3600000) < 24) && (object[0][this.model.appointmentSettings["allDay"]] !== true) && object[0][this.model.appointmentSettings["recurrence"]] != 1) 
                 {
				 object[0][proxy.model.appointmentSettings["startTime"]] = cellstrtime;
                 var newtime=cellstrtime.getTime()+diff;
                 var endate=new Date(newtime);
                 object[0][proxy.model.appointmentSettings["endTime"]] = endate;
                if (proxy._trigger("dragStop", { appointment: object[0] })) {
                   object[0][proxy.model.appointmentSettings["startTime"]] = prvcellstrtime;
                   object[0][proxy.model.appointmentSettings["endTime"]] = prvcellendtime;
                  }
					 proxy._dataProcessing(appList);
 					 proxy._renderAppointmentAll();
                 }
				else{
                var query = new ej.Query().where(proxy.model.appointmentSettings["id"], ej.FilterOperators.equal, appoint[proxy.model.appointmentSettings["id"]]);
                var object = new ej.DataManager(this._currentAppointmentData).executeLocal(query);
                var maxdate = new Date(new Date(this.model.maxDate).getTime());
                maxdate.setHours(23, 59, 59);
                if ((cellendtime >= new Date(this.model.minDate)) && (cellendtime <= maxdate)) {
					object[0][proxy.model.appointmentSettings["startTime"]] = cellstrtime;
                    object[0][proxy.model.appointmentSettings["endTime"]] = cellendtime;
                    if (proxy._trigger("dragStop", { appointment: object[0] })) {
                        object[0][proxy.model.appointmentSettings["startTime"]] = prvcellstrtime;
                        object[0][proxy.model.appointmentSettings["endTime"]] = prvcellendtime;
                    }
                    if (!ej.isNullOrUndefined(allday)) object[0][proxy.model.appointmentSettings["allDay"]] = allday;
                }
				}
                if (this.model.orientation == "horizontal" && !ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources)
                    proxy.element.find("#categorybar_" + appoint[proxy.model.appointmentSettings["id"]]).remove();
                if (!ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources)
                    object[0] = this._getDragDropResourceData(proxy, cellIndex, object[0]);
                var temp = this._timeZoneConversion(object[0]);
                promise = proxy._dataManager.update(proxy.model.appointmentSettings["id"], temp);
                var updateTemp = this._reverseTimeZoneConversion(temp);
                new ej.DataManager(this._currentAppointmentData).update(this.model.appointmentSettings["id"], updateTemp);                
                if (promise && $.isFunction(promise.promise) && proxy.dataSource() instanceof ej.DataManager) {
                    promise.done(function (e) {
                        new ej.DataManager(proxy._processed).update(proxy.model.appointmentSettings["id"], object[0]);
                        if (proxy.model.orientation == "vertical" && proxy.currentView() !== "month" && object[0][model["allDay"]] == 1) {
						proxy.element.find("div.e-alldayappointment").remove();
						proxy._renderAllDayAppointments();
                        proxy._unWireResizeEvents(); // Unwire appointments resize events.
                        proxy._wireResizeEvents(); // wire appointments resize events.
						proxy._dragdropAppointments();
						}	
                        else proxy._renderSingleApp(object[0], object[0]);
                        proxy._trigger("actionComplete", { appointment: object, requestType: "appointmentDrag" });
                    });
                    promise.fail(function (e) {
                        proxy._renderAppointmentAll();
                    });
                }
                else {
                    new ej.DataManager(proxy._processed).update(proxy.model.appointmentSettings["id"], object[0]);
                    this.element.find("#Appointment_" + appId).remove();
                    if (((object[0][model["endTime"]] - object[0][model["startTime"]]) / 3600000) > 24) {
                        proxy._dataProcessing(appList);
                    }
                if(this.model.orientation == "vertical" && this.currentView()!=="month" && object[0][model["allDay"]]==1) {
				    proxy.element.find("div.e-alldayappointment").remove();
				    proxy._renderAllDayAppointments();
                    proxy._unWireResizeEvents(); // Unwire appointments resize events.
                    proxy._wireResizeEvents(); // wire appointments resize events.
				    proxy._dragdropAppointments();
				  }		
                else proxy._renderSingleApp(object[0], object[0]);
                proxy._trigger("actionComplete", { appointment: object, requestType: "appointmentDrag" });
                }
                //new ej.DataManager(proxy._processed).update(proxy.model.appointmentSettings["id"], appList);
                $(args.element[0]).remove();
            }
            
            // proxy._dataProcessing(appList);
            //proxy._renderAppointmentAll();
    },
    /**
    * To get the appointments parent Id.
    * @private
    */
    _getAppointmentByParentId: function (appId) {
        var tempApp, appoint, appList = this._currentAppointmentData; // _processed;
        var tempApp = new ej.DataManager(this._processed).executeLocal(new ej.Query().where(this.model.appointmentSettings["id"], ej.FilterOperators.equal, appId));
        var appoint = new ej.DataManager(appList).executeLocal(new ej.Query().where(this.model.appointmentSettings["id"], ej.FilterOperators.equal, parseInt(tempApp[0]["ParentId"])));
        return !$.isEmptyObject(appoint) ? appoint[0] : appoint;
    },
    /**
    * To render all the appointments.
    * @private
    */
    _renderAppointmentAll: function () {
        Globalize.culture(this.model.locale);
        this.element.find("div.e-appointment,div.e-alldayappointment,div.e-monthappointment").remove();
        this.element.find("div.e-categorybar").remove();
        if (this.currentView() == "month" || (this._isCustomView()))
            this._renderMonthAppointment();
        else {
            this._renderAppointments();
            if (this.model.orientation == "vertical") this._renderAllDayAppointments();
            if (this.model.enableAppointmentNavigation)
                this._nextPrevButton(this._filtered);
        }
        this._wireResizeEvents();
        this._dragdropAppointments();
    },
    /**
    * Section to get the new end time after drag and drop the appointment.
    * @private
    */
    _getNewEndTime: function (newStartTime, hours, minutes) {
        var newEndTime = new Date(newStartTime);
        newEndTime.setHours(newEndTime.getHours() + hours);
        newEndTime.setMinutes(newEndTime.getMinutes() + minutes);
        return newEndTime;
    },
    /**
    * Section to get the new start time after drag and drop the appointment.
    * @private
    */
    _getNewStartTime: function (newTopTime, newStartTime) {
        newStartTime.setHours((newStartTime.getHours()) + parseInt(this.model.startHour) + parseInt(newTopTime / 60));
        newStartTime.setMinutes((newStartTime.getMinutes()) + parseInt(newTopTime % 60));
        newStartTime.setMinutes(Math.round(newStartTime.getMinutes() / 10.0) * 10);
        return newStartTime;
    },

    /**
    * Section to create the templates used in the schedule.
    * @private
    */
    _createTemplate: function (elt, templateId) {
        var scriptElt = document.createElement("script");
        scriptElt.id = (this._id + templateId + "_Template");
        scriptElt.type = "text/x-jsrender";
        scriptElt.text = elt;
        $("body").append(scriptElt);
        return scriptElt;
    },
    /**
    * Section for handle the keyboard support of the schedule.
    * @private
    */
    _documentOnKeyDown: function (event) {
        if (this.model.allowKeyboardNavigation) {
            var oEl = event.target || document.activeElement || event.srcElement;
            if (event.which == 27) {
                this._processEscapeKey();
            }
            else if (event.which == 13) {
                this._processEnterKey(oEl);
            }
            else if (event.shiftKey == false && event.which == 9) {
                this._processWindowTab(oEl);
            }
        }
    },
    /**
    * Section for handle the window tabbing process.
    * @private
    */
    _processWindowTab: function (oEl) {
        if ($(oEl).hasClass("qAppDone"))
            this._quickAppointWindow.find(".subject").focus();
        else if ($(oEl).hasClass("e-appointcancel") || $(oEl).hasClass("e-cancelrecur"))
            this._appointmentAddWindow.find(".subject").focus();
        else if ($(oEl).hasClass("e-editseries"))
            this.model.showQuickWindow && this._quickAppDetailsWindow.focus();
    },
    /**
    * Section for handle all the keyboard navigation process.
    * @private
    */
    _onKeyDown: function (event) {
        if (this.model.allowKeyboardNavigation) {
            this.model.showQuickWindow && (this._quickAppointWindow.ejDialog("close") && this._quickAppDetailsWindow.ejDialog("close"));
            var oRowCell = this.element.find('div.e-draggableworkarea tr');
            var oEl = event.target || document.activeElement || event.srcElement;
            var index = $(oEl).hasClass("e-workcells") ? $(oEl).index() : $(oEl).hasClass("e-alldaycells") ? $(oEl).index() : 7 - ((parseInt($(oEl).index() / 7) + 1) * 7 - $(oEl).index()) + ($(oEl).parent().index() * 7);             
            if (this.model.orientation == "horizontal") {
                (event.which == 39) && (index = index + 1);
                (event.which == 37) && (index = index - 1);
                index = this.model.currentView !== "month" ? Math.floor(index / ((this.model.endHour - this.model.startHour) * 2)) : index;
            }
            var renderDate = (this.model.orientation == "horizontal" && this.model.currentView == "month") ? this.monthDays : this.model.orientation == "vertical" ? this.dateRender : this._dateRender;
            var curDate = new Date(renderDate[index]);
            if ((curDate >= this.model.minDate) && (curDate <= this.model.maxDate)) {
               this.element.find("#" + this._id + "_navigator").ejDatePicker("hide");
               if($(oEl).hasClass("e-workcells")||$(oEl).hasClass("e-alldaycells")||$(oEl).hasClass("e-monthcells"))
    			   $(oEl).addClass("e-selectedCell");
                if (event.shiftKey == false && event.which == 38) { //up arrow navigation
                    this._stopDefaultAction(event);
                    this._processUpArrow(oEl, oRowCell);
                }
                else if (event.shiftKey == false && event.which == 40) { //down arrow for cell navigation
                    this._stopDefaultAction(event);
                    this._processDown(oEl, oRowCell);
                }
                else if (event.ctrlKey == false && event.shiftKey == false && event.which == 39) { //right arrow cell navigation
                    this._stopDefaultAction(event);
                    this._processRight(oEl, oRowCell);
                }
                else if (event.ctrlKey == false && event.shiftKey == false && event.which == 37) { //left arrow cell navigation
                    this._stopDefaultAction(event);
                    this._processLeft(oEl, oRowCell);
                }
                else if (event.shiftKey == true && event.which == 38) { //shift + up arrow
                    this._stopDefaultAction(event);
                    this._processShiftUp(oEl, event, oRowCell);
                }
                else if (event.shiftKey == true && event.which == 40) { //shift + down arrow
                    this._stopDefaultAction(event);
                    this._processShiftDown(oEl, event, oRowCell);
                }
                else if (event.shiftKey == true && event.which == 37) { //shift+left
                    this._stopDefaultAction(event);
                    this._processShiftLeft(oEl, event, oRowCell);
                }
                else if (event.shiftKey == true && event.which == 39) { //shift+right
                    this._stopDefaultAction(event);
                    this._processShiftRight(oEl, event, oRowCell);
                }
            }

            if (event.altKey == true && event.which == 67) { //Alt+C To show/hide the calendar pane
                this._stopDefaultAction(event);
                this.element.find(".e-datedisplay").click();
            }
            else if (event.ctrlKey == true && event.which == 37) { //Previous button
                this._stopDefaultAction(event);
                this.element.find("div.e-navigateprevious").click();
                this.element.find('div.e-navigateprevious').attr("tabIndex", 0).focus();
                this.element.find("#" + this._id + "_navigator").ejDatePicker({ value: new Date(this.currentDate()) });
            }
            else if (event.ctrlKey == true && event.which == 39) { //Next button
                this._stopDefaultAction(event);
                this.element.find("div.e-navigatenext").click();
                this.element.find('div.e-navigatenext').attr("tabIndex", 0).focus();
                this.element.find("#" + this._id + "_navigator").ejDatePicker({ value: new Date(this.currentDate()) });
            }
            else if ((event.altKey == true && event.which == 107) || (event.altKey == true && event.which == 187) || (event.altKey == true && event.which == 61)) { //Alt + "+" to navigate through the toolbar items
                this._stopDefaultAction(event);
                this._navigateToolbarRight(event);
            }
            else if ((event.altKey == true && event.which == 189) || (event.altKey == true && event.which == 109) || (event.altKey == true && event.which == 45) || (event.altKey == true && event.which == 173)) { // Alt + "-" to navigate back through the toolbar items
                this._stopDefaultAction(event);
                this._navigateToolbarLeft(event);
            }
            else if (event.ctrlKey == true && event.which == 67) { //Cancel Ctrl+C
                this._stopDefaultAction(event);
                this._cancel();
            }
            else if (event.which == 32) { //spacebar
                this._stopDefaultAction(event);
                if ($(document.activeElement)[0] === this.element.find("div.e-navigateprevious")[0]) {
                    this.element.find("div.e-navigateprevious").click();
                    this.element.find('div.e-navigateprevious').attr("tabIndex", 0).focus();
                }
                else if ($(document.activeElement)[0] === this.element.find("div.e-navigatenext")[0]) {
                    this.element.find("div.e-navigatenext").click();
                    this.element.find('div.e-navigatenext').attr("tabIndex", 0).focus();
                }
                this.element.find("#" + this._id + "_navigator").ejDatePicker({ value: new Date(this.currentDate()) });
            }
            else if (event.altKey == true && event.which == 78) { //New appointment window
                this._stopDefaultAction(event);
                this._newAppWindow(oEl, oRowCell);
                this.element.find("#" + this._id + "_navigator").ejDatePicker("hide");
            }
            else if (event.ctrlKey == true && event.which == 69 && this.element.find(".e-selectedAppointment").length > 0) { //(E)Edit appointment window
                this._stopDefaultAction(event);
                var elmt = this.element.find(".e-selectedAppointment");
                this._editKey = true;
                this._cellClick = false;
                this._appointmentWindow(elmt);
                this.element.find("#" + this._id + "_navigator").ejDatePicker("hide");
            }
            else if (event.which == 46) { //Delete
                this._stopDefaultAction(event);
                var delap = this.element.find('.e-selectedAppointment');
                if (delap.length > 0) {
                    var appId = delap[0].id.split("_")[1];
                    var parentId = this._getAppointmentByParentId(appId);
                    if (delap.length != 0 && ej.isNullOrUndefined(parentId[this.model.appointmentSettings["recurrenceRule"]]))
                        this._deleteApp(parseInt(appId));
                    else
                        this._deleteApp(parseInt(parentId[this.model.appointmentSettings["id"]]));
                }
            }
            else if (event.shiftKey == true && event.which == 9) { //Shift + tab for reverse navigation of appointments
                this._stopDefaultAction(event);
                this._reverseTab(oEl, event, oRowCell);
                this.element.find("#" + this._id + "_navigator").ejDatePicker("hide");
            }
            else if (event.shiftKey == false && event.which == 9) { // For tab navigation of appointments
                this._stopDefaultAction(event);
                this._processTab(oEl, event, oRowCell);
                this.element.find("#" + this._id + "_navigator").ejDatePicker("hide");
            }
            if (this.model.orientation === "horizontal") {
                this.currentView() != "month" ? $(this.element.find(".e-horizontaltimecells").find("table tr")[2]).css("left", (-this.element.find('.e-draggableworkarea').scrollLeft()) + "px") : this.element.find(".e-headerdays").css("left", (-this.element.find('.e-draggableworkarea').scrollLeft()) + "px");
                if (this.currentView() !== "day" && this.currentView() !== "month") {
                    var currentDateIndex = $(this.element.find(".e-headercells").find(".e-activeview").parent()).index();
                    var index = Math.floor((this.element.find('.e-draggableworkarea').scrollLeft() / (this.element.find(".e-workcells").width() + 1)) / 48);
                    if (currentDateIndex !== index)
                        this.element.find(".e-headercells").children().removeClass("e-activeview");
                    $(this.element.find(".e-headercells")[index]).children().addClass("e-activeview");
                }
            }
            else {
                if (!$(oEl).hasClass("e-monthcells"))
                    this.element.find(".e-scrolltimecells").css("top", (-this.element.find('.e-draggableworkarea').scrollTop()) + "px");
            }
        }
    },
    /**
    * Section for handle the shift up key process.
    * @private
    */
    _processShiftUp: function (oEl, event, oRowCell) {
        if (this.model.orientation == "horizontal") return false;
        if ($(oEl).hasClass('e-workcells')) {
            var rowcount = oRowCell.length - 1;
            var currrowindex = $(oEl).parent()[0].rowIndex;
            var currcolindex = $(oEl)[0].cellIndex;
            if (currrowindex > 0 && currrowindex <= rowcount && currrowindex != "undefined") {
                var newcur = parseInt(currrowindex) - 1;
                if (newcur >= 0) {
                    if ($(oRowCell[newcur].cells[currcolindex]).hasClass("e-selectedCell")) {
                        $(oRowCell[newcur].cells[currcolindex]).attr("tabIndex", 0).focus();
                        $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell");
                    }
                    else {
                        $(oRowCell[currrowindex].cells[currcolindex]).addClass("e-selectedCell");
                        $(oRowCell[newcur].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    }
                }
                this._currentRowIndex = newcur;
                this._currentColIndex = currcolindex;
            }
            else {
                $(oRowCell[currrowindex].cells[currcolindex]).attr("tabIndex", 0).focus();
                this._currentRowIndex = currrowindex;
                this._currentColIndex = currcolindex;
            }

        }
        else if ($(oEl).hasClass('e-monthcells')) {
            var resourceIndex = Math.floor($(oEl).index() / 7);
            var rowcount = oRowCell.length - 1, resmaxcolindex = 7 * (resourceIndex + 1), mincolindex = 7 * (parseInt(resourceIndex));
            var currrowindex = $(oEl).parent()[0].rowIndex;
            var currcolindex = $(oEl)[0].cellIndex;
            if (currrowindex > 0 && currrowindex <= rowcount && currrowindex != "undefined") {
                var newcur = parseInt(currrowindex) - 1;
                if (newcur >= 0) {
                    if ($(oRowCell[newcur].cells[currcolindex]).hasClass("e-selectedCell")) {
                        for (var i = currcolindex; i >= mincolindex; i--) {
                            $(oRowCell[currrowindex].cells[i]).attr("tabIndex", 0).focus();
                            $(oRowCell[currrowindex].cells[i]).removeClass("e-selectedCell");
                        }
                        for (var j = resmaxcolindex - 1; j >= currcolindex; j--) {
                            if (newcur >= 0) {
                                $(oRowCell[newcur].cells[j]).attr("tabIndex", 0).focus();
                                $(oRowCell[newcur].cells[j]).removeClass("e-selectedCell");
                            }
                        }
                        $(oRowCell[newcur].cells[currcolindex]).addClass("e-selectedCell");
                    }
                    else {
                        for (var i = currcolindex; i >= mincolindex; i--)
                            $(oRowCell[currrowindex].cells[i]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                        for (var j = resmaxcolindex - 1; j >= currcolindex; j--) {
                            if (newcur >= 0)
                                $(oRowCell[newcur].cells[j]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                        }
                    }
                }
                else
                    $(oRowCell[newcur + 1].cells[currcolindex]).attr("tabIndex", 0).focus();
            }
            else
                return false;
        }
        else
            return false;

    },
    /**
    * Section for handle the shift down key process.
    * @private
    */
    _processShiftDown: function (oEl, event, oRowCell) {
        if (this.model.orientation == "horizontal") return false;
        if ($(oEl).hasClass('e-workcells')) {
            var rowcount = oRowCell.length - 1; // this.get_RowCount();
            var currrowindex = $(oEl).parent()[0].rowIndex;
            var currcolindex = $(oEl)[0].cellIndex;
            if (currrowindex >= 0 && currrowindex <= rowcount && currrowindex != "undefined") {
                $(oRowCell[currrowindex].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                var newcur = parseInt(currrowindex) + 1;
                if (newcur <= rowcount) {
                    if ($(oRowCell[newcur].cells[currcolindex]).hasClass("e-selectedCell")) {
                        $(oRowCell[newcur].cells[currcolindex]).attr("tabIndex", 0).focus();
                        $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell");
                    }
                    else {
                        $(oRowCell[currrowindex].cells[currcolindex]).addClass("e-selectedCell");
                        $(oRowCell[newcur].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    }
                    this._currentRowIndex = newcur;
                    this._currentColIndex = currcolindex;
                }
                else {
                    $(oRowCell[currrowindex].cells[currcolindex]).attr("tabIndex", 0).focus();
                    this._currentRowIndex = currrowindex;
                    this._currentColIndex = currcolindex;
                }

            }
        }
        else if ($(oEl).hasClass('e-monthcells')) {
            var resourceIndex = Math.floor($(oEl).index() / 7);
            var rowcount = oRowCell.length - 1, resmaxcolindex = 7 * (resourceIndex + 1), mincolindex = 7 * (parseInt(resourceIndex));
            var currrowindex = $(oEl).parent()[0].rowIndex;
            var currcolindex = $(oEl)[0].cellIndex;
            if (currrowindex >= 0 && currrowindex <= rowcount && currrowindex != "undefined") {
                var newcur = parseInt(currrowindex) + 1;
                if (newcur < (this._dateRender.length) / 7) {
                    if ($(oRowCell[newcur].cells[currcolindex]).hasClass("e-selectedCell")) {
                        for (var i = currcolindex; i <= resmaxcolindex - 1; i++) {
                            $(oRowCell[currrowindex].cells[i]).attr("tabIndex", 0).focus();
                            $(oRowCell[currrowindex].cells[i]).removeClass("e-selectedCell");
                        }
                        for (var j = mincolindex; j <= currcolindex; j++) {
                            if (newcur < (this._dateRender.length) / 7) {
                                $(oRowCell[newcur].cells[j]).attr("tabIndex", 0).focus();
                                $(oRowCell[newcur].cells[j]).removeClass("e-selectedCell");
                            }
                        }
                        $(oRowCell[newcur].cells[currcolindex]).addClass("e-selectedCell");
                    }
                    else {
                        for (var i = currcolindex; i <= resmaxcolindex - 1; i++)
                            $(oRowCell[currrowindex].cells[i]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                        for (var j = mincolindex; j <= currcolindex; j++) {
                            if (newcur < (this._dateRender.length)/7)
                                $(oRowCell[newcur].cells[j]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                        }
                    }
                }
                else
                    $(oRowCell[newcur - 1].cells[currcolindex]).attr("tabIndex", 0).focus();
            }
            else
                return false;
        }
        else
            return false;
    },
    /**
    * Section for handle the shift left key process.
    * @private
    */
    _processShiftLeft: function (oEl, event, oRowCell) {
        var rowcount = oRowCell.length - 1;
        if ($(oEl).hasClass('e-workcells')) {
            var targetElement = oEl;
            var count = this.model.currentView == "day" ? 1 : this.model.currentView == "workweek" ? 5 : 7;
            var viewCount = this.model.orientation == "vertical" ? count : this.model.currentView == "month" ? this.totdays.length : count * (this.model.endHour - this.model.startHour) * 2;
            var resIndex = Math.floor($(targetElement).index() / viewCount);
            var resmaxcolindex = (viewCount * resIndex); // this.model.currentView == "day" ? 1 : this.model.currentView == "workweek" ? 5 : 7;
            var currColInx = $(targetElement)[0].cellIndex;
            var currRowInx = $(targetElement).parent()[0].rowIndex;
            var leftColInx = currColInx - 1;
            var irowcount = this.model.orientation == "vertical" ? 0 : currRowInx;
            var Hrowcount = this.model.orientation == "vertical" ? rowcount : currRowInx;
            if (currColInx > 0 && leftColInx > parseInt(resmaxcolindex) - 1 && currColInx != "undefined") {
                if ($(oRowCell[currRowInx].cells[leftColInx]).hasClass("e-selectedCell")) {
                    for (var i = irowcount; i <= parseInt(currRowInx) ; i++)
                        $(oRowCell[i].cells[currColInx]).removeClass("e-selectedCell");
                    for (var j = Hrowcount; j >= parseInt(currRowInx) ; j--)
                        $(oRowCell[j].cells[leftColInx]).removeClass("e-selectedCell");
                    $(oRowCell[currRowInx].cells[leftColInx]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                }
                else {
                    for (var i = irowcount; i <= parseInt(currRowInx) ; i++)
                        $(oRowCell[i].cells[currColInx]).addClass("e-selectedCell");
                    for (var j = Hrowcount; j >= parseInt(currRowInx) ; j--)
                        $(oRowCell[j].cells[leftColInx]).addClass("e-selectedCell");
                    $(oRowCell[currRowInx].cells[leftColInx]).attr("tabIndex", 0).focus();
                }
                this._currentRowIndex = currRowInx;
                this._currentColIndex = leftColInx;
            }
            else {
                $(oRowCell[currRowInx].cells[leftColInx + 1]).attr("tabIndex", 0).focus();
                this._currentRowIndex = currRowInx;
                this._currentColIndex = leftColInx + 1;
            }
        }
        else if ($(oEl).hasClass('e-monthcells')) {
            var resIndex = Math.floor($(oEl).index() / 7);
            var rowcount = oRowCell.length - 1, mcolind = 7 * (parseInt(resIndex) + 1); //7,
            var mincolindex = 7 * (parseInt(resIndex)); //0;
            var currrowindex = $(oEl).parent()[0].rowIndex;
            var currcolindex = $(oEl)[0].cellIndex;
            if (currcolindex >= mincolindex && currcolindex <= mcolind && currcolindex != "undefined") {
                newcur = parseInt(currcolindex) - 1;
                if ($(oRowCell[currrowindex].cells[newcur]).hasClass("e-selectedCell")) {
                    if (currcolindex == mincolindex && currrowindex >= 1) {
                        var newrow = parseInt(currrowindex) - 1;
                        var newcol = parseInt(mcolind) - 1;
                        if (newrow >= 0) {
                            $(oRowCell[newrow].cells[newcol]).attr("tabIndex", 0).focus();
                            $(oRowCell[newrow].cells[currcolindex]).removeClass("e-selectedCell");
                            $(oRowCell[currrowindex].cells[mincolindex]).removeClass("e-selectedClass");
                        }
                    }
                    else if (currcolindex < mcolind) {
                        newcur = parseInt(currcolindex) - 1;
                        $(oRowCell[currrowindex].cells[newcur]).attr("tabIndex", 0).focus();
                        $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell");
                    }
                }
                else {
                    if (currcolindex == mincolindex && currrowindex >= 0) {
                        var newrow = parseInt(currrowindex) - 1;
                        var newcol = parseInt(mcolind) - 1;
                        if (newrow >= 0)
                            $(oRowCell[newrow].cells[newcol]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                        else
                            $(oRowCell[newrow + 1].cells[currcolindex]).attr("tabIndex", 0).focus();
                    }
                    else if (currcolindex < mcolind) {
                        newcur = parseInt(currcolindex) - 1;
                        $(oRowCell[currrowindex].cells[newcur]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    }
                }
            }
            else
                return;
        }
        else
            return false;
    },
        /**
        * Section for handle the shift right key process.
        * @private
        */
    _processShiftRight: function (oEl, event, oRowCell) {
        if ($(oEl).hasClass('e-workcells')) {
            var rowcount = oRowCell.length - 1;
            var count = this.model.currentView == "day" ? 1 : this.model.currentView == "workweek" ? 5 : 7;
            var viewCount = this.model.orientation == "vertical" ? count : this.model.currentView == "month" ? this.totdays.length : count * (this.model.endHour - this.model.startHour) * 2;
            var resIndex = Math.floor($(oEl).index() / viewCount);
            var resmaxcolindex = (viewCount * (resIndex + 1));
            var currrowindex = $(oEl).parent()[0].rowIndex;
            var currcolindex = $(oEl)[0].cellIndex;
            var newcur = parseInt(currcolindex) + 1;
            var irowcount = this.model.orientation == "vertical" ? 0 : currrowindex;
            var Hrowcount = this.model.orientation == "vertical" ? rowcount : currrowindex;
            if (currcolindex >= 0 && currcolindex < parseInt(resmaxcolindex) - 1 && currcolindex != "undefined") {
                if ($(oRowCell[currrowindex].cells[newcur]).hasClass("e-selectedCell")) {
                    for (var i = parseInt(currrowindex) ; i <= Hrowcount; i++)
                        $(oRowCell[i].cells[currcolindex]).removeClass("e-selectedCell");
                    for (var j = irowcount; j <= currrowindex; j++)
                        $(oRowCell[j].cells[newcur]).removeClass("e-selectedCell").attr("tabIndex", 0).focus();
                    $(oRowCell[currrowindex].cells[newcur]).addClass("e-selectedCell");
                }
                else {
                    for (var i = parseInt(currrowindex) ; i <= Hrowcount; i++)
                        $(oRowCell[i].cells[currcolindex]).addClass("e-selectedCell");
                    for (var j = irowcount; j <= currrowindex; j++)
                        $(oRowCell[j].cells[newcur]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                }
                this._currentRowIndex = currrowindex;
                this._currentColIndex = newcur;
            }
            else
                $(oRowCell[currrowindex].cells[currcolindex]).attr("tabIndex", 0).focus();
        }
        else if ($(oEl).hasClass('e-monthcells')) {
            var resIndex = Math.floor($(oEl).index() / 7);
            var rowcount = oRowCell.length - 1, mcolind = resmaxcolindex = 7 * (parseInt(resIndex) + 1), mincolindex = 7 * (parseInt(resIndex));;
            var currrowindex = $(oEl).parent()[0].rowIndex;
            var currcolindex = $(oEl)[0].cellIndex;
            var newcur = parseInt(currcolindex) + 1;
            if (currcolindex >= 0 && currcolindex <= parseInt(resmaxcolindex) - 1 && currcolindex != "undefined") {
                if ($(oRowCell[currrowindex].cells[newcur]).hasClass("e-selectedCell")) {
                    if (newcur < mcolind) {
                        $(oRowCell[currrowindex].cells[newcur]).attr("tabIndex", 0).focus();
                        $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell");
                    }
                    if (currcolindex == parseInt(resmaxcolindex) - 1 && currrowindex < (this._dateRender.length) / 7) {
                        var newrow = parseInt(currrowindex) + 1;
                        currcolindex = mincolindex;
                        if (newrow < (this._dateRender.length) / 7) {
                            $(oRowCell[newrow].cells[currcolindex]).removeClass("e-selectedCell").attr("tabIndex", 0).focus();
                            if (newcur < mcolind) {
                                $(oRowCell[newrow].cells[newcur]).attr("tabIndex", 0).focus();
                                $(oRowCell[newrow].cells[currcolindex]).removeClass("e-selectedCell");
                            }
                        }
                    }
                }
                else {
                    if (newcur < mcolind)
                        $(oRowCell[currrowindex].cells[newcur]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    if (currcolindex == parseInt(resmaxcolindex) - 1 && currrowindex < (this._dateRender.length) / 7) {
                        var newrow = parseInt(currrowindex) + 1;
                        currcolindex = mincolindex;
                        if (newrow < (this._dateRender.length) / 7) {
                            $(oRowCell[newrow].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                            if (newcur < mcolind)
                                $(oRowCell[newrow].cells[newcur]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                        }
                        else
                            $(oRowCell[newrow - 1].cells[newcur - 1]).attr("tabIndex", 0).focus();
                    }
                }
            }
            else
                return false;
        }
        else
            return false;
    },
    /**
    * Section for handle the enter key process.
    * @private
    */
    _processEnterKey: function (oEl) {
        if ($(oEl).hasClass("e-workcells") || $(oEl).hasClass("e-monthcells") || $(oEl).hasClass("e-alldaycells")) {
            var tds = this.element.find('td.e-selectedCell');
            var nt = tds.length - 1;
            if (nt == 0) {
                this._cellSelection(oEl);
            }
            else {
                this._multipleCellAppointCreation(oEl);
            }
        }
        else if ($(oEl).hasClass("e-detailedapp e-detailedwindow")) {
            this._appointmentWindow(oEl);
        }
        else if ($(oEl).parent().hasClass("e-allday")) {
            var e = this._appointmentAddWindow.find("#" + this._id + "allday").ejCheckBox("option", "checked");
            var checkedVal = e ? false : true;
            this._appointmentAddWindow.find(".allday").ejCheckBox({ checked: checkedVal });
        }
        else if ($(oEl).parent().hasClass("e-recurrence")) {
            var e = this._appointmentAddWindow.find("#" + this._id + "recurrence").ejCheckBox("option", "checked");
            var checkedVal = e ? false : true;
            this._appointmentAddWindow.find(".recurrence").ejCheckBox({ checked: checkedVal });
            this._recurChecked = checkedVal ? true : false;
            this._repeat(oEl);
        }
        else if ($(oEl).hasClass("e-scheduledelete")) {
            this.model.showQuickWindow && this._quickAppDetailsWindow.find('.e-scheduledelete').click();
        }
        else if ($(oEl).hasClass("e-editevent"))
            this.model.showQuickWindow && this._quickAppDetailsWindow.find('.e-editevent').click();
        else if ($(oEl).hasClass(".e-editseries"))
            this.model.showQuickWindow && this._quickAppDetailsWindow.find('.e-editseries').click();
        else if ($(oEl).hasClass("e-appointment") || $(oEl).hasClass("e-alldayappointment") || $(oEl).hasClass("e-monthappointment"))
            this._cellSelection(oEl);
        else if ($(oEl).parent().hasClass("e-weekday")) {
            var e = this._appointmentAddWindow.find("#" + $(oEl).children()[0].id).ejCheckBox("option", "checked");
            var checkedVal = e ? false : true;
            this._appointmentAddWindow.find("#" + $(oEl).children()[0].id).ejCheckBox({ checked: checkedVal });
        }
    },
    /**
    * To find the minimum and maximum cell index of the schedule.
    * @private
    */
    _findMinMaxCellIndex: function () {
        var oRowCell = this.element.find('div.e-draggableworkarea tr');
        var rowcount = oRowCell.length - 1;
        var omincolIndex, omaxcolIndex, rowInx, maxrowInx, checkcolindex;
        var curr_View = this.currentView();
        var viewCount = curr_View == "day" ? 1 : curr_View == "workweek" ? 5 : 7;
        var proxy = this;
        this.element.find('td.e-selectedCell').each(function (index, tdItem) {
            var targetId = $(tdItem).index();
            if (targetId != null && !isNaN(targetId)) {
                if (omincolIndex == null) {
                    omincolIndex = targetId;
                    rowInx = $(tdItem).parent()[0].rowIndex;
                }
                else if (omincolIndex < targetId) {
                    omincolIndex = omincolIndex;
                }
                else {
                    if (omincolIndex != targetId) {
                        omincolIndex = targetId;
                        rowInx = $(tdItem).parent()[0].rowIndex;
                    }
                }
                if (omaxcolIndex == null) {
                    omaxcolIndex = targetId;
                    if (curr_View != "month") {
                        checkcolindex = parseInt(omaxcolIndex);
                        for (var i = 0; i <= rowcount; i++) {
                            if ($(oRowCell[i].cells[checkcolindex]).hasClass("e-selectedCell")) {
                                maxrowInx = i;

                            }
                        }
                    }
                }
                else if (omaxcolIndex > targetId) {
                    omaxcolIndex = omaxcolIndex;
                }
                else {
                    if (omaxcolIndex != targetId) {
                        omaxcolIndex = targetId;
                        if (curr_View != "month") {
                            checkcolindex = parseInt(omaxcolIndex);
                            for (var i = 0; i <= rowcount; i++) {
                                if ($(oRowCell[i].cells[checkcolindex]).hasClass("e-selectedCell")) {
                                    maxrowInx = i;

                                }
                            }
                        }
                    }
                }
            }
        });
        var _minMaxIndexes = { rowInx: rowInx, maxrowInx: maxrowInx, omincolIndex: omincolIndex, omaxcolIndex: omaxcolIndex };
        return _minMaxIndexes;
        //}

    },
    /**
    * Section for handle the multiple cell appointment creation.
    * @private
    */
    _multipleCellAppointCreation: function (target) {
        this._cellIndex = $(target).hasClass("e-workcells") ? $(target).index() : $(target).hasClass("e-alldaycells") ? $(target).index() : 7 - ((parseInt($(target).index() / 7) + 1) * 7 - $(target).index()) + ($(target).parent().index() * 7);
        if (this.model.orientation == "horizontal") {
            this._cellIndex = this.model.currentView !== "month" ? Math.floor(this._cellIndex / ((this.model.endHour - this.model.startHour) * 2)) : this._cellIndex;
            this._workCellIndex = $(target).parent().index();
        }
        var indexes = this._findMinMaxCellIndex(); //var renderDates = this.dateRender;
        var renderDates = (this.model.orientation == "horizontal" && this.model.currentView == "month") ? this.monthDays : this.model.orientation == "vertical" ? this.dateRender : this._dateRender;
        var omincolIndex = indexes.omincolIndex, omaxcolIndex = indexes.omaxcolIndex, rowInx = indexes.rowInx, maxrowInx = indexes.maxrowInx;
        var minStartDate = renderDates[omincolIndex]; var maxEndDate = renderDates[omaxcolIndex];
        var localizeDays = Globalize.culture(this.model.locale);
        if (this.model.orientation == "vertical") {
            if ($(target).hasClass("e-workcells")) {
                var minStartTime = (this.model.startHour + (rowInx / 2)).toString().split(".");
                var maxEndTime = (this.model.startHour + (maxrowInx / 2)).toString().split(".");
                this.cur_StartTime = new Date(minStartDate).setHours(parseInt(minStartTime[0]), parseInt(minStartTime[1]) == 5 ? 30 : 00);
                this.cur_EndTime = new Date(maxEndDate).setHours(parseInt(maxEndTime[0]), parseInt(maxEndTime[1]) == 5 ? 30 : 00);
                this.cur_EndTime = new Date(new Date(this.cur_EndTime).setMinutes(new Date(this.cur_EndTime).getMinutes() + 30));
            }
            else if ($(target).hasClass("e-monthcells")) {
                var selCell = this.element.find('td.e-selectedCell');
                var nsc = selCell.length - 1;
                var startIndex = ($(selCell[0]).parent().index() * 7) + ($(selCell[0]).index() - (Math.floor($(selCell[0]).index() / 7) * 7));
                var endIndex = ($(selCell[nsc]).parent().index() * 7) + ($(selCell[nsc]).index() - (Math.floor($(selCell[nsc]).index() / 7) * 7)); // $(selCell[nsc]).index();
                var startDate = new Date(this._dateRender[startIndex]);
                var endDate = new Date(this._dateRender[endIndex]);
                this.cur_StartTime = new Date(new Date(startDate).setHours(9));
                this.cur_StartTime = new Date(this.cur_StartTime).setMinutes(00); //.setHours(00)).setMinutes(00);
                this.cur_EndTime = new Date(new Date(endDate).setHours(9)); //.setHours(23)).setMinutes(59)); 
                this.cur_EndTime = new Date(new Date(this.cur_EndTime).setMinutes(30));
            }
        }
        else {
            if (this.currentView() != "month") {
                var minStartDate = renderDates[0]; var maxEndDate = renderDates[0];
                var minStartTime = (this.model.startHour + (omincolIndex / 2)).toString().split(".");
                var maxEndTime = (this.model.startHour + (omaxcolIndex / 2)).toString().split(".");
                this.cur_StartTime = new Date(minStartDate).setHours(parseInt(minStartTime[0]), parseInt(minStartTime[1]) == 5 ? 30 : 00);
                this.cur_EndTime = new Date(maxEndDate).setHours(parseInt(maxEndTime[0]), parseInt(maxEndTime[1]) == 5 ? 30 : 00);
                this.cur_EndTime = new Date(new Date(this.cur_EndTime).setMinutes(new Date(this.cur_EndTime).getMinutes() + 30));
            }
            else {
                var minStartDate = this.totdays[omincolIndex]; var maxEndDate = this.totdays[omaxcolIndex];
                var minStartTime = (this.model.startHour).toString().split(".");
                var maxEndTime = (this.model.startHour).toString().split(".");
                this.cur_StartTime = new Date(minStartDate).setHours(parseInt(minStartTime[0]), parseInt(minStartTime[1]) == 5 ? 30 : 00);
                this.cur_EndTime = new Date(maxEndDate).setHours(parseInt(maxEndTime[0]), parseInt(maxEndTime[1]) == 5 ? 30 : 00);
                this.cur_EndTime = new Date(new Date(this.cur_EndTime).setMinutes(new Date(this.cur_EndTime).getMinutes() + 30));
            }
        }
        if (this.model.showQuickWindow) {
            this._quickAppointWindow.find("#" + this._id + "_quickAppwindow").css("display", "block");

            //add the dialog code to display while clicking on the cells
            if (((new Date(this.cur_EndTime) - new Date(this.cur_StartTime)) / 3600000) < 24)
                this._quickAppointWindow.find('.e-quickstartend').html(localizeDays.calendar.days.names[new Date(this.cur_StartTime).getDay()] + ", " + Globalize.format(new Date(this.cur_StartTime), "MMMM") + " " + new Date(this.cur_StartTime).getDate() + ", " + Globalize.format(new Date(this.cur_StartTime), this._timeMode == "12" ? this._pattern.t : "HH:mm") + " - " + Globalize.format(new Date(this.cur_EndTime), this._timeMode == "12" ? this._pattern.t : "HH:mm"));
                else
                    this._quickAppointWindow.find('.e-quickstartend').html(localizeDays.calendar.days.names[new Date(this.cur_StartTime).getDay()] + ", " + Globalize.format(new Date(this.cur_StartTime), "MMMM") + " " + new Date(this.cur_StartTime).getDate() + ", " + Globalize.format(new Date(this.cur_StartTime), this._timeMode == "12" ? this._pattern.t : "HH:mm") + " - " + localizeDays.calendar.days.names[new Date(this.cur_EndTime).getDay()] + ", " + Globalize.format(new Date(this.cur_EndTime), "MMMM") + " " + new Date(this.cur_EndTime).getDate() + ", " + Globalize.format(new Date(this.cur_EndTime), this._timeMode == "12" ? this._pattern.t : "HH:mm"));
                this._quickAppointWindow.find('.subject').val("");
                if (!this.model.readOnly)
                    this._quickAppointWindow.ejDialog("open");
                var x = $(target).offset().left - ((this._quickAppointWindow.width() - $(target).width()) / 2) + 10;
                var y = $(target).offset().top - this._quickAppointWindow.height() - 10;
                this._quickAppointWindow.ejDialog({ position: { X: x, Y: y } });
                this._quickAppointWindow.find(".subject").focus();
                if (ej.scheduleFeatures.resources && !ej.isNullOrUndefined(this.model.resources))
                    this._getResourceDetails($(target));
            }
        this._cellClick = true;

    },
    /**
    * Section for handle the cell selection process using keyboard.
    * @private
    */
    _addCellSelection: function (oRowCell) {
        var tds = this.element.find('td.e-selectedCell');
        var nt = tds.length - 1;
        if (nt > 0) {
            this.element.find('td.e-selectedCell').removeClass("e-selectedCell");
            $(oRowCell[this._currentRowIndex].cells[this._currentColIndex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
        }
    },
    /**
    * Section for handle the up arrow key process.
    * @private
    */
    _processUpArrow: function (oEl, oRowCell) {
        if ($(oEl).hasClass("e-selectedAppointment")) {
            this.element.find('.e-selectedAppointment').removeClass("e-selectedAppointment");
            $(oRowCell[0].cells[0]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
        }
        else if ($(oEl).hasClass("e-selectedCell"))
            this._addCellSelection(oRowCell);
        var allda = this.element.find(".e-alldaycells");
        if ($(oEl).hasClass("e-workcells")) {
            var rowcount = oRowCell.length - 1;
            var currrowindex = this.element.find("td.e-selectedCell").parent()[0].rowIndex;
            var currcolindex = this.element.find("td.e-selectedCell")[0].cellIndex;
            var newcur = parseInt(currrowindex) - 1;
            if (currrowindex > 0 && currrowindex <= rowcount && currrowindex != "undefined") {
                if ($(oRowCell[currrowindex - 1].cells[currcolindex]).hasClass("e-resourceheadercells")) return false;
                $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell").blur();
                $(oRowCell[newcur].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
            }
            else if (currrowindex == 0) {
                if (this.model.orientation == "vertical") {
                    var currrowindex = this.element.find("td.e-selectedCell").parent()[0].rowIndex;
                    var currcolindex = this.element.find("td.e-selectedCell")[0].cellIndex;
                    $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell").blur();
                    $(this.element).attr("tabIndex", 0).focus();
                    $(allda[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                }
                else
                    $(oRowCell[0].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
            }
        }
        else if ($(oEl).hasClass("e-alldaycells")) {
            return false;
        }

        else if ($(oEl).hasClass("e-monthcells")) {
            var rowcount = oRowCell.length - 1;
            var currrowindex = this.element.find("td.e-selectedCell").parent()[0].rowIndex;
            var currcolindex = this.element.find("td.e-selectedCell")[0].cellIndex;
            var newcur = parseInt(currrowindex) - 1;
            if (currrowindex >= 0 && currrowindex <= rowcount && currrowindex != "undefined") {
                if (newcur >= 0) {
                    $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell").blur();
                    $(oRowCell[newcur].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                }
                else
                    $(oRowCell[0].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
            }
            else
                return false;
        }
        else
            return false;

    },
    /**
    * Section for handle the down arrow key process.
    * @private
    */
    _processDown: function (oEl, oRowCell) {
        if ($(oEl).hasClass("e-selectedAppointment")) {
            this.element.find('.e-selectedAppointment').removeClass("e-selectedAppointment");
            $(oRowCell[0].cells[0]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
        }
        else if ($(oEl).hasClass("e-selectedCell"))
            this._addCellSelection(oRowCell);
        if ($(oEl).hasClass("e-workcells")) {
            var rowcount = oRowCell.length - 1;
            var currrowindex = this.element.find("td.e-selectedCell").parent()[0].rowIndex;
            var currcolindex = this.element.find("td.e-selectedCell")[0].cellIndex;
            var newcur = parseInt(currrowindex) + 1;
            if (currrowindex >= 0 && currrowindex <= rowcount && currrowindex != "undefined") {
                if (newcur <= rowcount) {
                    if ($(oRowCell[currrowindex + 1].cells[currcolindex]).hasClass("e-resourceheadercells")) return false;
                    $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell").blur();
                    $(oRowCell[newcur].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                }
                else
                    $(oRowCell[currrowindex].cells[currcolindex]).attr("tabIndex", 0).focus();
            }
        }
        else if ($(oEl).hasClass("e-alldaycells")) {
            var allDayInx = this.element.find('td.e-selectedCell')[0].cellIndex;
            var allda = this.element.find(".e-alldaycells");
            $(allda[allDayInx]).removeClass("e-selectedCell").blur();
            $(oRowCell[0].cells[allDayInx]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
        }

        else if ($(oEl).hasClass("e-monthcells")) {
            var rowcount = oRowCell.length - 1;
            var currrowindex = this.element.find("td.e-selectedCell").parent()[0].rowIndex;
            var currcolindex = this.element.find("td.e-selectedCell")[0].cellIndex;
            var newcur = parseInt(currrowindex) + 1;
            if (currrowindex >= 0 && currrowindex < rowcount && currrowindex != "undefined") {
                if (newcur <= 7) {
                    $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell").blur();
                    $(oRowCell[newcur].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                }
                else
                    $(oRowCell[newcur - 1].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
            }
        }
        else
            return false;
    },
    /**
    * Section for handle the right arrow key process.
    * @private
    */
    _processRight: function (oEl, oRowCell) {
        if ($(oEl).hasClass("e-selectedAppointment")) {
            this.element.find('.e-selectedAppointment').removeClass("e-selectedAppointment");
            $(oRowCell[0].cells[0]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
        }
        else if ($(oEl).hasClass("e-selectedCell"))
            this._addCellSelection(oRowCell);
        if ($(oEl).hasClass("e-workcells")) {
            var count = this.model.currentView == "day" ? 1 : this.model.currentView == "workweek" ? 5 : 7;
            var colIndex = this.model.orientation == "vertical" ? count : this.model.currentView == "month" ? this.totdays.length : count * (this.model.endHour - this.model.startHour) * 2;
            maxcolindex = (!ej.isNullOrUndefined(this.model.resources) && !ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources) && this.model.orientation == "vertical" ? this.render_Resources[this.render_Resources.length - 1].length * colIndex : colIndex;
            var currrowindex = this.element.find("td.e-selectedCell").parent()[0].rowIndex;
            var currcolindex = this.element.find("td.e-selectedCell")[0].cellIndex;
            var newcur = parseInt(currcolindex) + 1;
            if (currcolindex >= 0 && currcolindex < parseInt(maxcolindex) - 1 && currcolindex != "undefined") {
                $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell").blur();
                $(oRowCell[currrowindex].cells[newcur]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
            }
            else if (currcolindex == parseInt(maxcolindex) - 1) {
                if (this.currentView() != "month") {
                    var maxrowInx1 = $(oEl).parent()[0].rowIndex;
                    this.element.find("div.e-navigatenext").click();
                    $(oRowCell[maxrowInx1].cells[0]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                } else {
                    this.element.find("div.e-navigatenext").click();
                    $($(".e-workcellstab").find("tr")[currrowindex].cells[0]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                }
            }
            else
                return false;
        }
        else if ($(oEl).hasClass("e-monthcells")) {
            var resIndex = Math.floor($(oEl).index() / 7);
            var rowcount = oRowCell.length - 1, mcolind = resmaxcolindex = 7 * (parseInt(resIndex) + 1), mincolindex = 7 * (parseInt(resIndex));;
            var currrowindex = $(oEl).parent()[0].rowIndex;
            var currcolindex = $(oEl)[0].cellIndex;
            var newcur = parseInt(currcolindex) + 1;
            if (newcur < mcolind) {
                $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell").blur();
                $(oRowCell[currrowindex].cells[newcur]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
            }
            if (currcolindex == parseInt(resmaxcolindex) - 1 && currrowindex < (this._dateRender.length) / 7) {
                $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell").blur();
                var newrow = parseInt(currrowindex) + 1;
                currcolindex = mincolindex;
                if (newrow < (this._dateRender.length) / 7) {
                    $(oRowCell[newrow].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    if (newcur < mcolind) {
                        $(oRowCell[newrow].cells[newcur]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    }
                }
                else {
                    var previndex = currcolindex / 7;
                    this.element.find("div.e-navigatenext").click();
                    var index = (!ej.isNullOrUndefined(this.model.group) ? previndex * 7 : 0);
                    $($(".e-monthcells")[index]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                }
            }
        }
        else if ($(oEl).hasClass("e-alldaycells")) {
            var allDayInx = this.element.find('td.e-selectedCell')[0].cellIndex;
            var allda = this.element.find(".e-alldaycells");
            var nall = parseInt(allda.length) - 1;
            var newallDayInx = parseInt(allDayInx) + 1;
            if (allDayInx >= 0 && allDayInx < nall) {
                $(allda[allDayInx]).removeClass("e-selectedCell").blur();
                $(allda[newallDayInx]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
            }
            else if (allDayInx == nall) {
                this.element.find("div.e-navigatenext").click();
                $(allda[0]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
            }
            else
                return false;
        }
    },
    /**
    * Section for handle the left arrow key process.
    * @private
    */
    _processLeft: function (oEl, oRowCell) {
        if ($(oEl).hasClass("e-selectedAppointment")) {
            this.element.find('.e-selectedAppointment').removeClass("e-selectedAppointment");
            $(oRowCell[0].cells[0]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
        }
        else if ($(oEl).hasClass("e-selectedCell"))
            this._addCellSelection(oRowCell);
        if ($(oEl).hasClass("e-workcells")) {
            var count = this.model.currentView == "day" ? 1 : this.model.currentView == "workweek" ? 5 : 7;
            var colIndex = this.model.orientation == "vertical" ? count : this.model.currentView == "month" ? this.totdays.length : count * (this.model.endHour - this.model.startHour) * 2;
            maxcolindex = (!ej.isNullOrUndefined(this.model.resources) && !ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources) && this.model.orientation == "vertical" ? this.render_Resources[this.render_Resources.length - 1].length * colIndex : colIndex;
            var currrowindex = this.element.find("td.e-selectedCell").parent()[0].rowIndex;
            var currcolindex = this.element.find("td.e-selectedCell")[0].cellIndex;
            var newcur = parseInt(currcolindex) - 1;
            if (currcolindex > 0 && currcolindex <= parseInt(maxcolindex) - 1 && currcolindex != "undefined") {
                $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell").blur();
                $(oRowCell[currrowindex].cells[newcur]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
            }
            else if (currcolindex == 0) {
                if (this.currentView() != "month") {
                    var maxrowInx1 = $(oEl).parent()[0].rowIndex;
                    this.element.find("div.e-navigateprevious").click();
                    $(oRowCell[maxrowInx1].cells[maxcolindex - 1]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                }
                else {
                    this.element.find("div.e-navigateprevious").click();
                    $($(".e-workcellstab").find("tr")[currrowindex].cells[this.totdays.length - 1]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                }
            }
            else
                return false;
        }
        else if ($(oEl).hasClass("e-monthcells")) {
            var resIndex = Math.floor($(oEl).index() / 7);
            var rowcount = oRowCell.length - 1, mcolind = 7 * (parseInt(resIndex) + 1); //7,
            var mincolindex = 7 * (parseInt(resIndex));
            var count = this.model.currentView == "day" ? 1 : this.model.currentView == "workweek" ? 5 : 7;
            var colIndex = this.model.orientation == "vertical" ? count : this.model.currentView == "month" ? this.totdays.length : count * (this.model.endHour - this.model.startHour) * 2;
            maxcolindex = (!ej.isNullOrUndefined(this.model.resources) && !ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources) && this.model.orientation == "vertical" ? this.render_Resources[this.render_Resources.length - 1].length * colIndex : colIndex;
            var currrowindex = this.element.find("td.e-selectedCell").parent()[0].rowIndex;
            var currcolindex = this.element.find("td.e-selectedCell")[0].cellIndex;

            if (currcolindex == mincolindex && currrowindex >= 0) {
                var newrow = parseInt(currrowindex) - 1;
                var newcol = parseInt(mcolind) - 1;
                if (newrow >= 0) {
                    $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell").blur();
                    $(oRowCell[newrow].cells[newcol]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                }
                else {
                    var previndex = currcolindex / 7;
                    this.element.find("div.e-navigateprevious").click();
                    var rowmax = this._dateRender.length / 7;
                    var index = (!ej.isNullOrUndefined(this.model.group) ? previndex * 7 : 0);
                    $($(".e-workcellstab").find("tr")[rowmax - 1].cells[index + 6]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                }
            }
            else if (currcolindex < mcolind) {
                newcur = parseInt(currcolindex) - 1;
                $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell").blur();
                $(oRowCell[currrowindex].cells[newcur]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
            }
        }
        else if ($(oEl).hasClass("e-alldaycells")) {
            var maxcolindex = this.currentView() == "day" ? 1 : this.currentView() == "workweek" ? 5 : 7;
            var allDayInx = this.element.find('td.e-selectedCell')[0].cellIndex;
            var allda = this.element.find(".e-alldaycells");
            var nall = parseInt(allda.length) - 1;
            var newallDayInx = parseInt(allDayInx) - 1;
            if (allDayInx > 0 && allDayInx <= nall) {
                $(allda[allDayInx]).removeClass("e-selectedCell").blur();
                $(allda[newallDayInx]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
            }
            else if (allDayInx == 0) {
                this.element.find("div.e-navigateprevious").click();
                $(allda[maxcolindex - 1]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
            }
            else
                return false;
        }
    },
    /**
    * Section for handle the navigate toolbar right key process.
    * @private
    */
    _navigateToolbarRight: function (event) {
        var views = this.model.views;
        var curViewIndex = this.element.find(".e-" + this.currentView()).parent().index();
        if (curViewIndex < views.length - 1) {
            var newView = views[curViewIndex + 1].toLowerCase(); this._navView = true;
            this._viewChange(event, this.currentView(), newView);
            this.element.find("#" + this._id + "_navigator").ejDatePicker({ value: new Date(this.currentDate()) });
        }
    },
    /**
    * Section for handle the navigate toolbar left key process.
    * @private
    */
    _navigateToolbarLeft: function (event) {
        var curViewIndex = this.element.find(".e-" + this.currentView()).parent().index();
        if (curViewIndex > 0) {
            var newView = this.model.views[curViewIndex - 1].toLowerCase(); this._navView = true;
            this._viewChange(event, this.currentView(), newView);
            this.element.find("#" + this._id + "_navigator").ejDatePicker({ value: new Date(this.currentDate()) });
        }
    },
       
    /**
    * Section to open the new appointment window using keyboard.
    * @private
    */
    _newAppWindow: function (contextElement, oRowCell) {
        if ($(contextElement).hasClass("e-selectedCell")) {
            this._currentAction = ej.Schedule.Actions.Add;
            var targetElement = contextElement == null ? event : contextElement;
            var rowIndex = $(targetElement).parent().index();
            var columnIndex = $(targetElement).index();
            var resourceIndex = 0, renderDates = (this.model.orientation == "horizontal" && this.model.currentView == "month") ? this.monthDays : this.model.orientation == "vertical" ? this.dateRender : this._dateRender;
            var s = this.element.find('td.e-selectedCell');
            var ns = parseInt(s.length) - 1;
            var index = $(targetElement).hasClass("e-workcells") ? $(targetElement).index() : $(targetElement).hasClass("e-alldaycells") ? $(targetElement).index() - 1 : ($(targetElement).parent().index() * 7) + ($(targetElement).index() - (Math.floor($(targetElement).index() / 7) * 7)); //($(targetElement).parent().index() * 7) + $(targetElement).index();
            if (this.model.orientation === "horizontal" && this.model.currentView !== "month")
                index = Math.floor(index / ((this.model.endHour - this.model.startHour) * 2));
            this._workCellIndex = $(targetElement).parent().index();
            if (ns == 0) {
                startdate = new Date(renderDates[index]);
                if ($(targetElement).hasClass("e-workcells")) {
                    var time = this.model.startHour + (rowIndex / 2);
                    var timemin = time.toString().split(".");
                    startTime = new Date(startdate).setHours(parseInt(timemin[0]), parseInt(timemin[1]) == 5 ? 30 : 00);
                    endTime = new Date(new Date(startTime).setMinutes(new Date(startTime).getMinutes() + 30));
                }
                else if ($(targetElement).hasClass("e-alldaycells")) {
                    startTime = new Date(startdate.setHours(0, 0));
                    endTime = new Date(startTime.setHours(0, 0));
                    this._appointmentAddWindow.find(".allday ").ejCheckBox({ checked: true });
                }
                else if ($(targetElement).hasClass("e-monthcells")) {
                    startTime = new Date(new Date(startdate).setHours(9));
                    startTime = new Date(startTime).setMinutes(00); //.setHours(00)).setMinutes(00);
                    endTime = new Date(new Date(startTime).setMinutes(30)); //.setHours(23)).setMinutes(59));
                }
            }
            else if (ns > 0) {
                var indexes = this._findMinMaxCellIndex();
                var omincolIndex = indexes.omincolIndex, omaxcolIndex = indexes.omaxcolIndex, rowInx = indexes.rowInx, maxrowInx = indexes.maxrowInx;
                if (this.model.orientation == "vertical") {
                    if ($(contextElement).hasClass('e-workcells')) {
                        var minStartDate = renderDates[omincolIndex]; var maxEndDate = renderDates[omaxcolIndex];
                        var minStartTime = (this.model.startHour + (rowInx / 2)).toString().split(".");
                        var maxEndTime = (this.model.startHour + (maxrowInx / 2)).toString().split(".");
                        startTime = new Date(new Date(minStartDate).setHours(parseInt(minStartTime[0]), parseInt(minStartTime[1]) == 5 ? 30 : 00));
                        endTime = new Date(maxEndDate).setHours(parseInt(maxEndTime[0]), parseInt(maxEndTime[1]) == 5 ? 30 : 00);
                        endTime = new Date(new Date(endTime).setMinutes(new Date(endTime).getMinutes() + 30));
                    }
                    else if ($(contextElement).hasClass('e-monthcells')) {
                        var selCell = this.element.find('td.e-selectedCell');
                        var nsc = selCell.length - 1;
                        var startIndex = ($(selCell[0]).parent().index() * 7) + ($(selCell[0]).index() - (Math.floor($(selCell[0]).index() / 7) * 7));
                        var endIndex = ($(selCell[nsc]).parent().index() * 7) + ($(selCell[nsc]).index() - (Math.floor($(selCell[nsc]).index() / 7) * 7)); // $(selCell[nsc]).index();
                        var startDate = new Date(this._dateRender[startIndex]);
                        var endDate = new Date(this._dateRender[endIndex]);
                        startTime = new Date(new Date(startDate).setHours(9));
                        startTime = new Date(new Date(startTime).setMinutes(00)); //.setHours(00)).setMinutes(00);
                        endTime = new Date(new Date(endDate).setHours(9)); //.setHours(23)).setMinutes(59)); 
                        endTime = new Date(new Date(endTime).setMinutes(30));
                    }
                }
                else {
                    if (this.currentView() != "month") {
                        var minStartDate = renderDates[0]; var maxEndDate = renderDates[0];
                        var minStartTime = (this.model.startHour + (omincolIndex / 2)).toString().split(".");
                        var maxEndTime = (this.model.startHour + (omaxcolIndex / 2)).toString().split(".");
                        startTime = new Date(new Date(minStartDate).setHours(parseInt(minStartTime[0]), parseInt(minStartTime[1]) == 5 ? 30 : 00));
                        endTime = new Date(maxEndDate).setHours(parseInt(maxEndTime[0]), parseInt(maxEndTime[1]) == 5 ? 30 : 00);
                        endTime = new Date(new Date(endTime).setMinutes(new Date(endTime).getMinutes() + 30));
                    }
                    else {
                        var minStartDate = this.totdays[omincolIndex]; var maxEndDate = this.totdays[omaxcolIndex];
                        var minStartTime = (this.model.startHour).toString().split(".");
                        var maxEndTime = (this.model.startHour).toString().split(".");
                        startTime = new Date(minStartDate).setHours(parseInt(minStartTime[0]), parseInt(minStartTime[1]) == 5 ? 30 : 00);
                        endTime = new Date(maxEndDate).setHours(parseInt(maxEndTime[0]), parseInt(maxEndTime[1]) == 5 ? 30 : 00);
                        endTime = new Date(new Date(endTime).setMinutes(new Date(endTime).getMinutes() + 30));
                    }
                }
            }
            if (ej.scheduleFeatures.resources && !ej.isNullOrUndefined(this.model.resources))
                this._renderResourceData($(targetElement), index);
            this._appointmentAddWindow.find("#" + this._id + "startdate").ejDatePicker("option", "value", Globalize.format(new Date(startTime), this._pattern.d));
            this._appointmentAddWindow.find("#" + this._id + "enddate").ejDatePicker("option", "value", Globalize.format(new Date(endTime), this._pattern.d));
            this._appointmentAddWindow.find("#" + this._id + "starttime").ejTimePicker("option", "value", Globalize.format(new Date(startTime), this._pattern.t));
            this._appointmentAddWindow.find("#" + this._id + "endtime").ejTimePicker("option", "value", Globalize.format(new Date(endTime), this._pattern.t));
            ($(contextElement).hasClass("e-alldaycells") || this.currentView() == "month" || (this._isCustomView())) && this._appointmentAddWindow.find(".allday").ejCheckBox({ checked: true });
            this._alldayCheck();
            if (this.model.timeZone == null) {
                this._appointmentAddWindow.find("#startutc").val("UTC " + Globalize.format(new Date(startTime), "zzz"));
                this._appointmentAddWindow.find("#endutc").val("UTC " + Globalize.format(new Date(endTime), "zzz"));
            }
            else {
                this._appointmentAddWindow.find("#startutc").val(this.model.timeZone);
                this._appointmentAddWindow.find("#endutc").val(this.model.timeZone);
            }
            if (!this.model.readOnly)
            {
                this._appointmentAddWindow.find(".e-appsave,#donerecur").ejButton("enable", true);
                (this._mediaQuery) && this._appointmentAddWindow.find(".e-btndelete").css("display", "none");
                this._appointmentAddWindow.ejDialog("open");
            }
            this._appointmentAddWindow.find('.subject').focus();
            this._cellClick = false;
        }

    },
    /**
    * Section for handle the tab key process.
    * @private
    */
    _processTab: function (oEl, event, oRowCell) {
        var appo = this.element.find('div.e-appointment,div.e-alldayappointment,div.e-monthappointment');
        if (oEl.id == this._id || $(oEl).hasClass("e-datedisplay")) {
            if (appo.length != 0)
                $(appo[0]).addClass("e-selectedAppointment").attr("tabIndex", 0).focus();
            else
                $(oRowCell[0].cells[0]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
        }
        if ($(oEl).hasClass("e-selectedCell")) {
            if (appo.length != 0) {
                var selcel = this.element.find('td.e-selectedCell');
                var n = parseInt(selcel.length) - 1;
                if (n > 0) {
                    for (var i = 0; i <= n; i++) {
                        selcel[i].blur();
                        $(selcel[i]).removeClass("e-selectedCell");
                    }
                }
                else
                    $(oEl).removeClass("e-selectedCell").blur();
                $(appo[0]).addClass("e-selectedAppointment").attr("tabIndex", 0).focus();
            }
        }
        if ($(oEl).hasClass("e-navigateprevious")) {
            this.element.find('.e-navigatenext').attr("tabIndex", 0).focus();
        }
        else if ($(oEl).hasClass("e-navigatenext")) {
            $(oRowCell[0].cells[0]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
            if ($(oRowCell[0].cells[0]).hasClass("e-resourceheadercells"))
                $(oRowCell[1].cells[0]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
        }
        if ($(oEl).hasClass("e-appointment") || $(oEl).hasClass("e-alldayappointment") || $(oEl).hasClass("e-monthappointment")) {
            var appcount = appo.length;
            var appindex = this.element.find("div.e-appointment,div.e-alldayappointment,div.e-monthappointment").index($(".e-selectedAppointment"));
            if (appindex < appcount && appindex >= 0) {
                $(appo[appindex]).removeClass("e-selectedAppointment").blur();
                var newappindex = parseInt(appindex) + 1;
                if (newappindex < appcount)
                    $(appo[newappindex]).addClass("e-selectedAppointment").attr("tabIndex", 0).focus();
                else if (newappindex == appcount)
                    this.element.find('.e-navigateprevious').attr("tabIndex", 0).focus();
            }
            else if (appindex == appcount)
                this.element.find('.e-navigateprevious').attr("tabIndex", 0).focus();
        }
    },
    /**
    * Section for handle the shift tab key process.
    * @private
    */
    _reverseTab: function (oEl, event, oRowCell) {
        var appo = this.element.find('div.e-appointment,div.e-alldayappointment,div.e-monthappointment');
        if (oEl.id == this._id || $(oEl).hasClass("e-datedisplay")) {
            var len = parseInt(appo.length) - 1;
            if (appo.length != 0)
                $(appo[len]).addClass("e-selectedAppointment").attr("tabIndex", 0).focus();
        }
        var appcount = appo.length;
        if ($(oEl).hasClass("e-selectedCell")) {
            var len = appo.length - 1;
            if (appo.length != 0) {
                var selcel = this.element.find('td.e-selectedCell');
                var n = parseInt(selcel.length) - 1;
                if (n > 0) {
                    for (var i = 0; i <= n; i++)
                        $(selcel[i]).removeClass("e-selectedCell").blur();
                }
                else
                    $(oEl).removeClass("e-selectedCell").blur();
                $(appo[len]).addClass("e-selectedAppointment").attr("tabIndex", 0).focus();
            }
        }
        if ($(oEl).hasClass("e-navigatenext"))
            $(this.element).find('.e-navigateprevious').attr("tabIndex", 0).focus();
        else if ($(oEl).hasClass("e-navigateprevious")) {
            $(oRowCell[0].cells[0]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
            if ($(oRowCell[0].cells[0]).hasClass("e-resourceheadercells"))
                $(oRowCell[1].cells[0]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
        }
        if ($(oEl).hasClass("e-appointment") || $(oEl).hasClass("e-alldayappointment") || $(oEl).hasClass("e-monthappointment")) {
            var appindex = this.element.find("div.e-appointment,div.e-alldayappointment,div.e-monthappointment").index($(".e-selectedAppointment"));
            if (appindex < appcount && appindex > 0) {
                $(appo[appindex]).removeClass("e-selectedAppointment").blur();
                var newappindex = parseInt(appindex) - 1;
                if (newappindex < appcount && appindex >= 0)
                    $(appo[newappindex]).addClass("e-selectedAppointment").attr("tabIndex", 0).focus();
                else if (newappindex == 0)
                    $(this.element).find('.e-navigatenext').attr("tabIndex", 0).focus();
            }
            else if (appindex == 0) {
                $(appo[appindex]).removeClass("e-selectedAppointment").blur();
                $(this.element).find('.e-navigatenext').attr("tabIndex", 0).focus();
            }
        }
    },
    /**
    * Section to stop the default action.
    * @private
    */
    _stopDefaultAction: function (e) {
        e.cancelBubble = true; e.returnValue = false; e.stopPropagation(); e.preventDefault();
    },
    /**
    * To get the localized labels.
    * @private
    */
    //get locale text
    _getLocalizedLabels: function (property) {
        return ej.Schedule.Locale[this.model.locale][property] === undefined ? ej.Schedule.Locale["en-US"][property] : ej.Schedule.Locale[this.model.locale][property];
    },
    /**
    * It is used to save the appointment. The appointment obj is based on the argument passed along with this method.  
    * @return jQuery
    * @param {object} argument.obj obj of the appointment
    * @example 
    * &lt;div id="Schedule"&gt;&lt;/div&gt; <br>
    * &lt;script&gt;
    * $('#Schedule').ejSchedule({
        *     appointmentSettings: { dataSource: window.Default, //collection of object from dataSource.
        *               id: "Id",
        *               subject: "Subject",
        *               description: "Description",
        *               startTime: "StartTime",
        *               endTime: "EndTime",
        *               recurrence: "Recurrence",
        *               recurrenceRule: "RecurrenceRule",
        *               allDay: "AllDay"
        *             }                            
        *   });
        * var schObj = $("#Schedule").data("ejSchedule");
    * schObj.saveAppointment(obj); //obj contains collection of appointment. 
    * &lt;/script&gt;
    * @memberof ejSchedule
    * @instance
    */
    //public methods
    saveAppointment: function (obj) {
        if (!this.model.readOnly) {
            var appointments = this._sortAppById(this._processed), maxId;
            var temp = this._timeZoneConversion(obj);
            var proxy = this;
            maxId = appointments.length > 0 ? appointments[appointments.length - 1][this.model.appointmentSettings["id"]] + 1 : 1;
            if (ej.isNullOrUndefined(obj[this.model.appointmentSettings["id"]]) || obj[this.model.appointmentSettings["id"]] == "") {
                temp[this.model.appointmentSettings["id"]] = maxId;
                obj[this.model.appointmentSettings["id"]] = maxId;
                temp["ParentId"] = maxId;
                obj["ParentId"]= maxId;
                if (this._trigger("actionBegin", {data:obj,requestType:"appointmentSave"}))
                    return false;
                if (this._trigger("appointmentSaved", {appointment:obj}))
                    return false;
                var promise = this._dataManager.insert(temp);
                updateTempNew = this._reverseTimeZoneConversion(temp);
                new ej.DataManager(this._currentAppointmentData).update(this.model.appointmentSettings["id"], updateTempNew);
                if (!ej.isNullOrUndefined(promise) && $.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                    promise.done(function (e) {
                        proxy._processed.push(obj);
                        proxy._currentAppointmentData.push(obj);
                        proxy._renderSingleApp(obj, obj);
                        proxy._trigger("actionComplete", { data: temp, requestType: "appointmentSave" });
                    });
                }
                else {
                    this._processed.push(obj);
                    this._renderSingleApp(obj, obj);
                    this._trigger("actionComplete", { data: obj, requestType: "appointmentSave" });
                }
            }
            else {
                if (this._trigger("actionBegin", { data: obj, requestType: "appointmentEdit" }))
                    return false;
                if (this._trigger("appointmentEdited", {appointment:obj}))
                    return false;
                var updateTemp = this._reverseTimeZoneConversion(temp);
                new ej.DataManager(this._currentAppointmentData).update(this.model.appointmentSettings["id"], updateTemp);
                var promise = this._dataManager.update(this.model.appointmentSettings["id"], temp);
                if ($.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                    promise.done(function (e) {
                        (updateTemp[proxy.model.appointmentSettings["recurrence"]] || (Globalize.format(new Date(updateTemp[proxy.model.appointmentSettings["startTime"]]), proxy._pattern.d) < Globalize.format(new Date(updateTemp[proxy.model.appointmentSettings["endTime"]]), proxy._pattern.d)) && (((new Date(updateTemp[proxy.model.appointmentSettings["endTime"]]) - new Date(updateTemp[proxy.model.appointmentSettings["startTime"]])) / 3600000) < 24) && (updateTemp[proxy.model.appointmentSettings["allDay"]] !== true)) ? proxy._dataProcessing(proxy._currentAppointmentData) : new ej.DataManager(proxy._processed).update(proxy.model.appointmentSettings["id"], updateTemp) && proxy.element.find("#Appointment_" + proxy._appId).remove() && proxy.element.find("#categorybar_" + proxy._appId).remove();
                        proxy._renderSingleApp(updateTemp, updateTemp);
                        proxy._trigger("actionComplete", { data: e, requestType: "appointmentEdit" });
                    });
                }
                else {
                    if (!(obj[this.model.appointmentSettings["recurrence"]] || (Globalize.format(new Date(obj[this.model.appointmentSettings["startTime"]]), this._pattern.d) < Globalize.format(new Date(obj[this.model.appointmentSettings["endTime"]]), this._pattern.d)) && (((new Date(obj[this.model.appointmentSettings["endTime"]]) - new Date(obj[this.model.appointmentSettings["startTime"]])) / 3600000) < 24) && (obj[this.model.appointmentSettings["allDay"]] !== true)))
                        new ej.DataManager(this._processed).update(this.model.appointmentSettings["id"], updateTemp) && this.element.find("#Appointment_" + this._appId).remove();
                    else
                        proxy._dataProcessing(proxy._currentAppointmentData);
                    proxy._renderSingleApp(updateTemp, updateTemp);
                    this._trigger("actionComplete", { data: updateTemp, requestType: "appointmentEdit" });
                }
            }
        }
    },
    /**
    * It is used to print the schedule. 
    * @return jQuery
    * @example 
    * &lt;div id="Schedule"&gt;&lt;/div&gt; <br>
    * &lt;script&gt;
    * $('#Schedule').ejSchedule({
        *     appointmentSettings: { dataSource: window.Default, //collection of object from dataSource.
        *               id: "Id",
        *               subject: "Subject",
        *               description: "Description",
        *               startTime: "StartTime",
        *               endTime: "EndTime",
        *               recurrence: "Recurrence",
        *               recurrenceRule: "RecurrenceRule",
        *               allDay: "AllDay"
        *             }                            
        *   });
        * var schObj = $("#Schedule").data("ejSchedule");
    * schObj.print();
    * &lt;/script&gt;
    * @memberof ejSchedule
    * @instance
    */
    //public methods
    print:function(){
    ej.print(this.element);
    },
    /**
    * It is used to delete the appointment. The id is based on the argument passed along with this method  
    * @return jQuery
    * @param {number} argument.id id value of the appointment
    * @example 
    * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
    * &lt;script&gt;
    * $('#Schedule').ejSchedule({
        *     appointmentSettings: { dataSource: window.Default, //collection of object from dataSource.
        *               id: "Id",
        *               subject: "Subject",
        *               description: "Description",
        *               startTime: "StartTime",
        *               endTime: "EndTime",
        *               recurrence: "Recurrence",
        *               recurrenceRule: "RecurrenceRule",
        *               allDay: "AllDay"
        *             }                            
        *   });
        * var schObj = $("#Schedule").data("ejSchedule");
        * schObj.deleteAppointment(105); //Appointments id number.
    * &lt;/script&gt;
    * @memberof ejSchedule
    * @instance
    */
    deleteAppointment: function (id) {
        if (!this.model.readOnly)
            this._deleteApp(id);
        //this._renderAppointmentAll();
    },
    /**
    * It is used to get the appointment list of schedule control. 
        * @return Appointments
    * @example 
    * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
    * &lt;script&gt;
    * $('#Schedule').ejSchedule({
        *     appointmentSettings: { dataSource: window.Default, //collection of object from dataSource.
        *               id: "Id",
        *               subject: "Subject",
        *               description: "Description",
        *               startTime: "StartTime",
        *               endTime: "EndTime",
        *               recurrence: "Recurrence",
        *               recurrenceRule: "RecurrenceRule",
        *               allDay: "AllDay"
        *             }                            
        *   });
        * var schObj = $("#Schedule").data("ejSchedule");
        * var appointments=schObj.getAppointments(); // Gets the appointments list of schedule control
    * &lt;/script&gt;
    * @memberof ejSchedule
    * @instance
    */
    getAppointments: function () {
        var appList = this.dataSource();
        return appList;
    },
    /**
    * It used search the appointments from appointment list of schedule control. 
    * @return Appointments
    * @param {string} argument.searchString searchString value of the search word in the appointments.
    * @param {string} argument.fields fields value of which feilds need search.
    * @param {string} argument.filterOperator filterOperator value of the search operation need to done.
    * @param {boolean} argument.ignoreCase ignoreCase value of the case.  
    * @example 
    * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
    * &lt;script&gt;
    * $('#Schedule').ejSchedule({
        *     appointmentSettings: { dataSource: window.Default, //collection of object from dataSource.
        *               id: "Id",
        *               subject: "Subject",
        *               description: "Description",
        *               startTime: "StartTime",
        *               endTime: "EndTime",
        *               recurrence: "Recurrence",
        *               recurrenceRule: "RecurrenceRule",
        *               allDay: "AllDay"
        *             }                            
        *   });
        * var schObj = $("#Schedule").data("ejSchedule");
        * var appointments=schObj.searchAppointments("gold"); // Gets the appointments list of schedule control
    * &lt;/script&gt;
    * @memberof ejSchedule
    * @instance
    */
    searchAppointments: function (searchString, fields, filterOperator, ignoreCase) {
        var queryManagar = ej.Query();
        var result, _fields = ej.isNullOrUndefined(fields) ? this._getColumns(this.model.appointmentSettings) : fields;
        filterOperator = ej.isNullOrUndefined(filterOperator) ? "contains" : filterOperator;
        ignoreCase = ej.isNullOrUndefined(ignoreCase) ? true : ignoreCase;
        if (typeof searchString == "string") {
            if (searchString.length) {
                queryManagar.search(searchString, _fields, filterOperator, ignoreCase);
                if ((this.dataSource() instanceof ej.DataManager)) {
                    result = queryManagar;
                }
                else
                    result = this._dataManager.executeLocal(queryManagar);
            }
        }
        else if (typeof searchString == "object")
            result = this.filterAppointments(searchString);
        return result;
    },
   /**
    * It used search the appointments from appointment list of schedule control. 
    * @return Appointments
    * @param {object} argument.filterConditions filterConditions value of the filter collections for appointments. 
    * @example 
    * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
    * &lt;script&gt;
    * $('#Schedule').ejSchedule({
        *     appointmentSettings: { dataSource: window.Default, //collection of object from dataSource.
        *               id: "Id",
        *               subject: "Subject",
        *               description: "Description",
        *               startTime: "StartTime",
        *               endTime: "EndTime",
        *               recurrence: "Recurrence",
        *               recurrenceRule: "RecurrenceRule",
        *               allDay: "AllDay"
        *             }                            
        *   });
        * var schObj = $("#Schedule").data("ejSchedule");
        * var filter=[{
        *    field: "Subject",
        *    operator: "contains",
        *    value: "gold",
        *    predicate: "or"
        *}];
        * var appointments=schObj.filterAppointments(filter); // Gets the appointments list of schedule control
    * &lt;/script&gt;
    * @memberof ejSchedule
    * @instance
    */
    filterAppointments: function (filterConditions) {
        var result, queryManagar = ej.Query();
        if(!ej.isNullOrUndefined(filterConditions)) {
            var firstFilterCondition = filterConditions[0];
            predicate = ej.Predicate(firstFilterCondition.field, firstFilterCondition.operator, firstFilterCondition.value, !firstFilterCondition.matchcase);
            for (var i = 1; i < filterConditions.length; i++)
                predicate = predicate[filterConditions[i].predicate](filterConditions[i].field, filterConditions[i].operator, filterConditions[i].value, !(filterConditions[i].matchcase));
            queryManagar.where(predicate);
            if ((this.dataSource() instanceof ej.DataManager)) {
                result = queryManagar;
            }
            else
                result = this._dataManager.executeLocal(queryManagar);
        }
        return result;
    },
	 /**
    * It used to Refresh Scroller while using schedule control in some other controls. 
      * @return Scroller
    * @example 
    * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
    * &lt;script&gt;
    * $('#Schedule').ejSchedule();
        * var schObj = $("#Schedule").data("ejSchedule");
        * schObj.refreshScroller(); // To refresh scroller while using schedule control in some other control
    * &lt;/script&gt;
    * @memberof ejSchedule
    * @instance
    */
	refreshScroller:function()
    {
      var scrollerObj = this.element.find(".e-scroller").data("ejScroller");
      scrollerObj.model.width = (this.model.orientation === "vertical" && !this.model.enableRTL) ? this.element.outerWidth() - (this.element.find('.e-draggableworkarea').offset().left - this.element.offset().left) : (this.model.orientation == "horizontal") && (!ej.isNullOrUndefined(this.model.group) && !ej.isNullOrUndefined(this.model.resources) && !this.model.enableRTL) ? this.element.width() - this.element.find(".e-resourceheadertable").width() : (this.model.enableRTL) ? this.element.width() - this.element.find('.e-scrolltimecells').parent().width() : this.element.width();
      scrollerObj.model.height = this.scHeight - (this.element.find('.e-draggableworkarea').offset().top - this.element.offset().top);;
      scrollerObj.refresh();
      if (this.model.orientation == "vertical") {
        if (this.model.cellWidth)
         this.element.find(".e-headrealldaytable").parent().width(this.element.find(".e-draggableworkarea").width());
         this.element.find(".e-datecommondiv").parent().width(this.element.width());
         this.element.find(".e-headrealldaytable").css("left", -(this.element.find(".e-draggableworkarea").scrollLeft()) + "px");
        }
     else 
          $(this.element.find(".e-horizontaltimecells").find("table tr")[2]).css("left", -(scrollerObj.model.scrollLeft) + "px");
     if(this.currentView() =="month" && this.model.orientation == "vertical")
       this._renderCurrentView();
    },
    /**
    * It used to Export the appointments from the schedule control. 
    * @return null
    * @param {string} argument.action to refer the controller action name to redirect. (For MVC)
    * @param {string} argument.serverEvent to refer the server event name.(For ASP)
    * @param {string} argument.id to pass the id of an appointment, in case if a single appointment needs to be exported. Otherwise, it takes the null value.
    * @example 
    * &lt;div id="Schedule"&gt;&lt;/div&gt; <br> 
    * &lt;script&gt;
    * $('#Schedule').ejSchedule({
        *     appointmentSettings: { dataSource: window.Default, //collection of object from dataSource.
        *               id: "Id",
        *               subject: "Subject",
        *               description: "Description",
        *               startTime: "StartTime",
        *               endTime: "EndTime",
        *               recurrence: "Recurrence",
        *               recurrenceRule: "RecurrenceRule",
        *               allDay: "AllDay"
        *             }                            
        *   });
        * var schObj = $("#Schedule").data("ejSchedule");
        * schObj.exportSchedule("ActionName","ExportToICS", null); // To Export all the Appointments
        * schObj.exportSchedule("ActionName","ExportToICS", 101); // To Export a single appointment with an id "101"
    * &lt;/script&gt;
    * @memberof ejSchedule
    * @instance
    */
    exportSchedule: function (action, serverEvent, id) {
        var modelClone = JSON.parse(JSON.stringify(this.model));
        var appointmentClone = JSON.parse(JSON.stringify(this.model.appointmentSettings));
        var attr = { action: action, method: 'post' };
        var form = ej.buildTag('form', "", null, attr);
        if (this._ignoreFromAppointmentOnExport) {
            for (var i = 0; i < this._ignoreFromAppointmentOnExport.length; i++) {
                delete appointmentClone[this._ignoreFromAppointmentOnExport[i]];
            }
        }
        if (ej.raiseWebFormsServerEvents) {
            var args = { model: modelClone, originalEventType: serverEvent };
            var clientArgs = { model: JSON.stringify(appointmentClone), appId: id };
            ej.raiseWebFormsServerEvents(serverEvent, args, clientArgs);
        }
        else {
            var inputAttr = { name: 'ScheduleModel', type: 'hidden', value: JSON.stringify(appointmentClone) }
            var input = ej.buildTag('input', "", null, inputAttr);

            //for exporting single appointment, passing the id of appointment into hidden field
            if(!ej.isNullOrUndefined(id)){
            var idAttr = {name: 'AppointmentId', type: 'hidden', value: id}
            var inputId = ej.buildTag('input', "", null, idAttr);
            form.append(inputId);
            }
            form.append(input); 
            form.append(this);
            $('body').append(form);
            form.submit();
        }
        return true;
    }
});

    if (ej.scheduleFeatures.resources)
        $.extend(ej.Schedule.prototype, ej.scheduleFeatures.resources);
    if (ej.scheduleFeatures.horizontal)
        $.extend(ej.Schedule.prototype, ej.scheduleFeatures.horizontal);


//Schedule Localization 
ej.Schedule.Locale = {};

//Default english localized values
ej.Schedule.Locale["en-US"] = {
    ReminderWindowTitle: "Reminder window",
    CreateAppointmentTitle: "Create Appointment",
    RecurrenceEditTitle: "Edit repeat appointment",
    RecurrenceEditMessage: "How would you like to change the event in the series?",
    RecurrenceEditOnly: "Only this appointment",
    RecurrenceEditSeries: "Entire series",
    PreviousAppointment: "Previous Appointment",
    NextAppointment:"Next Appointment",
    AppointmentSubject: "Subject",
    StartTime: "Start Time",
    EndTime: "End Time",
    AllDay: "All day",
    Today: "Today",
    Recurrence: "Repeat",
    Done: "Done",
    Cancel: "Cancel",
    Ok: "Ok",
    RepeatBy: "Repeat by",
    RepeatEvery: "Repeat every",
    RepeatOn: "Repeat on",
    StartsOn: "Starts on",
    Ends: "Ends",
    Summary: "Summary",
    Daily: "Daily",
    Weekly: "Weekly",
    Monthly: "Monthly",
    Yearly: "Yearly",
    Every: "Every",
    EveryWeekDay: "Every weekday",
    Never: "Never",
    After: "After",
    Occurence: "Occurrence(s)",
    On: "On",
    Edit: "Edit",
    RecurrenceDay: "Day(s)",
    RecurrenceWeek: "Week(s)",
    RecurrenceMonth: "Month(s)",
    RecurrenceYear: "Year(s)",
    The: "The",
    OfEvery: "of every",
    First: "First",
    Second: "Second",
    Third: "Third",
    Fourth: "Fourth",
    Last: "Last",
    WeekDay: "Weekday",
    WeekEndDay: "Weekendday",
    Subject: "Subject",
    Categorize: "Categories",
    DueIn: "Due In",
    DismissAll: "Dismiss All",
    Dismiss: "Dismiss",
    OpenItem: "Open Item",
    Snooze: "Snooze",
    Day: "Day",
    Week: "Week",
    WorkWeek: "Work Week",
    Month: "Month",
    CustomView: "Custom View",
    Agenda: "Agenda",
    Detailed: "Detailed",
    EventBeginsin: "Appointment Begins in",
    Editevent: "Edit Appointment",
    Editseries: "Edit series",
    Times: "times",
    Until: "until",
    Eventwas: "Appointment was",
    Hours: "hrs",
    Minutes: "mins",
    Overdue: "Overdue Appointment",
    Days: "day(s)",
    Event: "Subject",
    Select: "select",
    Previous: "prev",
    Next: "next",
    Close: "close",
    Delete: "delete",
    Date: "Date",
    Showin: "Show in",
    Gotodate: "Go To Date",
    RESOURCES: "RESOURCES" 
};
/**
* Enum for various schedule actions while create/edit appointments	 
* @enum {string}
* @global 
*/
ej.Schedule.Actions = {
    /**  support to know the action as add while create appointment in the schedule */
    Add: "add",
    /**  support to know the action as save while create appointment in the schedule */
    Save: "save",
    /**  support to know the action as delete while delete appointment in the schedule */
    Delete: "delete",
    /**  support to know the action as edit occurance while editin the occurrence appointment */
    EditOcurrence: "editOcurrence",
    /**  support to know the action as edit series while editing the complete series appointment */
    EditSeries: "editSeries"
};
/**
* Enum for various schedule view	 
* @enum {string}
* @global 
*/
ej.Schedule.CurrentView = {
    /**  Creates schedule with current view as day */
    Day: "day",
    /**  Creates schedule with current view as week */
    Week: "week",
    /**  Creates schedule with current view as work week */
    Workweek: "workweek",
    /**  Creates schedule with current view as month */
    Month: "month",
    /** Creates Schedule with current view as Custom days */
    CustomView: "customview"
};
/**
* Enum for various schedule timemode	 
* @enum {string}
* @global 
*/
ej.Schedule.TimeMode = {
    /**  Creates schedule with time mode as twelve hour */
    Hour12: "12",
    /**  Creates schedule with time mode as twenty four hour */
    Hour24: "24"
};

    /**
    * Enum for schedule orientation	 
    * @enum {string}
    * @global 
    */
ej.Schedule.Orientation = {
    /**  Creates schedule in vertical orientation */
    Vertical: "vertical",
    /**  Creates schedule in horizontal orientation */
    Horizontal: "horizontal"
};

})(jQuery, Syncfusion);